//==============================================================
//
// Bmp_viewer
//
//==============================================================
#include "bcl_filedlg.h"
#include "bcl_dirdlg.h"
#include "bcl_menu.h"
#include "bcl_citr.h"
#include "bcl_textfile.h"
#include "resouce.h"
#include "bmp_viewer.h"
#include "create_cld_viewer.h"
#include "cld_viewer.h"
#include "ver.h"

/// RXgN^
Bmp_viewer::Bmp_viewer()
{
	ON_SIZE(Bmp_viewer::on_size);
	ON_NOTIFY(Bmp_viewer::on_notify);
	ON_COMMAND(IDM_OPEN, Bmp_viewer::on_open);
	ON_COMMAND(IDM_EXIT, Bcl_wnd::on_close);
	ON_COMMAND(IDM_CASCADE, Bmp_viewer::on_cascade);
	ON_COMMAND(IDM_TILEHORZ, Bmp_viewer::on_tilehorz);
	ON_COMMAND(IDM_TILEVERT, Bmp_viewer::on_tilevert);
	ON_COMMAND(IDM_ARRANGE, Bmp_viewer::on_arrange);
	ON_COMMAND(IDM_VERSION, Bmp_viewer::on_version);
	ON_COMMAND(IDM_DOUBLE, Bmp_viewer::on_double);
	ON_MSG(WM_DROPFILES, Bmp_viewer::on_drop_files);
}

/// WM_CREATEbZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Bmp_viewer::on_create(WPARAM wp, LPARAM lp)
{
	DragAcceptFiles(m_handle, TRUE);

	m_tbar.create(this, TOOLBAR);
	m_tbar.add_std_button(STD_FILEOPEN, IDM_OPEN, TBSTATE_ENABLED, TBSTYLE_BUTTON, "J");
	m_tbar.add_std_button(STD_FILESAVE, IDM_SAVEAS, 0, TBSTYLE_BUTTON, "Oĕۑ");
	m_tbar.add_separetor();
	m_tbar.add_std_button(STD_PRINT, IDM_PRINT, 0, TBSTYLE_BUTTON, "");
	m_tbar.add_separetor();
	m_tbar.add_std_button(STD_HELP, IDM_VERSION, TBSTATE_ENABLED, TBSTYLE_BUTTON, "wv");
	m_tbar.show();
	
	m_sbar.create(this, STATUSBAR);
	m_sbar.add_section(get_client_width() - 700);
	m_sbar.add_section(300, true);
	m_sbar.add_section(100, true);
	m_sbar.add_section(100, true);
	m_sbar.add_section(200, true);
	m_sbar.set_section();

}

/// WM_SIZEbZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Bmp_viewer::on_size(WPARAM wp, LPARAM lp)
{
	m_tbar.auto_size();
	m_sbar.auto_size();
	set_client_size(m_tbar.get_height(), m_sbar.get_height());
}


/// WM_NOTIFYbZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Bmp_viewer::on_notify(WPARAM wp, LPARAM lp)
{
	m_tbar.show_tooltip((LPTOOLTIPTEXT)lp);
}

/// WM_COMMAND(IDM_OPEN)bZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Bmp_viewer::on_open(WPARAM wp, LPARAM lp)
{
	Bcl_filedlg dlg(this);
	dlg.add_filter("all files","*.*");
	if (dlg.do_modal() == true)
	{
		Bcl_str fname = dlg.get_fname();
		if (!is_open(fname))
		{
			load(fname);
		}
	}
}

/// WM_COMMAND(IDM_CASCADE)bZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Bmp_viewer::on_cascade(WPARAM wp, LPARAM lp)
{
	arrange_cascade();
}

/// WM_COMMAND(IDM_TILEHORZ)bZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Bmp_viewer::on_tilehorz(WPARAM wp, LPARAM lp)
{
	arrange_tile_horz();
}

/// WM_COMMAND(IDM_TILEVERT)bZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Bmp_viewer::on_tilevert(WPARAM wp, LPARAM lp)
{
	arrange_tile_vert();
}

/// WM_COMMAND(IDM_ARRANGE)bZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Bmp_viewer::on_arrange(WPARAM wp, LPARAM lp)
{
	arrange_icon();
}

/// WM_COMMAND(IDM_VERSION)bZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Bmp_viewer::on_version(WPARAM wp, LPARAM lp)
{
	Ver dlg(this);
	dlg.do_modal();
}

/// WM_DROPFILESbZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Bmp_viewer::on_drop_files(WPARAM wp, LPARAM lp)
{
	HDROP hdrop;
	UINT file_no;
	char file_name[256];
	
	set_foreground_window();
	hdrop = (HDROP)wp;
	file_no = DragQueryFile(hdrop, 0xFFFFFFFF, NULL, 0);
	if ((int)file_no > 0)
	{
		DragQueryFile(hdrop, 0, file_name, sizeof(file_name));
		Bcl_str fname(file_name);
		if ((fname.left(1) == "\"") && (fname.right(1) == "\""))
		{
			fname = fname.mid(1, fname.get_length() - 2);
		}
		if (is_open(fname))
		{
			return;
		}
		load(fname);
	}
}

/// WM_COMMAND(IDM_DOUBLE)bZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Bmp_viewer::on_double(WPARAM wp, LPARAM lp)
{
	HANDLE map_file;
	static LPSTR map_addr;

	map_file = OpenFileMapping(FILE_MAP_ALL_ACCESS, FALSE, "BMPViewerMDIFrameWnd");
	if (!map_file)
	{
		return;
	}
	map_addr = (LPSTR)MapViewOfFile(map_file, FILE_MAP_ALL_ACCESS, 0, 0, 0);
	if (map_addr == NULL)
	{
		return;
	}
	Bcl_str fname(map_addr);
	CloseHandle(map_file);
	if ((fname.left(1) == "\"") && (fname.right(1) == "\""))
	{
		fname = fname.mid(1, fname.get_length() - 2);
	}
	if (is_open(fname))
	{
		return;
	}
	load(fname);
}

/// j[̏ԕύX
/// @param flag 
void Bmp_viewer::change_menu_status(bool flag)
{
	Bcl_menu menu(this);
	menu.set_enabled_by_pos(1, flag);
	Bcl_menu sub_menu = menu.get_sub_menu(0);
	sub_menu.set_enabled_by_cmd(IDM_SAVEAS, flag);
	sub_menu.set_enabled_by_cmd(IDM_PRINT, flag);
	menu.draw();
	m_tbar.set_enabled(IDM_SAVEAS, flag);
	m_tbar.set_enabled(IDM_PRINT, flag);
	if (flag)
	{
		Cld_viewer* cld = (Cld_viewer*)get_focus();
		set_statusbar(cld);
	}
	else
	{
		set_statusbar(NULL);
	}
}

/// t@Cǂݍ
/// @param fname t@C
/// @return 
bool Bmp_viewer::load(const Bcl_str& fname)
{
	Create_cld_viewer creator;
	Cld_viewer* cld = (Cld_viewer*)create_child(&creator);
	if (!cld->load(fname))
	{
		close_child(cld);
		return false;
	}
	cld->create("MDIChildWnd", fname.to_char());
	set_statusbar(cld);
	return true;
}

/// t@CJĂ邩ǂ肵AJĂ炻̃EBhEANeBuɂ
/// @param fname t@C
/// @return 
bool Bmp_viewer::is_open(const Bcl_str& fname)
{
	HWND exist = NULL;
	Bcl_citr< std::vector<Bcl_mdichild*> > itr(m_cld_list);
	while (itr.has_next())
	{
		Cld_viewer* cld = (Cld_viewer*)itr.next();
		if (cld->get_fname() == fname)
		{
			exist = cld->get_handle();
			break;
		}
	}
	if (exist != NULL)
	{
		SetFocus(exist);
		return true;
	}
	return false;
}

/// Xe[^Xo[ݒ
/// @param cld qEBhE
void Bmp_viewer::set_statusbar(Cld_viewer* cld)
{
	m_sbar.set_text(0, "");
	if (cld == NULL)
	{
		m_sbar.set_text(1, "");
		m_sbar.set_text(2, "");
		m_sbar.set_text(3, "");
		m_sbar.set_text(4, "");
	}
	else
	{
		m_sbar.set_text(1, cld->get_fname());
		m_sbar.set_text(2, Bcl_str(cld->get_width(), RADIX_DEC));
		m_sbar.set_text(3, Bcl_str(cld->get_height(), RADIX_DEC));
		Bcl_str col;
		switch (cld->get_color_bit())
		{
			case 1:
				col = "mN";
				break;
			case 4:
				col = "PUF";
				break;
			case 8:
				col = "QTUF";
				break;
			case 16:
				col = "UTTRUF";
				break;
			case 24:
				col = "QSrbg TRUEJ[";
				break;
			case 32:
				col = "RQrbg TRUEJ[";
				break;
		}
		m_sbar.set_text(4, col);
	}
}
