//==============================================================
//
// Cld_viewer
//
//==============================================================
#include "bcl_filedlg.h"
#include "bcl_mdi.h"
#include "resouce.h"
#include "cld_viewer.h"
#include "bmp_viewer.h"
#include "printer.h"

/// RXgN^
/// @param parent eEBhE
Cld_viewer::Cld_viewer(Bcl_mdi* parent) : Bcl_mdichild(parent), m_create(false)
{
	ON_PAINT(Cld_viewer::on_paint);
	ON_SIZE(Cld_viewer::on_size);
	ON_HSCROLL(Cld_viewer::on_hscroll);
	ON_VSCROLL(Cld_viewer::on_vscroll);
	ON_MDIACTIVATE(Cld_viewer::on_mdi_activate);
	ON_COMMAND(IDM_SAVEAS, Cld_viewer::on_saveas);
	ON_COMMAND(IDM_PRINT, Cld_viewer::on_print);
}

/// WM_CREATEbZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Cld_viewer::on_create(WPARAM wp, LPARAM lp)
{
	m_hscrl.init(this, m_bmp.get_width(), 1, SB_HORZ);
	m_vscrl.init(this, m_bmp.get_height(), 1, SB_VERT);
	m_cvs.set_canvas(this);
	m_cvs.put_bmp(m_bmp, 0, 0, SRCCOPY);
	m_create = true;
}

/// WM_MDIACTIVATEbZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Cld_viewer::on_mdi_activate(WPARAM wp, LPARAM lp)
{
	if(m_handle == (HWND)lp)
	{
		((Bmp_viewer*)m_parent)->change_menu_status(true);
	}
	else
	{
		((Bmp_viewer*)m_parent)->change_menu_status(false);
	}
}

/// WM_PAINTbZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Cld_viewer::on_paint(WPARAM wp, LPARAM lp)
{
	m_cvs.paint();
}


/// WM_SIZEbZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Cld_viewer::on_size(WPARAM wp, LPARAM lp)
{
	if (m_create)
	{
		m_hscrl.set_page(get_client_width());
		m_vscrl.set_page(get_client_height());
		m_cvs.put_bmp(m_bmp, 0 - m_hscrl.get_pos(), 0 - m_vscrl.get_pos(), SRCCOPY);
	}
}

/// WM_HSCROLLbZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Cld_viewer::on_hscroll(WPARAM wp, LPARAM lp)
{
	m_hscrl.scroll(LOWORD(wp), HIWORD(wp));
	m_cvs.clear();
	m_cvs.put_bmp(m_bmp, 0 - m_hscrl.get_pos(), 0 - m_vscrl.get_pos(), SRCCOPY);
}

/// WM_VSCROLLbZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Cld_viewer::on_vscroll(WPARAM wp, LPARAM lp)
{
	m_vscrl.scroll(LOWORD(wp), HIWORD(wp));
	m_cvs.clear();
	m_cvs.put_bmp(m_bmp, 0 - m_hscrl.get_pos(), 0 - m_vscrl.get_pos(), SRCCOPY);
}

/// WM_COMMAND(IDM_SAVEAS)bZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Cld_viewer::on_saveas(WPARAM wp, LPARAM lp)
{
	Bcl_filedlg dlg(this);
	dlg.set_mode(MODE_SAVE);
	dlg.add_filter("rbg}bvimNj","*.bmp");
	dlg.add_filter("rbg}bvi16Fj","*.bmp");
	dlg.add_filter("rbg}bvi256Fj","*.bmp");
	dlg.add_filter("rbg}bvi65536Fj","*.bmp");
	dlg.add_filter("rbg}bvi24bit trueJ[j","*.bmp");
	dlg.add_filter("rbg}bvi32bit trueJ[j","*.bmp");
	int index = 5;
	switch (m_bmp.get_color_bit())
	{
		case 1:
			index = 1;
			break;
		case 4:
			index = 2;
			break;
		case 8:
			index = 3;
			break;
		case 16:
			index = 4;
			break;
		case 24:
			index = 5;
			break;
		case 32:
			index = 6;
			break;
	}
	dlg.set_filter_index(index);
	if (dlg.do_modal() == true)
	{
		WORD col = 24;
		switch (dlg.get_filter_index())
		{
			case 1:
				col = 1;
				break;
			case 2:
				col = 4;
				break;
			case 3:
				col = 8;
				break;
			case 4:
				col = 16;
				break;
			case 5:
				col = 24;
				break;
			case 6:
				col = 32;
				break;
		}
		m_bmp.save(dlg.get_fname(), col);
	}
}

/// WM_COMMAND(IDM_PRINT)bZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Cld_viewer::on_print(WPARAM wp, LPARAM lp)
{
	Printer dlg(this);
	if (dlg.do_modal() == true)
	{
		Bcl_printer printer;
		switch (dlg.get_paper())
		{
			case 0:
				printer.set_paper_size(PAPER_A4_VERT);
				break;
			case 1:
				printer.set_paper_size(PAPER_A4_HORZ);
				break;
			case 2:
				printer.set_paper_size(PAPER_B5_VERT);
				break;
			case 3:
				printer.set_paper_size(PAPER_B5_HORZ);
				break;
		}
		printer.create_dc(dlg.get_printer_idx());
		printer.set_document_name("bmp_viewer");
		printer.print_start();
		int width = m_bmp.get_width() * 4;
		int height = m_bmp.get_height() * 4;
		int prn_width = printer.get_width();
		int prn_height = printer.get_height();
		int x = 0;
		int y = 0;
		while (1)
		{
			printer.fit_bmp(m_bmp, -x, -y, width, height, SRCCOPY);
			x += prn_width;
			if (x > width)
			{
				x = 0;
				y += prn_height;
				if (y > height)
				{
					break;
				}
			}
			printer.next_page();
		}
		printer.print_end();
	}
}

/// ǂݍ
/// @param fname t@C
/// @return 
bool Cld_viewer::load(const Bcl_str& fname)
{
	if (!m_bmp.load(m_parent, fname.to_char(), true))
	{
		return false;
	}
	m_fname = fname;
	return true;
}

/// t@C擾
/// @return t@C
Bcl_str Cld_viewer::get_fname()
{
	return m_fname;
}

/// 擾
/// @return 
long Cld_viewer::get_width() const
{
	return m_bmp.get_width();
}

/// 擾
/// @return 
long Cld_viewer::get_height() const
{
	return m_bmp.get_height();
}

/// J[rbg擾
/// @return J[rbg
WORD Cld_viewer::get_color_bit() const
{
	return m_bmp.get_color_bit();
}
