//==============================================================
//
// Printer
//
//==============================================================
#include "bcl_verinfo.h"
#include "resouce.h"
#include "printer.h"

/// RXgN^
/// @param parent eEBhE
Printer::Printer(Bcl_wnd* parent) : Bcl_dlg(parent, "IDD_PRINT")
{
	ON_COMMAND(IDOK, Printer::on_ok);
	ON_COMMAND(IDCANCEL, Printer::on_cancel);
	ON_COMMAND(IDC_CMB_PRINTER, Printer::on_cmb_printer);
}

/// _CAO
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Printer::on_init(WPARAM wp, LPARAM lp)
{
	m_cmb_printer.assign(this, IDC_CMB_PRINTER);
	m_lbl_place.assign(this, IDC_LBL_PLACE);
	m_cmb_paper.assign(this, IDC_CMB_PAPER);
	m_btn_ok.assign(this, IDOK);
	
	int def = 0;
	int num = m_printer.get_printer_num();
	if (num > 0)
	{
		Bcl_str def_name = m_printer.get_default_printer(this);
		for (int i = 0; i < num; i++)
		{
			Bcl_str name = m_printer.get_printer_name(i);
			m_cmb_printer.add_item(name);
			if (name == def_name)
			{
				def = i;
			}
		}
		m_cmb_printer.set_cursel(def);
		m_lbl_place.set_text(m_printer.get_port_name(def));
	}
	else
	{
		m_cmb_printer.set_enabled(false);
		m_lbl_place.set_text("v^܂B");
		m_btn_ok.set_enabled(false);
	}

	m_cmb_paper.add_item("`Sc");
	m_cmb_paper.add_item("`S");
	m_cmb_paper.add_item("aTc");
	m_cmb_paper.add_item("aT");
	m_cmb_paper.set_cursel(0);
	move_center_of_parent();
}

/// WM_COMMAND(IDOK)̃bZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Printer::on_ok(WPARAM wp, LPARAM lp)
{
	m_printer_idx = m_cmb_printer.get_cursel();
	m_paper = m_cmb_paper.get_cursel();
	end_modal(true);
}

/// WM_COMMAND(IDCANCEL)̃bZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Printer::on_cancel(WPARAM wp, LPARAM lp)
{
	end_modal(false);
}

/// WM_COMMAND(IDC_CMB_PRINTER)̃bZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Printer::on_cmb_printer(WPARAM wp, LPARAM lp)
{
	if (HIWORD(wp) == CBN_SELCHANGE)
	{
		m_lbl_place.set_text(m_printer.get_port_name(m_cmb_printer.get_cursel()));
	}
}

/// v^[CfbNX擾
/// @return v^[CfbNX
int Printer::get_printer_idx()
{
	return m_printer_idx;
}

/// p擾
/// @return p
int Printer::get_paper()
{
	return m_paper;
}
