//==============================================================
//
// Diary
//
//==============================================================
#ifndef _DIARY_H_
#define _DIARY_H_

#include <map>
#include "bcl_sdi.h"
#include "bcl_toolbar.h"
#include "bcl_tab.h"
#include "bcl_listview.h"
#include "bcl_hsplit.h"
#include "bcl_treeview.h"
#include "bcl_edit.h"
#include "bcl_date.h"

class Diary : public Bcl_sdi
{
	Bcl_toolbar m_tbar;
	Bcl_tab m_tab;
	Bcl_listview m_lv;
	Bcl_hsplit m_hs;
	Bcl_treeview m_tv;
	Bcl_edit m_edit;
	std::multimap<Bcl_date, Bcl_str> m_data;
	Bcl_str m_fname;
	std::map<HTREEITEM, std::multimap<Bcl_date, Bcl_str>::iterator> m_tv_data;
	bool m_modify;

	void on_create(WPARAM wp, LPARAM lp);
	void on_size(WPARAM wp, LPARAM lp);
	void on_notify(WPARAM wp, LPARAM lp);
	void on_new(WPARAM wp, LPARAM lp);
	void on_open(WPARAM wp, LPARAM lp);
	void on_save(WPARAM wp, LPARAM lp);
	void on_saveas(WPARAM wp, LPARAM lp);
	void on_add(WPARAM wp, LPARAM lp);
	void on_edit(WPARAM wp, LPARAM lp);
	void on_del(WPARAM wp, LPARAM lp);
	void on_topic(WPARAM wp, LPARAM lp);
	void on_version(WPARAM wp, LPARAM lp);
	void on_close(WPARAM wp, LPARAM lp);
	void on_drop_files(WPARAM wp, LPARAM lp);
	void on_help(WPARAM wp, LPARAM lp);
	void display_lv();
	void display_tv();
	Bcl_str get_line_str(const Bcl_str& str);
	void save(const Bcl_str& fname);
	void change_menu_status();
	void change_title();
	bool modify_chk();
	HTREEITEM add_tree_item(std::multimap<Bcl_date, Bcl_str>::iterator itr);
	void delete_tree_item(HTREEITEM item);
public:
	Diary();
	bool load(const Bcl_str& fname);
	bool is_open(const Bcl_str& fname);
};

#endif
