//==============================================================
//
// Dayedit
//
//==============================================================
#include "bcl_htmlhelp.h"
#include "bcl_mover.h"
#include "bcl_layout_ctrl.h"
#include "bcl_layout_horz.h"
#include "resouce.h"
#include "dayedit.h"

/// RXgN^
/// @param parent eEBhE
Dayedit::Dayedit(Bcl_wnd* parent) : Bcl_dlg(parent, "IDD_EDIT"), m_mode(MODE_ADD)
{
	ON_COMMAND(IDOK, Dayedit::on_ok);
	ON_COMMAND(IDCANCEL, Dayedit::on_cancel);
	ON_SIZE(Dayedit::on_size);
	ON_MSG(WM_HELP, Dayedit::on_help);
	ON_MSG(WM_GETMINMAXINFO, Dayedit::on_get_min_max_info);
}

/// WM_INITDIALOG̃bZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Dayedit::on_init(WPARAM wp, LPARAM lp)
{
	m_dtp_date.assign(this, IDC_DTP_DATE);
	m_edit_data.assign(this, IDC_EDIT_DATA);
	
	m_dtp_date.set_date(m_date);
	m_edit_data.set_text(m_data);
	if (m_mode == MODE_EDIT)
	{
		set_text("f[^ҏW");
	}
	m_width = get_width();
	m_height = get_height();

	m_layout.add_layout(new Bcl_layout_ctrl(&m_edit_data), true, true);
	Bcl_layout_horz* layout = new Bcl_layout_horz();
	layout->add_spring();
	layout->add_layout(new Bcl_layout_ctrl(this, IDOK), false, false);
	layout->add_layout(new Bcl_layout_ctrl(this, IDCANCEL), false, false);
	layout->add_spring();
	m_layout.add_layout(layout, true, false);
	m_layout.set_initial_size(0, 0, get_client_width(), get_client_height());
	move_center_of_parent();
}

/// WM_COMMAND(IDOK)̃bZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Dayedit::on_ok(WPARAM wp, LPARAM lp)
{
	m_date = m_dtp_date.get_date();
	m_data = m_edit_data.get_text();
	end_modal(true);
}

/// WM_COMMAND(IDCANCEL)̃bZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Dayedit::on_cancel(WPARAM wp, LPARAM lp)
{
	end_modal(false);
}

/// WM_SIZẼbZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Dayedit::on_size(WPARAM wp, LPARAM lp)
{
	Bcl_mover mover;
	m_layout.move(mover, 0, 0, LOWORD(lp), HIWORD(lp));
}

/// WM_HELP̃bZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Dayedit::on_help(WPARAM wp, LPARAM lp)
{
	Bcl_htmlhelp::get_instance()->open(HLP_IDH_ADD_DATA);
}

/// WM_GETMINMAXINFÕbZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Dayedit::on_get_min_max_info(WPARAM wp, LPARAM lp)
{
	LPMINMAXINFO lpmm;
	lpmm = (LPMINMAXINFO)lp;
	lpmm->ptMinTrackSize.x = m_width; 
	lpmm->ptMinTrackSize.y = m_height;
}

/// 
/// @param date t
/// @param data f[^
void Dayedit::init(const Bcl_date& date, const Bcl_str& data)
{
	m_date = date;
	m_data = data;
	m_mode = MODE_EDIT;
}

/// t擾
/// @return t
Bcl_date Dayedit::get_date() const
{
	return m_date;
}

/// f[^擾
/// @return f[^
Bcl_str Dayedit::get_data() const
{
	return m_data;
}
