//==============================================================
//
// Diary
//
//==============================================================
#include "bcl_citr.h"
#include "bcl_filedlg.h"
#include "bcl_binaryfile.h"
#include "bcl_menu.h"
#include "bcl_htmlhelp.h"
#include "resouce.h"
#include "diary.h"
#include "dayedit.h"
#include "ver.h"

/// RXgN^
Diary::Diary() : m_modify(false)
{
	ON_SIZE(Diary::on_size);
	ON_NOTIFY(Diary::on_notify);
	ON_COMMAND(IDM_NEW, Diary::on_new);
	ON_COMMAND(IDM_OPEN, Diary::on_open);
	ON_COMMAND(IDM_SAVE, Diary::on_save);
	ON_COMMAND(IDM_SAVEAS, Diary::on_saveas);
	ON_COMMAND(IDM_EXIT, Diary::on_close);
	ON_COMMAND(IDM_ADD, Diary::on_add);
	ON_COMMAND(IDM_EDIT, Diary::on_edit);
	ON_COMMAND(IDM_DEL, Diary::on_del);
	ON_COMMAND(IDM_HELP, Diary::on_topic);
	ON_COMMAND(IDM_VERSION, Diary::on_version);
	ON_MSG(WM_DROPFILES, Diary::on_drop_files);
	ON_MSG(WM_HELP, Diary::on_help);
}

/// WM_CREATEbZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Diary::on_create(WPARAM wp, LPARAM lp)
{
	DragAcceptFiles(m_handle, TRUE);

	m_tbar.create(this);
	m_tbar.add_bmp("IDI_TBEDITOR", 4);
	m_tbar.add_std_button(STD_FILENEW, IDM_NEW, TBSTATE_ENABLED, TBSTYLE_BUTTON, IDS_NEW);
	m_tbar.add_std_button(STD_FILEOPEN, IDM_OPEN, TBSTATE_ENABLED, TBSTYLE_BUTTON, IDS_OPEN);
	m_tbar.add_std_button(STD_FILESAVE, IDM_SAVE, TBSTATE_ENABLED, TBSTYLE_BUTTON, IDS_SAVE);
	m_tbar.add_separetor();
	m_tbar.add_user_button(IDM_ADD, TBSTATE_ENABLED, TBSTYLE_BUTTON, IDS_ADD);
	m_tbar.add_user_button(IDM_EDIT, 0, TBSTYLE_BUTTON, IDS_EDIT);
	m_tbar.add_user_button(IDM_DEL, 0, TBSTYLE_BUTTON, IDS_DEL);
	m_tbar.add_separetor();
	m_tbar.add_user_button(IDM_HELP, TBSTATE_ENABLED, TBSTYLE_BUTTON, IDS_HELP);
	m_tbar.show();
	m_tab.create(this, IDC_TAB);
	m_lv.set_single_select(true);
	m_lv.set_allways_select(true);
	m_lv.create(&m_tab, IDC_LISTVIEW);
	m_lv.add_column(200, "t");
	m_lv.add_column(400, "e");
	m_tab.add_page(&m_lv, "ꗗ");
	m_hs.create(&m_tab, IDC_HSPLIT);
	m_tv.create(&m_hs, IDC_TREEVIEW);
	m_edit.set_mode(EDIT_MODE_MULTI);
	m_edit.set_readonly(true);
	m_edit.create(&m_hs, IDC_EDIT);
	m_hs.set_window(&m_tv, &m_edit);
	m_tab.add_page(&m_hs, "ڍ");
	m_tab.set_cur_page(0);
}

/// WM_SIZEbZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Diary::on_size(WPARAM wp, LPARAM lp)
{
	m_tbar.auto_size();
	m_tab.move(0, m_tbar.get_height(), LOWORD(lp), HIWORD(lp) - m_tbar.get_height());
}

/// WM_NOTIFYbZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Diary::on_notify(WPARAM wp, LPARAM lp)
{
	m_tbar.show_tooltip((LPTOOLTIPTEXT)lp);
	if (wp == IDC_TAB)
	{
		if (((NMHDR *)lp)->code == TCN_SELCHANGE)
		{
			m_tab.changed_page();
		}
		change_menu_status();
	}
	else if (wp == IDC_LISTVIEW)
	{
		LV_DISPINFO* plv_disp = (LV_DISPINFO*)lp;
		if (plv_disp->hdr.code == LVN_ITEMCHANGED)
		{
			change_menu_status();
		}
		else if ((plv_disp->hdr.code == NM_DBLCLK) || (plv_disp->hdr.code == NM_RETURN))
		{
			int sel = m_lv.get_next_item(-1, LVNI_ALL | LVNI_SELECTED);
			if (sel != -1)
			{
				on_edit(wp, lp);
			}
		}
	}
	else if (wp == IDC_TREEVIEW)
	{
		TV_DISPINFO* ptv_disp = (TV_DISPINFO*)lp;
		if (ptv_disp->hdr.code == TVN_SELCHANGED)
		{
			HTREEITEM item = m_tv.get_selection();
			if (m_tv_data.find(item) != m_tv_data.end())
			{
				m_edit.set_text(m_tv_data[item]->second);
			}
			else
			{
				m_edit.set_text("");
			}
			change_menu_status();
		}
		else if ((ptv_disp->hdr.code == NM_DBLCLK) || (ptv_disp->hdr.code == NM_RETURN))
		{
			if (m_tv_data.find(m_tv.get_selection()) != m_tv_data.end())
			{
				on_edit(wp, lp);
			}
		}
	}
}

/// WM_COMMAND(IDM_NEW)bZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Diary::on_new(WPARAM wp, LPARAM lp)
{
	if (modify_chk() == true)
	{
		m_modify = false;
		m_fname = "";
		m_data.clear();
		display_lv();
		display_tv();
		change_title();
		change_menu_status();
	}
}

/// WM_COMMAND(IDM_OPEN)bZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Diary::on_open(WPARAM wp, LPARAM lp)
{
	if (modify_chk() == true)
	{
		Bcl_filedlg dlg(this);
		dlg.add_filter("Lt@C", "*.dly");
		dlg.add_filter("ׂẴt@C", "*.*");
		if (dlg.do_modal() == true)
		{
			Bcl_str fname = dlg.get_fname();
			if (is_open(fname))
			{
				return;
			}
			load(fname);
		}
	}
}

/// WM_COMMAND(IDM_SAVE)bZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Diary::on_save(WPARAM wp, LPARAM lp)
{
	if (m_fname == "")
	{
		on_saveas(wp, lp);
	}
	else
	{
		save(m_fname);
	}
}

/// WM_COMMAND(IDM_SAVEAS)bZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Diary::on_saveas(WPARAM wp, LPARAM lp)
{
	Bcl_filedlg dlg(this);
	dlg.set_mode(MODE_SAVE);
	dlg.add_filter("Lt@C", "*.dly");
	dlg.add_filter("ׂẴt@C", "*.*");
	if (dlg.do_modal() == true)
	{
		save(dlg.get_fname());
	}
}

/// WM_COMMAND(IDM_ADD)bZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Diary::on_add(WPARAM wp, LPARAM lp)
{
	Dayedit dlg(this);
	if (dlg.do_modal() == true)
	{
		std::multimap<Bcl_date, Bcl_str>::iterator itr = m_data.insert(std::multimap<Bcl_date, Bcl_str>::value_type(dlg.get_date(), dlg.get_data()));
		int sel = std::distance(m_data.begin(), itr);
		m_lv.insert_item(sel, itr->first.get_string(DATE_FMT_SPACE_WEEK));
		m_lv.set_item(sel, 1, get_line_str(itr->second));
		HTREEITEM tree = add_tree_item(itr);
		if (m_tab.get_cur_page() == 0)
		{
			m_lv.ensure_visible(sel, false);
			m_lv.set_item_state(sel, LVIS_FOCUSED | LVIS_SELECTED, LVIS_FOCUSED | LVIS_SELECTED );
			m_lv.set_focus();
		}
		else
		{
			m_tv.select_item(tree);
			m_tv.invalidate(true);
			m_edit.set_text(itr->second);
			m_tv.set_focus();
		}
		change_menu_status();
		m_modify = true;
		change_title();
	}
}

/// WM_COMMAND(IDM_EDIT)bZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Diary::on_edit(WPARAM wp, LPARAM lp)
{
	std::multimap<Bcl_date, Bcl_str>::iterator itr;
	int sel;
	HTREEITEM tree;
	if (m_tab.get_cur_page() == 0)
	{
		sel = m_lv.get_next_item(-1, LVNI_ALL | LVNI_SELECTED);
		itr = m_data.begin();
		std::advance(itr, sel);
		Bcl_citr< std::map<HTREEITEM, std::multimap<Bcl_date, Bcl_str>::iterator> > tree_itr(m_tv_data);
		while (tree_itr.has_next())
		{
			const std::map<HTREEITEM, std::multimap<Bcl_date, Bcl_str>::iterator>::value_type& tree_data = tree_itr.next();
			if (tree_data.second == itr)
			{
				tree = tree_data.first;
				break;
			}
		}
	}
	else
	{
		tree = m_tv.get_selection();
		itr = m_tv_data[tree];
		sel = std::distance(m_data.begin(), itr);
	}
	Dayedit dlg(this);
	dlg.init(itr->first, itr->second);
	if (dlg.do_modal() == true)
	{
		if (itr->first == dlg.get_date())
		{
			itr->second = dlg.get_data();
			m_lv.set_item(sel, 1, get_line_str(itr->second));
			HTREEITEM item = m_tv.get_selection();
			if (m_tv_data.find(item) != m_tv_data.end())
			{
				m_edit.set_text(m_tv_data[item]->second);
			}
			else
			{
				m_edit.set_text("");
			}
		}
		else
		{
			m_lv.delete_item(sel);
			delete_tree_item(tree);
			m_data.erase(itr);
			itr = m_data.insert(std::multimap<Bcl_date, Bcl_str>::value_type(dlg.get_date(), dlg.get_data()));
			sel = std::distance(m_data.begin(), itr);
			m_lv.insert_item(sel, itr->first.get_string(DATE_FMT_SPACE_WEEK));
			m_lv.set_item(sel, 1, get_line_str(itr->second));
			HTREEITEM tree = add_tree_item(itr);
			if (m_tab.get_cur_page() == 0)
			{
				m_lv.ensure_visible(sel, false);
				m_lv.set_item_state(sel, LVIS_FOCUSED | LVIS_SELECTED, LVIS_FOCUSED | LVIS_SELECTED );
				m_lv.set_focus();
			}
			else
			{
				m_tv.select_item(tree);
				m_tv.invalidate(true);
				m_edit.set_text(itr->second);
				m_tv.set_focus();
			}
		}
		m_modify = true;
		change_title();
	}
}

/// WM_COMMAND(IDM_DEL)bZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Diary::on_del(WPARAM wp, LPARAM lp)
{
	if (MessageBox(m_handle, "폜ĂłH", "mF", MB_YESNO) == IDYES)
	{
		std::multimap<Bcl_date, Bcl_str>::iterator itr;
		int sel;
		HTREEITEM tree;
		if (m_tab.get_cur_page() == 0)
		{
			sel = m_lv.get_next_item(-1, LVNI_ALL | LVNI_SELECTED);
			itr = m_data.begin();
			std::advance(itr, sel);
			Bcl_citr< std::map<HTREEITEM, std::multimap<Bcl_date, Bcl_str>::iterator> > tree_itr(m_tv_data);
			while (tree_itr.has_next())
			{
				const std::map<HTREEITEM, std::multimap<Bcl_date, Bcl_str>::iterator>::value_type& tree_data = tree_itr.next();
				if (tree_data.second == itr)
				{
					tree = tree_data.first;
					break;
				}
			}
		}
		else
		{
			tree = m_tv.get_selection();
			itr = m_tv_data[tree];
			sel = std::distance(m_data.begin(), itr);
		}
		m_lv.delete_item(sel);
		delete_tree_item(tree);
		m_data.erase(itr);
		if (m_tab.get_cur_page() == 0)
		{
			if (!m_data.empty())
			{
				if (sel >= (int)m_data.size())
				{
					sel--;
				}
				m_lv.ensure_visible(sel, false);
				m_lv.set_item_state(sel, LVIS_FOCUSED | LVIS_SELECTED, LVIS_FOCUSED | LVIS_SELECTED );
				m_lv.set_focus();
			}
		}
		m_modify = true;
		change_title();
	}
}

/// WM_COMMAND(IDM_HELP)bZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Diary::on_topic(WPARAM wp, LPARAM lp)
{
	Bcl_htmlhelp::get_instance()->open();
}

/// WM_COMMAND(IDM_VERSION)bZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Diary::on_version(WPARAM wp, LPARAM lp)
{
	Ver dlg(this);
	dlg.do_modal();
}

/// WM_CLOSEbZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Diary::on_close(WPARAM wp, LPARAM lp)
{
	if (modify_chk() == true)
	{
		Bcl_sdi::on_close(wp, lp);
	}
}

/// WM_DROPFILESbZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Diary::on_drop_files(WPARAM wp, LPARAM lp)
{
	HDROP hdrop;
	UINT file_no;
	char file_name[256];
	
	set_foreground_window();
	hdrop = (HDROP)wp;
	file_no = DragQueryFile(hdrop, 0xFFFFFFFF, NULL, 0);
	if ((int)file_no > 0)
	{
		DragQueryFile(hdrop, 0, file_name, sizeof(file_name));
		Bcl_str fname(file_name);
		if ((fname.left(1) == "\"") && (fname.right(1) == "\""))
		{
			fname = fname.mid(1, fname.get_length() - 2);
		}
		if (is_open(fname))
		{
			return;
		}
		if (!modify_chk())
		{
			return;
		}
		load(fname);
	}
}

/// WM_HELPbZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Diary::on_help(WPARAM wp, LPARAM lp)
{
	if (m_tab.get_cur_page() == 0)
	{
		Bcl_htmlhelp::get_instance()->open(HLP_IDH_LIST);
	}
	else
	{
		Bcl_htmlhelp::get_instance()->open(HLP_IDH_DETAIL);
	}
}

/// Xgr[\
void Diary::display_lv()
{
	m_lv.delete_all_items();
	int row = 0;
	Bcl_citr< std::multimap<Bcl_date, Bcl_str> > itr(m_data);
	while (itr.has_next())
	{
		const std::multimap<Bcl_date, Bcl_str>::value_type& data = itr.next();
		m_lv.insert_item(row, data.first.get_string(DATE_FMT_SPACE_WEEK));
		m_lv.set_item(row, 1, get_line_str(data.second));
		row++;
	}
}

/// c[r[\
void Diary::display_tv()
{
	HTREEITEM item = m_tv.get_child(NULL);
	while (item != NULL)
	{
		HTREEITEM next_item = m_tv.get_next(item);
		m_tv.delete_item(item);
		item = next_item;
	}
	m_tv_data.clear();
	int year = 0;
	int month = 0;
	HTREEITEM year_item;
	HTREEITEM month_item;
	std::multimap<Bcl_date, Bcl_str>::iterator itr = m_data.begin();
	std::multimap<Bcl_date, Bcl_str>::iterator itr_end = m_data.end();
	for (; itr != itr_end; ++itr)
	{
		if (year < itr->first.get_year())
		{
			year = itr->first.get_year();
			year_item = m_tv.insert_item((Bcl_str(year, RADIX_DEC) + "N"));
			month = 0;
		}
		if (month < itr->first.get_month())
		{
			month = itr->first.get_month();
			month_item = m_tv.insert_item((Bcl_str(month, RADIX_DEC) + ""), year_item);
		}
		HTREEITEM item = m_tv.insert_item((Bcl_str(itr->first.get_day(), RADIX_DEC) + ""), month_item);
		m_tv_data[item] = itr;
	}
}

/// Psɂ擾
/// @param str 
/// @return 
Bcl_str Diary::get_line_str(const Bcl_str& str)
{
	Bcl_str all_str = str;
	Bcl_str line_str;
	while (all_str.has_next_line())
	{
		line_str += all_str.next_line();
		if (all_str.has_next_line()) line_str += " ";
	}
	return line_str;
}

/// ۑ
/// @param fname t@C
void Diary::save(const Bcl_str& fname)
{
	Bcl_binaryfile file;
	file.open_write(fname);
	file.char_write('D');
	file.char_write('L');
	file.char_write('Y');
	file.int_write(100, 2);
	file.int_write(100, 2);
	file.int_write(m_data.size(), 2);
	Bcl_citr< std::multimap<Bcl_date, Bcl_str> > itr(m_data);
	while (itr.has_next())
	{
		const std::multimap<Bcl_date, Bcl_str>::value_type& data = itr.next();
		file.date_write(data.first);
		file.str_write(data.second, 2);
	}
	file.close();
	m_fname = fname;
	m_modify = false;
	change_title();
}

/// ǂݍ
/// @param fname t@C
/// @return 
bool Diary::load(const Bcl_str& fname)
{
	m_data.clear();
	Bcl_binaryfile file;
	file.open_read(fname);
	Bcl_str sign;
	char c;
	file.char_read(&c);
	sign = c;
	file.char_read(&c);
	sign += c;
	file.char_read(&c);
	sign += c;
	if (sign != "DLY")
	{
		Bcl_str msg(fname);
		msg += "́AL̃t@Cł͂܂B";
		MessageBox(m_handle, msg.to_char(), "f[^ُ", MB_OK);
		return false;
	}
	long val;
	file.int_read(2, &val);
	int data_ver = val;
	file.int_read(2, &val);
	int prg_ver = val;
	if (data_ver > 100)
	{
		Bcl_str msg;
		msg.format("%s͂̃vOł͓ǂ߂܂B\nvOo[W%d.%02dȍ~gpB", fname.to_char(), prg_ver / 100, prg_ver % 100);
		MessageBox(m_handle, msg.to_char(), "f[^ُ", MB_OK);
		return false;
	}
	file.int_read(2, &val);
	int size = val;
	for (int i = 0; i < size; i++)
	{
		Bcl_date date;
		Bcl_str data;
		file.date_read(&date);
		file.str_read(&data, 2);
		m_data.insert(std::multimap<Bcl_date, Bcl_str>::value_type(date, data));
	}
	file.close();
	display_lv();
	display_tv();
	m_fname = fname;
	m_modify = false;
	change_title();
	return true;
}

/// t@CJĂ邩ǂ肵AJĂ炻̃EBhEANeBuɂ
/// @param fname t@C
/// @return t@CJĂ邩
bool Diary::is_open(const Bcl_str& fname)
{
	Bcl_str title("L - ");
	title += fname;
	HWND handle = FindWindow("DiaryMainWnd", title.to_char());
	if (handle == NULL)
	{
		title = title + " *";
		handle = FindWindow("DiaryMainWnd", title.to_char());
	}
	if (handle != NULL)
	{
		if(IsIconic(handle))
		{
			ShowWindow(handle, SW_RESTORE);
		}
		SetForegroundWindow(handle);
		return true;
	}
	return false;
}

/// j[̏ԕύX
void Diary::change_menu_status()
{
	Bcl_menu menu(this);
	Bcl_menu sub_menu = menu.get_sub_menu(1);
	bool flag = true;
	if (m_tab.get_cur_page() == 0)
	{
		int sel_item = m_lv.get_next_item(-1, LVNI_ALL | LVNI_SELECTED);
		if (sel_item == -1)
		{
			flag = false;
		}
	}
	else
	{
		if (m_tv_data.find(m_tv.get_selection()) == m_tv_data.end())
		{
			flag = false;
		}
	}
	sub_menu.set_enabled_by_cmd(IDM_EDIT, flag);
	sub_menu.set_enabled_by_cmd(IDM_DEL, flag);
	m_tbar.set_enabled(IDM_EDIT, flag);
	m_tbar.set_enabled(IDM_DEL, flag);
}

/// EBhE^CgύX
void Diary::change_title()
{
	Bcl_str title("L - ");
	if (m_fname == "")
	{
		title += "";
	}
	else
	{
		title += m_fname;
	}
	if (m_modify)
	{
		title += " *";
	}
	set_text(title);

}

/// ύX`FbN܂
/// @return 
bool Diary::modify_chk()
{
	if (m_modify)
	{
		Bcl_str msg;
		if (m_fname == "")
		{
			msg = "";
		}
		else
		{
			msg = m_fname;
		}
		msg += "͍XVĂ܂Bۑ܂H";
		int rtn = MessageBox(m_handle, msg.to_char(), "mF", MB_YESNOCANCEL | MB_ICONEXCLAMATION);
		if (rtn == IDYES)
		{
			if (m_fname == "")
			{
				Bcl_filedlg dlg(this);
				dlg.set_mode(MODE_SAVE);
				if (dlg.do_modal() == true)
				{
					save(dlg.get_fname());
				}
				else
				{
					return false;
				}
			}
			else
			{
				save(m_fname);
			}
		}
		else if (rtn == IDCANCEL)
		{
			return false;
		}
	}
	return true;
}

/// c[ɃACeǉ܂
/// @param itr ACe
/// @return ǉACe
HTREEITEM Diary::add_tree_item(std::multimap<Bcl_date, Bcl_str>::iterator itr)
{
	HTREEITEM tree = m_tv.get_child(NULL);
	HTREEITEM after = TVI_FIRST;
	while (tree != NULL)
	{
		if (m_tv.get_text(tree).to_number(RADIX_DEC) >= itr->first.get_year())
		{
			break;
		}
		after = tree;
		tree = m_tv.get_next(tree);
	}
	if (tree == NULL)
	{
		tree = m_tv.insert_item(Bcl_str(itr->first.get_year(), RADIX_DEC) + "N");
	}
	else if (m_tv.get_text(tree).to_number(RADIX_DEC) > itr->first.get_year())
	{
		tree = m_tv.insert_item(Bcl_str(itr->first.get_year(), RADIX_DEC) + "N", TVI_ROOT, after);
	}
	HTREEITEM ytree = tree;
	tree = m_tv.get_child(ytree);
	after = TVI_FIRST;
	while (tree != NULL)
	{
		if (m_tv.get_text(tree).to_number(RADIX_DEC) >= itr->first.get_month())
		{
			break;
		}
		after = tree;
		tree = m_tv.get_next(tree);
	}
	if (tree == NULL)
	{
		tree = m_tv.insert_item(Bcl_str(itr->first.get_month(), RADIX_DEC) + "", ytree);
	}
	else if (m_tv.get_text(tree).to_number(RADIX_DEC) > itr->first.get_month())
	{
		tree = m_tv.insert_item(Bcl_str(itr->first.get_month(), RADIX_DEC) + "", ytree, after);
	}
	HTREEITEM mtree = tree;
	tree = m_tv.get_child(mtree);
	after = TVI_FIRST;
	while (tree != NULL)
	{
		if (m_tv.get_text(tree).to_number(RADIX_DEC) > itr->first.get_day())
		{
			break;
		}
		after = tree;
		tree = m_tv.get_next(tree);
	}
	if (tree == NULL)
	{
		after = TVI_LAST;
	}
	tree = m_tv.get_child(mtree);
	tree = m_tv.insert_item((Bcl_str(itr->first.get_day(), RADIX_DEC) + ""), mtree, after);
	m_tv_data[tree] = itr;
	return tree;
}

/// c[̃ACe폜܂
/// @param item ACe
void Diary::delete_tree_item(HTREEITEM item)
{
	HTREEITEM mtree = m_tv.get_parent(item);
	HTREEITEM ytree = m_tv.get_parent(mtree);
	m_tv.delete_item(item);
	if (m_tv.get_child(mtree) == NULL)
	{
		m_tv.delete_item(mtree);
		if (m_tv.get_child(ytree) == NULL)
		{
			m_tv.delete_item(ytree);
		}
	}
}
