//==============================================================
//
// Bcl_bmp
//
//==============================================================
#ifndef _BCL_BMP_H_
#define _BCL_BMP_H_

#include "bcl_typedef.h"
#include "bcl_str.h"

class Bcl_wnd;

/// BITMAPpNX
class Bcl_bmp
{
	HBITMAP m_bmp;
	BITMAP m_info;
	PBITMAPINFO 		m_header;
	PBITMAPFILEHEADER	m_file_header;
	WORD m_col_bit;
	
	
	void copy(const Bcl_bmp& ref);
	void get_bmp_info();
	void get_bmp_info(const Bcl_str& fname);
public:
	Bcl_bmp();
	Bcl_bmp(const Bcl_bmp& ref);
	Bcl_bmp& operator=(const Bcl_bmp& ref);
	~Bcl_bmp();
	bool load(Bcl_wnd* parent, LPCTSTR bmp_name, bool flag = false);
	bool is_valid() const;
	void set_handle(HBITMAP bmp);
	HBITMAP get_handle() const;
	int get_type() const;
	long get_width() const;
	long get_height() const;
	long get_width_bytes() const;
	BYTE get_planes() const;
	BYTE get_bits_pixel() const;
	LPVOID get_bits() const;
	WORD get_color_bit() const;
	WORD get_file_type() const;
	DWORD get_file_size() const;
	WORD get_file_reserved1() const;
	WORD get_file_reserved2() const;
	DWORD get_file_offset_bit() const;
	DWORD get_header_size() const;
	WORD get_bit_count() const;
	DWORD get_compression() const;
	DWORD get_size_image() const;
	LONG get_pixel_pre_meter_x() const;
	LONG get_pixel_pre_meter_y() const;
	DWORD get_color_used() const;
	DWORD get_color_important() const;
	void save(const Bcl_str& fname);
	void save(const Bcl_str& fname, WORD col_bit);

};

#endif
