//==============================================================
//
// Bcl_date
//
//==============================================================
#ifndef _BCL_DATE_H_
#define _BCL_DATE_H_

class Bcl_str;

enum DATE_FORMAT
{
	DATE_FMT_TRIM,
	DATE_FMT_ZERO,
	DATE_FMT_SPACE,
	DATE_FMT_TRIM_WEEK,
	DATE_FMT_ZERO_WEEK,
	DATE_FMT_SPACE_WEEK,
	DATE_FMT_TRIM_ENG_WEEK,
	DATE_FMT_ZERO_ENG_WEEK,
	DATE_FMT_SPACE_ENG_WEEK
};

/// tNX
class Bcl_date
{
	friend class Bcl_binaryfile;
	
	unsigned long m_date;
	static int max_day[];

	void set_date(int year, int month, int day);
	bool is_uru(int year) const;
	void get_date(int& year, int& month, int& day) const;
public:
	Bcl_date();
	Bcl_date(int year, int month, int day);
	~Bcl_date();
	Bcl_str get_string(DATE_FORMAT fmt) const;
	int get_year() const;
	int get_month() const;
	int get_day() const;
	char get_week() const;
	Bcl_str get_week_str() const;
	Bcl_str get_week_english_str() const;
	bool operator<(const Bcl_date& rhs) const;
	bool operator<=(const Bcl_date& rhs) const;
	bool operator>(const Bcl_date& rhs) const;
	bool operator>=(const Bcl_date& rhs) const;
	bool operator==(const Bcl_date& rhs) const;
	bool operator!=(const Bcl_date& rhs) const;
	Bcl_date& operator++();
	Bcl_date operator++(int dmy);
	Bcl_date& operator--();
	Bcl_date operator--(int dmy);
	Bcl_date operator+(int x) const;
	Bcl_date& operator+=(int x);
	Bcl_date operator-(int x) const;
	long operator-(const Bcl_date& x) const;
	Bcl_date& operator-=(int x);
};

#endif
