//==============================================================
//
// Bcl_dlg
//
//==============================================================
#ifndef _BCL_DLG_H_
#define _BCL_DLG_H_

#include "bcl_wnd.h"
#include "bcl_str.h"

/// _CAO쐬pNX
class Bcl_dlg : public Bcl_wnd
{
	Bcl_wnd* m_parent;
	Bcl_str m_name;
	HACCEL m_accel;
	bool m_modal;
	bool m_dlg_proc_rtn;
	
	static BOOL CALLBACK modal_dlg_proc(HWND handle, UINT msg, WPARAM wp, LPARAM lp);
	static BOOL CALLBACK modeless_dlg_proc(HWND handle, UINT msg, WPARAM wp, LPARAM lp);

protected:
	void end_modal(int rtn);
	virtual void on_init(WPARAM wp, LPARAM lp);
	virtual void on_close(WPARAM wp, LPARAM lp);
	virtual bool is_change_focus();
	void move_center_of_parent();
	void change_no_proc();
	void set_drag_accept_files(bool flag);

public:
	Bcl_dlg(Bcl_wnd* parent, const Bcl_str& name);
	Bcl_dlg(HINSTANCE instance, const Bcl_str& name);
	virtual ~Bcl_dlg();
	int do_modal();
	bool create();
	bool include_accel(LPCTSTR name);
	UINT loop();
	bool is_only_one(char* uniq_name) const;
	bool is_zoomed() const;
};
#endif
