//==============================================================
//
// Bcl_dtpicker
//
//==============================================================
#ifndef _BCL_DTPICKER_H_
#define _BCL_DTPICKER_H_

#ifndef USE_SYSTEM_DTPICKER
#pragma comment(lib,"imm32.lib")
#endif

#include "bcl_ctrl.h"
#include "bcl_date.h"
#include "bcl_time.h"
#ifndef USE_SYSTEM_DTPICKER
#include "bcl_button.h"
#include "bcl_edit.h"
#include "bcl_monthcal.h"
#include "bcl_udctrl.h"

class Bcl_dtpicker;

/// Date Time Pickerp`FbN{bNXNX
class Bcl_dtp_chk : public Bcl_button
{
	WNDPROC m_org_proc;
	Bcl_dtpicker* m_dtp_parent;
	bool m_is_chk;
	static std::map<HWND, Bcl_dtp_chk*> m_dtp_chk_list;

	void on_sys_key_down(WPARAM wp, LPARAM lp);
	void on_key_down(WPARAM wp, LPARAM lp);

public:
	Bcl_dtp_chk();
	virtual ~Bcl_dtp_chk();
	bool create(Bcl_dtpicker* parent, int id, int x, int y, int w, int h);
	bool is_checked() const;
	void set_check(bool chk);
	static LRESULT CALLBACK dtp_chk_proc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp);

};

class Bcl_dtp_edit;

/// Date Time Pickerp̓C^[tF[X
class Bcl_dtp_analyze
{
public:
	virtual int get_length(bool is_current) = 0;
	virtual bool is_select_target() = 0;
	virtual int get_select_start(Bcl_dtp_edit* parent) = 0;
	virtual void calc(Bcl_dtp_edit* parent, int val) = 0;
	virtual Bcl_str get_text(Bcl_dtp_edit* parent, bool is_current) = 0;
	virtual void on_char(Bcl_dtp_edit* parent, char ch) = 0;
	virtual void analyze_char(Bcl_dtp_edit* parent, int num) = 0;
};

/// Date Time Pickerp͒ۃNX
class Bcl_dtp_analyze_abst : public Bcl_dtp_analyze
{
	bool m_is_select_target;

protected:
	int get_max_day(int year, int month);
	void calc_min_or_max_date(Bcl_dtp_edit* parent, const Bcl_date& date);
	void calc_min_or_max_time(Bcl_dtp_edit* parent, const Bcl_time& time);

public:
	Bcl_dtp_analyze_abst(bool is_select_target);
	virtual bool is_select_target();
};

/// Date Time Pickerp͂ȂNX
class Bcl_dtp_analyze_none : public Bcl_dtp_analyze_abst
{
	Bcl_str m_str;
public:
	Bcl_dtp_analyze_none(bool is_select_target, const Bcl_str& str);
	virtual int get_length(bool is_current);
	int get_select_start(Bcl_dtp_edit* parent);
	virtual void calc(Bcl_dtp_edit* parent, int val);
	virtual Bcl_str get_text(Bcl_dtp_edit* parent, bool is_current);
	virtual void on_char(Bcl_dtp_edit* parent, char ch);
	virtual void analyze_char(Bcl_dtp_edit* parent, int num);
};

/// Date Time PickerpN̓NX
class Bcl_dtp_analyze_abst_year : public Bcl_dtp_analyze_abst
{
public:
	Bcl_dtp_analyze_abst_year(bool is_select_target);
	int get_select_start(Bcl_dtp_edit* parent);
	virtual void calc(Bcl_dtp_edit* parent, int val);
	virtual void on_char(Bcl_dtp_edit* parent, char ch);
	virtual void analyze_char(Bcl_dtp_edit* parent, int num);
};

/// Date Time PickerpNi4j̓NX
class Bcl_dtp_analyze_year4 : public Bcl_dtp_analyze_abst_year
{
public:
	Bcl_dtp_analyze_year4(bool is_select_target);
	virtual int get_length(bool is_current);
	virtual Bcl_str get_text(Bcl_dtp_edit* parent, bool is_current);
};

/// Date Time PickerpNi2j̓NX
class Bcl_dtp_analyze_year2 : public Bcl_dtp_analyze_abst_year
{
public:
	Bcl_dtp_analyze_year2(bool is_select_target);
	virtual int get_length(bool is_current);
	virtual Bcl_str get_text(Bcl_dtp_edit* parent, bool is_current);
};

/// Date Time PickerpNi1܂2j̓NX
class Bcl_dtp_analyze_year1 : public Bcl_dtp_analyze_abst_year
{
public:
	Bcl_dtp_analyze_year1(bool is_select_target);
	virtual int get_length(bool is_current);
	virtual Bcl_str get_text(Bcl_dtp_edit* parent, bool is_current);
};

/// Date Time Pickerp̓NX
class Bcl_dtp_analyze_abst_month : public Bcl_dtp_analyze_abst
{
public:
	Bcl_dtp_analyze_abst_month(bool is_select_target);
	virtual void calc(Bcl_dtp_edit* parent, int val);
	virtual void on_char(Bcl_dtp_edit* parent, char ch);
	virtual void analyze_char(Bcl_dtp_edit* parent, int num);
};

/// Date Time Pickerpi2+j̓NX
class Bcl_dtp_analyze_month2_str : public Bcl_dtp_analyze_abst_month
{
public:
	Bcl_dtp_analyze_month2_str(bool is_select_target);
	virtual int get_length(bool is_current);
	int get_select_start(Bcl_dtp_edit* parent);
	virtual Bcl_str get_text(Bcl_dtp_edit* parent, bool is_current);
};

/// Date Time Pickerpi1܂2+j̓NX
class Bcl_dtp_analyze_month1_str : public Bcl_dtp_analyze_abst_month
{
public:
	Bcl_dtp_analyze_month1_str(bool is_select_target);
	virtual int get_length(bool is_current);
	int get_select_start(Bcl_dtp_edit* parent);
	virtual Bcl_str get_text(Bcl_dtp_edit* parent, bool is_current);
};

/// Date Time Pickerpi2j̓NX
class Bcl_dtp_analyze_month2 : public Bcl_dtp_analyze_abst_month
{
public:
	Bcl_dtp_analyze_month2(bool is_select_target);
	virtual int get_length(bool is_current);
	int get_select_start(Bcl_dtp_edit* parent);
	virtual Bcl_str get_text(Bcl_dtp_edit* parent, bool is_current);
};

/// Date Time Pickerpi1܂2j̓NX
class Bcl_dtp_analyze_month1 : public Bcl_dtp_analyze_abst_month
{
public:
	Bcl_dtp_analyze_month1(bool is_select_target);
	virtual int get_length(bool is_current);
	int get_select_start(Bcl_dtp_edit* parent);
	virtual Bcl_str get_text(Bcl_dtp_edit* parent, bool is_current);
};

/// Date Time Pickerp̓NX
class Bcl_dtp_analyze_abst_day : public Bcl_dtp_analyze_abst
{
public:
	Bcl_dtp_analyze_abst_day(bool is_select_target);
	virtual int get_length(bool is_current);
	virtual void calc(Bcl_dtp_edit* parent, int val);
	virtual void on_char(Bcl_dtp_edit* parent, char ch);
	virtual void analyze_char(Bcl_dtp_edit* parent, int num);
};

/// Date Time Pickerpi2j̓NX
class Bcl_dtp_analyze_day2 : public Bcl_dtp_analyze_abst_day
{
public:
	Bcl_dtp_analyze_day2(bool is_select_target);
	int get_select_start(Bcl_dtp_edit* parent);
	virtual Bcl_str get_text(Bcl_dtp_edit* parent, bool is_current);
};

/// Date Time Pickerpi1܂2j̓NX
class Bcl_dtp_analyze_day1 : public Bcl_dtp_analyze_abst_day
{
public:
	Bcl_dtp_analyze_day1(bool is_select_target);
	int get_select_start(Bcl_dtp_edit* parent);
	virtual Bcl_str get_text(Bcl_dtp_edit* parent, bool is_current);
};

/// Date Time Pickerpj̓NX
class Bcl_dtp_analyze_abst_week : public Bcl_dtp_analyze_abst
{
public:
	Bcl_dtp_analyze_abst_week(bool is_select_target);
	int get_select_start(Bcl_dtp_edit* parent);
	virtual void calc(Bcl_dtp_edit* parent, int val);
	virtual void on_char(Bcl_dtp_edit* parent, char ch);
	virtual void analyze_char(Bcl_dtp_edit* parent, int num);
};

/// Date Time Pickerpj̓NX
class Bcl_dtp_analyze_long_week : public Bcl_dtp_analyze_abst_week
{
public:
	Bcl_dtp_analyze_long_week(bool is_select_target);
	virtual int get_length(bool is_current);
	virtual Bcl_str get_text(Bcl_dtp_edit* parent, bool is_current);
};

/// Date Time PickerpZj̓NX
class Bcl_dtp_analyze_short_week : public Bcl_dtp_analyze_abst_week
{
public:
	Bcl_dtp_analyze_short_week(bool is_select_target);
	virtual int get_length(bool is_current);
	virtual Bcl_str get_text(Bcl_dtp_edit* parent, bool is_current);
};

/// Date Time Pickerpԁi24ԕ\Lj̓NX
class Bcl_dtp_analyze_abst_24h_hour : public Bcl_dtp_analyze_abst
{
public:
	Bcl_dtp_analyze_abst_24h_hour(bool is_select_target);
	virtual int get_length(bool is_current);
	virtual void calc(Bcl_dtp_edit* parent, int val);
	virtual void on_char(Bcl_dtp_edit* parent, char ch);
	virtual void analyze_char(Bcl_dtp_edit* parent, int num);
};

/// Date Time Pickerpԁi24ԕ\L2j̓NX
class Bcl_dtp_analyze_24h_hour2 : public Bcl_dtp_analyze_abst_24h_hour
{
public:
	Bcl_dtp_analyze_24h_hour2(bool is_select_target);
	int get_select_start(Bcl_dtp_edit* parent);
	virtual Bcl_str get_text(Bcl_dtp_edit* parent, bool is_current);
};

/// Date Time Pickerpԁi24ԕ\L1܂2j̓NX
class Bcl_dtp_analyze_24h_hour1 : public Bcl_dtp_analyze_abst_24h_hour
{
public:
	Bcl_dtp_analyze_24h_hour1(bool is_select_target);
	int get_select_start(Bcl_dtp_edit* parent);
	virtual Bcl_str get_text(Bcl_dtp_edit* parent, bool is_current);
};

/// Date Time Pickerpԁi12ԕ\Lj̓NX
class Bcl_dtp_analyze_abst_12h_hour : public Bcl_dtp_analyze_abst
{
public:
	Bcl_dtp_analyze_abst_12h_hour(bool is_select_target);
	virtual int get_length(bool is_current);
	virtual void calc(Bcl_dtp_edit* parent, int val);
	virtual void on_char(Bcl_dtp_edit* parent, char ch);
	virtual void analyze_char(Bcl_dtp_edit* parent, int num);
};

/// Date Time Pickerpԁi12ԕ\L2j̓NX
class Bcl_dtp_analyze_12h_hour2 : public Bcl_dtp_analyze_abst_12h_hour
{
public:
	Bcl_dtp_analyze_12h_hour2(bool is_select_target);
	int get_select_start(Bcl_dtp_edit* parent);
	virtual Bcl_str get_text(Bcl_dtp_edit* parent, bool is_current);
};

/// Date Time Pickerpԁi12ԕ\L1܂2j̓NX
class Bcl_dtp_analyze_12h_hour1 : public Bcl_dtp_analyze_abst_12h_hour
{
public:
	Bcl_dtp_analyze_12h_hour1(bool is_select_target);
	int get_select_start(Bcl_dtp_edit* parent);
	virtual Bcl_str get_text(Bcl_dtp_edit* parent, bool is_current);
};

/// Date Time Pickerpԋ敪̓NX
class Bcl_dtp_analyze_abst_time_division : public Bcl_dtp_analyze_abst
{
public:
	Bcl_dtp_analyze_abst_time_division(bool is_select_target);
	int get_select_start(Bcl_dtp_edit* parent);
	virtual void calc(Bcl_dtp_edit* parent, int val);
	virtual void on_char(Bcl_dtp_edit* parent, char ch);
	virtual void analyze_char(Bcl_dtp_edit* parent, int num);
};

/// Date Time Pickerpԋ敪̓NX
class Bcl_dtp_analyze_long_time_division : public Bcl_dtp_analyze_abst_time_division
{
public:
	Bcl_dtp_analyze_long_time_division(bool is_select_target);
	virtual int get_length(bool is_current);
	virtual Bcl_str get_text(Bcl_dtp_edit* parent, bool is_current);
};

/// Date Time PickerpZԋ敪̓NX
class Bcl_dtp_analyze_short_time_division : public Bcl_dtp_analyze_abst_time_division
{
public:
	Bcl_dtp_analyze_short_time_division(bool is_select_target);
	virtual int get_length(bool is_current);
	virtual Bcl_str get_text(Bcl_dtp_edit* parent, bool is_current);
};

/// Date Time Pickerp̓NX
class Bcl_dtp_analyze_abst_minute : public Bcl_dtp_analyze_abst
{
public:
	Bcl_dtp_analyze_abst_minute(bool is_select_target);
	virtual int get_length(bool is_current);
	virtual void calc(Bcl_dtp_edit* parent, int val);
	virtual void on_char(Bcl_dtp_edit* parent, char ch);
	virtual void analyze_char(Bcl_dtp_edit* parent, int num);
};

/// Date Time Pickerpi2j̓NX
class Bcl_dtp_analyze_minute2 : public Bcl_dtp_analyze_abst_minute
{
public:
	Bcl_dtp_analyze_minute2(bool is_select_target);
	int get_select_start(Bcl_dtp_edit* parent);
	virtual Bcl_str get_text(Bcl_dtp_edit* parent, bool is_current);
};

/// Date Time Pickerpi1܂2j̓NX
class Bcl_dtp_analyze_minute1 : public Bcl_dtp_analyze_abst_minute
{
public:
	Bcl_dtp_analyze_minute1(bool is_select_target);
	int get_select_start(Bcl_dtp_edit* parent);
	virtual Bcl_str get_text(Bcl_dtp_edit* parent, bool is_current);
};

/// Date Time Pickerpb̓NX
class Bcl_dtp_analyze_abst_second : public Bcl_dtp_analyze_abst
{
public:
	Bcl_dtp_analyze_abst_second(bool is_select_target);
	virtual int get_length(bool is_current);
	virtual void calc(Bcl_dtp_edit* parent, int val);
	virtual void on_char(Bcl_dtp_edit* parent, char ch);
	virtual void analyze_char(Bcl_dtp_edit* parent, int num);
};

/// Date Time Pickerpbi2j̓NX
class Bcl_dtp_analyze_second2 : public Bcl_dtp_analyze_abst_second
{
public:
	Bcl_dtp_analyze_second2(bool is_select_target);
	int get_select_start(Bcl_dtp_edit* parent);
	virtual Bcl_str get_text(Bcl_dtp_edit* parent, bool is_current);
};

/// Date Time Pickerpbi1܂2j̓NX
class Bcl_dtp_analyze_second1 : public Bcl_dtp_analyze_abst_second
{
public:
	Bcl_dtp_analyze_second1(bool is_select_target);
	int get_select_start(Bcl_dtp_edit* parent);
	virtual Bcl_str get_text(Bcl_dtp_edit* parent, bool is_current);
};

/// Date Time Pickerp̓NXNX
class Bcl_dtp_analyze_creator
{
public:
	virtual Bcl_str get_format_str() = 0;
	virtual Bcl_dtp_analyze* create_analyze() = 0;
	virtual bool is_select_target() = 0;
};

/// Date Time Pickerp͂ȂNXNX
class Bcl_dtp_analyze_none_creator : public Bcl_dtp_analyze_creator
{
	Bcl_str m_str;

public:
	Bcl_dtp_analyze_none_creator(const Bcl_str& str);
	virtual Bcl_str get_format_str();
	virtual Bcl_dtp_analyze* create_analyze();
	virtual bool is_select_target();
};

/// Date Time PickerpNi4j̓NXNX
class Bcl_dtp_analyze_year4_creator : public Bcl_dtp_analyze_creator
{
public:
	virtual Bcl_str get_format_str();
	virtual Bcl_dtp_analyze* create_analyze();
	virtual bool is_select_target();
};

/// Date Time PickerpNi2j̓NXNX
class Bcl_dtp_analyze_year2_creator : public Bcl_dtp_analyze_creator
{
public:
	virtual Bcl_str get_format_str();
	virtual Bcl_dtp_analyze* create_analyze();
	virtual bool is_select_target();
};

/// Date Time PickerpNi1܂2j̓NXNX
class Bcl_dtp_analyze_year1_creator : public Bcl_dtp_analyze_creator
{
public:
	virtual Bcl_str get_format_str();
	virtual Bcl_dtp_analyze* create_analyze();
	virtual bool is_select_target();
};

/// Date Time Pickerpi2+j̓NXNX
class Bcl_dtp_analyze_month2_str_creator : public Bcl_dtp_analyze_creator
{
public:
	virtual Bcl_str get_format_str();
	virtual Bcl_dtp_analyze* create_analyze();
	virtual bool is_select_target();
};

/// Date Time Pickerpi1܂2+j̓NXNX
class Bcl_dtp_analyze_month1_str_creator : public Bcl_dtp_analyze_creator
{
public:
	virtual Bcl_str get_format_str();
	virtual Bcl_dtp_analyze* create_analyze();
	virtual bool is_select_target();
};

/// Date Time Pickerpi2j̓NXNX
class Bcl_dtp_analyze_month2_creator : public Bcl_dtp_analyze_creator
{
public:
	virtual Bcl_str get_format_str();
	virtual Bcl_dtp_analyze* create_analyze();
	virtual bool is_select_target();
};

/// Date Time Pickerpi1܂2j̓NXNX
class Bcl_dtp_analyze_month1_creator : public Bcl_dtp_analyze_creator
{
public:
	virtual Bcl_str get_format_str();
	virtual Bcl_dtp_analyze* create_analyze();
	virtual bool is_select_target();
};

/// Date Time Pickerpi2j̓NXNX
class Bcl_dtp_analyze_day2_creator : public Bcl_dtp_analyze_creator
{
public:
	virtual Bcl_str get_format_str();
	virtual Bcl_dtp_analyze* create_analyze();
	virtual bool is_select_target();
};

/// Date Time Pickerpi1܂2j̓NXNX
class Bcl_dtp_analyze_day1_creator : public Bcl_dtp_analyze_creator
{
public:
	virtual Bcl_str get_format_str();
	virtual Bcl_dtp_analyze* create_analyze();
	virtual bool is_select_target();
};

/// Date Time Pickerpj̓NXNX
class Bcl_dtp_analyze_long_week_creator : public Bcl_dtp_analyze_creator
{
public:
	virtual Bcl_str get_format_str();
	virtual Bcl_dtp_analyze* create_analyze();
	virtual bool is_select_target();
};

/// Date Time PickerpZj̓NXNX
class Bcl_dtp_analyze_short_week_creator : public Bcl_dtp_analyze_creator
{
public:
	virtual Bcl_str get_format_str();
	virtual Bcl_dtp_analyze* create_analyze();
	virtual bool is_select_target();
};

/// Date Time Pickerpԁi24ԕ\L2j̓NXNX
class Bcl_dtp_analyze_24h_hour2_creator : public Bcl_dtp_analyze_creator
{
public:
	virtual Bcl_str get_format_str();
	virtual Bcl_dtp_analyze* create_analyze();
	virtual bool is_select_target();
};

/// Date Time Pickerpԁi24ԕ\L1܂2j̓NXNX
class Bcl_dtp_analyze_24h_hour1_creator : public Bcl_dtp_analyze_creator
{
public:
	virtual Bcl_str get_format_str();
	virtual Bcl_dtp_analyze* create_analyze();
	virtual bool is_select_target();
};

/// Date Time Pickerpԁi12ԕ\L2j̓NXNX
class Bcl_dtp_analyze_12h_hour2_creator : public Bcl_dtp_analyze_creator
{
public:
	virtual Bcl_str get_format_str();
	virtual Bcl_dtp_analyze* create_analyze();
	virtual bool is_select_target();
};

/// Date Time Pickerpԁi12ԕ\L1܂2j̓NXNX
class Bcl_dtp_analyze_12h_hour1_creator : public Bcl_dtp_analyze_creator
{
public:
	virtual Bcl_str get_format_str();
	virtual Bcl_dtp_analyze* create_analyze();
	virtual bool is_select_target();
};

/// Date Time Pickerpԋ敪̓NXNX
class Bcl_dtp_analyze_long_time_division_creator : public Bcl_dtp_analyze_creator
{
public:
	virtual Bcl_str get_format_str();
	virtual Bcl_dtp_analyze* create_analyze();
	virtual bool is_select_target();
};

/// Date Time PickerpZԋ敪̓NXNX
class Bcl_dtp_analyze_short_time_division_creator : public Bcl_dtp_analyze_creator
{
public:
	virtual Bcl_str get_format_str();
	virtual Bcl_dtp_analyze* create_analyze();
	virtual bool is_select_target();
};

/// Date Time Pickerpi2j̓NXNX
class Bcl_dtp_analyze_minute2_creator : public Bcl_dtp_analyze_creator
{
public:
	virtual Bcl_str get_format_str();
	virtual Bcl_dtp_analyze* create_analyze();
	virtual bool is_select_target();
};

/// Date Time Pickerpi1܂2j̓NXNX
class Bcl_dtp_analyze_minute1_creator : public Bcl_dtp_analyze_creator
{
public:
	virtual Bcl_str get_format_str();
	virtual Bcl_dtp_analyze* create_analyze();
	virtual bool is_select_target();
};

/// Date Time Pickerpbi2j̓NXNX
class Bcl_dtp_analyze_second2_creator : public Bcl_dtp_analyze_creator
{
public:
	virtual Bcl_str get_format_str();
	virtual Bcl_dtp_analyze* create_analyze();
	virtual bool is_select_target();
};

/// Date Time Pickerpbi1܂2j̓NXNX
class Bcl_dtp_analyze_second1_creator : public Bcl_dtp_analyze_creator
{
public:
	virtual Bcl_str get_format_str();
	virtual Bcl_dtp_analyze* create_analyze();
	virtual bool is_select_target();
};

/// Date Time Pickerp̓NXXg
class Bcl_dtp_analyze_list
{
	std::vector<Bcl_dtp_analyze*> m_analyze_list;
	
public:
	void add_analyze(Bcl_dtp_analyze* ana);
	int get_length(bool is_current);
	int get_select_start(Bcl_dtp_edit* parent);
	int get_select_end();
	void calc(Bcl_dtp_edit* parent, int val);
	Bcl_str get_text(Bcl_dtp_edit* parent, bool is_current);
	void on_char(Bcl_dtp_edit* parent, char ch);
	void analyze_char(Bcl_dtp_edit* parent, int num);
};

/// Date Time PickerpGfBbgNX
class Bcl_dtp_edit : public Bcl_edit
{
	friend class Bcl_dtp_analyze_abst;
	friend class Bcl_dtp_analyze_abst_year;
	friend class Bcl_dtp_analyze_year4;
	friend class Bcl_dtp_analyze_year2;
	friend class Bcl_dtp_analyze_year1;
	friend class Bcl_dtp_analyze_abst_month;
	friend class Bcl_dtp_analyze_month2_str;
	friend class Bcl_dtp_analyze_month1_str;
	friend class Bcl_dtp_analyze_month2;
	friend class Bcl_dtp_analyze_month1;
	friend class Bcl_dtp_analyze_abst_day;
	friend class Bcl_dtp_analyze_day2;
	friend class Bcl_dtp_analyze_day1;
	friend class Bcl_dtp_analyze_abst_week;
	friend class Bcl_dtp_analyze_long_week;
	friend class Bcl_dtp_analyze_short_week;
	friend class Bcl_dtp_analyze_abst_24h_hour;
	friend class Bcl_dtp_analyze_24h_hour2;
	friend class Bcl_dtp_analyze_24h_hour1;
	friend class Bcl_dtp_analyze_abst_12h_hour;
	friend class Bcl_dtp_analyze_12h_hour2;
	friend class Bcl_dtp_analyze_12h_hour1;
	friend class Bcl_dtp_analyze_abst_time_division;
	friend class Bcl_dtp_analyze_long_time_division;
	friend class Bcl_dtp_analyze_short_time_division;
	friend class Bcl_dtp_analyze_abst_minute;
	friend class Bcl_dtp_analyze_minute2;
	friend class Bcl_dtp_analyze_minute1;
	friend class Bcl_dtp_analyze_abst_second;
	friend class Bcl_dtp_analyze_second2;
	friend class Bcl_dtp_analyze_second1;
	
	WNDPROC m_org_proc;
	Bcl_dtpicker* m_dtp_parent;
	int m_year;
	int m_month;
	int m_day;
	int m_hour;
	int m_minute;
	int m_second;
	Bcl_date m_min_date;
	Bcl_date m_max_date;
	Bcl_time m_min_time;
	Bcl_time m_max_time;
	std::vector<char> m_char_list;
	std::vector<Bcl_dtp_analyze_list*> m_analyze_list;
	static std::map<HWND, Bcl_dtp_edit*> m_dtp_edit_list;

	void on_mouse_move(WPARAM wp, LPARAM lp);
	void on_rbutton_down(WPARAM wp, LPARAM lp);
	void on_rbutton_up(WPARAM wp, LPARAM lp);
	void on_lbutton_down(WPARAM wp, LPARAM lp);
	void on_lbutton_up(WPARAM wp, LPARAM lp);
	void on_lbutton_dblclk(WPARAM wp, LPARAM lp);
	void on_sys_key_down(WPARAM wp, LPARAM lp);
	void on_key_down(WPARAM wp, LPARAM lp);
	void on_char(WPARAM wp, LPARAM lp);
	void on_set_focus(WPARAM wp, LPARAM lp);
	void on_kill_focus(WPARAM wp, LPARAM lp);
	void on_setsel(WPARAM wp, LPARAM lp);
	void analyze_char();
	void set_select_text();
	void set_display_text();
	void send_date_time_change_msg();
	void add_creator(std::vector<Bcl_dtp_analyze_creator*>& list, Bcl_dtp_analyze_creator* ana);

public:
	Bcl_dtp_edit();
	virtual ~Bcl_dtp_edit();
	bool create(Bcl_dtpicker* parent, int id, int x, int y, int w, int h);
	Bcl_date get_date() const;
	Bcl_date get_mindate() const;
	Bcl_date get_maxdate() const;
	void set_date(const Bcl_date& date);
	void set_mindate(const Bcl_date& date);
	void set_maxdate(const Bcl_date& date);
	Bcl_time get_time() const;
	void set_time(const Bcl_time& time);
	void set_mintime(const Bcl_time& time);
	void set_maxtime(const Bcl_time& time);
	void set_delta_pos(int delta);
	void set_format(const Bcl_str& format);
	int get_cursor_count() const;
	static LRESULT CALLBACK dtp_edit_proc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp);
};

class Bcl_dtp_cal_dlg;

/// Date Time PickerpJ_NX
class Bcl_dtp_monthcal : public Bcl_monthcal
{
	WNDPROC m_org_proc;
	Bcl_dtp_cal_dlg* m_dtp_parent;
	static std::map<HWND, Bcl_dtp_monthcal*> m_dtp_monthcal_list;

	void on_key_down(WPARAM wp, LPARAM lp);
	void on_destroy();

public:
	Bcl_dtp_monthcal();
	bool create(Bcl_dtp_cal_dlg* parent, int id, int x, int y, int w, int h);
	static LRESULT CALLBACK dtp_monthcal_proc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp);
};

/// Date Time PickerpJ__CAONX
class Bcl_dtp_cal_dlg : public Bcl_ctrl
{
	WNDPROC m_org_proc;
	Bcl_dtp_monthcal m_cal;
	Bcl_dtpicker* m_dtp_parent;
	Bcl_date m_date;
	bool m_is_close;
	static std::map<HWND, Bcl_dtp_cal_dlg*> m_dtp_cal_list;

	void on_activate(WPARAM wp, LPARAM lp);
	void on_set_focus(WPARAM wp, LPARAM lp);
	void on_notify(WPARAM wp, LPARAM lp);
	void on_close(WPARAM wp, LPARAM lp);
	void on_destroy(WPARAM wp, LPARAM lp);
	void on_command(WPARAM wp, LPARAM lp);

public:
	Bcl_dtp_cal_dlg();
	bool create(Bcl_dtpicker* parent, int x, int y, int w, int h);
	void set_date(const Bcl_date& date);
	void set_minmax_date(const Bcl_date& min_date, const Bcl_date& max_date);
	static LRESULT CALLBACK dtp_cal_proc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp);
};
#endif

enum DTP_MODE
{
	DTP_SHORTDATE,
	DTP_LONGDATE,
	DTP_TIME,
	DTP_CHK_SHORTDATE,
	DTP_CHK_LONGDATE,
	DTP_CHK_TIME
};

/// Date Time PickerpNX
class Bcl_dtpicker : public Bcl_ctrl
{
#ifndef USE_SYSTEM_DTPICKER
	friend class Bcl_dtp_cal_dlg;
	friend class Bcl_dtp_chk;
	friend class Bcl_dtp_edit;
	
	Bcl_dtp_chk m_chk_valid;
	Bcl_dtp_edit m_edit_display;
	Bcl_button m_btn_calendar;
	Bcl_udctrl m_ud_time;
	Bcl_dtp_cal_dlg m_dlg_cal;
	int m_cursor;

	void on_notify(WPARAM wp, LPARAM lp);
	void on_size(WPARAM wp, LPARAM lp);
	void on_set_focus(WPARAM wp, LPARAM lp);
	void on_btn_calendar(WPARAM wp, LPARAM lp);
	void on_chk_valid(WPARAM wp, LPARAM lp);
	void on_get_month_cal(WPARAM wp, LPARAM lp);
	void on_draw_item(WPARAM wp, LPARAM lp);
	void create_child(Bcl_wnd* parent);
	void set_date(int year, int month, int day);
	void set_cursor_by_edit(int cursor);
	int get_cursor_for_edit();
	void next_cursor();
	void prev_cursor();
	void send_date_time_change_msg();
	void draw_rectangle(HDC hdc, int sx, int sy, int ex, int ey, COLORREF col);
	void draw_polygon(HDC hdc, CONST POINT *pt, int count, COLORREF col);
#endif
public:
	Bcl_dtpicker();
	virtual ~Bcl_dtpicker();
#ifndef USE_SYSTEM_DTPICKER
	bool set_register(HINSTANCE instance);
	bool create(Bcl_wnd* parent, int id,
				int x = CW_USEDEFAULT, int y = CW_USEDEFAULT, int w = CW_USEDEFAULT, int h = CW_USEDEFAULT);
	bool assign(Bcl_wnd* parent, int id);
#endif
	void set_mode(DTP_MODE mode);
	void set_format(const Bcl_str& format);
	Bcl_date get_date() const;
	void set_date(const Bcl_date& date);
	void set_mindate(const Bcl_date& date);
	void set_maxdate(const Bcl_date& date);
	Bcl_time get_time() const;
	void set_time(const Bcl_time& time);
	void set_mintime(const Bcl_time& time);
	void set_maxtime(const Bcl_time& time);
	void set_check(bool chk);
	bool is_checked() const;
#ifndef USE_SYSTEM_DTPICKER
	void set_enabled(bool flg);
#endif
};



#endif
