//==============================================================
//
// Bcl_filedlg
//
//==============================================================
#ifndef _BCL_FILEDLG_H_
#define _BCL_FILEDLG_H_

#include "bcl_typedef.h"
#include "bcl_str.h"

class Bcl_wnd;

enum FILEDLG_MODE
{
	MODE_SAVE,
	MODE_LOAD
};

enum FILEDLG_STYLE
{
	STYLE_EXPLORER,
	STYLE_OLDSTYLE,
	STYLE_OLDSTYLE_NONETWORK
};

/// R_CAÕt@C_CAOpNX
class Bcl_filedlg
{
	Bcl_wnd* m_parent;
	std::vector<Bcl_str> m_fname;
	std::vector< std::pair<Bcl_str, Bcl_str> > m_filter;
	DWORD m_index;
	FILEDLG_MODE m_mode;
	Bcl_str m_title;
	Bcl_str m_ext;
	Bcl_str m_path;
	DWORD m_flags;
	bool m_is_readonly;

	static UINT CALLBACK dmy_hook(HWND wnd, UINT msg, WPARAM wp, LPARAM lp);
	Bcl_str get_long_fname(const Bcl_str& fname);
public:
	Bcl_filedlg(Bcl_wnd* parent);
	~Bcl_filedlg();
	bool do_modal();
	void add_filter(const Bcl_str& name, const Bcl_str& ext);
	int get_filenum() const;
	Bcl_str get_fname(int idx = 0) const;
	void set_mode(FILEDLG_MODE mode);
	void set_filter_index(DWORD index);
	DWORD get_filter_index() const;
	void set_title(const Bcl_str& title);
	void set_default_ext(const Bcl_str& ext);
	void set_ini_path(const Bcl_str& path);
	void show_readonly(bool flg);
	void set_readonly(bool flg);
	void set_createprompt(bool flg);
	bool is_readonly() const;
	void set_multiselect(bool flg);
	void set_style(FILEDLG_STYLE style);
};

#endif
