//==============================================================
//
// Bcl_font
//
//==============================================================
#ifndef _BCL_FONT_H_
#define _BCL_FONT_H_

#include "bcl_typedef.h"
#include "bcl_str.h"

class Bcl_wnd;

/// tHgݒNX
class Bcl_font
{
	HFONT	m_font;
	LOGFONT m_lf;

	void copy(const Bcl_font& ref);
public:
	Bcl_font();
	Bcl_font(HFONT font);
	Bcl_font(Bcl_wnd* parent, int size, const Bcl_str& name, int angle = 0);
	Bcl_font(int height, const Bcl_str& name, int angle = 0);
	Bcl_font(const Bcl_font& ref);
	Bcl_font& operator=(const Bcl_font& ref);
	~Bcl_font();
	void set_font(Bcl_wnd* parent, int size, const Bcl_str& name, int angle = 0);
	void set_font(int height, const Bcl_str& name, int angle = 0);
	void set_size(Bcl_wnd* parent, int size);
	void set_height(int height);
	void set_angle(int angle);
	int get_angle() const;
	bool is_valid() const;
	HFONT get_handle() const;
	void set_handle(HFONT font);
	int get_height() const;
	void set_font_effect(LONG bold, bool italic, bool underline, bool strikeout);
	LONG get_bold() const;
	bool is_italic() const;
	bool is_underline() const;
	bool is_strikeout() const;
	int get_point_size(Bcl_wnd* parent) const;
	void set_charset(BYTE charset);
	BYTE get_charset() const;
	void set_pitch_and_family(BYTE pitch_and_family);
	BYTE get_pitch_and_family() const;
	Bcl_str get_font_name() const;
};

#endif
