//==============================================================
//
// Bcl_imglist
//
//==============================================================
#ifndef _BCL_IMGLIST_H_
#define _BCL_IMGLIST_H_

#include "bcl_typedef.h"

class Bcl_bmp;
class Bcl_wnd;

/// C[WXgpNX
class Bcl_imglist
{
	Bcl_wnd* m_parent;
	HIMAGELIST m_img_handle;
	int m_w;
	int m_h;
public:
	Bcl_imglist();
	Bcl_imglist(Bcl_wnd* parent, int w, int h, UINT flag = ILC_COLOR, int ininum = 32, int addnum = 8);
	virtual ~Bcl_imglist();
	HIMAGELIST get_handle() const;
	bool is_valid() const;
	void init(Bcl_wnd* parent, int w, int h, UINT flag = ILC_COLOR, int ininum = 32, int addnum = 8);
	bool add_img(const Bcl_bmp& img);
	bool add_img(const Bcl_bmp& img, const Bcl_bmp& mask);
	bool add_img(const Bcl_bmp& img, COLORREF mask);
	bool insert_img(int idx, const Bcl_bmp& img);
	bool insert_img(int idx, const Bcl_bmp& img, const Bcl_bmp& mask);
	bool insert_img(int idx, const Bcl_bmp& img, COLORREF mask);
	bool del_img(int num);
	int get_count() const;
	void show_img(HDC dc, int x, int y, int num) const;
	void show_all(HDC dc, int x, int y) const;
	int get_width() const;
	int get_height() const;
	bool start_dragging(int imgx, int imgy, int x, int y, int num);
	bool move_dragging(int x, int y);
	bool stop_dragging();
};
#endif
