//==============================================================
//
// Bcl_listview
//
//==============================================================
#ifndef _BCL_LISTVIEW_H_
#define _BCL_LISTVIEW_H_

#include "bcl_ctrl.h"
#include "bcl_str.h"

enum LV_DISP
{
	LV_DISP_SMALL_ICON,
	LV_DISP_LARGE_ICON,
	LV_DISP_LIST,
	LV_DISP_REPORT
};

/// Xgr[ݒNX
class Bcl_listview : public Bcl_ctrl
{
	HIMAGELIST m_large_list;				//Xgr[pC[WXg(Large)
	HIMAGELIST m_small_list;				//Xgr[pC[WXg(Small)
	int m_col;
public:
	Bcl_listview();
	virtual ~Bcl_listview();
	bool create(Bcl_wnd* parent, int id,
				int x = 0, int y = 0, int w = 0, int h = 0);
	void add_column(int cx, const Bcl_str& text, int fmt = LVCFMT_LEFT);
	void set_column(int col, int fmt, int cx, const Bcl_str& text);
	void insert_item(int row, const Bcl_str& text, int image = -1, int lp = -1);
	void set_item(int row, int col, const Bcl_str& text);
	void set_item_text(int row, int col, const Bcl_str& text);
	void display(LV_DISP mode);
	void create_small_list(int w, int h, UINT flag, int num, int ext);
	void create_large_list(int w, int h, UINT flag, int num, int ext);
	void add_small_icon(LPCTSTR icon);
	void add_large_icon(LPCTSTR icon);
	int get_next_item(int start, UINT flag) const;
	void delete_item(int item);
	void delete_all_items();
	void set_editable();
	void edit_label(int item);
	void edit_label_end(int item);
	void sort_item(PFNLVCOMPARE func, int col);
	int find_item(int start, LPARAM lp) const;
	int find_item(int start, const Bcl_str& str) const;
	Bcl_str get_item_text(int row, int col) const;
	POINT get_item_position(int item) const;
	int get_hpos() const;
	int get_vpos() const;
	int get_item_count() const;
	void set_gridline(bool flg);
	void set_fullrowselect(bool flg);
	void set_single_select(bool flg);
	void set_allways_select(bool flg);
	void set_style_info_tip(bool flg);
	void set_checkbox(bool flg);
	void set_select(int item);
	void set_item_state(int item, UINT state, UINT mask);
	void ensure_visible(int item, bool flag);
	int get_column_size(int col) const;
	bool is_checked(int col) const;
	void set_check(int col, bool chk);
	LV_HITTESTINFO hit_test(const POINT& pt);
	void scroll(int x, int y);
};

#endif
