//==============================================================
//
// Bcl_mdi
//
//==============================================================
#ifndef _BCL_MDI_H_
#define _BCL_MDI_H_

#include "bcl_wnd.h"

class Bcl_mdichild;
class Bcl_cld_creator;

/// MDI쐬pNX
class Bcl_mdi : public Bcl_wnd
{
	friend class Bcl_mdichild;
	HACCEL m_accel;
	int m_menu;
	bool m_zoomed;
	HWND m_client;

	bool pre_create();

	static LRESULT CALLBACK mdi_proc(HWND handle, UINT msg, WPARAM wp, LPARAM lp);
protected:
	std::vector<Bcl_mdichild*> m_cld_list;

	void set_client_size(int tbar_height = 0, int sbar_height = 0);
	void set_drag_accept_files(bool flag);
	void arrange_cascade();
	void arrange_tile_horz();
	void arrange_tile_vert();
	void arrange_icon();
public:
	Bcl_mdi();
	virtual ~Bcl_mdi();
	bool create(LPCTSTR class_name, HINSTANCE instance,
				int x = CW_USEDEFAULT, int y = CW_USEDEFAULT, int w = CW_USEDEFAULT, int h = CW_USEDEFAULT);
	bool create(LPCTSTR class_name, HINSTANCE instance, bool is_enable_dblclk,
				int x = CW_USEDEFAULT, int y = CW_USEDEFAULT, int w = CW_USEDEFAULT, int h = CW_USEDEFAULT);
	HWND get_client() const;
	Bcl_mdichild* create_child(Bcl_cld_creator* creator);
	void close_child(Bcl_mdichild* cld);
	Bcl_mdichild* get_focus() const;
	Bcl_mdichild* get_child(HWND handle) const;
	bool include_accel(LPCTSTR name);
	UINT loop();
	bool is_only_one(char* uniq_name) const;
	void set_window_menu(int menu);
	bool is_zoomed() const;
};
#endif
