//==============================================================
//
// Bcl_redit
//
//==============================================================
#ifndef _BCL_REDIT_H_
#define _BCL_REDIT_H_

#include <windows.h>
#include <richedit.h>
#include "bcl_ctrl.h"
#include "bcl_str.h"
#include "bcl_font.h"

enum ALIGN_MODE
{
	ALIGN_LEFT,
	ALIGN_RIGHT,
	ALIGN_CENTER
};

enum INDENT_MODE
{
	INDENT_UP_RIGHT,
	INDENT_DOWN_RIGHT,
	INDENT_UP_LEFT,
	INDENT_DOWN_LEFT
};

/// b`GfBbgpNX
class Bcl_redit : public Bcl_ctrl
{
	HINSTANCE m_lib;
	FINDREPLACE m_fr;
	char m_find_text[MAX_PATH];		//obt@[
	char m_replace_text[MAX_PATH];	//uobt@[
	HWND m_fr_handle;
	UINT m_frMsg;

	bool was_found(FINDTEXT& ft, UINT flag);

	static DWORD CALLBACK read_proc(DWORD cookie, LPBYTE buf, LONG cb, LONG* pcb);
	static DWORD CALLBACK write_proc(DWORD cookie, LPBYTE buf, LONG cb, LONG* pcb);
public:
	Bcl_redit(Bcl_wnd* parent, void (Bcl_wnd::*func)(WPARAM, LPARAM));
	virtual ~Bcl_redit();
	void align(ALIGN_MODE mode);
	void indent(INDENT_MODE mode);
	bool load(const Bcl_str& fname);
	bool save(const Bcl_str& fname);
	void set_font(const Bcl_font& font);
	void set_textcolor(COLORREF col);
	void find_text();
	void replace_text();
	void find_replace(WPARAM wp, LPARAM lp);
};

#endif
