//==============================================================
//
// Bcl_str
//
//==============================================================
#ifndef _BCL_STR_H_
#define _BCL_STR_H_

#include "bcl_typedef.h"

enum RADIX
{
	RADIX_BIN,
	RADIX_OCT,
	RADIX_DEC,
	RADIX_UDEC,
	RADIX_HEX
};

/// NX
class Bcl_str
{
	std::string m_str;
	UINT m_place;
public:
	Bcl_str();
	Bcl_str(const char* str);
	Bcl_str(char c);
	Bcl_str(long num, RADIX radix);
	char* to_char();
	const char* to_char() const;
	int get_length() const;
	int get_wlength() const;
	void format(const char* fmt, ...);
	void format(int size, const char* fmt, ...);
	Bcl_str mid(int start, int num) const;
	Bcl_str right(int num) const;
	Bcl_str left(int num) const;
	Bcl_str wmid(int start, int num) const;
	Bcl_str wright(int num) const;
	Bcl_str wleft(int num) const;
	Bcl_str to_lower() const;
	Bcl_str to_upper() const;
	long to_number(RADIX radix) const;
	bool operator==(const Bcl_str& str) const;
	bool operator==(const char* str) const;
	bool operator!=(const Bcl_str& str) const;
	bool operator!=(const char* str) const;
	bool operator>(const Bcl_str& str) const;
	bool operator>(const char* str) const;
	bool operator<(const Bcl_str& str) const;
	bool operator<(const char* str) const;
	bool operator>=(const Bcl_str& str) const;
	bool operator>=(const char* str) const;
	bool operator<=(const Bcl_str& str) const;
	bool operator<=(const char* str) const;
	Bcl_str& operator=(const Bcl_str& str);
	Bcl_str& operator=(const char* str);
	Bcl_str& operator=(char c);
	Bcl_str operator+(const Bcl_str& str) const;
	Bcl_str operator+(const char* str) const;
	Bcl_str operator+(char c) const;
	Bcl_str& operator+=(const Bcl_str& str);
	Bcl_str& operator+=(const char* str);
	Bcl_str& operator+=(char c);
	char operator[](int idx) const;
	char& operator[](int idx);
	int find(const Bcl_str& str, int start = 0) const;
	bool has_next_line();
	Bcl_str next_line();
	void reset_line();
	friend std::ostream& operator<<(std::ostream& os, const Bcl_str& str);
	friend std::istream& operator>>(std::istream& is, Bcl_str& str);
	friend Bcl_str operator+(const char* str1, const Bcl_str& str2);
	friend Bcl_str operator+(char c, const Bcl_str& str);
};
#endif
