//==============================================================
//
// Bcl_tab
//
//==============================================================
#ifndef _BCL_TAB_H_
#define _BCL_TAB_H_

#include "bcl_ctrl.h"

/// ^uRg[pNX
class Bcl_tab : public Bcl_ctrl
{
	WNDPROC m_org_proc;
	static std::map<HWND, Bcl_tab*> m_tab_list;
	std::vector<Bcl_wnd*> m_wnd;
	int m_cur_wnd;

	static LRESULT CALLBACK proc(HWND handle, UINT msg, WPARAM wp, LPARAM lp);
public:
	Bcl_tab();
	virtual ~Bcl_tab();
	bool create(Bcl_wnd* parent, int id,
				int x = CW_USEDEFAULT, int y = CW_USEDEFAULT, int w = CW_USEDEFAULT, int h = CW_USEDEFAULT);
	void assign(Bcl_wnd* parent, int id);
	int get_tab_count() const;
	int get_cur_page() const;
	void set_cur_page(int page);
	void add_page(Bcl_wnd* wnd, const Bcl_str& text);
	void del_page();
	virtual void move(int x, int y, int w, int h);
	void changed_page();
	RECT get_adjust_rect() const;
	RECT get_adjust_rect(RECT parent_rect) const;
};

#endif
