//==============================================================
//
// Bcl_toolbar
//
//==============================================================
#ifndef _BCL_TOOLBAR_H_
#define _BCL_TOOLBAR_H_

#include "bcl_ctrl.h"
#include "bcl_str.h"

#define TOOLBAR 4001

/// c[o[ݒNX
class Bcl_toolbar : public Bcl_ctrl
{
	std::vector<TBBUTTON> m_tbb;
	LRESULT m_img_id;
	LRESULT m_std_id;
	LRESULT m_view_id;
	std::map<int, Bcl_str> m_tooltip_str;
	std::map<int, int> m_tooltip_int;
public:
	Bcl_toolbar();
	virtual ~Bcl_toolbar();
	bool create(Bcl_wnd* parent, int id = TOOLBAR);
	void assign(Bcl_wnd* parent, int id);
	void add_bmp(LPCTSTR name, int n);
	void add_std_button(int id, int cmd, BYTE state, BYTE style, int tooltip = 0);
	void add_std_button(int id, int cmd, BYTE state, BYTE style, const Bcl_str& tooltip);
	void add_view_button(int id, int cmd, BYTE state, BYTE style, int tooltip = 0);
	void add_view_button(int id, int cmd, BYTE state, BYTE style, const Bcl_str& tooltip);
	void add_user_button(int cmd, BYTE state, BYTE style, int tooltip = 0);
	void add_user_button(int cmd, BYTE state, BYTE style, const Bcl_str& tooltip);
	void add_separetor();
	void show();
	void auto_size();
	void set_checked(int cmd, bool chk);
	void set_enabled(int cmd, bool flg);
	void set_visible(int cmd, bool flg);
	void show_tooltip(LPTOOLTIPTEXT lptip);
};
#endif
