//==============================================================
//
// Bcl_treeview
//
//==============================================================
#ifndef _BCL_TREEVIEW_H_
#define _BCL_TREEVIEW_H_

#include "bcl_ctrl.h"
#include "bcl_str.h"

/// c[r[pNX
class Bcl_treeview : public Bcl_ctrl
{
	HIMAGELIST m_h_img_list;				//c[r[pC[WXg
public:
	Bcl_treeview();
	virtual ~Bcl_treeview();
	HTREEITEM insert_item(const Bcl_str& title, HTREEITEM parent = TVI_ROOT, HTREEITEM after = TVI_LAST, int img = -1, int sel_img = -1, int lp = -1);
	void create_icon_list(int w, int h, UINT flag, int num, int ext);
	void add_icon(LPCTSTR icon, COLORREF mask = RGB(0, 0, 0));
	void add_icon(int icon, COLORREF mask = RGB(0, 0, 0));
	HTREEITEM get_selection() const;
	void delete_item(HTREEITEM hitem);
	void sort_children(HTREEITEM hitem);
	void set_item(TV_ITEM* item);
	void set_item_state(HTREEITEM hitem, UINT state, UINT mask);
	TVHITTESTINFO hit_test(const POINT& pt);
	Bcl_str get_text(HTREEITEM hitem) const;
	HTREEITEM find_item(HTREEITEM hitem, const Bcl_str& text) const;
	void select_item(HTREEITEM hitem) const;
	void select_drop_target(HTREEITEM hitem) const;
	void select_set_first_visible(HTREEITEM hitem) const;
	HTREEITEM get_parent(HTREEITEM hitem) const;
	HTREEITEM get_child(HTREEITEM hitem) const;
	HTREEITEM get_next(HTREEITEM hitem) const;
	void expand(HTREEITEM hitem, bool flag) const;
};

#endif
