#ifndef _BCL_TYOEDEF_H_
#define	_BCL_TYOEDEF_H_

#include <windows.h>
#include <map>
#include <vector>
#include <string>
#include <commctrl.h>

#define ON_MOUSEMOVE(func) m_msg.push_back(Message(WM_MOUSEMOVE, 0, (void (Bcl_wnd::*)(WPARAM, LPARAM))&func))
#define ON_LBUTTONDOWN(func) m_msg.push_back(Message(WM_LBUTTONDOWN, 0, (void (Bcl_wnd::*)(WPARAM, LPARAM))&func))
#define ON_LBUTTONUP(func) m_msg.push_back(Message(WM_LBUTTONUP, 0, (void (Bcl_wnd::*)(WPARAM, LPARAM))&func))
#define ON_LBUTTONDBLCLK(func) m_msg.push_back(Message(WM_LBUTTONDBLCLK, 0, (void (Bcl_wnd::*)(WPARAM, LPARAM))&func))
#define ON_MBUTTONDOWN(func) m_msg.push_back(Message(WM_MBUTTONDOWN, 0, (void (Bcl_wnd::*)(WPARAM, LPARAM))&func))
#define ON_MBUTTONUP(func) m_msg.push_back(Message(WM_MBUTTONUP, 0, (void (Bcl_wnd::*)(WPARAM, LPARAM))&func))
#define ON_MBUTTONDBLCLK(func) m_msg.push_back(Message(WM_MBUTTONDBLCLK, 0, (void (Bcl_wnd::*)(WPARAM, LPARAM))&func))
#define ON_RBUTTONDOWN(func) m_msg.push_back(Message(WM_RBUTTONDOWN, 0, (void (Bcl_wnd::*)(WPARAM, LPARAM))&func))
#define ON_RBUTTONUP(func) m_msg.push_back(Message(WM_RBUTTONUP, 0, (void (Bcl_wnd::*)(WPARAM, LPARAM))&func))
#define ON_RBUTTONDBLCLK(func) m_msg.push_back(Message(WM_RBUTTONDBLCLK, 0, (void (Bcl_wnd::*)(WPARAM, LPARAM))&func))
#define ON_MOUSEWHEEL(func) m_msg.push_back(Message(WM_MOUSEWHEEL, 0, (void (Bcl_wnd::*)(WPARAM, LPARAM))&func))
#define ON_CONTEXTMENU(func) m_msg.push_back(Message(WM_CONTEXTMENU, 0, (void (Bcl_wnd::*)(WPARAM, LPARAM))&func))
#define ON_SIZE(func) m_msg.push_back(Message(WM_SIZE, 0, (void (Bcl_wnd::*)(WPARAM, LPARAM))&func))
#define ON_NOTIFY(func) m_msg.push_back(Message(WM_NOTIFY, 0, (void (Bcl_wnd::*)(WPARAM, LPARAM))&func))
#define ON_PAINT(func) m_msg.push_back(Message(WM_PAINT, 0, (void (Bcl_wnd::*)(WPARAM, LPARAM))&func))
#define ON_HSCROLL(func) m_msg.push_back(Message(WM_HSCROLL, 0, (void (Bcl_wnd::*)(WPARAM, LPARAM))&func))
#define ON_VSCROLL(func) m_msg.push_back(Message(WM_VSCROLL, 0, (void (Bcl_wnd::*)(WPARAM, LPARAM))&func))
#define ON_TIMER(func) m_msg.push_back(Message(WM_TIMER, 0, (void (Bcl_wnd::*)(WPARAM, LPARAM))&func))
#define ON_MDIACTIVATE(func) m_msg.push_back(Message(WM_MDIACTIVATE, 0, (void (Bcl_wnd::*)(WPARAM, LPARAM))&func))
#define ON_GETMINMAXINFO(func) m_msg.push_back(Message(WM_GETMINMAXINFO, 0, (void (Bcl_wnd::*)(WPARAM, LPARAM))&func))
#define ON_HELP(func) m_msg.push_back(Message(WM_HELP, 0, (void (Bcl_wnd::*)(WPARAM, LPARAM))&func))
#define ON_DROPFILES(func) m_msg.push_back(Message(WM_DROPFILES, 0, (void (Bcl_wnd::*)(WPARAM, LPARAM))&func))
#define ON_DRAWITEM(func) m_msg.push_back(Message(WM_DRAWITEM, 0, (void (Bcl_wnd::*)(WPARAM, LPARAM))&func))
#define ON_KEYDOWN(func) m_msg.push_back(Message(WM_KEYDOWN, 0, (void (Bcl_wnd::*)(WPARAM, LPARAM))&func))
#define ON_KEYUP(func) m_msg.push_back(Message(WM_KEYUP, 0, (void (Bcl_wnd::*)(WPARAM, LPARAM))&func))
#define ON_CHAR(func) m_msg.push_back(Message(WM_CHAR, 0, (void (Bcl_wnd::*)(WPARAM, LPARAM))&func))
#define ON_ACTIVATE(func) m_msg.push_back(Message(WM_ACTIVATE, 0, (void (Bcl_wnd::*)(WPARAM, LPARAM))&func))
#define ON_SETFOCUS(func) m_msg.push_back(Message(WM_SETFOCUS, 0, (void (Bcl_wnd::*)(WPARAM, LPARAM))&func))
#define ON_KILLFOCUS(func) m_msg.push_back(Message(WM_KILLFOCUS, 0, (void (Bcl_wnd::*)(WPARAM, LPARAM))&func))
#define ON_COMMAND(id, func) m_msg.push_back(Message(WM_COMMAND, id, (void (Bcl_wnd::*)(WPARAM, LPARAM))&func))
#define ON_MSG(msg, func) m_msg.push_back(Message(msg, 0, (void (Bcl_wnd::*)(WPARAM, LPARAM))&func))

enum BRUSH_TYPE
{
	BRUSH_TRANSPARENT,
	BRUSH_SOLID,
	BRUSH_HHATCH,
	BRUSH_VHATCH,
	BRUSH_HVHATCH,
	BRUSH_RHATCH,
	BRUSH_LHATCH,
	BRUSH_RLHATCH
};

enum PEN_TYPE
{
	PEN_SOLID,
	PEN_DASH,
	PEN_DOT,
	PEN_DASHDOT,
	PEN_DASHDOTDOT
};

static const COLORREF BLACK       = RGB(0, 0, 0);
static const COLORREF DARKBLUE    = RGB(0, 0, 128);
static const COLORREF DARKRED     = RGB(128, 0, 0);
static const COLORREF DARKMAZENDA = RGB(128, 0, 128);
static const COLORREF DARKGREEN   = RGB(0, 128, 0);
static const COLORREF DARKCIAN    = RGB(0, 128, 128);
static const COLORREF DARKYELLOW  = RGB(128, 128, 0);
static const COLORREF DARKWHITE   = RGB(192, 192, 192);
static const COLORREF GRAY        = RGB(128, 128, 128);
static const COLORREF BLUE        = RGB(0, 0, 255);
static const COLORREF RED         = RGB(255, 0, 0);
static const COLORREF MAZENDA     = RGB(255, 0, 255);
static const COLORREF GREEN       = RGB(0, 255, 0);
static const COLORREF CIAN        = RGB(0, 255, 255);
static const COLORREF YELLOW      = RGB(255, 255, 0);
static const COLORREF WHITE       = RGB(255, 255, 255);

#endif
