//==============================================================
//
// Bcl_binaryfile
//
//==============================================================
#include "bcl_binaryfile.h"
#include "bcl_str.h"
#include "bcl_date.h"

/// RXgN^
Bcl_binaryfile::Bcl_binaryfile()
{
	m_fp = NULL;
}

/// fXgN^
Bcl_binaryfile::~Bcl_binaryfile()
{
	if (m_fp != NULL)
	{
		fclose(m_fp);
	}
}

/// ݃[hŊJ
/// @param fname t@C
/// @return 
bool Bcl_binaryfile::open_write(const Bcl_str& fname)
{
	m_fp = fopen(fname.to_char(), "wb");
	if (m_fp == NULL)
	{
		return false;
	}
	return true;
}

/// l
/// @param val l
/// @param size TCY
/// @return 
bool Bcl_binaryfile::int_write(long val, int size)
{
	char c;
	if (m_fp == NULL)
	{
		return(false);
	}
	if (size > 3)
	{
		c = (char)((val >> 24) & 0xFF);
		fwrite(&c, 1, 1, m_fp);
	}
	if (size > 2)
	{
		c = (char)((val >> 16) & 0xFF);
		fwrite(&c, 1, 1, m_fp);
	}
	if (size > 1)
	{
		c = (char)((val >> 8) & 0xFF);
		fwrite(&c, 1, 1, m_fp);
	}
	c = (char)(val & 0xFF);
	fwrite(&c, 1, 1, m_fp);
	return true;
}

/// 񏑂
/// @param str 
/// @param size 񐔂̃TCY
/// @return 
bool Bcl_binaryfile::str_write(const Bcl_str& str, int size)
{
	if (m_fp == NULL)
	{
		return(false);
	}
	int_write(str.get_length(), size);
	for (int i = 0; i < str.get_length(); i++)
	{
		char_write(str[i]);
	}
	return true;
}

/// 
/// @param data 
/// @return 
bool Bcl_binaryfile::char_write(char data)
{
	if (m_fp == NULL)
	{
		return(false);
	}
	fputc(data, m_fp);
	return true;
}

/// t
/// @param date t
/// @return 
bool Bcl_binaryfile::date_write(const Bcl_date& date)
{
	return int_write(date.m_date, 4);
}

/// ǂݍ݃[hŊJ
/// @param fname t@C
/// @return 
bool Bcl_binaryfile::open_read(const Bcl_str& fname)
{
	m_fp = fopen(fname.to_char(), "rb");
	if (m_fp == NULL)
	{
		return false;
	}
	return true;
}

/// lǂݍ
/// @param size TCY
/// @param *val l
/// @return 
bool Bcl_binaryfile::int_read(int size, long *val)
{
	int i;
	unsigned char c;
	if (m_fp == NULL)
	{
		return(false);
	}
	*val = 0;
	for (i = 0; i < size; i++)
	{
		*val <<= 8;
		if (fread(&c, 1, 1, m_fp) == 0)
		{
			return false;
		}
		*val += c;
	}
	return true;
}

/// ǂݍ
/// @param str 
/// @param size TCY
/// @return 
bool Bcl_binaryfile::str_read(Bcl_str* str, int size)
{
	long val;
	
	if (m_fp == NULL)
	{
		return(false);
	}
	if (int_read(size, &val) == false)
	{
		return false;
	}
	*str = "";
	if (val == 0)
	{
		return true;
	}
	char* data = new char[val + 1];
	for (int i = 0; i < val; i++)
	{
		if (char_read(&data[i]) == false)
		{
			delete[] data;
			return false;
		}
	}
	data[val] = 0;
	*str = data;
	delete[] data;
	return true;
}

/// ǂݍ
/// @param *data 
/// @return 
bool Bcl_binaryfile::char_read(char *data)
{
	if (m_fp == NULL)
	{
		return(false);
	}
	if (fread(data, 1, 1, m_fp) < 1)
	{
		return false;
	}
	return true;
}

/// tǂݍ
/// @param date t
/// @return 
bool Bcl_binaryfile::date_read(Bcl_date* date)
{
	if (m_fp == NULL)
	{
		return false;
	}
	long val;
	if (int_read(4, &val) == false)
	{
		return false;
	}
	date->m_date = val;
	return true;
}

/// 
void Bcl_binaryfile::close()
{
	if (m_fp != NULL)
	{
		fclose(m_fp);
	}
	m_fp = NULL;
}

/// t@C̃[hCgʒuύX
/// @param pos [hCgʒu
/// @return 
bool Bcl_binaryfile::set_pos(int pos)
{
	if (m_fp == NULL)
	{
		return false;
	}
	fseek(m_fp, pos, SEEK_SET);
	return true;
}

/// t@C̃[hCgʒu擾
/// @return [hCgʒu
int Bcl_binaryfile::get_pos() const
{
	if (m_fp == NULL)
	{
		return 0;
	}
	return ftell(m_fp);
}
