//==============================================================
//
// Bcl_bmp
//
//==============================================================
#include "bcl_bmp.h"
#include "bcl_wnd.h"
#include "bcl_binaryfile.h"

/// RXgN^
Bcl_bmp::Bcl_bmp() : m_bmp(NULL)
{
}

/// Rs[RXgN^
/// @param ref Rs[
Bcl_bmp::Bcl_bmp(const Bcl_bmp& ref) : m_bmp(NULL)
{
	copy(ref);
}

/// Zq
/// @param ref Rs[
/// @return ւ̎Q
Bcl_bmp& Bcl_bmp::operator=(const Bcl_bmp& ref)
{
	copy(ref);
	return *this;
}

/// Rs[
/// @param ref Rs[
void Bcl_bmp::copy(const Bcl_bmp& ref)
{
	HDC hDC = GetDC(0);						//EBhEDC擾
	HDC mem_copyDC = CreateCompatibleDC(hDC);			//Rp`cb쐬
	HDC memDC = CreateCompatibleDC(hDC);			//Rp`cb쐬
	HBITMAP bmp = CreateCompatibleBitmap(hDC, ref.get_width(), ref.get_height());	//Rp`rbg}bv쐬
	SelectObject(mem_copyDC, bmp);							//rbg}bvI
	SelectObject(memDC, ref.m_bmp);						//rbg}bvI
	BitBlt(mem_copyDC, 0, 0, ref.get_width(), ref.get_height(), memDC, 0, 0, SRCCOPY);
	ReleaseDC(0, hDC);							//EBhEDCJ
	DeleteObject(memDC);							//Rp`cb폜
	DeleteObject(mem_copyDC);							//Rp`cb폜
	if (m_bmp != NULL)
	{
		DeleteObject(m_bmp);
		LocalFree(m_header);
		LocalFree(m_file_header);
	}
	m_bmp = bmp;
	m_file_header = (PBITMAPFILEHEADER)LocalAlloc(LPTR, sizeof(BITMAPFILEHEADER));
	memcpy((char*)m_file_header, (char*)ref.m_file_header, sizeof(BITMAPFILEHEADER));
	int size = m_file_header->bfOffBits - sizeof(BITMAPFILEHEADER);
	m_header = (PBITMAPINFO)LocalAlloc(LPTR, size);
	memcpy((char*)m_header, (char*)ref.m_header, size);
	GetObject(m_bmp, sizeof(BITMAP), &m_info);
	m_col_bit = ref.m_col_bit;
}

/// fXgN^
Bcl_bmp::~Bcl_bmp()
{
	if (m_bmp != NULL)
	{
		DeleteObject(m_bmp);
		LocalFree(m_header);
		LocalFree(m_file_header);
	}
}

/// L`FbN
/// @return L
bool Bcl_bmp::is_valid() const
{
	if (m_bmp == NULL)
	{
		return false;
	}
	return true;
}

/// ǂݍ
/// @param parent eEChE
/// @param bmp_name rbg}bv
/// @param flag tOit@Chcj
/// @return 
bool Bcl_bmp::load(Bcl_wnd* parent, LPCTSTR bmp_name, bool flag)
{
	UINT opt;
	if (flag)
	{
		opt = LR_DEFAULTCOLOR | LR_LOADFROMFILE;
	}
	else
	{
		opt = LR_DEFAULTCOLOR;
	}
	m_bmp = (HBITMAP)LoadImage(parent->get_instance(), bmp_name, IMAGE_BITMAP, 0, 0, opt);
	//rbg}bvǂݍ߂
	if(!m_bmp)
	{
		MessageBox(NULL, "rbg}bv̍쐬Ɏs܂", "G[!", MB_OK | MB_ICONSTOP);
		return false;
	}
	if (flag)
	{
		get_bmp_info(bmp_name);
	}
	else
	{
		get_bmp_info();
	}
	return true;
}

/// ۑ
/// @param fname t@C
void Bcl_bmp::save(const Bcl_str& fname)
{
	save(fname, m_col_bit);
}

/// ۑ
/// @param fname t@C
/// @param col_bit J[rbg
void Bcl_bmp::save(const Bcl_str& fname, WORD col_bit)
{
	LPBYTE bits;			// [ւ̃|C^[
	DWORD bmp_size;			//rbg}bvTCYvZp
	int rtn;			//GetDIBits֐̐tO
	HDC dc, mem;			//fXNgbvDCƃRp`rbg}bvDC
	BITMAP bmp;				//ݗp
	PBITMAPINFO info;		//ݗp
	PBITMAPFILEHEADER fheder;	//ݗp

	//PBITMAPINFO inföׂ̃[m
	if (col_bit <= 8)
		info = (PBITMAPINFO)LocalAlloc(LPTR,	//Œ胁[E[ŏ
				sizeof(BITMAPINFOHEADER) +
				sizeof(RGBQUAD) * (1 << col_bit));
	//24bittH[}bg͖ܘ_16, 32bitBI_RGB̏ꍇɂRGBQUADȂ
	else
		info = (PBITMAPINFO)LocalAlloc(LPTR,
				sizeof(BITMAPINFOHEADER));
	if(!info) {	//[mێs
			MessageBox(NULL, "infõ[J[mۂɎs܂",
						"G[!", MB_OK | MB_ICONSTOP);
			return;
	}
	//fXeBl[Ṽrbg}bv\̂
	GetObject(m_bmp, sizeof(BITMAP), &bmp);
	//BITMAPINFȌ
	info->bmiHeader.biSize		= sizeof(BITMAPINFOHEADER);
	info->bmiHeader.biWidth		= m_info.bmWidth;
	info->bmiHeader.biHeight	= m_info.bmHeight;
	info->bmiHeader.biPlanes	= 1;
	info->bmiHeader.biBitCount	= col_bit;
	info->bmiHeader.biCompression	= BI_RGB;		//0x0
	info->bmiHeader.biXPelsPerMeter	= 0;
	info->bmiHeader.biYPelsPerMeter	= 0;
	info->bmiHeader.biClrUsed		= 0;
	info->bmiHeader.biClrImportant	= 0;
	//rbg}bvf[^TCYZo
	bmp_size = ((col_bit * info->bmiHeader.biWidth + 31) / 32) * 4
				* abs(info->bmiHeader.biHeight);
	info->bmiHeader.biSizeImage	= bmp_size;
	//BITMAPFILEHEADEȐ
	fheder = (PBITMAPFILEHEADER)LocalAlloc(LPTR,
			sizeof(BITMAPFILEHEADER));
	if(!fheder) {	//[mێs
			MessageBox(NULL, "fheder̃[J[mۂɎs܂",
						"G[!", MB_OK | MB_ICONSTOP);
			LocalFree(info);
			return;
	}
	fheder->bfType = 0x4D42;
	fheder->bfReserved1 = fheder->bfReserved2 = 0;
	if(col_bit <= 8)	//BITMAPFILEHEADER + BITMAPINFOHEADER + RGBQUAD
		fheder->bfOffBits = 54 + (4 * (1 << col_bit));
	else			//BITMAPFILEHEADER + BITMAPINFOHEADER
		fheder->bfOffBits = 54;
	fheder->bfSize = bmp_size + fheder->bfOffBits;
	bits = (LPBYTE)GlobalAlloc(GMEM_FIXED, bmp_size);
	if(!bits) {
		MessageBox(NULL, "O[o[mۂł܂ł",
					"G[", MB_OK | MB_ICONSTOP);
		LocalFree(info);
		LocalFree(fheder);
		return;
	}
	//ŐFύX
	dc = GetDC(0);					//fXNgbṽfoCXReLXg
	mem = CreateCompatibleDC(dc);	//̃Rp`DC
	SelectObject(mem, m_bmp);		//rbg}bvǂ܂
	//rbgzGetDIBits֐ŃO[o[Ɏo
	rtn = GetDIBits(mem, m_bmp, 0, bmp.bmHeight,
							bits, info, DIB_RGB_COLORS);
	DeleteDC(mem) ;				//Rp`DC폜
	ReleaseDC(0, dc);				//fXNgbṽfoCXReLXgJ
	if(!rtn) {	//FύXs
		MessageBox(NULL, "FύXɎs܂",
					"G[", MB_OK | MB_ICONSTOP);
		LocalFree(info);
		LocalFree(fheder);
		GlobalFree((HGLOBAL)bits);
		return;
	}
	Bcl_binaryfile file;
	file.open_write(fname);
	char* work = (char*)fheder;
	for (int i = 0; i < sizeof(BITMAPFILEHEADER); i++)
	{
		file.char_write(*work);
		work++;
	}
	int size = fheder->bfOffBits - sizeof(BITMAPFILEHEADER);
	work = (char*)info;
	for (int i = 0; i < size; i++)
	{
		file.char_write(*work);
		work++;
	}
	work = (char*)bits;
	for (DWORD i = 0; i < bmp_size; i++)
	{
		file.char_write(*work);
		work++;
	}
	file.close();
	//[
	LocalFree(info);
	LocalFree(fheder);
	GlobalFree((HGLOBAL)bits);
	return;
}

/// rbg}bvnhݒ
/// @param bmp rbg}bvnh
void Bcl_bmp::set_handle(HBITMAP bmp)
{
	if (m_bmp != NULL)
	{
		DeleteObject(m_bmp);
		LocalFree(m_header);
		LocalFree(m_file_header);
	}
	m_bmp = bmp;
	get_bmp_info();
}

/// rbg}bvnh擾
/// @return rbg}bvnh
HBITMAP Bcl_bmp::get_handle() const
{
	return m_bmp;
}

/// rbg}bv擾
void Bcl_bmp::get_bmp_info()
{
	if (m_bmp == NULL)
	{
		return;
	}
	//rbg}bṽJ[tH[}bgAcATCY擾 
	if (!GetObject(m_bmp, sizeof(BITMAP), (LPSTR)&m_info)) {
		MessageBox(NULL, "rbg}bv񂪓ǂ߂܂ł",
					"G[", MB_OK | MB_ICONSTOP);
		return;
	}
	//J[tH[}bgvZ(bmPlanes * bmBitsPixel)
	m_col_bit = (WORD)(m_info.bmPlanes * m_info.bmBitsPixel);
	//PBITMAPINFO m_headerׂ̈̃[m(1, 4, 8bit)
	if (m_col_bit <= 8)
		m_header = (PBITMAPINFO)LocalAlloc(LPTR,	//Œ胁[E[ŏ
				sizeof(BITMAPINFOHEADER) +
				sizeof(RGBQUAD) * (1 << m_col_bit));
	//24bittH[}bg͖ܘ_16, 32bitBI_RGB̏ꍇɂRGBQUADȂ
	else
		m_header = (PBITMAPINFO)LocalAlloc(LPTR,
				sizeof(BITMAPINFOHEADER));
	//BITMAPINFO\̗̂vf
	m_header->bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
	m_header->bmiHeader.biWidth = m_info.bmWidth;
	m_header->bmiHeader.biHeight = m_info.bmHeight;
	m_header->bmiHeader.biPlanes = m_info.bmPlanes;
	m_header->bmiHeader.biBitCount = m_info.bmBitsPixel;
	if (m_col_bit <= 8)
		m_header->bmiHeader.biClrUsed = (1 << m_col_bit);
	else	//tJ[ɂ0
		m_header->bmiHeader.biClrUsed = 0;
	//rbg}bvkĂȂȂBI_RGB(0)tO𗧂Ă
	m_header->bmiHeader.biCompression = BI_RGB;
	//Fz̃oCgvZbiSizeImageɂ܂
	m_header->bmiHeader.biSizeImage = ((((m_header->bmiHeader.biWidth * m_col_bit) +
									31) & ~31) >> 3)
									* m_header->bmiHeader.biHeight;
	//biClrImportant0ɂiSĂ̐FdvAӖj
	m_header->bmiHeader.biClrImportant = 0;
	//rbg}bvt@Cwb_[쐬
	m_file_header = (PBITMAPFILEHEADER)LocalAlloc(LPTR,
				sizeof(BITMAPFILEHEADER));
	m_file_header->bfType = 0x4d42;	//0x420x4d"BM"Ńrbg}bv̈Ӗ
	//t@CTCY̌vZiBITMAPINFOHEADERւ̃|C^[쐬j
	PBITMAPINFOHEADER PBmih = (PBITMAPINFOHEADER)m_header;
	m_file_header->bfSize = (DWORD) (sizeof(BITMAPFILEHEADER) +
							PBmih->biSize + PBmih->biClrUsed
							* sizeof(RGBQUAD) + PBmih->biSizeImage);
	m_file_header->bfReserved1 = m_file_header->bfReserved2 = 0;
	//J[܂ł̃ItZbgvZ
	m_file_header->bfOffBits = (DWORD) sizeof(BITMAPFILEHEADER) +
								PBmih->biSize + PBmih->biClrUsed
								* sizeof (RGBQUAD);
}

/// rbg}bv擾
/// @param fname t@C
void Bcl_bmp::get_bmp_info(const Bcl_str& fname)
{
	Bcl_binaryfile file;
	file.open_read(fname);
	m_file_header = (PBITMAPFILEHEADER)LocalAlloc(LPTR, sizeof(BITMAPFILEHEADER));
	char* work = (char*)m_file_header;
	for (int i = 0; i < sizeof(BITMAPFILEHEADER); i++)
	{
		file.char_read(work);
		work++;
	}
	int size = m_file_header->bfOffBits - sizeof(BITMAPFILEHEADER);
	m_header = (PBITMAPINFO)LocalAlloc(LPTR, size);
	work = (char*)m_header;
	for (int i = 0; i < size; i++)
	{
		file.char_read(work);
		work++;
	}
	file.close();
	m_col_bit = (WORD)(m_header->bmiHeader.biPlanes * m_header->bmiHeader.biBitCount);
	//Ōm_BmpɃf[^ZbgiDDBf[^Ȃ̂Ńt@Cf[^ƈقȂj
	GetObject(m_bmp, sizeof(BITMAP), &m_info);
}

/// ^Cv擾
/// @return ^Cv
int Bcl_bmp::get_type() const
{
	return m_info.bmType;
}

/// 擾
/// @return 
long Bcl_bmp::get_width() const
{
	return m_info.bmWidth;
}

/// 擾
/// @return 
long Bcl_bmp::get_height() const
{
	return m_info.bmHeight;
}

/// X^sƂ̃oCg擾
/// @return X^sƂ̃oCg
long Bcl_bmp::get_width_bytes() const
{
	return m_info.bmWidthBytes;
}

/// v[擾
/// @return v[
BYTE Bcl_bmp::get_planes() const
{
	return m_info.bmPlanes;
}

/// 1 sNZ`̂ɕKvȁAev[̗אڂJ[ rbg̐擾
/// @return 1 sNZ`̂ɕKvȁAev[̗אڂJ[ rbg̐
BYTE Bcl_bmp::get_bits_pixel() const
{
	return m_info.bmBitsPixel;
}

/// rbgl擾
/// @return rbgl
LPVOID Bcl_bmp::get_bits() const
{
	return m_info.bmBits;
}

/// J[rbg擾
/// @return J[rbg
WORD Bcl_bmp::get_color_bit() const
{
	return m_col_bit;
}

/// t@C^Cv擾
/// @return t@C^Cv
WORD Bcl_bmp::get_file_type() const
{
	return m_file_header->bfType;
}

/// t@CTCY擾
/// @return t@CTCY
DWORD Bcl_bmp::get_file_size() const
{
	return m_file_header->bfSize;
}

/// \P擾
/// @return \1
WORD Bcl_bmp::get_file_reserved1() const
{
	return m_file_header->bfReserved1;
}

/// \Q擾
/// @return \Q
WORD Bcl_bmp::get_file_reserved2() const
{
	return m_file_header->bfReserved2;
}

/// 摜rbg܂ł̃ItZbg擾
/// @return 摜rbg܂ł̃ItZbg
DWORD Bcl_bmp::get_file_offset_bit() const
{
	return m_file_header->bfOffBits;
}

/// wb_TCY擾
/// @return wb_TCY
DWORD Bcl_bmp::get_header_size() const
{
	return m_header->bmiHeader.biSize;
}

/// PsNZ̃rbg擾
/// @return PsNZ̃rbg
WORD Bcl_bmp::get_bit_count() const
{
	return m_header->bmiHeader.biBitCount;
}

/// kԎ擾
/// @return k
DWORD Bcl_bmp::get_compression() const
{
	return m_header->bmiHeader.biCompression;
}

/// 摜̃TCY擾
/// @return 摜̃TCY
DWORD Bcl_bmp::get_size_image() const
{
	return m_header->bmiHeader.biSizeImage;
}

/// P[g̃sNZij擾
/// @return P[g̃sNZij
LONG Bcl_bmp::get_pixel_pre_meter_x() const
{
	return m_header->bmiHeader.biXPelsPerMeter;
}

/// P[g̃sNZij擾
/// @return P[g̃sNZij
LONG Bcl_bmp::get_pixel_pre_meter_y() const
{
	return m_header->bmiHeader.biYPelsPerMeter;
}

/// gĂJ[e[ũGg[擾
/// @return gĂJ[e[ũGg[
DWORD Bcl_bmp::get_color_used() const
{
	return m_header->bmiHeader.biClrUsed;
}

/// KvȃJ[e[ũGg[擾
/// @return KvȃJ[e[ũGg[
DWORD Bcl_bmp::get_color_important() const
{
	return m_header->bmiHeader.biClrImportant;
}
