//==============================================================
//
// Bcl_button
//
//==============================================================
#include "bcl_button.h"
#include "bcl_str.h"

/// RXgN^
Bcl_button::Bcl_button()
{
	m_class_name	= "BUTTON";
	m_style			= WS_CHILD | WS_VISIBLE | WS_TABSTOP | BS_DEFPUSHBUTTON;
	m_window_name	= "Button";
}

/// fXgN^
Bcl_button::~Bcl_button()
{
}

/// {^[hݒ
/// @param mode [h
void Bcl_button::set_mode(BTN_MODE mode)
{
	switch (mode)
	{
		
		case BTN_MODE_PUSHBTN:
			m_style = WS_CHILD | WS_VISIBLE | WS_TABSTOP | BS_PUSHBUTTON;
			break;
		case BTN_MODE_DEFPUSHBTN:
			m_style = WS_CHILD | WS_VISIBLE | WS_TABSTOP | BS_DEFPUSHBUTTON;
			break;
		case BTN_MODE_CHECKBOX:
			m_style = WS_CHILD | WS_VISIBLE | WS_TABSTOP | BS_AUTOCHECKBOX;
			break;
		case BTN_MODE_RADIOBTN:
			m_style = WS_CHILD | WS_VISIBLE | WS_TABSTOP | BS_AUTORADIOBUTTON;
			break;
		case BTN_MODE_GROUPBOX:
			m_style = WS_CHILD | WS_VISIBLE | BS_GROUPBOX;
			break;
	}
	if (m_handle != NULL)
	{
		SetWindowLong(m_handle, GWL_STYLE, m_style);
	}
}

/// {^`FbNĂ邩ǂ肵܂
/// @return 
bool Bcl_button::is_checked() const
{
	
	if (SendMessage(m_handle, BM_GETCHECK, 0, 0) == BST_CHECKED)
	{
		return true;
	}
	return false;
}

/// {^̃`FbNԂݒ肵܂
/// @param chk `FbN
void Bcl_button::set_check(bool chk)
{
	if (chk)
	{
		SendMessage(m_handle, BM_SETCHECK, BST_CHECKED, 0);
	}
	else
	{
		SendMessage(m_handle, BM_SETCHECK, BST_UNCHECKED, 0);
	}
}
