//==============================================================
//
// Bcl_canvas
//
//==============================================================
#include "bcl_canvas.h"
#include "bcl_imglist.h"
#include "bcl_wnd.h"
#include "bcl_citr.h"

#define PAI 3.1415926

/// RXgN^
Bcl_canvas::Bcl_canvas()
 : m_bg_color(WHITE), m_color(BLACK), m_text_color(BLACK), m_brush(BRUSH_TRANSPARENT),
   m_pen(PEN_SOLID), m_hdc(NULL), m_canvas(NULL), m_focus(false)
{
}

/// RXgN^
/// @param parent eEBhE
/// @param x 
/// @param y 
Bcl_canvas::Bcl_canvas(Bcl_wnd* parent, int x, int y)
 : m_bg_color(WHITE), m_color(BLACK), m_text_color(BLACK), m_brush(BRUSH_TRANSPARENT),
   m_pen(PEN_SOLID), m_hdc(NULL), m_canvas(NULL), m_focus(false)
{
	set_canvas(parent, x, y);
}

/// LoX̐ݒ
/// @param parent eEBhE
/// @param x 
/// @param y 
/// @return 
bool Bcl_canvas::set_canvas(Bcl_wnd* parent, int x, int y)
{
	if(parent == NULL) {
		MessageBox(NULL, "EBhEnhw肳Ă܂",
					"G[", MB_OK | MB_ICONEXCLAMATION);
		return false;
	}
	if (m_hdc != NULL)
	{
		DeleteObject(m_canvas);	
		DeleteDC(m_hdc);								//Rp`cb폜
	}
	m_parent = parent;
	m_handle = parent->get_handle();					//EBhEnhL^
	HDC hDC = GetDC(m_handle);						//ΏۃEBhEDC擾
	m_hdc = CreateCompatibleDC(hDC);				//Rp`cb쐬
	m_left = m_top = 0;
	m_right = x;
	m_bottom = y;
	m_canvas = CreateCompatibleBitmap(hDC,			//m_hdcł͂Ȃ̂Œ
				m_right,							//m_hdcɂƃmNƂȂ
				m_bottom);
	SelectObject(m_hdc, m_canvas);					//L@X̎
	m_color = BLACK;								//
	m_text_color = BLACK;							//
	m_brush = BRUSH_TRANSPARENT;
	PatBlt(m_hdc, m_left, m_top, m_right, m_bottom, PATCOPY);	//`
	ReleaseDC(m_handle, hDC);							//hDCJ

	Bcl_font font(m_parent, 12, "lr ");
	set_font(font);
	return true;
}

/// fXgN^
Bcl_canvas::~Bcl_canvas()
{
	DeleteObject(m_canvas);	
	DeleteDC(m_hdc);								//Rp`cb폜
}

/// ʃNA
void Bcl_canvas::clear()
{
	HBRUSH brush = create_brush(m_bg_color, BRUSH_SOLID);
	HBRUSH old_brush = (HBRUSH)SelectObject(m_hdc, brush);
	PatBlt(m_hdc, m_left, m_top, m_right, m_bottom, PATCOPY);
	InvalidateRect(m_handle, NULL, TRUE);
	SelectObject(m_hdc, old_brush);
	DeleteObject(brush);			//NULL_BRUSH̏ꍇł͖
}

/// wiFݒ
/// @param col wiF
void Bcl_canvas::set_bg_color(COLORREF col)
{
	m_bg_color = col;
	SetBkColor(m_hdc, col);
}

/// Fݒ
/// @param col F
void Bcl_canvas::set_color(COLORREF col)
{
	m_color = col;
}

/// eLXgFݒ
/// @param col eLXgF
void Bcl_canvas::set_text_color(COLORREF col)
{
	m_text_color = col;
}

/// uV^Cvݒ
/// @param brush uV^Cv
void Bcl_canvas::set_brush_type(BRUSH_TYPE brush)
{
	m_brush = brush;
}

/// y^Cvݒ
/// @param pen y^Cv
void Bcl_canvas::set_pen_type(PEN_TYPE pen)
{
	m_pen = pen;
}

/// _`
/// @param x W
/// @param y W
void Bcl_canvas::dot(int x, int y)
{
	SetPixel(m_hdc, x, y, m_color);
	RECT rec;
	rec.left = x;
	rec.right = x + 1;
	rec.top = y;
	rec.bottom = y + 1;
	InvalidateRect(m_handle, &rec, TRUE);
}

/// `
/// @param sx n_W
/// @param sy n_W
/// @param ex I_W
/// @param ey I_W
void Bcl_canvas::line(int sx, int sy, int ex, int ey)
{
	HPEN pen = CreatePen(get_pen_type(), 0, m_color);
	HPEN old_pen = (HPEN)SelectObject(m_hdc, pen);
	MoveToEx(m_hdc, sx, sy, NULL);
	LineTo(m_hdc, ex, ey);
	SelectObject(m_hdc, old_pen);
	DeleteObject(pen);
	redraw(sx, sy, ex, ey);
	dot(ex, ey);
}

/// `
/// @param sx ゘W
/// @param sy ゙W
/// @param ex EW
/// @param ey EW
void Bcl_canvas::box(int sx, int sy, int ex, int ey)
{
	if (sx > ex)
	{
		int tmp = sx;
		sx = ex;
		ex = tmp;
	}
	if (sy > ey)
	{
		int tmp = sy;
		sy = ey;
		ey = tmp;
	}
	HPEN pen = CreatePen(get_pen_type(), 0, m_color);
	HPEN old_pen = (HPEN)SelectObject(m_hdc, pen);
	HBRUSH brush = create_brush(m_color, m_brush);
	HBRUSH old_brush = (HBRUSH)SelectObject(m_hdc, brush);
	Rectangle(m_hdc, sx, sy, ex + 1, ey + 1);
	SelectObject(m_hdc, old_pen);
	SelectObject(m_hdc, old_brush);
	DeleteObject(pen);
	DeleteObject(brush);			//NULL_BRUSH̏ꍇł͖
	redraw(sx, sy, ex + 1, ey + 1);
}

/// ~`
/// @param x SW
/// @param y SW
/// @param r a
void Bcl_canvas::circle(int x, int y, int r)
{
	HPEN pen = CreatePen(get_pen_type(), 0, m_color);
	HPEN old_pen = (HPEN)SelectObject(m_hdc, pen);
	HBRUSH brush = create_brush(m_color, m_brush);
	HBRUSH old_brush = (HBRUSH)SelectObject(m_hdc, brush);
	Ellipse(m_hdc, x - r, y - r, x + r, y + r);
	SelectObject(m_hdc, old_pen);
	SelectObject(m_hdc, old_brush);
	DeleteObject(pen);
	DeleteObject(brush);			//NULL_BRUSH̏ꍇł͖
	redraw(x - r, y - r, x + r + 1, y + r + 1);
}

/// ȉ~`
/// @param sx Oڒ`̍゘W
/// @param sy Oڒ`゙̍W
/// @param ex Oڒ`̉EW
/// @param ey Oڒ`̉EW
void Bcl_canvas::ellipse(int sx, int sy, int ex, int ey)
{
	if (sx > ex)
	{
		int tmp = sx;
		sx = ex;
		ex = tmp;
	}
	if (sy > ey)
	{
		int tmp = sy;
		sy = ey;
		ey = tmp;
	}
	HPEN pen = CreatePen(get_pen_type(), 0, m_color);
	HPEN old_pen = (HPEN)SelectObject(m_hdc, pen);
	HBRUSH brush = create_brush(m_color, m_brush);
	HBRUSH old_brush = (HBRUSH)SelectObject(m_hdc, brush);
	Ellipse(m_hdc, sx, sy, ex + 1, ey + 1);
	SelectObject(m_hdc, old_pen);
	SelectObject(m_hdc, old_brush);
	DeleteObject(pen);
	DeleteObject(brush);			//NULL_BRUSH̏ꍇł͖
	redraw(sx, sy, ex + 1, ey + 1);
}

/// ~ʕ`
/// @param sx ȉ~̊Oڒ`̍゘W
/// @param sy ȉ~̊Oڒ`゙̍W
/// @param ex ȉ~̊Oڒ`̉EW
/// @param ey ȉ~̊Oڒ`̉EW
/// @param srx ȉ~̌ʂ̎n_`˒̒[_̂W
/// @param sry ȉ~̌ʂ̎n_`˒̒[_̂W
/// @param erx ȉ~̌ʂ̏I_`˒̒[_̂W
/// @param ery ȉ~̌ʂ̏I_`˒̒[_̂W
void Bcl_canvas::arc(int sx, int sy, int ex, int ey, int srx, int sry, int erx, int ery)
{
	HPEN pen = CreatePen(get_pen_type(), 0, m_color);
	HPEN old_pen = (HPEN)SelectObject(m_hdc, pen);
	Arc(m_hdc, sx, sy, ex, ey, srx, sry, erx, ery);
	SelectObject(m_hdc, old_pen);
	DeleteObject(pen);
	redraw(sx, sy, ex, ey);
}

/// `
/// @param sx ȉ~̊Oڒ`̍゘W
/// @param sy ȉ~̊Oڒ`゙̍W
/// @param ex ȉ~̊Oڒ`̉EW
/// @param ey ȉ~̊Oڒ`̉EW
/// @param srx ȉ~̌ʂ̎n_`˒̒[_̂W
/// @param sry ȉ~̌ʂ̎n_`˒̒[_̂W
/// @param erx ȉ~̌ʂ̏I_`˒̒[_̂W
/// @param ery ȉ~̌ʂ̏I_`˒̒[_̂W
void Bcl_canvas::chord(int sx, int sy, int ex, int ey, int srx, int sry, int erx, int ery)
{
	HPEN pen = CreatePen(get_pen_type(), 0, m_color);
	HPEN old_pen = (HPEN)SelectObject(m_hdc, pen);
	HBRUSH brush = create_brush(m_color, m_brush);
	HBRUSH old_brush = (HBRUSH)SelectObject(m_hdc, brush);
	Chord(m_hdc, sx, sy, ex, ey, srx, sry, erx, ery);
	SelectObject(m_hdc, old_pen);
	SelectObject(m_hdc, old_brush);
	DeleteObject(pen);
	DeleteObject(brush);			//NULL_BRUSH̏ꍇł͖
	redraw(sx, sy, ex, ey);
}

/// p``
/// @param pts _̗
void Bcl_canvas::polygon(const std::vector<POINT>& pts)
{
	HPEN pen = CreatePen(get_pen_type(), 0, m_color);
	HPEN old_pen = (HPEN)SelectObject(m_hdc, pen);
	HBRUSH brush = create_brush(m_color, m_brush);
	HBRUSH old_brush = (HBRUSH)SelectObject(m_hdc, brush);
	POINT* lp_point = new POINT[pts.size()];
	Bcl_citr< std::vector<POINT> > itr(pts);
	POINT min;
	POINT max;
	min.x = 0x7fffffff;
	min.y = 0x7fffffff;
	max.x = 0x80000000;
	max.y = 0x80000000;
	while (itr.has_next())
	{
		int i = itr.get_count();
		lp_point[i] = itr.next();
		if (min.x > lp_point[i].x) min.x = lp_point[i].x;
		if (min.y > lp_point[i].y) min.y = lp_point[i].y;
		if (max.x < lp_point[i].x) max.x = lp_point[i].x;
		if (max.y < lp_point[i].y) max.y = lp_point[i].y;
	}
	Polygon(m_hdc, lp_point, pts.size());
	delete[] lp_point;
	SelectObject(m_hdc, old_pen);
	SelectObject(m_hdc, old_brush);
	DeleteObject(pen);
	DeleteObject(brush);			//NULL_BRUSH̏ꍇł͖
	redraw(min.x, min.y, max.x, max.y);
}

/// ĕ`
/// @param sx ゘W
/// @param sy ゙W
/// @param ex EW
/// @param ey EW
void Bcl_canvas::redraw(int sx, int sy, int ex, int ey)
{
	RECT rec;
	rec.left = sx > ex ? ex : sx;
	rec.right = sx > ex ? sx + 1 : ex + 1;
	rec.top = sy > ey ? ey : sy;
	rec.bottom = sy > ey ? sy + 1 : ey + 1;
	InvalidateRect(m_handle, &rec, TRUE);
}

/// hbO`
/// @param x W
/// @param y W
/// @param flag hbO
void Bcl_canvas::drag_rect(int x, int y, bool flag)
{
	static RECT rect;
	HDC hDC = GetDC(m_handle);
	if(flag) {		//`
		if(m_focus)
		{
			DrawFocusRect(hDC, &rect);
			rect.left = m_start.x <= x ? m_start.x : x;
			rect.right = m_start.x > x ? m_start.x : x;
			rect.top = m_start.y <= y ? m_start.y : y;
			rect.bottom = m_start.y > y ? m_start.y : y;
			DrawFocusRect(hDC, &rect);
		}
		else
		{
			m_start.x = rect.left = rect.right = x;
			m_start.y = rect.top = rect.bottom = y;
			DrawFocusRect(hDC, &rect);
			m_focus = true;
		}
	}
	else
	{
		DrawFocusRect(hDC, &rect);
		m_focus = false;
	}
	ReleaseDC(m_handle, hDC);
}

/// `
void Bcl_canvas::paint()
{
	PAINTSTRUCT paint;
	HDC hDC = BeginPaint(m_handle, &paint);
	BitBlt(hDC, m_left, m_top, m_right, m_bottom, m_hdc, 0, 0, SRCCOPY);
	EndPaint(m_handle, &paint);
}

/// uV
/// @param col F
/// @param type uV^Cv
/// @return uV
HBRUSH Bcl_canvas::create_brush(COLORREF col, BRUSH_TYPE type)
{
	HBRUSH brush;
	switch (type)
	{
	case BRUSH_SOLID:
		brush = CreateSolidBrush(col);
		break;
	case BRUSH_HHATCH:
		brush = CreateHatchBrush(HS_HORIZONTAL, col);
		break;
	case BRUSH_VHATCH:
		brush = CreateHatchBrush(HS_VERTICAL, col);
		break;
	case BRUSH_HVHATCH:
		brush = CreateHatchBrush(HS_CROSS, col);
		break;
	case BRUSH_RHATCH:
		brush = CreateHatchBrush(HS_BDIAGONAL, col);
		break;
	case BRUSH_LHATCH:
		brush = CreateHatchBrush(HS_FDIAGONAL, col);
		break;
	case BRUSH_RLHATCH:
		brush = CreateHatchBrush(HS_DIAGCROSS, col);
		break;
	case BRUSH_TRANSPARENT:
	default:
		brush = (HBRUSH)GetStockObject(NULL_BRUSH);
		break;
	}
	return brush;
}

/// y^Cv擾
/// @return y^Cv
int Bcl_canvas::get_pen_type()
{
	int rtn;
	switch (m_pen)
	{
		case PEN_SOLID:
			rtn = PS_SOLID;
			break;
		case PEN_DASH:
			rtn = PS_DASH;
			break;
		case PEN_DOT:
			rtn = PS_DOT;
			break;
		case PEN_DASHDOT:
			rtn = PS_DASHDOT;
			break;
		case PEN_DASHDOTDOT:
			rtn = PS_DASHDOTDOT;
			break;
		default:
			rtn = PS_SOLID;
			break;
	}
	return rtn;
}

/// rbg}bv擾
/// @param x W
/// @param y W
/// @param w 
/// @param h 
/// @return rbg}bv
Bcl_bmp* Bcl_canvas::get_bmp(int x, int y, int w, int h) const
{
	Bcl_bmp* rtn_bmp = new Bcl_bmp();
	HDC hDC = GetDC(m_handle);						//EBhEDC擾
	HDC memDC = CreateCompatibleDC(hDC);			//Rp`cb쐬
	HBITMAP bmp = CreateCompatibleBitmap(hDC, w, h);	//Rp`rbg}bv쐬
	SelectObject(memDC, bmp);							//rbg}bvI
	StretchBlt(memDC, 0, 0, w, h, m_hdc, x, y, w, h, SRCCOPY);
	ReleaseDC(m_handle, hDC);							//EBhEDCJ
	DeleteObject(memDC);							//Rp`cb폜
	rtn_bmp->set_handle(bmp);
	return rtn_bmp;
}

/// rbg}bv`
/// @param bmp rbg}bv
/// @param x W
/// @param y W
/// @param ro X^Iy[VR[h
void Bcl_canvas::put_bmp(const Bcl_bmp& bmp, int x, int y, DWORD ro)
{
	if (bmp.get_handle() == NULL)
	{
		return;			// leave function
	}
	HDC hDC = GetDC(m_handle);						//EBhEDC擾
	HDC memDC = CreateCompatibleDC(hDC);			//Rp`cb쐬
	SelectObject(memDC, bmp.get_handle());			//rbg}bvI
	BitBlt(m_hdc, x, y, bmp.get_width(), bmp.get_height(), memDC, 0, 0, ro);
	redraw(x, y, x + bmp.get_width(), y + bmp.get_height());	//`
	ReleaseDC(m_handle, hDC);							//EBhEDCJ
	DeleteObject(memDC);							//Rp`cb폜
}

/// rbg}bv`igEkj
/// @param bmp rbg}bv
/// @param x W
/// @param y W
/// @param w 
/// @param h 
/// @param ro X^Iy[VR[h
/// @param mode Xgb`O[h
void Bcl_canvas::fit_bmp(const Bcl_bmp& bmp, int x, int y, int w, int h, DWORD ro, int mode)
{
	if (bmp.get_handle() == NULL)
	{
		return;			// leave function
	}
	HDC hDC = GetDC(m_handle);						//EBhEDC擾
	HDC memDC = CreateCompatibleDC(hDC);			//Rp`cb쐬
	SelectObject(memDC, bmp.get_handle());			//rbg}bvI
	SetStretchBltMode(m_hdc, mode);
	StretchBlt(m_hdc, x, y, w, h, memDC, 0, 0, bmp.get_width(), bmp.get_height(), ro);
	redraw(x, y, x + w, y + h);	//`
	ReleaseDC(m_handle, hDC);							//EBhEDCJ
	DeleteObject(memDC);							//Rp`cb폜
}

/// eLXg`
/// @param x W
/// @param y W
/// @param str eLXg
/// @param w `敝
/// @param fmt eLXg`IvV
void Bcl_canvas::print_text(int x, int y, const Bcl_str& str, int w, UINT fmt)
{
	RECT rec;
	SetTextColor(m_hdc, m_text_color);
	HFONT old_font;
	if (m_font.is_valid())
	{
		old_font = (HFONT)SelectObject(m_hdc, m_font.get_handle());
	}
	GetClientRect(m_handle, &rec);
	rec.left = x;
	rec.top = y;
	if (w > 0)	rec.right = x + w;
	RECT chk_rec = rec;
	rec.bottom = y + DrawText(m_hdc, str.to_char(), -1, &chk_rec, fmt | DT_CALCRECT);
	DrawText(m_hdc, str.to_char(), -1, &rec, fmt);
	if (m_font.is_valid())
	{
		SelectObject(m_hdc, old_font);
	}
	RECT rec_st = rec;
	double angle = 0;
	if (m_font.is_valid())
	{
		angle = m_font.get_angle() / 10;
	}
	if (angle < 90)
	{
		rec.left = rec_st.left;
		rec.top = rec_st.top - (rec_st.right - rec_st.left)  * sin(PAI / 180 * angle);
		rec.right = rec_st.left + (rec_st.right - rec_st.left)  * cos(PAI / 180 * angle) + (rec_st.bottom - rec_st.top)  * sin(PAI / 180 * angle);
		rec.bottom = rec_st.top + (rec_st.bottom - rec_st.top)  * cos(PAI / 180 * angle);
	}
	else if (angle < 180)
	{
		rec.left = rec_st.left + (rec_st.right - rec_st.left)  * cos(PAI / 180 * angle);
		rec.top = rec_st.top - (rec_st.right - rec_st.left)  * sin(PAI / 180 * angle) - (rec_st.bottom - rec_st.top)  * sin(PAI / 180 * (angle - 90));
		rec.right = rec_st.left + (rec_st.bottom - rec_st.top)  * cos(PAI / 180 * (angle - 90));
		rec.bottom = rec_st.top;
	}
	else if (angle < 270)
	{
		rec.left = rec_st.left + (rec_st.right - rec_st.left)  * cos(PAI / 180 * angle) + (rec_st.bottom - rec_st.top)  * cos(PAI / 180 * (angle - 90));
		rec.top = rec_st.top - (rec_st.bottom - rec_st.top)  * sin(PAI / 180 * (angle - 90));
		rec.right = rec_st.left;
		rec.bottom = rec_st.top - (rec_st.right - rec_st.left)  * sin(PAI / 180 * angle);
	}
	else
	{
		rec.left = rec_st.left + (rec_st.bottom - rec_st.top)  * cos(PAI / 180 * (angle - 90));
		rec.top = rec_st.top;
		rec.right = rec_st.left + (rec_st.right - rec_st.left)  * cos(PAI / 180 * angle);
		rec.bottom = rec_st.top - (rec_st.right - rec_st.left)  * sin(PAI / 180 * angle) - (rec_st.bottom - rec_st.top)  * sin(PAI / 180 * (angle - 90));
	}
	InvalidateRect(m_handle, &rec, TRUE);
}

/// eLXg`掞̕ύXꂽ擾
/// @param str eLXg
/// @param w `敝
/// @param fmt eLXg`IvV
/// @return ύXꂽ
Bcl_str Bcl_canvas::get_modify_text_by_print(const Bcl_str& str, int w, UINT fmt)
{
	RECT rec;
	HFONT old_font;
	if (m_font.is_valid())
	{
		old_font = (HFONT)SelectObject(m_hdc, m_font.get_handle());
	}
	GetClientRect(m_handle, &rec);
	rec.left = 0;
	rec.top = 100;
	if (w > 0)	rec.right = w;
	char* work_str = new char[str.get_length() + 10];
	strcpy(work_str, str.to_char());
	DrawText(m_hdc, work_str, -1, &rec, fmt | DT_CALCRECT | DT_MODIFYSTRING);
	if (m_font.is_valid())
	{
		SelectObject(m_hdc, old_font);
	}
	Bcl_str modify_str(work_str);
	delete[] work_str;
	return modify_str;
}

/// eLXg`icj
/// @param x W
/// @param y W
/// @param str eLXg
/// @param size ő`敶
void Bcl_canvas::print_htext(int x, int y, const Bcl_str& str, int size, UINT fmt)
{
char moji[3];
int i, j, len;
	i = 0;
	j = 0;
	len = strlen(str.to_char());
	Bcl_font font_hold = m_font;
	m_font.set_font_effect(m_font.get_bold(), m_font.is_italic(), false, false);
	double angle = 0;
	if (m_font.is_valid())
	{
		angle = PAI / 180 * (m_font.get_angle() / 10);
	}
	while ((i < len) && (j < size))
	{
		if (((0x81 <= (unsigned char)str[i]) && ((unsigned char)str[i] <= 0x9F)) ||
			((0xE0 <= (unsigned char)str[i])))
		{
			moji[0] = str[i];
			moji[1] = str[i + 1];
			moji[2] = 0;
			i += 2;
			int height = j * m_font.get_height();
			if ((strcmp(moji, "i") == 0) || (strcmp(moji, "j") == 0) || (strcmp(moji, "[") == 0))
			{
				Bcl_font font = m_font;
				m_font.set_angle((m_font.get_angle() + 2700) % 3600);
			 	int width = m_font.get_height();
			 	print_text(x + sin(angle) * height + cos(angle) * width, y + cos(angle) * height - sin(angle) * width, moji, 0, fmt);
			 	m_font = font;
			}
			else
			{
			 	print_text(x + sin(angle) * height, y + cos(angle) * height, moji, 0, fmt);
			}
		}
		else
		{
			moji[0] = str[i];
			moji[1] = 0;
			i++;
			if ((strcmp(moji, "(") == 0) || (strcmp(moji, ")") == 0) || (strcmp(moji, "-") == 0))
			{
				Bcl_font font = m_font;
				m_font.set_angle((m_font.get_angle() + 2700) % 3600);
				int height = j * m_font.get_height() + m_font.get_height() / 4;
				int width = m_font.get_height();
				print_text(x + sin(angle) * height + cos(angle) * width, y + cos(angle) * height - sin(angle) * width, moji, 0, fmt);
			 	m_font = font;
			}
			else
			{
				int height = j * m_font.get_height();
				int width = m_font.get_height() / 4;
				print_text(x + sin(angle) * height + cos(angle) * width, y + cos(angle) * height - sin(angle) * width, moji, 0, fmt);
			}
		}
		j++;
	}
	COLORREF color = m_color;
	m_color = m_text_color;
	int height = j * m_font.get_height() - 1;
	int width = m_font.get_height() / 2;
	if (font_hold.is_underline())
	{
		line(x, y, x + sin(angle) * height, y + cos(angle) * height);
	}
	if (font_hold.is_strikeout())
	{
		line(x + cos(angle) * width, y - sin(angle) * width, x + cos(angle) * width + sin(angle) * height, y - sin(angle) * width + cos(angle) * height);
	}
	m_color = color;
	m_font = font_hold;
}

/// C[WXg`
/// @param list C[WXg
/// @param x W
/// @param y W
/// @param num \C[W̃CfbNX
void Bcl_canvas::show_imglist(const Bcl_imglist& list, int x, int y, int num)
{
	list.show_img(m_hdc, x, y, num);
	redraw(x, y, x + list.get_width() - 1, y + list.get_height() - 1);
}

/// C[WXgS`
/// @param list C[WXg
/// @param x W
/// @param y W
void Bcl_canvas::show_all_imglist(const Bcl_imglist& list, int x, int y)
{
	list.show_all(m_hdc, x, y);
	redraw(x, y, x + list.get_width() * list.get_count() - 1, y + list.get_height() - 1);
}

/// w肵W̐F擾
/// @param x W
/// @param y W
/// @return F
COLORREF Bcl_canvas::get_pixel(int x, int y) const
{
	return GetPixel(m_hdc, x, y);
}

/// tHgݒ
/// @param font tHg
void Bcl_canvas::set_font(const Bcl_font& font)
{
	m_font = font;
}

/// tHgTCYݒ
/// @param size tHgTCY
void Bcl_canvas::set_font_size(int size)
{
	m_font.set_size(m_parent, size);
}

/// tHgݒ
/// @param height tHg
void Bcl_canvas::set_font_height(int height)
{
	m_font.set_height(height);
}

/// tHg̊pxݒ
/// @param angle px
void Bcl_canvas::set_font_angle(int angle)
{
	m_font.set_angle(angle);
}

/// tHǧʂݒ肵܂
/// @param bold 
/// @param italic Α
/// @param underline 
/// @param strikeout 
void Bcl_canvas::set_font_effect(LONG bold, bool italic, bool underline, bool strikeout)
{
	m_font.set_font_effect(bold, italic, underline, strikeout);
}

/// tHg擾
/// @return tHg
const Bcl_font& Bcl_canvas::get_font() const
{
	return m_font;
}

/// tHgTCY擾
/// @return tHgTCY
int Bcl_canvas::get_font_height() const
{
	return m_font.get_height();
}
