//==============================================================
//
// Bcl_colordlg
//
//==============================================================
#include "bcl_colordlg.h"
#include "bcl_wnd.h"

bool Bcl_colordlg::m_init = false;
COLORREF Bcl_colordlg::m_ccol[16];

/// RXgN^
Bcl_colordlg::Bcl_colordlg(Bcl_wnd* parent) : m_parent(parent), m_col(RGB(0, 0, 0))
{
	if (!m_init)
	{
		for (int i = 0; i < 16; i++)
		{
			m_ccol[i] = RGB(255, 255, 255);
		}
		m_init = true;
	}
	m_flags = CC_RGBINIT;
}

/// fXgN^
Bcl_colordlg::~Bcl_colordlg()
{
}

/// J[_CAO쐬܂
/// @return 
bool Bcl_colordlg::do_modal()
{
	CHOOSECOLOR clr;

	clr.lStructSize		= sizeof(CHOOSECOLOR);
	clr.hwndOwner		= m_parent->get_handle();
	clr.hInstance		= 0;
	clr.rgbResult		= m_col; //CC_RGBINITtbOƂꂪftHgɂȂ
	clr.lpCustColors	= m_ccol;
	clr.Flags			= m_flags;
	clr.lCustData		= 0L;
	clr.lpfnHook		= NULL;
	clr.lpTemplateName	= NULL;
	if (!ChooseColor(&clr))
	{
		return false;		// leave function
	}
	m_col = clr.rgbResult;
	return true;
}

/// Fݒ
/// @param col F
void Bcl_colordlg::set_color(COLORREF col)
{
	m_col = col;
}

/// F擾
/// @return F
COLORREF Bcl_colordlg::get_color() const
{
	return m_col;
}

/// JX^Fݒ
/// @param idx CfbNX(0-15)
/// @param col JX^F
void Bcl_colordlg::set_custom_color(int idx, COLORREF col)
{
	if ((idx < 0) || (idx >= 16)) return;
	m_ccol[idx] = col;
}

/// JX^F擾
/// @param idx CfbNX(0-15)
/// @return JX^F
COLORREF Bcl_colordlg::get_custom_color(int idx) const
{
	if ((idx < 0) || (idx >= 16)) return RGB(0, 0, 0);
	return m_ccol[idx];
}

/// F̍쐬̏Ԃݒ肵܂
/// @param mode F̍쐬̏
void Bcl_colordlg::set_fullopen(FULLOPEN_MODE mode)
{
	switch (mode)
	{
		case FULLOPEN:
			m_flags = CC_RGBINIT | CC_FULLOPEN;
			break;
		case NOT_FULLOPEN:
			m_flags = CC_RGBINIT;
			break;
		case DISABLE_FULLOPEN:
			m_flags = CC_RGBINIT | CC_PREVENTFULLOPEN;
			break;
	}
}
