//==============================================================
//
// Bcl_date
//
//==============================================================
#include	<dos.h>
#include	"Bcl_date.h"
#include	"Bcl_str.h"

int Bcl_date::max_day[] = {31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};

/// RXgN^
Bcl_date::Bcl_date()
{
	std::date d;
	getdate(&d);
	set_date(d.da_year, d.da_mon, d.da_day);
}

/// RXgN^
/// @param year N
/// @param month 
/// @param day 
Bcl_date::Bcl_date(int year, int month, int day)
{
	set_date(year, month, day);
}

/// ݒ
/// @param year N
/// @param month 
/// @param day 
void Bcl_date::set_date(int year, int month, int day)
{
	m_date = (year - 1) * 365;
	m_date = m_date + (year - 1) / 4 - (year - 1) / 100 + (year - 1) / 400;
	for (int i = 0; i < month - 1; i++)
	{
		m_date += max_day[i];
		if ((i == 1) && (is_uru(year)))
		{
			m_date++;
		}
	}
	m_date += day - 1;
}

/// fXgN^
Bcl_date::~Bcl_date()
{
}

/// t擾
/// @param fmt tH[}bg
/// @return t
Bcl_str Bcl_date::get_string(DATE_FORMAT fmt) const
{
	int year;
	int month;
	int day;
	get_date(year, month, day);
	Bcl_str rtn;
	if ((fmt == DATE_FMT_SPACE) || (fmt == DATE_FMT_SPACE_WEEK) || (fmt == DATE_FMT_SPACE_ENG_WEEK))
	{
		rtn = Bcl_str(year, RADIX_DEC) + Bcl_str("/");
		if (month < 10)
		{
			rtn += Bcl_str(" ");
		}
		rtn += Bcl_str(month, RADIX_DEC) + Bcl_str("/");
		if (day < 10)
		{
			rtn += Bcl_str(" ");
		}
		rtn += Bcl_str(day, RADIX_DEC);
	}
	else if ((fmt == DATE_FMT_ZERO) || (fmt == DATE_FMT_ZERO_WEEK) || (fmt == DATE_FMT_ZERO_ENG_WEEK))
	{
		rtn = Bcl_str(year, RADIX_DEC) + Bcl_str("/");
		if (month < 10)
		{
			rtn += Bcl_str("0");
		}
		rtn += Bcl_str(month, RADIX_DEC) + Bcl_str("/");
		if (day < 10)
		{
			rtn += Bcl_str("0");
		}
		rtn += Bcl_str(day, RADIX_DEC);
	}
	else
	{
		rtn = Bcl_str(year, RADIX_DEC) + Bcl_str("/") + Bcl_str(month, RADIX_DEC) + Bcl_str("/") + Bcl_str(day, RADIX_DEC);
	}
	if ((fmt == DATE_FMT_SPACE_WEEK) || (fmt == DATE_FMT_ZERO_WEEK) || (fmt == DATE_FMT_TRIM_WEEK))
	{
		rtn += Bcl_str("(") + get_week_str() + Bcl_str(")");
	}
	else if ((fmt == DATE_FMT_SPACE_ENG_WEEK) || (fmt == DATE_FMT_ZERO_ENG_WEEK) || (fmt == DATE_FMT_TRIM_ENG_WEEK))
	{
		rtn += Bcl_str("(") + get_week_english_str() + Bcl_str(")");
	}
	return rtn;
}

/// 邤N`FbN
/// @param year N
/// @return 
bool Bcl_date::is_uru(int year) const
{
	return (((year % 4) == 0) && (((year % 100) != 0) || ((year % 400) == 0)));
}

/// T擾
/// @return T
Bcl_str Bcl_date::get_week_str() const
{
	Bcl_str rtn;
	switch (get_week())
	{
		case 0:
			rtn = "";
			break;
		case 1:
			rtn = "";
			break;
		case 2:
			rtn = "";
			break;
		case 3:
			rtn = "";
			break;
		case 4:
			rtn = "";
			break;
		case 5:
			rtn = "";
			break;
		case 6:
			rtn = "y";
			break;
	}
	return rtn;
}

/// Tipj擾
/// @return T
Bcl_str Bcl_date::get_week_english_str() const
{
	Bcl_str rtn;
	switch (get_week())
	{
		case 0:
			rtn = "SUN";
			break;
		case 1:
			rtn = "MON";
			break;
		case 2:
			rtn = "TUE";
			break;
		case 3:
			rtn = "WED";
			break;
		case 4:
			rtn = "THU";
			break;
		case 5:
			rtn = "FRI";
			break;
		case 6:
			rtn = "SAT";
			break;
	}
	return rtn;
}

/// N擾
/// @return N
int Bcl_date::get_year() const
{
	int year;
	int month;
	int day;
	get_date(year, month, day);
	return year;
}

/// 擾
/// @return 
int Bcl_date::get_month() const
{
	int year;
	int month;
	int day;
	get_date(year, month, day);
	return month;
}

/// 擾
/// @return 
int Bcl_date::get_day() const
{
	int year;
	int month;
	int day;
	get_date(year, month, day);
	return day;
}

/// T擾
/// @return T
char Bcl_date::get_week() const
{
	return (char)((m_date + 1) % 7);
}

/// t擾
/// @param year N
/// @param month 
/// @param day 
void Bcl_date::get_date(int& year, int& month, int& day) const
{
	day = m_date + 1;
	year = 1;
	while (day > (365 + (is_uru(year) ? 1 : 0)))
	{
		day -= 365 + (is_uru(year) ? 1 : 0);
		year++;
	}
	month = 1;
	while (day > max_day[month - 1] + ((month == 2) && (is_uru(year)) ? 1 : 0))
	{
		day -= max_day[month - 1] + ((month == 2) && (is_uru(year)) ? 1 : 0);
		month++;
	}
}

/// rij֐
/// @param rhs rΏ
/// @return 
bool Bcl_date::operator<(const Bcl_date& rhs) const
{
	if (m_date < rhs.m_date)
	{
		return true;
	}
	return false;
}

/// rij֐
/// @param rhs rΏ
/// @return 
bool Bcl_date::operator<=(const Bcl_date& rhs) const
{
	if (m_date <= rhs.m_date)
	{
		return true;
	}
	return false;
}

/// rij֐
/// @param rhs rΏ
/// @return 
bool Bcl_date::operator>(const Bcl_date& rhs) const
{
	if (m_date > rhs.m_date)
	{
		return true;
	}
	return false;
}

/// rij֐
/// @param rhs rΏ
/// @return 
bool Bcl_date::operator>=(const Bcl_date& rhs) const
{
	if (m_date >= rhs.m_date)
	{
		return true;
	}
	return false;
}

/// rij֐
/// @param rhs rΏ
/// @return 
bool Bcl_date::operator==(const Bcl_date& rhs) const
{
	if (m_date == rhs.m_date)
	{
		return true;
	}
	return false;
}

/// riIj֐
/// @param rhs rΏ
/// @return 
bool Bcl_date::operator!=(const Bcl_date& rhs) const
{
	if (m_date != rhs.m_date)
	{
		return true;
	}
	return false;
}

/// CNgiOuj
/// @return gւ̎Q
Bcl_date& Bcl_date::operator++()
{
	m_date++;
	return *this;
}

/// CNgiuj
/// @return CNgO̒l
Bcl_date Bcl_date::operator++(int dmy)
{
	Bcl_date rtn = *this;
	m_date++;
	return rtn;
}

/// fNgiOuj
/// @return gւ̎Q
Bcl_date& Bcl_date::operator--()
{
	m_date--;
	return *this;
}

/// fNgiuj
/// @return fNgO̒l
Bcl_date Bcl_date::operator--(int dmy)
{
	Bcl_date rtn = *this;
	m_date--;
	return rtn;
}

/// ZZq
/// @param x Zl
/// @return 
Bcl_date Bcl_date::operator+(int x) const
{
	Bcl_date z;
	z.m_date = m_date + x;
	return z;
}

/// ZZq
/// @param x Zl
/// @return gւ̎Q
Bcl_date& Bcl_date::operator+=(int x)
{
	m_date += x;
	return *this;
}

/// ZZq
/// @param x Zl
/// @return 
Bcl_date Bcl_date::operator-(int x) const
{
	Bcl_date z;
	z.m_date = m_date - x;
	return z;
}

/// ZZq
/// @param x Zl
/// @return gւ̎Q
Bcl_date& Bcl_date::operator-=(int x)
{
	m_date -= x;
	return *this;
}

/// vZ
/// @param x Ώۓ
/// @return 
long Bcl_date::operator-(const Bcl_date& x) const
{
	return m_date - x.m_date;
}
