//==============================================================
//
// Bcl_dlg
//
//==============================================================
#include "bcl_dlg.h"
#include "bcl_citr.h"

/// RXgN^
/// @param parent eEBhE
/// @param name _CAO
Bcl_dlg::Bcl_dlg(Bcl_wnd* parent, const Bcl_str& name)
 : m_parent(parent), m_name(name), m_dlg_proc_rtn(true)
{
	m_handle = NULL;
	m_instance = m_parent->get_instance();
}

/// RXgN^
/// @param instance CX^X
/// @param name _CAO
Bcl_dlg::Bcl_dlg(HINSTANCE instance, const Bcl_str& name) : m_parent(NULL), m_name(name)
{
	m_handle = NULL;
	m_instance = instance;
}

/// fXgN^
Bcl_dlg::~Bcl_dlg()
{
}

/// [__CAO쐬܂
/// @return 
int Bcl_dlg::do_modal()
{
	m_modal = true;
	m_cur_wnd = this;
	if (m_handle != NULL) return false;
	//_CAOJ
	HWND wnd = NULL;
	if (m_parent != NULL)
	{
		wnd = m_parent->get_handle();
	}
	int ret = DialogBox(m_instance, m_name.to_char(), wnd, modal_dlg_proc);
	if(ret == -1)
		return false;
	return ret;
}

/// [hX_CAO쐬܂
/// @return 
bool Bcl_dlg::create()
{
	m_modal = false;
	m_cur_wnd = this;
	if(m_handle)	return false;
	//_CAOJ
	HWND wnd = NULL;
	if (m_parent != NULL)
	{
		wnd = m_parent->get_handle();
	}
	m_handle = CreateDialog(m_instance, m_name.to_char(), wnd, modeless_dlg_proc);
	if(!m_handle)
	{
		return false;
	}
	if (m_parent != NULL)
	{
		m_parent->m_dlg_handle.push_back(m_handle);
	}
	ShowWindow(m_handle, SW_SHOWNORMAL);
	UpdateWindow(m_handle);
	return true;
}

/// ANZ[^ݒ肵܂
/// @param name ANZ[^
/// @return 
bool Bcl_dlg::include_accel(LPCTSTR name)
{
	m_accel = LoadAccelerators(m_instance, name);
	if(!m_accel)
	{
		MessageBox(NULL, "ANZ[^[̓ǍɎs܂","G[", MB_OK);
		return false;
	}
	return true;
}

/// bZ[W[v
/// @return 
UINT Bcl_dlg::loop()
{
	MSG msg;
	while(GetMessage(&msg, NULL, 0, 0))
	{
		Bcl_citr< std::vector<HWND> > itr(m_dlg_handle);
		bool flg = false;
		while (itr.has_next())
		{
			if (IsDialogMessage(itr.next(), &msg))
			{
				flg = true;
				break;
			}
		}
		if ((!flg) && (!TranslateAccelerator(m_handle, m_accel, &msg)) &&
			(!IsDialogMessage(m_handle, &msg)))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}
	return msg.wParam;
}

/// dN`FbNi~[ebNXɒlݒ肵āA݂邩ǂŃ`FbN܂j
/// @param uniq_name dN`FbŃi~[ebNXɐݒ肷lj
/// @return dNĂ邩ǂ
bool Bcl_dlg::is_only_one(char* uniq_name) const
{
	HANDLE hMutex = CreateMutex(NULL, TRUE, uniq_name);
	if (!hMutex) 	return FALSE;
	// GetLastError()AERROR_ALREADY_EXISTSȂA
	// łɃAvP[VNĂ
	if (GetLastError() == ERROR_ALREADY_EXISTS)
	{
    	//dN
    	return false;
	}
	return true;
}

/// [__CAȌI
/// @param rtn ߂l
void Bcl_dlg::end_modal(int rtn)
{
	EndDialog(m_handle, rtn);
	m_handle = NULL;
}

/// WM_INITDIALOG̃bZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Bcl_dlg::on_init(WPARAM wp, LPARAM lp)
{
}

/// WM_CLOSẼbZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Bcl_dlg::on_close(WPARAM wp, LPARAM lp)
{
	if (m_modal)
	{
		end_modal(0);
	}
	else
	{
		if (m_parent != NULL)
		{
			std::vector<HWND>::iterator itr = std::find(m_parent->m_dlg_handle.begin(), m_parent->m_dlg_handle.end(), m_handle);
			m_parent->m_dlg_handle.erase(itr);
		}
		Bcl_wnd::on_close(wp, lp);
	}
}

/// ŃtH[JXύX
/// @return 
bool Bcl_dlg::is_change_focus()
{
	return false;
}

/// _CAOeEBhE̒Ɉړ܂
void Bcl_dlg::move_center_of_parent()
{
	RECT parent_rect;
	if (m_parent != NULL)
	{
		parent_rect = m_parent->get_rect();
	}
	else
	{
		GetWindowRect(NULL, &parent_rect);
	}
	int parent_width = parent_rect.right - parent_rect.left + 1;
	int parent_height = parent_rect.bottom - parent_rect.top + 1;
	RECT dlg_rect = get_rect();
	int dlg_width = dlg_rect.right - dlg_rect.left + 1;
	int dlg_height = dlg_rect.bottom - dlg_rect.top + 1;
	RECT win_rect;
	GetWindowRect(GetDesktopWindow(), &win_rect);
	RECT tbar_rect = {0, 0, 0, 0};
	HWND tbar_hwnd = FindWindow("Shell_TrayWnd", NULL);
	if (tbar_hwnd != NULL) GetWindowRect(tbar_hwnd, &tbar_rect);
	if ((tbar_rect.top <= 0) && (tbar_rect.left <= 0))
	{
		if (tbar_rect.right >= win_rect.right) win_rect.top = tbar_rect.bottom; else win_rect.left = tbar_rect.right;
	}
	else
	{
		if (tbar_rect.left <= 0) win_rect.bottom = tbar_rect.top; else win_rect.right = tbar_rect.left;
	}
	int x = parent_rect.left + (parent_width - dlg_width) / 2;
	int y = parent_rect.top + (parent_height - dlg_height) / 2;
	if (win_rect.right - win_rect.left > dlg_width)
	{
		if (x < win_rect.left) x = win_rect.left;
		if (win_rect.right < x + dlg_width) x = win_rect.right - dlg_width;
	}
	else
	{
		x = win_rect.left;
	}
	if (win_rect.bottom - win_rect.top > dlg_height)
	{
		if (y < win_rect.top) y = win_rect.top;
		if (win_rect.bottom < y + dlg_height) y = win_rect.bottom - dlg_height;
	}
	else
	{
		y = win_rect.top;
	}
	move(x, y, dlg_width, dlg_height);
}

/// EBhEvV[WŏȂɕύX܂
void Bcl_dlg::change_no_proc()
{
	m_dlg_proc_rtn = false;
}

/// [__CAÕEBhEvV[W
/// @param handle EBhEnh
/// @param msg bZ[W
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
BOOL CALLBACK Bcl_dlg::modal_dlg_proc(HWND handle, UINT msg, WPARAM wp, LPARAM lp)
{
	bool user_func;
	switch (msg)
	{
		case WM_INITDIALOG:
			m_cur_wnd->set_handle(handle);
			m_wnd_list[handle] = m_cur_wnd;
			((Bcl_dlg*)m_wnd_list[handle])->on_init(wp, lp);
			user_func = !((Bcl_dlg*)m_wnd_list[handle])->is_change_focus();
			break;
		case WM_CLOSE:
			m_wnd_list[handle]->on_close(wp, lp);
			user_func = true;
			break;
		default:
			user_func = proc_msg(handle, msg, wp, lp);
	}
	if (!user_func) return false;
	if (m_wnd_list.find(handle) != m_wnd_list.end())
	{
		user_func = ((Bcl_dlg*)m_wnd_list[handle])->m_dlg_proc_rtn;
		((Bcl_dlg*)m_wnd_list[handle])->m_dlg_proc_rtn = true;
	}
	return user_func;
}

/// [hX_CAÕEBhEvV[W
/// @param handle EBhEnh
/// @param msg bZ[W
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
BOOL CALLBACK Bcl_dlg::modeless_dlg_proc(HWND handle, UINT msg, WPARAM wp, LPARAM lp)
{
	bool user_func;
	if (msg == WM_INITDIALOG)
	{
		m_cur_wnd->set_handle(handle);
		m_wnd_list[handle] = m_cur_wnd;
		((Bcl_dlg*)m_wnd_list[handle])->on_init(wp, lp);
		user_func = !((Bcl_dlg*)m_wnd_list[handle])->is_change_focus();
	}
	else if (msg == WM_CLOSE)
	{
		m_wnd_list[handle]->on_close(wp, lp);
		user_func = true;
	}
	else
	{
		user_func = proc_msg(handle, msg, wp, lp);
	}
	if (!user_func) return false;
	if (m_wnd_list.find(handle) != m_wnd_list.end())
	{
		user_func = ((Bcl_dlg*)m_wnd_list[handle])->m_dlg_proc_rtn;
		((Bcl_dlg*)m_wnd_list[handle])->m_dlg_proc_rtn = true;
	}
	return user_func;
}

/// t@C̃hbO邩ǂݒ肵܂
/// @param flag t@C̃hbO邩ǂ
void Bcl_dlg::set_drag_accept_files(bool flag)
{
	DragAcceptFiles(m_handle, flag);
}

/// ő剻Ă邩ǂ肵܂
/// @return ő剻Ă邩ǂ
bool Bcl_dlg::is_zoomed() const
{
	return IsZoomed(m_handle);
}
