//==============================================================
//
// Bcl_dtpicker
//
//==============================================================
#include "bcl_dtpicker.h"
#ifndef USE_SYSTEM_DTPICKER
#include "bcl_itr.h"

#define IDC_CHK_VALID		100
#define IDC_EDIT_DISPLAY	101
#define IDC_BTN_CALENDAR	102
#define IDC_UD_TIME			103
#define IDC_CAL_COMBO		104

//--------------------------------------------------------------
//
// Date Time Pickerp`FbN{bNXNX
//
//--------------------------------------------------------------
std::map<HWND, Bcl_dtp_chk*> Bcl_dtp_chk::m_dtp_chk_list;

/// RXgN^
Bcl_dtp_chk::Bcl_dtp_chk() : m_is_chk(true)
{
	m_style = WS_VISIBLE | WS_CHILD | BS_OWNERDRAW;
	ON_MSG(WM_SYSKEYDOWN, Bcl_dtp_chk::on_sys_key_down);
	ON_KEYDOWN(Bcl_dtp_chk::on_key_down);
}

/// fXgN^
Bcl_dtp_chk::~Bcl_dtp_chk()
{
	SetWindowLong(Bcl_wnd::m_handle, GWL_WNDPROC, (LONG)m_org_proc);
	m_dtp_chk_list.erase(Bcl_wnd::m_handle);
}

//// EBhE쐬֐
/// @param parent eEBhE
/// @param id ID
/// @param x W
/// @param y W
/// @param w 
/// @param h 
/// @return 
bool Bcl_dtp_chk::create(Bcl_dtpicker* parent, int id, int x, int y, int w, int h)
{
	if (!Bcl_ctrl::create(parent, id, x, y, w, h)) return false;
	m_dtp_parent = parent;
	m_dtp_chk_list[m_handle] = this;
	m_org_proc = (WNDPROC)GetWindowLong(m_handle, GWL_WNDPROC);
	SetWindowLong(m_handle, GWL_WNDPROC, (LONG)dtp_chk_proc);
	return true;
}

/// WM_SYSKEYDOWÑbZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Bcl_dtp_chk::on_sys_key_down(WPARAM wp, LPARAM lp)
{
	if (((lp & 0x20000000) != 0) && ((int)wp == VK_DOWN))
	{
		m_dtp_parent->post_msg(WM_COMMAND, MAKEWPARAM(IDC_BTN_CALENDAR, BN_CLICKED), 0);
	}
	else
	{
		CallWindowProc(m_org_proc, m_handle, WM_SYSKEYDOWN, wp, lp);
	}
}

/// WM_KEYDOWÑbZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Bcl_dtp_chk::on_key_down(WPARAM wp, LPARAM lp)
{
	if ((GetKeyState(VK_RIGHT) & 0x8000) != 0)
	{
		if (m_is_chk) m_dtp_parent->next_cursor();
	}
	else if ((GetKeyState(VK_LEFT) & 0x8000) != 0)
	{
		if (m_is_chk) m_dtp_parent->prev_cursor();
	}
	else
	{
		CallWindowProc(m_org_proc, m_handle, WM_KEYDOWN, wp, lp);
	}
}

/// `FbNĂ邩ǂ肵܂
/// @return 
bool Bcl_dtp_chk::is_checked() const
{
	
	return m_is_chk;
}

/// `FbNԂݒ肵܂
/// @param chk `FbN
void Bcl_dtp_chk::set_check(bool chk)
{
	m_is_chk = chk;
	invalidate(true);
}

/// EBhEvV[W
/// @param hwnd EBhEnh
/// @param msg bZ[W
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
/// @return 
LRESULT CALLBACK Bcl_dtp_chk::dtp_chk_proc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp)
{
	Bcl_dtp_chk* ctrl = m_dtp_chk_list[hwnd];
	if (!proc_msg(hwnd, msg, wp, lp))
	{
		if (msg == WM_GETDLGCODE) return DLGC_WANTARROWS;
		return CallWindowProc(ctrl->m_org_proc, hwnd, msg, wp, lp);
	}
	return 0L;
}

//--------------------------------------------------------------
//
// Date Time Pickerp͒ۃNX
//
//--------------------------------------------------------------
/// RXgN^
/// @param is_select_target IΏۂǂ
Bcl_dtp_analyze_abst::Bcl_dtp_analyze_abst(bool is_select_target)
{
	m_is_select_target = is_select_target;
}

/// IΏۂǂ肵܂
/// @return 
bool Bcl_dtp_analyze_abst::is_select_target()
{
	return m_is_select_target;
}

/// ő̓擾܂
/// @param year N
/// @param month 
/// @return 
int Bcl_dtp_analyze_abst::get_max_day(int year, int month)
{
	if ((month == 4) || (month == 6) || (month == 9) || (month == 11))
	{
		return 30;
	}
	else if (month != 2)
	{
		return 31;
	}
	else
	{
		if (((year % 4) == 0) && (((year % 100) != 0) || ((year % 400) == 0))) return 29; else return 28;
	}
}

/// ŏ܂͍ő̓tvZ܂
/// @param parent eEBhE
/// @param date t
void Bcl_dtp_analyze_abst::calc_min_or_max_date(Bcl_dtp_edit* parent, const Bcl_date& date)
{
	if (date < parent->m_min_date)
	{
		if ((parent->m_year != parent->m_min_date.get_year()) ||
			(parent->m_month != parent->m_min_date.get_month()) ||
			(parent->m_day != parent->m_min_date.get_day()))
		{
			parent->m_year = parent->m_min_date.get_year();
			parent->m_month = parent->m_min_date.get_month();
			parent->m_day = parent->m_min_date.get_day();
			parent->send_date_time_change_msg();
		}
	}
	else
	{
		if ((parent->m_year != parent->m_max_date.get_year()) ||
			(parent->m_month != parent->m_max_date.get_month()) ||
			(parent->m_day != parent->m_max_date.get_day()))
		{
			parent->m_year = parent->m_max_date.get_year();
			parent->m_month = parent->m_max_date.get_month();
			parent->m_day = parent->m_max_date.get_day();
			parent->send_date_time_change_msg();
		}
	}
}

/// ŏ܂͍ő̎ԂvZ܂
/// @param parent eEBhE
/// @param time 
void Bcl_dtp_analyze_abst::calc_min_or_max_time(Bcl_dtp_edit* parent, const Bcl_time& time)
{
	if (time < parent->m_min_time)
	{
		if ((parent->m_hour != parent->m_min_time.get_hour()) ||
			(parent->m_minute != parent->m_min_time.get_minute()) ||
			(parent->m_second != parent->m_min_time.get_sec()))
		{
			parent->m_hour = parent->m_min_time.get_hour();
			parent->m_minute = parent->m_min_time.get_minute();
			parent->m_second = parent->m_min_time.get_sec();
			parent->send_date_time_change_msg();
		}
	}
	else
	{
		if ((parent->m_hour != parent->m_max_time.get_hour()) ||
			(parent->m_minute != parent->m_max_time.get_minute()) ||
			(parent->m_second != parent->m_max_time.get_sec()))
		{
			parent->m_hour = parent->m_max_time.get_hour();
			parent->m_minute = parent->m_max_time.get_minute();
			parent->m_second = parent->m_max_time.get_sec();
			parent->send_date_time_change_msg();
		}
	}
}

//--------------------------------------------------------------
//
// Date Time Pickerp͂ȂNX
//
//--------------------------------------------------------------
/// RXgN^
/// @param is_select_target IΏۂǂ
/// @param str 
Bcl_dtp_analyze_none::Bcl_dtp_analyze_none(bool is_select_target, const Bcl_str& str) : Bcl_dtp_analyze_abst(is_select_target)
{
	m_str = str;
}

/// 擾܂
/// @param is_current ݑIʒuǂ
/// @return 
int Bcl_dtp_analyze_none::get_length(bool is_current)
{
	return m_str.get_length();
}

/// IJnʒu擾܂
/// @param parent eEBhE
/// @return IJnʒu
int Bcl_dtp_analyze_none::get_select_start(Bcl_dtp_edit* parent)
{
	return 0;
}

/// vZ܂
/// @param parent eEBhE
/// @param val ύXl
void Bcl_dtp_analyze_none::calc(Bcl_dtp_edit* parent, int val)
{
}

/// eLXg擾܂
/// @param parent eEBhE
/// @param is_current ݑIʒuǂ
/// @return eLXg
Bcl_str Bcl_dtp_analyze_none::get_text(Bcl_dtp_edit* parent, bool is_current)
{
	return m_str;
}

/// L[͂܂
/// @param parent eEBhE
/// @param ch L[
void Bcl_dtp_analyze_none::on_char(Bcl_dtp_edit* parent, char ch)
{
}

/// ͂ꂽl͂܂
/// @param parent eEBhE
/// @param num ͂ꂽl
void Bcl_dtp_analyze_none::analyze_char(Bcl_dtp_edit* parent, int num)
{
}

//--------------------------------------------------------------
//
// Date Time PickerpN̓NX
//
//--------------------------------------------------------------
/// RXgN^
/// @param is_select_target IΏۂǂ
Bcl_dtp_analyze_abst_year::Bcl_dtp_analyze_abst_year(bool is_select_target) : Bcl_dtp_analyze_abst(is_select_target)
{
}

/// IJnʒu擾܂
/// @param parent eEBhE
/// @return IJnʒu
int Bcl_dtp_analyze_abst_year::get_select_start(Bcl_dtp_edit* parent)
{
	if (!parent->m_char_list.empty()) return 4 - parent->m_char_list.size(); else return 0;
}

/// vZ܂
/// @param parent eEBhE
/// @param val ύXl
void Bcl_dtp_analyze_abst_year::calc(Bcl_dtp_edit* parent, int val)
{
	int year = parent->m_year + val;
	Bcl_date date(year, parent->m_month, parent->m_day);
	if ((date >= parent->m_min_date) && (date <= parent->m_max_date))
	{
		parent->m_year = year;
		if ((parent->m_year == 1752) && (parent->m_month == 9))
		{
			if (parent->m_day > 19) parent->m_day = 19;
		}
		else
		{
			int max_day = get_max_day(year, parent->m_month);
			if (parent->m_day > max_day) parent->m_day = max_day;
		}
		parent->send_date_time_change_msg();
	}
	else
	{
		calc_min_or_max_date(parent, date);
	}
}

/// L[͂܂
/// @param parent eEBhE
/// @param ch L[
void Bcl_dtp_analyze_abst_year::on_char(Bcl_dtp_edit* parent, char ch)
{
	if (parent->m_char_list.size() == 4) parent->m_char_list.clear();
	parent->m_char_list.push_back(ch);
	if (parent->m_char_list.size() == 4) parent->analyze_char();
}

/// ͂ꂽl͂܂
/// @param parent eEBhE
/// @param num ͂ꂽl
void Bcl_dtp_analyze_abst_year::analyze_char(Bcl_dtp_edit* parent, int num)
{
	int year = num;
	if (num < 30)
	{
		year = 2000 + num;
	}
	else if (num < 100)
	{
		year = 1900 + num;
	}
	Bcl_date date(year, parent->m_month, parent->m_day);
	if ((date >= parent->m_min_date) && (date <= parent->m_max_date))
	{
		if ((year == 1752) && (parent->m_month == 9))
		{
			if ((parent->m_day >= 14) && (parent->m_day <= 19))
			{
				parent->m_year = year;
				parent->send_date_time_change_msg();
			}
		}
		else
		{
			parent->m_year = year;
			parent->send_date_time_change_msg();
		}
	}
}

//--------------------------------------------------------------
//
// Date Time PickerpNi4j̓NX
//
//--------------------------------------------------------------
/// RXgN^
/// @param is_select_target IΏۂǂ
Bcl_dtp_analyze_year4::Bcl_dtp_analyze_year4(bool is_select_target) : Bcl_dtp_analyze_abst_year(is_select_target)
{
}

/// 擾܂
/// @param is_current ݑIʒuǂ
/// @return 
int Bcl_dtp_analyze_year4::get_length(bool is_current)
{
	return 4;
}

/// eLXg擾܂
/// @param parent eEBhE
/// @param is_current ݑIʒuǂ
/// @return eLXg
Bcl_str Bcl_dtp_analyze_year4::get_text(Bcl_dtp_edit* parent, bool is_current)
{
	Bcl_str str;
	if ((is_current) && (!parent->m_char_list.empty()))
	{
		for (int i = 0; i < (int)(4 - parent->m_char_list.size()); i++)
		{
			str += " ";
		}
		Bcl_itr< std::vector<char> > itr(parent->m_char_list);
		while (itr.has_next())
		{
			str += itr.next();
		}
	}
	else
	{
		str.format("%04d", parent->m_year);
	}
	return str;
}

//--------------------------------------------------------------
//
// Date Time PickerpNi2j̓NX
//
//--------------------------------------------------------------
/// RXgN^
/// @param is_select_target IΏۂǂ
Bcl_dtp_analyze_year2::Bcl_dtp_analyze_year2(bool is_select_target) : Bcl_dtp_analyze_abst_year(is_select_target)
{
}

/// 擾܂
/// @param is_current ݑIʒuǂ
/// @return 
int Bcl_dtp_analyze_year2::get_length(bool is_current)
{
	if (is_current) return 4; else return 2;
}

/// eLXg擾܂
/// @param parent eEBhE
/// @param is_current ݑIʒuǂ
/// @return eLXg
Bcl_str Bcl_dtp_analyze_year2::get_text(Bcl_dtp_edit* parent, bool is_current)
{
	Bcl_str str;
	if ((is_current) && (!parent->m_char_list.empty()))
	{
		for (int i = 0; i < (int)(4 - parent->m_char_list.size()); i++)
		{
			str += " ";
		}
		Bcl_itr< std::vector<char> > itr(parent->m_char_list);
		while (itr.has_next())
		{
			str += itr.next();
		}
	}
	else if (is_current)
	{
		str.format("%04d", parent->m_year);
	}
	else
	{
		str.format("%02d", parent->m_year % 100);
	}
	return str;
}

//--------------------------------------------------------------
//
// Date Time PickerpNi1܂2j̓NX
//
//--------------------------------------------------------------
/// RXgN^
/// @param is_select_target IΏۂǂ
Bcl_dtp_analyze_year1::Bcl_dtp_analyze_year1(bool is_select_target) : Bcl_dtp_analyze_abst_year(is_select_target)
{
}

/// 擾܂
/// @param is_current ݑIʒuǂ
/// @return 
int Bcl_dtp_analyze_year1::get_length(bool is_current)
{
	if (is_current) return 4; else return 2;
}

/// eLXg擾܂
/// @param parent eEBhE
/// @param is_current ݑIʒuǂ
/// @return eLXg
Bcl_str Bcl_dtp_analyze_year1::get_text(Bcl_dtp_edit* parent, bool is_current)
{
	Bcl_str str;
	if ((is_current) && (!parent->m_char_list.empty()))
	{
		for (int i = 0; i < (int)(4 - parent->m_char_list.size()); i++)
		{
			str += " ";
		}
		Bcl_itr< std::vector<char> > itr(parent->m_char_list);
		while (itr.has_next())
		{
			str += itr.next();
		}
	}
	else if (is_current)
	{
		str.format("%04d", parent->m_year);
	}
	else
	{
		str.format("%2d", parent->m_year % 100);
	}
	return str;
}

//--------------------------------------------------------------
//
// Date Time Pickerp̓NX
//
//--------------------------------------------------------------
/// RXgN^
/// @param is_select_target IΏۂǂ
Bcl_dtp_analyze_abst_month::Bcl_dtp_analyze_abst_month(bool is_select_target) : Bcl_dtp_analyze_abst(is_select_target)
{
}

/// vZ܂
/// @param parent eEBhE
/// @param val ύXl
void Bcl_dtp_analyze_abst_month::calc(Bcl_dtp_edit* parent, int val)
{
	int month = (parent->m_month + val + 11) % 12 + 1;
	Bcl_date date(parent->m_year, month, parent->m_day);
	if ((date >= parent->m_min_date) && (date <= parent->m_max_date))
	{
		parent->m_month = month;
		if ((parent->m_year == 1752) && (month == 9))
		{
			if (parent->m_day > 19) parent->m_day = 19;
		}
		else
		{
			int max_day = get_max_day(parent->m_year, parent->m_month);
			if (parent->m_day > max_day) parent->m_day = max_day;
		}
		parent->send_date_time_change_msg();
	}
	else
	{
		calc_min_or_max_date(parent, date);
	}
}

/// L[͂܂
/// @param parent eEBhE
/// @param ch L[
void Bcl_dtp_analyze_abst_month::on_char(Bcl_dtp_edit* parent, char ch)
{
	if (parent->m_char_list.size() == 2)
	{
		parent->m_char_list.clear();
	}
	else if (parent->m_char_list.size() == 1)
	{
		if (parent->m_char_list[0] == '1')
		{
			if ((ch != '0')  && (ch != '1') && (ch != '2'))
			{
				parent->m_char_list.clear();
			}
		}
		else if (parent->m_char_list[0] != '0')
		{
			parent->m_char_list.clear();
		}
	}
	parent->m_char_list.push_back(ch);
	if (parent->m_char_list.size() == 2) parent->analyze_char();
}

/// ͂ꂽl͂܂
/// @param parent eEBhE
/// @param num ͂ꂽl
void Bcl_dtp_analyze_abst_month::analyze_char(Bcl_dtp_edit* parent, int num)
{
	Bcl_date date(parent->m_year, num, parent->m_day);
	if ((date >= parent->m_min_date) && (date <= parent->m_max_date))
	{
		if ((parent->m_year == 1752) && (num == 9))
		{
			if ((parent->m_day >= 14) && (parent->m_day <= 19))
			{
				parent->m_month = num;
				parent->send_date_time_change_msg();
			}
		}
		else
		{
			parent->m_month = num;
			parent->send_date_time_change_msg();
		}
	}
}

//--------------------------------------------------------------
//
// Date Time Pickerpi2+j̓NX
//
//--------------------------------------------------------------
/// RXgN^
/// @param is_select_target IΏۂǂ
Bcl_dtp_analyze_month2_str::Bcl_dtp_analyze_month2_str(bool is_select_target) : Bcl_dtp_analyze_abst_month(is_select_target)
{
}

/// 擾܂
/// @param is_current ݑIʒuǂ
/// @return 
int Bcl_dtp_analyze_month2_str::get_length(bool is_current)
{
	return 4;
}

/// IJnʒu擾܂
/// @param parent eEBhE
/// @return IJnʒu
int Bcl_dtp_analyze_month2_str::get_select_start(Bcl_dtp_edit* parent)
{
	if (!parent->m_char_list.empty()) return 2 - parent->m_char_list.size(); else return 0;
}

/// eLXg擾܂
/// @param parent eEBhE
/// @param is_current ݑIʒuǂ
/// @return eLXg
Bcl_str Bcl_dtp_analyze_month2_str::get_text(Bcl_dtp_edit* parent, bool is_current)
{
	Bcl_str str;
	if ((is_current) && (!parent->m_char_list.empty()))
	{
		if (parent->m_char_list.size() == 1) str = " ";
		Bcl_itr< std::vector<char> > itr(parent->m_char_list);
		while (itr.has_next())
		{
			str += itr.next();
		}
	}
	else
	{
		str.format("%02d", parent->m_month);
	}
	str += "";
	return str;
}

//--------------------------------------------------------------
//
// Date Time Pickerpi1܂2+j̓NX
//
//--------------------------------------------------------------
/// RXgN^
/// @param is_select_target IΏۂǂ
Bcl_dtp_analyze_month1_str::Bcl_dtp_analyze_month1_str(bool is_select_target) : Bcl_dtp_analyze_abst_month(is_select_target)
{
}

/// 擾܂
/// @param is_current ݑIʒuǂ
/// @return 
int Bcl_dtp_analyze_month1_str::get_length(bool is_current)
{
	return 4;
}

/// IJnʒu擾܂
/// @param parent eEBhE
/// @return IJnʒu
int Bcl_dtp_analyze_month1_str::get_select_start(Bcl_dtp_edit* parent)
{
	if (!parent->m_char_list.empty()) return 2 - parent->m_char_list.size(); else return parent->m_month < 10 ? 1 : 0;
}

/// eLXg擾܂
/// @param parent eEBhE
/// @param is_current ݑIʒuǂ
/// @return eLXg
Bcl_str Bcl_dtp_analyze_month1_str::get_text(Bcl_dtp_edit* parent, bool is_current)
{
	Bcl_str str;
	if ((is_current) && (!parent->m_char_list.empty()))
	{
		if (parent->m_char_list.size() == 1) str = " ";
		Bcl_itr< std::vector<char> > itr(parent->m_char_list);
		while (itr.has_next())
		{
			str += itr.next();
		}
	}
	else
	{
		str.format("%2d", parent->m_month);
	}
	str += "";
	return str;
}

//--------------------------------------------------------------
//
// Date Time Pickerpi2j̓NX
//
//--------------------------------------------------------------
/// RXgN^
/// @param is_select_target IΏۂǂ
Bcl_dtp_analyze_month2::Bcl_dtp_analyze_month2(bool is_select_target) : Bcl_dtp_analyze_abst_month(is_select_target)
{
}

/// 擾܂
/// @param is_current ݑIʒuǂ
/// @return 
int Bcl_dtp_analyze_month2::get_length(bool is_current)
{
	return 2;
}

/// IJnʒu擾܂
/// @param parent eEBhE
/// @return IJnʒu
int Bcl_dtp_analyze_month2::get_select_start(Bcl_dtp_edit* parent)
{
	if (!parent->m_char_list.empty()) return 2 - parent->m_char_list.size(); else return 0;
}

/// eLXg擾܂
/// @param parent eEBhE
/// @param is_current ݑIʒuǂ
/// @return eLXg
Bcl_str Bcl_dtp_analyze_month2::get_text(Bcl_dtp_edit* parent, bool is_current)
{
	Bcl_str str;
	if ((is_current) && (!parent->m_char_list.empty()))
	{
		if (parent->m_char_list.size() == 1) str = " ";
		Bcl_itr< std::vector<char> > itr(parent->m_char_list);
		while (itr.has_next())
		{
			str += itr.next();
		}
	}
	else
	{
		str.format("%02d", parent->m_month);
	}
	return str;
}

//--------------------------------------------------------------
//
// Date Time Pickerpi1܂2j̓NX
//
//--------------------------------------------------------------
/// RXgN^
/// @param is_select_target IΏۂǂ
Bcl_dtp_analyze_month1::Bcl_dtp_analyze_month1(bool is_select_target) : Bcl_dtp_analyze_abst_month(is_select_target)
{
}

/// 擾܂
/// @param is_current ݑIʒuǂ
/// @return 
int Bcl_dtp_analyze_month1::get_length(bool is_current)
{
	return 2;
}

/// IJnʒu擾܂
/// @param parent eEBhE
/// @return IJnʒu
int Bcl_dtp_analyze_month1::get_select_start(Bcl_dtp_edit* parent)
{
	if (!parent->m_char_list.empty()) return 2 - parent->m_char_list.size(); else return parent->m_month < 10 ? 1 : 0;
}

/// eLXg擾܂
/// @param parent eEBhE
/// @param is_current ݑIʒuǂ
/// @return eLXg
Bcl_str Bcl_dtp_analyze_month1::get_text(Bcl_dtp_edit* parent, bool is_current)
{
	Bcl_str str;
	if ((is_current) && (!parent->m_char_list.empty()))
	{
		if (parent->m_char_list.size() == 1) str = " ";
		Bcl_itr< std::vector<char> > itr(parent->m_char_list);
		while (itr.has_next())
		{
			str += itr.next();
		}
	}
	else
	{
		str.format("%2d", parent->m_month);
	}
	return str;
}

//--------------------------------------------------------------
//
// Date Time Pickerp̓NX
//
//--------------------------------------------------------------
/// RXgN^
/// @param is_select_target IΏۂǂ
Bcl_dtp_analyze_abst_day::Bcl_dtp_analyze_abst_day(bool is_select_target) : Bcl_dtp_analyze_abst(is_select_target)
{
}

/// 擾܂
/// @param is_current ݑIʒuǂ
/// @return 
int Bcl_dtp_analyze_abst_day::get_length(bool is_current)
{
	return 2;
}

/// vZ܂
/// @param parent eEBhE
/// @param val ύXl
void Bcl_dtp_analyze_abst_day::calc(Bcl_dtp_edit* parent, int val)
{
	int max_day = get_max_day(parent->m_year, parent->m_month);
	int day = (parent->m_day + val + max_day - 1) % max_day + 1;
	Bcl_date date(parent->m_year, parent->m_month, day);
	if ((date >= parent->m_min_date) && (date <= parent->m_max_date))
	{
		if ((parent->m_year == 1752) && (parent->m_month == 9))
		{
			if (day > 19) parent->m_day = parent->m_min_date.get_day(); else parent->m_day = day;
			parent->send_date_time_change_msg();
		}
		else
		{
			parent->m_day = day;
			parent->send_date_time_change_msg();
		}
	}
	else
	{
		calc_min_or_max_date(parent, date);
	}
}

/// L[͂܂
/// @param parent eEBhE
/// @param ch L[
void Bcl_dtp_analyze_abst_day::on_char(Bcl_dtp_edit* parent, char ch)
{
	if (parent->m_char_list.size() == 2)
	{
		parent->m_char_list.clear();
	}
	else if (parent->m_char_list.size() == 1)
	{
		if (parent->m_char_list[0] == '3')
		{
			if ((ch != '0')  && (ch != '1'))
			{
				parent->m_char_list.clear();
			}
		}
		else if ((parent->m_char_list[0] != '0') && (parent->m_char_list[0] != '1') && (parent->m_char_list[0] != '2'))
		{
			parent->m_char_list.clear();
		}
	}
	parent->m_char_list.push_back(ch);
	if (parent->m_char_list.size() == 2) parent->analyze_char();
}

/// ͂ꂽl͂܂
/// @param parent eEBhE
/// @param num ͂ꂽl
void Bcl_dtp_analyze_abst_day::analyze_char(Bcl_dtp_edit* parent, int num)
{
	Bcl_date date(parent->m_year, parent->m_month, num);
	if ((date >= parent->m_min_date) && (date <= parent->m_max_date))
	{
		if ((parent->m_year == 1752) && (parent->m_month == 9))
		{
			if ((num >= 14) && (num <= 19))
			{
				parent->m_day = num;
				parent->send_date_time_change_msg();
			}
		}
		else
		{
			if (num <= get_max_day(parent->m_year, parent->m_month))
			{
				parent->m_day = num;
				parent->send_date_time_change_msg();
			}
		}
	}
}

//--------------------------------------------------------------
//
// Date Time Pickerpi2j̓NX
//
//--------------------------------------------------------------
/// RXgN^
/// @param is_select_target IΏۂǂ
Bcl_dtp_analyze_day2::Bcl_dtp_analyze_day2(bool is_select_target) : Bcl_dtp_analyze_abst_day(is_select_target)
{
}

/// IJnʒu擾܂
/// @param parent eEBhE
/// @return IJnʒu
int Bcl_dtp_analyze_day2::get_select_start(Bcl_dtp_edit* parent)
{
	if (!parent->m_char_list.empty()) return 2 - parent->m_char_list.size(); else return 0;
}

/// eLXg擾܂
/// @param parent eEBhE
/// @param is_current ݑIʒuǂ
/// @return eLXg
Bcl_str Bcl_dtp_analyze_day2::get_text(Bcl_dtp_edit* parent, bool is_current)
{
	Bcl_str str;
	if ((is_current) && (!parent->m_char_list.empty()))
	{
		if (parent->m_char_list.size() == 1) str = " ";
		Bcl_itr< std::vector<char> > itr(parent->m_char_list);
		while (itr.has_next())
		{
			str += itr.next();
		}
	}
	else
	{
		str.format("%02d", parent->m_day);
	}
	return str;
}

//--------------------------------------------------------------
//
// Date Time Pickerpi1܂2j̓NX
//
//--------------------------------------------------------------
/// RXgN^
/// @param is_select_target IΏۂǂ
Bcl_dtp_analyze_day1::Bcl_dtp_analyze_day1(bool is_select_target) : Bcl_dtp_analyze_abst_day(is_select_target)
{
}

/// IJnʒu擾܂
/// @param parent eEBhE
/// @return IJnʒu
int Bcl_dtp_analyze_day1::get_select_start(Bcl_dtp_edit* parent)
{
	if (!parent->m_char_list.empty()) return 2 - parent->m_char_list.size(); else if (parent->m_day < 10) return 1; else return 0;
}

/// eLXg擾܂
/// @param parent eEBhE
/// @param is_current ݑIʒuǂ
/// @return eLXg
Bcl_str Bcl_dtp_analyze_day1::get_text(Bcl_dtp_edit* parent, bool is_current)
{
	Bcl_str str;
	if ((is_current) && (!parent->m_char_list.empty()))
	{
		if (parent->m_char_list.size() == 1) str = " ";
		Bcl_itr< std::vector<char> > itr(parent->m_char_list);
		while (itr.has_next())
		{
			str += itr.next();
		}
	}
	else
	{
		str.format("%2d", parent->m_day);
	}
	return str;
}

//--------------------------------------------------------------
//
// Date Time Pickerpj̓NX
//
//--------------------------------------------------------------
/// RXgN^
/// @param is_select_target IΏۂǂ
Bcl_dtp_analyze_abst_week::Bcl_dtp_analyze_abst_week(bool is_select_target) : Bcl_dtp_analyze_abst(is_select_target)
{
}

/// IJnʒu擾܂
/// @param parent eEBhE
/// @return IJnʒu
int Bcl_dtp_analyze_abst_week::get_select_start(Bcl_dtp_edit* parent)
{
	return 0;
}

/// vZ܂
/// @param parent eEBhE
/// @param val ύXl
void Bcl_dtp_analyze_abst_week::calc(Bcl_dtp_edit* parent, int val)
{
}

/// L[͂܂
/// @param parent eEBhE
/// @param ch L[
void Bcl_dtp_analyze_abst_week::on_char(Bcl_dtp_edit* parent, char ch)
{
}

/// ͂ꂽl͂܂
/// @param parent eEBhE
/// @param num ͂ꂽl
void Bcl_dtp_analyze_abst_week::analyze_char(Bcl_dtp_edit* parent, int num)
{
}

//--------------------------------------------------------------
//
// Date Time Pickerpj̓NX
//
//--------------------------------------------------------------
/// RXgN^
/// @param is_select_target IΏۂǂ
Bcl_dtp_analyze_long_week::Bcl_dtp_analyze_long_week(bool is_select_target) : Bcl_dtp_analyze_abst_week(is_select_target)
{
}

/// 擾܂
/// @param is_current ݑIʒuǂ
/// @return 
int Bcl_dtp_analyze_long_week::get_length(bool is_current)
{
	return 6;
}

/// eLXg擾܂
/// @param parent eEBhE
/// @param is_current ݑIʒuǂ
/// @return eLXg
Bcl_str Bcl_dtp_analyze_long_week::get_text(Bcl_dtp_edit* parent, bool is_current)
{
	int day = parent->m_day;
	if ((parent->m_year == 1752) && (parent->m_month == 9)) day += 4;
	Bcl_date date = Bcl_date(parent->m_year, parent->m_month, day);
	return date.get_week_str() + "j";
}

//--------------------------------------------------------------
//
// Date Time PickerpZj̓NX
//
//--------------------------------------------------------------
/// RXgN^
/// @param is_select_target IΏۂǂ
Bcl_dtp_analyze_short_week::Bcl_dtp_analyze_short_week(bool is_select_target) : Bcl_dtp_analyze_abst_week(is_select_target)
{
}

/// 擾܂
/// @param is_current ݑIʒuǂ
/// @return 
int Bcl_dtp_analyze_short_week::get_length(bool is_current)
{
	return 2;
}

/// eLXg擾܂
/// @param parent eEBhE
/// @param is_current ݑIʒuǂ
/// @return eLXg
Bcl_str Bcl_dtp_analyze_short_week::get_text(Bcl_dtp_edit* parent, bool is_current)
{
	int day = parent->m_day;
	if ((parent->m_year == 1752) && (parent->m_month == 9)) day += 4;
	Bcl_date date = Bcl_date(parent->m_year, parent->m_month, day);
	return date.get_week_str();
}

//--------------------------------------------------------------
//
// Date Time Pickerpԁi24ԕ\Lj̓NX
//
//--------------------------------------------------------------
/// RXgN^
/// @param is_select_target IΏۂǂ
Bcl_dtp_analyze_abst_24h_hour::Bcl_dtp_analyze_abst_24h_hour(bool is_select_target) : Bcl_dtp_analyze_abst(is_select_target)
{
}

/// 擾܂
/// @param is_current ݑIʒuǂ
/// @return 
int Bcl_dtp_analyze_abst_24h_hour::get_length(bool is_current)
{
	return 2;
}

/// vZ܂
/// @param parent eEBhE
/// @param val ύXl
void Bcl_dtp_analyze_abst_24h_hour::calc(Bcl_dtp_edit* parent, int val)
{
	int hour = (parent->m_hour + val + 24) % 24;
	Bcl_time time(hour, parent->m_minute, parent->m_second, 0);
	if ((time >= parent->m_min_time) && (time <= parent->m_max_time))
	{
		parent->m_hour = hour;
		parent->send_date_time_change_msg();
	}
	else
	{
		calc_min_or_max_time(parent, time);
	}
}

/// L[͂܂
/// @param parent eEBhE
/// @param ch L[
void Bcl_dtp_analyze_abst_24h_hour::on_char(Bcl_dtp_edit* parent, char ch)
{
	if (parent->m_char_list.size() == 2)
	{
		parent->m_char_list.clear();
	}
	else if (parent->m_char_list.size() == 1)
	{
		if (parent->m_char_list[0] == '2')
		{
			if ((ch != '0')  && (ch != '1') && (ch != '2') && (ch != '3'))
			{
				parent->m_char_list.clear();
			}
		}
		else if ((parent->m_char_list[0] != '0') && (parent->m_char_list[0] != '1'))
		{
			parent->m_char_list.clear();
		}
	}
	parent->m_char_list.push_back(ch);
	if (parent->m_char_list.size() == 2) parent->analyze_char();
}

/// ͂ꂽl͂܂
/// @param parent eEBhE
/// @param num ͂ꂽl
void Bcl_dtp_analyze_abst_24h_hour::analyze_char(Bcl_dtp_edit* parent, int num)
{
	Bcl_time time(num, parent->m_minute, parent->m_second, 0);
	if ((time >= parent->m_min_time) && (time <= parent->m_max_time))
	{
		parent->m_hour = num;
		parent->send_date_time_change_msg();
	}
}

//--------------------------------------------------------------
//
// Date Time Pickerpԁi24ԕ\L2j̓NX
//
//--------------------------------------------------------------
/// RXgN^
/// @param is_select_target IΏۂǂ
Bcl_dtp_analyze_24h_hour2::Bcl_dtp_analyze_24h_hour2(bool is_select_target) : Bcl_dtp_analyze_abst_24h_hour(is_select_target)
{
}

/// IJnʒu擾܂
/// @param parent eEBhE
/// @return IJnʒu
int Bcl_dtp_analyze_24h_hour2::get_select_start(Bcl_dtp_edit* parent)
{
	if (!parent->m_char_list.empty()) return 2 - parent->m_char_list.size(); else return 0;
}

/// eLXg擾܂
/// @param parent eEBhE
/// @param is_current ݑIʒuǂ
/// @return eLXg
Bcl_str Bcl_dtp_analyze_24h_hour2::get_text(Bcl_dtp_edit* parent, bool is_current)
{
	Bcl_str str;
	if ((is_current) && (!parent->m_char_list.empty()))
	{
		if (parent->m_char_list.size() == 1) str = " ";
		Bcl_itr< std::vector<char> > itr(parent->m_char_list);
		while (itr.has_next())
		{
			str += itr.next();
		}
	}
	else
	{
		str.format("%02d", parent->m_hour);
	}
	return str;
}

//--------------------------------------------------------------
//
// Date Time Pickerpԁi24ԕ\L1܂2j̓NX
//
//--------------------------------------------------------------
/// RXgN^
/// @param is_select_target IΏۂǂ
Bcl_dtp_analyze_24h_hour1::Bcl_dtp_analyze_24h_hour1(bool is_select_target) : Bcl_dtp_analyze_abst_24h_hour(is_select_target)
{
}

/// IJnʒu擾܂
/// @param parent eEBhE
/// @return IJnʒu
int Bcl_dtp_analyze_24h_hour1::get_select_start(Bcl_dtp_edit* parent)
{
	if (!parent->m_char_list.empty()) return 2 - parent->m_char_list.size(); else if (parent->m_hour < 10) return 1; else return 0;
}

/// eLXg擾܂
/// @param parent eEBhE
/// @param is_current ݑIʒuǂ
/// @return eLXg
Bcl_str Bcl_dtp_analyze_24h_hour1::get_text(Bcl_dtp_edit* parent, bool is_current)
{
	Bcl_str str;
	if ((is_current) && (!parent->m_char_list.empty()))
	{
		if (parent->m_char_list.size() == 1) str = " ";
		Bcl_itr< std::vector<char> > itr(parent->m_char_list);
		while (itr.has_next())
		{
			str += itr.next();
		}
	}
	else
	{
		str.format("%2d", parent->m_hour);
	}
	return str;
}

//--------------------------------------------------------------
//
// Date Time Pickerpԁi12ԕ\Lj̓NX
//
//--------------------------------------------------------------
/// RXgN^
/// @param is_select_target IΏۂǂ
Bcl_dtp_analyze_abst_12h_hour::Bcl_dtp_analyze_abst_12h_hour(bool is_select_target) : Bcl_dtp_analyze_abst(is_select_target)
{
}

/// 擾܂
/// @param is_current ݑIʒuǂ
/// @return 
int Bcl_dtp_analyze_abst_12h_hour::get_length(bool is_current)
{
	return 2;
}

/// vZ܂
/// @param parent eEBhE
/// @param val ύXl
void Bcl_dtp_analyze_abst_12h_hour::calc(Bcl_dtp_edit* parent, int val)
{
	int hour = (parent->m_hour + val + 24) % 24;
	Bcl_time time(hour, parent->m_minute, parent->m_second, 0);
	if ((time >= parent->m_min_time) && (time <= parent->m_max_time))
	{
		parent->m_hour = hour;
		parent->send_date_time_change_msg();
	}
	else
	{
		calc_min_or_max_time(parent, time);
	}
}

/// L[͂܂
/// @param parent eEBhE
/// @param ch L[
void Bcl_dtp_analyze_abst_12h_hour::on_char(Bcl_dtp_edit* parent, char ch)
{
	if (parent->m_char_list.size() == 2)
	{
		parent->m_char_list.clear();
	}
	else if (parent->m_char_list.size() == 1)
	{
		if (parent->m_char_list[0] == '2')
		{
			if ((ch != '0')  && (ch != '1') && (ch != '2') && (ch != '3'))
			{
				parent->m_char_list.clear();
			}
		}
		else if ((parent->m_char_list[0] != '0') && (parent->m_char_list[0] != '1'))
		{
			parent->m_char_list.clear();
		}
	}
	parent->m_char_list.push_back(ch);
	if (parent->m_char_list.size() == 2) parent->analyze_char();
}

/// ͂ꂽl͂܂
/// @param parent eEBhE
/// @param num ͂ꂽl
void Bcl_dtp_analyze_abst_12h_hour::analyze_char(Bcl_dtp_edit* parent, int num)
{
	if ((parent->m_hour >= 12)&& (num < 12)) num += 12;
	Bcl_time time(num, parent->m_minute, parent->m_second, 0);
	if ((time >= parent->m_min_time) && (time <= parent->m_max_time))
	{
		parent->m_hour = num;
		parent->send_date_time_change_msg();
	}
}

//--------------------------------------------------------------
//
// Date Time Pickerpԁi12ԕ\L2j̓NX
//
//--------------------------------------------------------------
/// RXgN^
/// @param is_select_target IΏۂǂ
Bcl_dtp_analyze_12h_hour2::Bcl_dtp_analyze_12h_hour2(bool is_select_target) : Bcl_dtp_analyze_abst_12h_hour(is_select_target)
{
}

/// IJnʒu擾܂
/// @param parent eEBhE
/// @return IJnʒu
int Bcl_dtp_analyze_12h_hour2::get_select_start(Bcl_dtp_edit* parent)
{
	if (!parent->m_char_list.empty()) return 2 - parent->m_char_list.size(); else return 0;
}

/// eLXg擾܂
/// @param parent eEBhE
/// @param is_current ݑIʒuǂ
/// @return eLXg
Bcl_str Bcl_dtp_analyze_12h_hour2::get_text(Bcl_dtp_edit* parent, bool is_current)
{
	Bcl_str str;
	if ((is_current) && (!parent->m_char_list.empty()))
	{
		if (parent->m_char_list.size() == 1) str = " ";
		Bcl_itr< std::vector<char> > itr(parent->m_char_list);
		while (itr.has_next())
		{
			str += itr.next();
		}
	}
	else
	{
		str.format("%02d", (parent->m_hour + 11) % 12 + 1);
	}
	return str;
}

//--------------------------------------------------------------
//
// Date Time Pickerpԁi12ԕ\L1܂2j̓NX
//
//--------------------------------------------------------------
/// RXgN^
/// @param is_select_target IΏۂǂ
Bcl_dtp_analyze_12h_hour1::Bcl_dtp_analyze_12h_hour1(bool is_select_target) : Bcl_dtp_analyze_abst_12h_hour(is_select_target)
{
}

/// IJnʒu擾܂
/// @param parent eEBhE
/// @return IJnʒu
int Bcl_dtp_analyze_12h_hour1::get_select_start(Bcl_dtp_edit* parent)
{
	if (!parent->m_char_list.empty()) return 2 - parent->m_char_list.size(); else if (((parent->m_hour + 11) % 12 + 1) < 10) return 1; else return 0;
}

/// eLXg擾܂
/// @param parent eEBhE
/// @param is_current ݑIʒuǂ
/// @return eLXg
Bcl_str Bcl_dtp_analyze_12h_hour1::get_text(Bcl_dtp_edit* parent, bool is_current)
{
	Bcl_str str;
	if ((is_current) && (!parent->m_char_list.empty()))
	{
		if (parent->m_char_list.size() == 1) str = " ";
		Bcl_itr< std::vector<char> > itr(parent->m_char_list);
		while (itr.has_next())
		{
			str += itr.next();
		}
	}
	else
	{
		str.format("%2d", (parent->m_hour + 11) % 12 + 1);
	}
	return str;
}

//--------------------------------------------------------------
//
// Date Time Pickerpԋ敪̓NX
//
//--------------------------------------------------------------
/// RXgN^
/// @param is_select_target IΏۂǂ
Bcl_dtp_analyze_abst_time_division::Bcl_dtp_analyze_abst_time_division(bool is_select_target) : Bcl_dtp_analyze_abst(is_select_target)
{
}

/// IJnʒu擾܂
/// @param parent eEBhE
/// @return IJnʒu
int Bcl_dtp_analyze_abst_time_division::get_select_start(Bcl_dtp_edit* parent)
{
	return 0;
}

/// vZ܂
/// @param parent eEBhE
/// @param val ύXl
void Bcl_dtp_analyze_abst_time_division::calc(Bcl_dtp_edit* parent, int val)
{
	int hour = (parent->m_hour + 12) % 24;
	Bcl_time time(hour, parent->m_minute, parent->m_second, 0);
	if ((time >= parent->m_min_time) && (time <= parent->m_max_time))
	{
		parent->m_hour = hour;
		parent->send_date_time_change_msg();
	}
	else
	{
		calc_min_or_max_time(parent, time);
	}
}

/// L[͂܂
/// @param parent eEBhE
/// @param ch L[
void Bcl_dtp_analyze_abst_time_division::on_char(Bcl_dtp_edit* parent, char ch)
{
}

/// ͂ꂽl͂܂
/// @param parent eEBhE
/// @param num ͂ꂽl
void Bcl_dtp_analyze_abst_time_division::analyze_char(Bcl_dtp_edit* parent, int num)
{
}

//--------------------------------------------------------------
//
// Date Time Pickerpԋ敪̓NX
//
//--------------------------------------------------------------
/// RXgN^
/// @param is_select_target IΏۂǂ
Bcl_dtp_analyze_long_time_division::Bcl_dtp_analyze_long_time_division(bool is_select_target) : Bcl_dtp_analyze_abst_time_division(is_select_target)
{
}

/// 擾܂
/// @param is_current ݑIʒuǂ
/// @return 
int Bcl_dtp_analyze_long_time_division::get_length(bool is_current)
{
	return 4;
}

/// eLXg擾܂
/// @param parent eEBhE
/// @param is_current ݑIʒuǂ
/// @return eLXg
Bcl_str Bcl_dtp_analyze_long_time_division::get_text(Bcl_dtp_edit* parent, bool is_current)
{
	if (parent->m_hour < 12) return "ߑO"; else return "ߌ";
}

//--------------------------------------------------------------
//
// Date Time PickerpZԋ敪̓NX
//
//--------------------------------------------------------------
/// RXgN^
/// @param is_select_target IΏۂǂ
Bcl_dtp_analyze_short_time_division::Bcl_dtp_analyze_short_time_division(bool is_select_target) : Bcl_dtp_analyze_abst_time_division(is_select_target)
{
}

/// 擾܂
/// @param is_current ݑIʒuǂ
/// @return 
int Bcl_dtp_analyze_short_time_division::get_length(bool is_current)
{
	return 2;
}

/// eLXg擾܂
/// @param parent eEBhE
/// @param is_current ݑIʒuǂ
/// @return eLXg
Bcl_str Bcl_dtp_analyze_short_time_division::get_text(Bcl_dtp_edit* parent, bool is_current)
{
	if (parent->m_hour < 12) return "O"; else return "";
}

//--------------------------------------------------------------
//
// Date Time Pickerp̓NX
//
//--------------------------------------------------------------
/// RXgN^
/// @param is_select_target IΏۂǂ
Bcl_dtp_analyze_abst_minute::Bcl_dtp_analyze_abst_minute(bool is_select_target) : Bcl_dtp_analyze_abst(is_select_target)
{
}

/// 擾܂
/// @param is_current ݑIʒuǂ
/// @return 
int Bcl_dtp_analyze_abst_minute::get_length(bool is_current)
{
	return 2;
}

/// vZ܂
/// @param parent eEBhE
/// @param val ύXl
void Bcl_dtp_analyze_abst_minute::calc(Bcl_dtp_edit* parent, int val)
{
	int minute = (parent->m_minute + val + 60) % 60;
	Bcl_time time(parent->m_hour, minute, parent->m_second, 0);
	if ((time >= parent->m_min_time) && (time <= parent->m_max_time))
	{
		parent->m_minute = minute;
		parent->send_date_time_change_msg();
	}
	else
	{
		calc_min_or_max_time(parent, time);
	}
}

/// L[͂܂
/// @param parent eEBhE
/// @param ch L[
void Bcl_dtp_analyze_abst_minute::on_char(Bcl_dtp_edit* parent, char ch)
{
	if (parent->m_char_list.size() == 2)
	{
		parent->m_char_list.clear();
	}
	else if (parent->m_char_list.size() == 1)
	{
		if ((parent->m_char_list[0] == '6') || (parent->m_char_list[0] == '7') || (parent->m_char_list[0] == '8') || (parent->m_char_list[0] == '9'))
		{
			parent->m_char_list.clear();
		}
	}
	parent->m_char_list.push_back(ch);
	if (parent->m_char_list.size() == 2) parent->analyze_char();
}

/// ͂ꂽl͂܂
/// @param parent eEBhE
/// @param num ͂ꂽl
void Bcl_dtp_analyze_abst_minute::analyze_char(Bcl_dtp_edit* parent, int num)
{
	Bcl_time time(parent->m_hour, num, parent->m_second, 0);
	if ((time >= parent->m_min_time) && (time <= parent->m_max_time))
	{
		parent->m_minute = num;
		parent->send_date_time_change_msg();
	}
}

//--------------------------------------------------------------
//
// Date Time Pickerpi2j̓NX
//
//--------------------------------------------------------------
/// RXgN^
/// @param is_select_target IΏۂǂ
Bcl_dtp_analyze_minute2::Bcl_dtp_analyze_minute2(bool is_select_target) : Bcl_dtp_analyze_abst_minute(is_select_target)
{
}

/// IJnʒu擾܂
/// @param parent eEBhE
/// @return IJnʒu
int Bcl_dtp_analyze_minute2::get_select_start(Bcl_dtp_edit* parent)
{
	if (!parent->m_char_list.empty()) return 2 - parent->m_char_list.size(); else return 0;
}

/// eLXg擾܂
/// @param parent eEBhE
/// @param is_current ݑIʒuǂ
/// @return eLXg
Bcl_str Bcl_dtp_analyze_minute2::get_text(Bcl_dtp_edit* parent, bool is_current)
{
	Bcl_str str;
	if ((is_current) && (!parent->m_char_list.empty()))
	{
		if (parent->m_char_list.size() == 1) str = " ";
		Bcl_itr< std::vector<char> > itr(parent->m_char_list);
		while (itr.has_next())
		{
			str += itr.next();
		}
	}
	else
	{
		str.format("%02d", parent->m_minute);
	}
	return str;
}

//--------------------------------------------------------------
//
// Date Time Pickerpi1܂2j̓NX
//
//--------------------------------------------------------------
/// RXgN^
/// @param is_select_target IΏۂǂ
Bcl_dtp_analyze_minute1::Bcl_dtp_analyze_minute1(bool is_select_target) : Bcl_dtp_analyze_abst_minute(is_select_target)
{
}

/// IJnʒu擾܂
/// @param parent eEBhE
/// @return IJnʒu
int Bcl_dtp_analyze_minute1::get_select_start(Bcl_dtp_edit* parent)
{
	if (!parent->m_char_list.empty()) return 2 - parent->m_char_list.size(); else if (parent->m_minute < 10) return 1; return 0;
}

/// eLXg擾܂
/// @param parent eEBhE
/// @param is_current ݑIʒuǂ
/// @return eLXg
Bcl_str Bcl_dtp_analyze_minute1::get_text(Bcl_dtp_edit* parent, bool is_current)
{
	Bcl_str str;
	if ((is_current) && (!parent->m_char_list.empty()))
	{
		if (parent->m_char_list.size() == 1) str = " ";
		Bcl_itr< std::vector<char> > itr(parent->m_char_list);
		while (itr.has_next())
		{
			str += itr.next();
		}
	}
	else
	{
		str.format("%2d", parent->m_minute);
	}
	return str;
}

//--------------------------------------------------------------
//
// Date Time Pickerpb̓NX
//
//--------------------------------------------------------------
/// RXgN^
/// @param is_select_target IΏۂǂ
Bcl_dtp_analyze_abst_second::Bcl_dtp_analyze_abst_second(bool is_select_target) : Bcl_dtp_analyze_abst(is_select_target)
{
}

/// 擾܂
/// @param is_current ݑIʒuǂ
/// @return 
int Bcl_dtp_analyze_abst_second::get_length(bool is_current)
{
	return 2;
}

/// vZ܂
/// @param parent eEBhE
/// @param val ύXl
void Bcl_dtp_analyze_abst_second::calc(Bcl_dtp_edit* parent, int val)
{
	int second = (parent->m_second + val + 60) % 60;
	Bcl_time time(parent->m_hour, parent->m_minute, second, 0);
	if ((time >= parent->m_min_time) && (time <= parent->m_max_time))
	{
		parent->m_second = second;
		parent->send_date_time_change_msg();
	}
	else
	{
		calc_min_or_max_time(parent, time);
	}
}

/// L[͂܂
/// @param parent eEBhE
/// @param ch L[
void Bcl_dtp_analyze_abst_second::on_char(Bcl_dtp_edit* parent, char ch)
{
	if (parent->m_char_list.size() == 2)
	{
		parent->m_char_list.clear();
	}
	else if (parent->m_char_list.size() == 1)
	{
		if ((parent->m_char_list[0] == '6') || (parent->m_char_list[0] == '7') || (parent->m_char_list[0] == '8') || (parent->m_char_list[0] == '9'))
		{
			parent->m_char_list.clear();
		}
	}
	parent->m_char_list.push_back(ch);
	if (parent->m_char_list.size() == 2) parent->analyze_char();
}

/// ͂ꂽl͂܂
/// @param parent eEBhE
/// @param num ͂ꂽl
void Bcl_dtp_analyze_abst_second::analyze_char(Bcl_dtp_edit* parent, int num)
{
	Bcl_time time(parent->m_hour, parent->m_minute, num, 0);
	if ((time >= parent->m_min_time) && (time <= parent->m_max_time))
	{
		parent->m_second = num;
		parent->send_date_time_change_msg();
	}
}

//--------------------------------------------------------------
//
// Date Time Pickerpbi2j̓NX
//
//--------------------------------------------------------------
/// RXgN^
/// @param is_select_target IΏۂǂ
Bcl_dtp_analyze_second2::Bcl_dtp_analyze_second2(bool is_select_target) : Bcl_dtp_analyze_abst_second(is_select_target)
{
}

/// IJnʒu擾܂
/// @param parent eEBhE
/// @return IJnʒu
int Bcl_dtp_analyze_second2::get_select_start(Bcl_dtp_edit* parent)
{
	if (!parent->m_char_list.empty()) return 2 - parent->m_char_list.size(); else return 0;
}

/// eLXg擾܂
/// @param parent eEBhE
/// @param is_current ݑIʒuǂ
/// @return eLXg
Bcl_str Bcl_dtp_analyze_second2::get_text(Bcl_dtp_edit* parent, bool is_current)
{
	Bcl_str str;
	if ((is_current) && (!parent->m_char_list.empty()))
	{
		if (parent->m_char_list.size() == 1) str = " ";
		Bcl_itr< std::vector<char> > itr(parent->m_char_list);
		while (itr.has_next())
		{
			str += itr.next();
		}
	}
	else
	{
		str.format("%02d", parent->m_second);
	}
	return str;
}

//--------------------------------------------------------------
//
// Date Time Pickerpbi1܂2j̓NX
//
//--------------------------------------------------------------
/// RXgN^
/// @param is_select_target IΏۂǂ
Bcl_dtp_analyze_second1::Bcl_dtp_analyze_second1(bool is_select_target) : Bcl_dtp_analyze_abst_second(is_select_target)
{
}

/// IJnʒu擾܂
/// @param parent eEBhE
/// @return IJnʒu
int Bcl_dtp_analyze_second1::get_select_start(Bcl_dtp_edit* parent)
{
	if (!parent->m_char_list.empty()) return 2 - parent->m_char_list.size(); else if (parent->m_second < 10) return 1; else return 0;
}

/// eLXg擾܂
/// @param parent eEBhE
/// @param is_current ݑIʒuǂ
/// @return eLXg
Bcl_str Bcl_dtp_analyze_second1::get_text(Bcl_dtp_edit* parent, bool is_current)
{
	Bcl_str str;
	if ((is_current) && (!parent->m_char_list.empty()))
	{
		if (parent->m_char_list.size() == 1) str = " ";
		Bcl_itr< std::vector<char> > itr(parent->m_char_list);
		while (itr.has_next())
		{
			str += itr.next();
		}
	}
	else
	{
		str.format("%2d", parent->m_second);
	}
	return str;
}

//--------------------------------------------------------------
//
// Date Time Pickerp͂ȂNXNX
//
//--------------------------------------------------------------
/// RXgN^
/// @param str 
Bcl_dtp_analyze_none_creator::Bcl_dtp_analyze_none_creator(const Bcl_str& str) : m_str(str)
{
}

/// tH[}bg擾܂
/// @return tH[}bg
Bcl_str Bcl_dtp_analyze_none_creator::get_format_str()
{
	return "";
}

/// ̓NX𐶐܂
/// @return ̓NX
Bcl_dtp_analyze* Bcl_dtp_analyze_none_creator::create_analyze()
{
	return new Bcl_dtp_analyze_none(is_select_target(), m_str);
}

/// IΏۂǂ肵܂
/// @return 
bool Bcl_dtp_analyze_none_creator::is_select_target()
{
	return false;
}

//--------------------------------------------------------------
//
// Date Time PickerpNi4j̓NXNX
//
//--------------------------------------------------------------
/// tH[}bg擾܂
/// @return tH[}bg
Bcl_str Bcl_dtp_analyze_year4_creator::get_format_str()
{
	return "yyyy";
}

/// ̓NX𐶐܂
/// @return ̓NX
Bcl_dtp_analyze* Bcl_dtp_analyze_year4_creator::create_analyze()
{
	return new Bcl_dtp_analyze_year4(is_select_target());
}

/// IΏۂǂ肵܂
/// @return 
bool Bcl_dtp_analyze_year4_creator::is_select_target()
{
	return true;
}

//--------------------------------------------------------------
//
// Date Time PickerpNi2j̓NXNX
//
//--------------------------------------------------------------
/// tH[}bg擾܂
/// @return tH[}bg
Bcl_str Bcl_dtp_analyze_year2_creator::get_format_str()
{
	return "yy";
}

/// ̓NX𐶐܂
/// @return ̓NX
Bcl_dtp_analyze* Bcl_dtp_analyze_year2_creator::create_analyze()
{
	return new Bcl_dtp_analyze_year2(is_select_target());
}

/// IΏۂǂ肵܂
/// @return 
bool Bcl_dtp_analyze_year2_creator::is_select_target()
{
	return true;
}

//--------------------------------------------------------------
//
// Date Time PickerpNi1܂2j̓NXNX
//
//--------------------------------------------------------------
/// tH[}bg擾܂
/// @return tH[}bg
Bcl_str Bcl_dtp_analyze_year1_creator::get_format_str()
{
	return "y";
}

/// ̓NX𐶐܂
/// @return ̓NX
Bcl_dtp_analyze* Bcl_dtp_analyze_year1_creator::create_analyze()
{
	return new Bcl_dtp_analyze_year1(is_select_target());
}

/// IΏۂǂ肵܂
/// @return 
bool Bcl_dtp_analyze_year1_creator::is_select_target()
{
	return true;
}

//--------------------------------------------------------------
//
// Date Time Pickerpi2+j̓NXNX
//
//--------------------------------------------------------------
/// tH[}bg擾܂
/// @return tH[}bg
Bcl_str Bcl_dtp_analyze_month2_str_creator::get_format_str()
{
	return "MMMM";
}

/// ̓NX𐶐܂
/// @return ̓NX
Bcl_dtp_analyze* Bcl_dtp_analyze_month2_str_creator::create_analyze()
{
	return new Bcl_dtp_analyze_month2_str(is_select_target());
}

/// IΏۂǂ肵܂
/// @return 
bool Bcl_dtp_analyze_month2_str_creator::is_select_target()
{
	return true;
}

//--------------------------------------------------------------
//
// Date Time Pickerpi1܂2+j̓NXNX
//
//--------------------------------------------------------------
/// tH[}bg擾܂
/// @return tH[}bg
Bcl_str Bcl_dtp_analyze_month1_str_creator::get_format_str()
{
	return "MMM";
}

/// ̓NX𐶐܂
/// @return ̓NX
Bcl_dtp_analyze* Bcl_dtp_analyze_month1_str_creator::create_analyze()
{
	return new Bcl_dtp_analyze_month1_str(is_select_target());
}

/// IΏۂǂ肵܂
/// @return 
bool Bcl_dtp_analyze_month1_str_creator::is_select_target()
{
	return true;
}

//--------------------------------------------------------------
//
// Date Time Pickerpi2j̓NXNX
//
//--------------------------------------------------------------
/// tH[}bg擾܂
/// @return tH[}bg
Bcl_str Bcl_dtp_analyze_month2_creator::get_format_str()
{
	return "MM";
}

/// ̓NX𐶐܂
/// @return ̓NX
Bcl_dtp_analyze* Bcl_dtp_analyze_month2_creator::create_analyze()
{
	return new Bcl_dtp_analyze_month2(is_select_target());
}

/// IΏۂǂ肵܂
/// @return 
bool Bcl_dtp_analyze_month2_creator::is_select_target()
{
	return true;
}

//--------------------------------------------------------------
//
// Date Time Pickerpi1܂2j̓NXNX
//
//--------------------------------------------------------------
/// tH[}bg擾܂
/// @return tH[}bg
Bcl_str Bcl_dtp_analyze_month1_creator::get_format_str()
{
	return "M";
}

/// ̓NX𐶐܂
/// @return ̓NX
Bcl_dtp_analyze* Bcl_dtp_analyze_month1_creator::create_analyze()
{
	return new Bcl_dtp_analyze_month1(is_select_target());
}

/// IΏۂǂ肵܂
/// @return 
bool Bcl_dtp_analyze_month1_creator::is_select_target()
{
	return true;
}

//--------------------------------------------------------------
//
// Date Time Pickerpi2j̓NXNX
//
//--------------------------------------------------------------
/// tH[}bg擾܂
/// @return tH[}bg
Bcl_str Bcl_dtp_analyze_day2_creator::get_format_str()
{
	return "dd";
}

/// ̓NX𐶐܂
/// @return ̓NX
Bcl_dtp_analyze* Bcl_dtp_analyze_day2_creator::create_analyze()
{
	return new Bcl_dtp_analyze_day2(is_select_target());
}

/// IΏۂǂ肵܂
/// @return 
bool Bcl_dtp_analyze_day2_creator::is_select_target()
{
	return true;
}

//--------------------------------------------------------------
//
// Date Time Pickerpi1܂2j̓NXNX
//
//--------------------------------------------------------------
/// tH[}bg擾܂
/// @return tH[}bg
Bcl_str Bcl_dtp_analyze_day1_creator::get_format_str()
{
	return "d";
}

/// ̓NX𐶐܂
/// @return ̓NX
Bcl_dtp_analyze* Bcl_dtp_analyze_day1_creator::create_analyze()
{
	return new Bcl_dtp_analyze_day1(is_select_target());
}

/// IΏۂǂ肵܂
/// @return 
bool Bcl_dtp_analyze_day1_creator::is_select_target()
{
	return true;
}

//--------------------------------------------------------------
//
// Date Time Pickerpj̓NXNX
//
//--------------------------------------------------------------
/// tH[}bg擾܂
/// @return tH[}bg
Bcl_str Bcl_dtp_analyze_long_week_creator::get_format_str()
{
	return "dddd";
}

/// ̓NX𐶐܂
/// @return ̓NX
Bcl_dtp_analyze* Bcl_dtp_analyze_long_week_creator::create_analyze()
{
	return new Bcl_dtp_analyze_long_week(is_select_target());
}

/// IΏۂǂ肵܂
/// @return 
bool Bcl_dtp_analyze_long_week_creator::is_select_target()
{
	return false;
}

//--------------------------------------------------------------
//
// Date Time PickerpZj̓NXNX
//
//--------------------------------------------------------------
/// tH[}bg擾܂
/// @return tH[}bg
Bcl_str Bcl_dtp_analyze_short_week_creator::get_format_str()
{
	return "ddd";
}

/// ̓NX𐶐܂
/// @return ̓NX
Bcl_dtp_analyze* Bcl_dtp_analyze_short_week_creator::create_analyze()
{
	return new Bcl_dtp_analyze_short_week(is_select_target());
}

/// IΏۂǂ肵܂
/// @return 
bool Bcl_dtp_analyze_short_week_creator::is_select_target()
{
	return false;
}

//--------------------------------------------------------------
//
// Date Time Pickerpԁi24ԕ\L2j̓NXNX
//
//--------------------------------------------------------------
/// tH[}bg擾܂
/// @return tH[}bg
Bcl_str Bcl_dtp_analyze_24h_hour2_creator::get_format_str()
{
	return "HH";
}

/// ̓NX𐶐܂
/// @return ̓NX
Bcl_dtp_analyze* Bcl_dtp_analyze_24h_hour2_creator::create_analyze()
{
	return new Bcl_dtp_analyze_24h_hour2(is_select_target());
}

/// IΏۂǂ肵܂
/// @return 
bool Bcl_dtp_analyze_24h_hour2_creator::is_select_target()
{
	return true;
}

//--------------------------------------------------------------
//
// Date Time Pickerpԁi24ԕ\L1܂2j̓NXNX
//
//--------------------------------------------------------------
/// tH[}bg擾܂
/// @return tH[}bg
Bcl_str Bcl_dtp_analyze_24h_hour1_creator::get_format_str()
{
	return "H";
}

/// ̓NX𐶐܂
/// @return ̓NX
Bcl_dtp_analyze* Bcl_dtp_analyze_24h_hour1_creator::create_analyze()
{
	return new Bcl_dtp_analyze_24h_hour1(is_select_target());
}

/// IΏۂǂ肵܂
/// @return 
bool Bcl_dtp_analyze_24h_hour1_creator::is_select_target()
{
	return true;
}

//--------------------------------------------------------------
//
// Date Time Pickerpԁi12ԕ\L2j̓NXNX
//
//--------------------------------------------------------------
/// tH[}bg擾܂
/// @return tH[}bg
Bcl_str Bcl_dtp_analyze_12h_hour2_creator::get_format_str()
{
	return "hh";
}

/// ̓NX𐶐܂
/// @return ̓NX
Bcl_dtp_analyze* Bcl_dtp_analyze_12h_hour2_creator::create_analyze()
{
	return new Bcl_dtp_analyze_12h_hour2(is_select_target());
}

/// IΏۂǂ肵܂
/// @return 
bool Bcl_dtp_analyze_12h_hour2_creator::is_select_target()
{
	return true;
}

//--------------------------------------------------------------
//
// Date Time Pickerpԁi12ԕ\L1܂2j̓NXNX
//
//--------------------------------------------------------------
/// tH[}bg擾܂
/// @return tH[}bg
Bcl_str Bcl_dtp_analyze_12h_hour1_creator::get_format_str()
{
	return "h";
}

/// ̓NX𐶐܂
/// @return ̓NX
Bcl_dtp_analyze* Bcl_dtp_analyze_12h_hour1_creator::create_analyze()
{
	return new Bcl_dtp_analyze_12h_hour1(is_select_target());
}

/// IΏۂǂ肵܂
/// @return 
bool Bcl_dtp_analyze_12h_hour1_creator::is_select_target()
{
	return true;
}

//--------------------------------------------------------------
//
// Date Time Pickerpԋ敪̓NXNX
//
//--------------------------------------------------------------
/// tH[}bg擾܂
/// @return tH[}bg
Bcl_str Bcl_dtp_analyze_long_time_division_creator::get_format_str()
{
	return "tt";
}

/// ̓NX𐶐܂
/// @return ̓NX
Bcl_dtp_analyze* Bcl_dtp_analyze_long_time_division_creator::create_analyze()
{
	return new Bcl_dtp_analyze_long_time_division(is_select_target());
}

/// IΏۂǂ肵܂
/// @return 
bool Bcl_dtp_analyze_long_time_division_creator::is_select_target()
{
	return true;
}

//--------------------------------------------------------------
//
// Date Time PickerpZԋ敪̓NXNX
//
//--------------------------------------------------------------
/// tH[}bg擾܂
/// @return tH[}bg
Bcl_str Bcl_dtp_analyze_short_time_division_creator::get_format_str()
{
	return "t";
}

/// ̓NX𐶐܂
/// @return ̓NX
Bcl_dtp_analyze* Bcl_dtp_analyze_short_time_division_creator::create_analyze()
{
	return new Bcl_dtp_analyze_short_time_division(is_select_target());
}

/// IΏۂǂ肵܂
/// @return 
bool Bcl_dtp_analyze_short_time_division_creator::is_select_target()
{
	return true;
}

//--------------------------------------------------------------
//
// Date Time Pickerpi2j̓NXNX
//
//--------------------------------------------------------------
/// tH[}bg擾܂
/// @return tH[}bg
Bcl_str Bcl_dtp_analyze_minute2_creator::get_format_str()
{
	return "mm";
}

/// ̓NX𐶐܂
/// @return ̓NX
Bcl_dtp_analyze* Bcl_dtp_analyze_minute2_creator::create_analyze()
{
	return new Bcl_dtp_analyze_minute2(is_select_target());
}

/// IΏۂǂ肵܂
/// @return 
bool Bcl_dtp_analyze_minute2_creator::is_select_target()
{
	return true;
}

//--------------------------------------------------------------
//
// Date Time Pickerpi1܂2j̓NXNX
//
//--------------------------------------------------------------
/// tH[}bg擾܂
/// @return tH[}bg
Bcl_str Bcl_dtp_analyze_minute1_creator::get_format_str()
{
	return "m";
}

/// ̓NX𐶐܂
/// @return ̓NX
Bcl_dtp_analyze* Bcl_dtp_analyze_minute1_creator::create_analyze()
{
	return new Bcl_dtp_analyze_minute1(is_select_target());
}

/// IΏۂǂ肵܂
/// @return 
bool Bcl_dtp_analyze_minute1_creator::is_select_target()
{
	return true;
}

//--------------------------------------------------------------
//
// Date Time Pickerpbi2j̓NXNX
//
//--------------------------------------------------------------
/// tH[}bg擾܂
/// @return tH[}bg
Bcl_str Bcl_dtp_analyze_second2_creator::get_format_str()
{
	return "ss";
}

/// ̓NX𐶐܂
/// @return ̓NX
Bcl_dtp_analyze* Bcl_dtp_analyze_second2_creator::create_analyze()
{
	return new Bcl_dtp_analyze_second2(is_select_target());
}

/// IΏۂǂ肵܂
/// @return 
bool Bcl_dtp_analyze_second2_creator::is_select_target()
{
	return true;
}

//--------------------------------------------------------------
//
// Date Time Pickerpbi1܂2j̓NXNX
//
//--------------------------------------------------------------
/// tH[}bg擾܂
/// @return tH[}bg
Bcl_str Bcl_dtp_analyze_second1_creator::get_format_str()
{
	return "s";
}

/// ̓NX𐶐܂
/// @return ̓NX
Bcl_dtp_analyze* Bcl_dtp_analyze_second1_creator::create_analyze()
{
	return new Bcl_dtp_analyze_second1(is_select_target());
}

/// IΏۂǂ肵܂
/// @return 
bool Bcl_dtp_analyze_second1_creator::is_select_target()
{
	return true;
}

//--------------------------------------------------------------
//
// Date Time Pickerp̓NXXg
//
//--------------------------------------------------------------
/// ̓NXǉ܂
/// @param ana ̓NX
void Bcl_dtp_analyze_list::add_analyze(Bcl_dtp_analyze* ana)
{
	m_analyze_list.push_back(ana);
}

/// 擾܂
/// @param is_current ݑIʒuǂ
/// @return 
int Bcl_dtp_analyze_list::get_length(bool is_current)
{
	int len = 0;
	Bcl_itr< std::vector<Bcl_dtp_analyze*> > itr(m_analyze_list);
	while (itr.has_next())
	{
		len += itr.next()->get_length(is_current);
	}
	return len;
}

/// IJnʒu擾܂
/// @param parent eEBhE
/// @return IJnʒu
int Bcl_dtp_analyze_list::get_select_start(Bcl_dtp_edit* parent)
{
	int len = 0;
	Bcl_itr< std::vector<Bcl_dtp_analyze*> > itr(m_analyze_list);
	while (itr.has_next())
	{
		Bcl_dtp_analyze* ana = itr.next();
		if (ana->is_select_target())
		{
			len += ana->get_select_start(parent);
			break;
		}
		len += ana->get_length(true);
	}
	return len;
}

/// IIʒu擾܂
/// @return IIʒu
int Bcl_dtp_analyze_list::get_select_end()
{
	int len = 0;
	Bcl_itr< std::vector<Bcl_dtp_analyze*> > itr(m_analyze_list);
	while (itr.has_next())
	{
		Bcl_dtp_analyze* ana = itr.next();
		len += ana->get_length(true);
		if (ana->is_select_target()) break;
	}
	return len;
}

/// vZ܂
/// @param parent eEBhE
/// @param val ύXl
void Bcl_dtp_analyze_list::calc(Bcl_dtp_edit* parent, int val)
{
	Bcl_itr< std::vector<Bcl_dtp_analyze*> > itr(m_analyze_list);
	while (itr.has_next())
	{
		Bcl_dtp_analyze* ana = itr.next();
		if (ana->is_select_target()) ana->calc(parent, val);
	}
}

/// eLXg擾܂
/// @param parent eEBhE
/// @param is_current ݑIʒuǂ
/// @return eLXg
Bcl_str Bcl_dtp_analyze_list::get_text(Bcl_dtp_edit* parent, bool is_current)
{
	Bcl_str str;
	Bcl_itr< std::vector<Bcl_dtp_analyze*> > itr(m_analyze_list);
	while (itr.has_next())
	{
		str += itr.next()->get_text(parent, is_current);
	}
	return str;
}

/// L[͂܂
/// @param parent eEBhE
/// @param ch L[
void Bcl_dtp_analyze_list::on_char(Bcl_dtp_edit* parent, char ch)
{
	Bcl_itr< std::vector<Bcl_dtp_analyze*> > itr(m_analyze_list);
	while (itr.has_next())
	{
		Bcl_dtp_analyze* ana = itr.next();
		if (ana->is_select_target()) ana->on_char(parent, ch);
	}
}

/// ͂ꂽl͂܂
/// @param parent eEBhE
/// @param num ͂ꂽl
void Bcl_dtp_analyze_list::analyze_char(Bcl_dtp_edit* parent, int num)
{
	Bcl_itr< std::vector<Bcl_dtp_analyze*> > itr(m_analyze_list);
	while (itr.has_next())
	{
		Bcl_dtp_analyze* ana = itr.next();
		if (ana->is_select_target()) ana->analyze_char(parent, num);
	}
}

//--------------------------------------------------------------
//
// Date Time PickerpGfBbgNX
//
//--------------------------------------------------------------
std::map<HWND, Bcl_dtp_edit*> Bcl_dtp_edit::m_dtp_edit_list;

/// RXgN^
Bcl_dtp_edit::Bcl_dtp_edit() : m_min_date(Bcl_date(1752, 9, 14)), m_max_date(Bcl_date(9999, 12, 31)), m_min_time(Bcl_time(0, 0, 0, 0)), m_max_time(Bcl_time(23, 59, 59, 99))
{
	m_style = WS_CHILD | WS_VISIBLE | ES_AUTOHSCROLL;
	ON_MOUSEMOVE(Bcl_dtp_edit::on_mouse_move);
	ON_RBUTTONDOWN(Bcl_dtp_edit::on_rbutton_down);
	ON_RBUTTONUP(Bcl_dtp_edit::on_rbutton_up);
	ON_LBUTTONDOWN(Bcl_dtp_edit::on_lbutton_down);
	ON_LBUTTONDBLCLK(Bcl_dtp_edit::on_lbutton_dblclk);
	ON_LBUTTONUP(Bcl_dtp_edit::on_rbutton_up);
	ON_MSG(WM_SYSKEYDOWN, Bcl_dtp_edit::on_sys_key_down);
	ON_KEYDOWN(Bcl_dtp_edit::on_key_down);
	ON_CHAR(Bcl_dtp_edit::on_char);
	ON_SETFOCUS(Bcl_dtp_edit::on_set_focus);
	ON_KILLFOCUS(Bcl_dtp_edit::on_kill_focus);
	ON_MSG(EM_SETSEL, Bcl_dtp_edit::on_setsel);
}

/// fXgN^
Bcl_dtp_edit::~Bcl_dtp_edit()
{
	SetWindowLong(m_handle, GWL_WNDPROC, (LONG)m_org_proc);
	m_dtp_edit_list.erase(m_handle);
}

//// EBhE쐬֐
/// @param parent eEBhE
/// @param id ID
/// @param x W
/// @param y W
/// @param w 
/// @param h 
/// @return 
bool Bcl_dtp_edit::create(Bcl_dtpicker* parent, int id, int x, int y, int w, int h)
{
	if (!Bcl_ctrl::create(parent, id, x, y, w, h)) return false;
	m_dtp_parent = parent;
	m_dtp_edit_list[m_handle] = this;
	ImmAssociateContext(m_handle, NULL); 
	m_org_proc = (WNDPROC)GetWindowLong(m_handle, GWL_WNDPROC);
	SetWindowLong(m_handle, GWL_WNDPROC, (LONG)dtp_edit_proc);
	return true;
}

/// WM_MOUSEMOVẼbZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Bcl_dtp_edit::on_mouse_move(WPARAM wp, LPARAM lp)
{
	SetCursor(LoadCursor(NULL, IDC_ARROW));
}

/// WM_RBUTTONDOWÑbZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Bcl_dtp_edit::on_rbutton_down(WPARAM wp, LPARAM lp)
{
	SetCursor(LoadCursor(NULL, IDC_ARROW));
}

/// WM_RBUTTONUP̃bZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Bcl_dtp_edit::on_rbutton_up(WPARAM wp, LPARAM lp)
{
	SetCursor(LoadCursor(NULL, IDC_ARROW));
}

/// WM_LBUTTONDOWÑbZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Bcl_dtp_edit::on_lbutton_down(WPARAM wp, LPARAM lp)
{
	SetCursor(LoadCursor(NULL, IDC_ARROW));
	POINT pt;
	GetCursorPos(&pt);
	pt = get_client_from_screen(pt);
	int pos = LOWORD(send_msg(EM_CHARFROMPOS, 0, MAKELONG(pt.x, pt.y))) - 1;
	int len = 0;
	int cursor = m_dtp_parent->get_cursor_for_edit();
	Bcl_itr< std::vector<Bcl_dtp_analyze_list*> > itr(m_analyze_list);
	while (itr.has_next())
	{
		Bcl_dtp_analyze_list* ana = itr.next();
		if ((!itr.has_next()) || (pos < len + ana->get_length(itr.get_count() - 1 == cursor)))
		{
			m_dtp_parent->set_cursor_by_edit(itr.get_count() - 1);
			set_display_text();
			set_select_text();
			break;
		}
		len += ana->get_length(itr.get_count() - 1 == cursor);
	}
	set_focus();
}

/// WM_LBUTTONUP̃bZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Bcl_dtp_edit::on_lbutton_up(WPARAM wp, LPARAM lp)
{
	SetCursor(LoadCursor(NULL, IDC_ARROW));
}

/// WM_LBUTTONDBLCLK̃bZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Bcl_dtp_edit::on_lbutton_dblclk(WPARAM wp, LPARAM lp)
{
	SetCursor(LoadCursor(NULL, IDC_ARROW));
}

/// WM_SYSKEYDOWÑbZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Bcl_dtp_edit::on_sys_key_down(WPARAM wp, LPARAM lp)
{
	if (((lp & 0x20000000) != 0) && ((int)wp == VK_DOWN))
	{
		m_dtp_parent->post_msg(WM_COMMAND, MAKEWPARAM(IDC_BTN_CALENDAR, BN_CLICKED), 0);
	}
	else
	{
		CallWindowProc(m_org_proc, m_handle, WM_SYSKEYDOWN, wp, lp);
	}
}

/// WM_KEYDOWÑbZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Bcl_dtp_edit::on_key_down(WPARAM wp, LPARAM lp)
{
	if (((int)wp == VK_LEFT) || ((int)wp == VK_RIGHT) || (wp == ':') || (wp == '.') || (wp == '/'))
	{
		analyze_char();
		if ((int)wp == VK_LEFT)
		{
			m_dtp_parent->prev_cursor();
		}
		else
		{
			m_dtp_parent->next_cursor();
		}
		int cursor = m_dtp_parent->get_cursor_for_edit();
		if (cursor >= 0)
		{
			set_display_text();
			set_select_text();
		}
	}
	else if (((int)wp == VK_UP) || ((int)wp == VK_DOWN))
	{
		analyze_char();
		int cursor = m_dtp_parent->get_cursor_for_edit();
		m_analyze_list[cursor]->calc(this, (int)wp == VK_UP ? 1 : -1);
		set_display_text();
		set_select_text();
	}
	else
	{
		CallWindowProc(m_org_proc, m_handle, WM_KEYDOWN, wp, lp);
	}
}

/// WM_CHAR̃bZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Bcl_dtp_edit::on_char(WPARAM wp, LPARAM lp)
{
	if ((wp >= '0') && (wp <= '9'))
	{
		int cursor = m_dtp_parent->get_cursor_for_edit();
		m_analyze_list[cursor]->on_char(this, (char)wp);
		set_display_text();
		set_select_text();
	}
	if ((wp == ':') || (wp == '.') || (wp == '/'))
	{
		analyze_char();
		m_dtp_parent->next_cursor();
		int cursor = m_dtp_parent->get_cursor_for_edit();
		if (cursor >= 0)
		{
			set_display_text();
			set_select_text();
		}
	}
}

/// WM_SETFOCUS̃bZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Bcl_dtp_edit::on_set_focus(WPARAM wp, LPARAM lp)
{
	CallWindowProc(m_org_proc, m_handle, WM_SETFOCUS, wp, lp);
	HideCaret(m_handle);
	set_display_text();
	set_select_text();
}

/// WM_KILLDOCUS̃bZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Bcl_dtp_edit::on_kill_focus(WPARAM wp, LPARAM lp)
{
	analyze_char();
	CallWindowProc(m_org_proc, m_handle, WM_KILLFOCUS, wp, lp);
}

/// WM_SETSEL̃bZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Bcl_dtp_edit::on_setsel(WPARAM wp, LPARAM lp)
{
	if (lp != -1) CallWindowProc(m_org_proc, m_handle, EM_SETSEL, wp, lp);
}

/// ͂ꂽl͂܂
void Bcl_dtp_edit::analyze_char()
{
	if (!m_char_list.empty())
	{
		int num = 0;
		Bcl_itr< std::vector<char> > itr(m_char_list);
		while (itr.has_next())
		{
			num *= 10;
			num += itr.next() - '0';
		}
		int cursor = m_dtp_parent->get_cursor_for_edit();
		m_analyze_list[cursor]->analyze_char(this, num);
	}
	m_char_list.clear();
	set_display_text();
}

/// eLXgI܂
void Bcl_dtp_edit::set_select_text()
{
	int cursor = m_dtp_parent->get_cursor_for_edit();
	int len = 0;
	Bcl_itr< std::vector<Bcl_dtp_analyze_list*> > itr(m_analyze_list);
	while (itr.has_next())
	{
		Bcl_dtp_analyze_list* ana = itr.next();
		Bcl_str dbg_str;
		if (itr.get_count() - 1 == cursor)
		{
			send_msg(EM_SETSEL, len + ana->get_select_start(this), len + ana->get_select_end());
			break;
		}
		len += ana->get_length(false);
	}
}

/// eLXg\܂
void Bcl_dtp_edit::set_display_text()
{
	int cursor = m_dtp_parent->get_cursor_for_edit();
	Bcl_str str;
	Bcl_itr< std::vector<Bcl_dtp_analyze_list*> > itr(m_analyze_list);
	while (itr.has_next())
	{
		Bcl_dtp_analyze_list* ana = itr.next();
		str += ana->get_text(this, (GetFocus() == m_handle) && (itr.get_count() - 1 == cursor));
	}
	set_text(str);
}

/// t擾܂
/// @return t
Bcl_date Bcl_dtp_edit::get_date() const
{
	return Bcl_date(m_year, m_month, m_day);
}

/// IłłÂt擾܂
/// @return łÂt
Bcl_date Bcl_dtp_edit::get_mindate() const
{
	return m_min_date;
}

/// IłłVt擾܂
/// @return łVt
Bcl_date Bcl_dtp_edit::get_maxdate() const
{
	return m_max_date;
}

/// tݒ肵܂
/// @param date t
void Bcl_dtp_edit::set_date(const Bcl_date& date)
{
	m_year = date.get_year();
	m_month = date.get_month();
	m_day = date.get_day();
	set_display_text();
}

/// IłłÂtݒ肵܂
/// @param date łÂt
void Bcl_dtp_edit::set_mindate(const Bcl_date& date)
{
	Bcl_date min_date1 = Bcl_date(1752, 9, 14);
	Bcl_date min_date2 = Bcl_date(1752, 9, 19);
	Bcl_date min_date3 = Bcl_date(1752, 10, 1);
	if (date <= min_date1)
	{
		m_min_date = min_date1;
	}
	else if ((date > min_date2) && (date <= min_date3))
	{
		m_min_date = min_date3;
	}
	else
	{
		m_min_date = date;
	}
}

/// IłłVtݒ肵܂
/// @param date łVt
void Bcl_dtp_edit::set_maxdate(const Bcl_date& date)
{
	m_max_date = date;
}

/// Ԃ擾܂
/// @return 
Bcl_time Bcl_dtp_edit::get_time() const
{
	return Bcl_time(m_hour, m_minute, m_second, 0);
}

/// Ԃݒ肵܂
/// @param time 
void Bcl_dtp_edit::set_time(const Bcl_time& time)
{
	m_hour = time.get_hour();
	m_minute = time.get_minute();
	m_second = time.get_sec();
	set_display_text();
}

/// IłłԂݒ肵܂
/// @param time ł
void Bcl_dtp_edit::set_mintime(const Bcl_time& time)
{
	m_min_time = time;
}

/// IłłxԂݒ肵܂
/// @param time łx
void Bcl_dtp_edit::set_maxtime(const Bcl_time& time)
{
	m_max_time = time;
}

/// ύXlݒ肵܂
/// @param delta ύXl
void Bcl_dtp_edit::set_delta_pos(int delta)
{
	int cursor = m_dtp_parent->get_cursor_for_edit();
	if (cursor >= 0)
	{
		m_analyze_list[cursor]->calc(this, -delta);
		set_display_text();
		set_select_text();
	}
	else
	{
		m_parent->set_focus();
	}
}

/// tH[}bgݒ肵܂
/// @param format tH[}bg
void Bcl_dtp_edit::set_format(const Bcl_str& format)
{
	std::vector<Bcl_dtp_analyze_creator*> creator_list;
	add_creator(creator_list, new Bcl_dtp_analyze_year4_creator());
	add_creator(creator_list, new Bcl_dtp_analyze_year2_creator());
	add_creator(creator_list, new Bcl_dtp_analyze_year1_creator());
	add_creator(creator_list, new Bcl_dtp_analyze_month2_str_creator());
	add_creator(creator_list, new Bcl_dtp_analyze_month1_str_creator());
	add_creator(creator_list, new Bcl_dtp_analyze_month2_creator());
	add_creator(creator_list, new Bcl_dtp_analyze_month1_creator());
	add_creator(creator_list, new Bcl_dtp_analyze_long_week_creator());
	add_creator(creator_list, new Bcl_dtp_analyze_short_week_creator());
	add_creator(creator_list, new Bcl_dtp_analyze_day2_creator());
	add_creator(creator_list, new Bcl_dtp_analyze_day1_creator());
	add_creator(creator_list, new Bcl_dtp_analyze_24h_hour2_creator());
	add_creator(creator_list, new Bcl_dtp_analyze_24h_hour1_creator());
	add_creator(creator_list, new Bcl_dtp_analyze_12h_hour2_creator());
	add_creator(creator_list, new Bcl_dtp_analyze_12h_hour1_creator());
	add_creator(creator_list, new Bcl_dtp_analyze_long_time_division_creator());
	add_creator(creator_list, new Bcl_dtp_analyze_short_time_division_creator());
	add_creator(creator_list, new Bcl_dtp_analyze_minute2_creator());
	add_creator(creator_list, new Bcl_dtp_analyze_minute1_creator());
	add_creator(creator_list, new Bcl_dtp_analyze_second2_creator());
	add_creator(creator_list, new Bcl_dtp_analyze_second1_creator());
	
	Bcl_itr< std::vector<Bcl_dtp_analyze_list*> > itr(m_analyze_list);
	while (itr.has_next())
	{
		delete itr.next();
	}
	m_analyze_list.clear();
	Bcl_dtp_analyze_list* ana = new Bcl_dtp_analyze_list();
	Bcl_str str;
	int len = format.get_wlength();
	
	int i = 0;
	bool is_first = true;
	while (i < len)
	{
		bool is_chk = false;
		Bcl_itr< std::vector<Bcl_dtp_analyze_creator*> > itr(creator_list);
		while (itr.has_next())
		{
			Bcl_dtp_analyze_creator* creator = itr.next();
			Bcl_str target = creator->get_format_str();
			if (format.wmid(i, target.get_wlength()) == target)
			{
				if (str != "")
				{
					ana->add_analyze(Bcl_dtp_analyze_none_creator(str).create_analyze());
					str = "";
				}
				if (creator->is_select_target())
				{
					if (is_first)
					{
						is_first = false;
					}
					else
					{
						m_analyze_list.push_back(ana);
						ana = new Bcl_dtp_analyze_list();
					}
				}
				ana->add_analyze(creator->create_analyze());
				i += target.get_wlength();
				is_chk = true;
				break;
			}
		}
		if (!is_chk)
		{
			str += format.wmid(i, 1);
			i++;
		}
	}
	if (str != "") ana->add_analyze(Bcl_dtp_analyze_none_creator(str).create_analyze());
	m_analyze_list.push_back(ana);
	Bcl_itr< std::vector<Bcl_dtp_analyze_creator*> > creator_itr(creator_list);
	while (creator_itr.has_next())
	{
		delete creator_itr.next();
	}
	set_display_text();
}

/// ̓NXNXǉ܂
/// @param list ̓NXNXXg
/// @param ana ̓NXNX
void Bcl_dtp_edit::add_creator(std::vector<Bcl_dtp_analyze_creator*>& list, Bcl_dtp_analyze_creator* ana)
{
	list.push_back(ana);
}

/// DTN_DATETIMECHANGE𑗐M܂
void Bcl_dtp_edit::send_date_time_change_msg()
{
	set_display_text();
	m_dtp_parent->send_date_time_change_msg();
}

/// IΏې擾܂
/// @return IΏې
int Bcl_dtp_edit::get_cursor_count() const
{
	return m_analyze_list.size();
}

/// EBhEvV[W
/// @param hwnd EBhEnh
/// @param msg bZ[W
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
/// @return 
LRESULT CALLBACK Bcl_dtp_edit::dtp_edit_proc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp)
{
	Bcl_dtp_edit* ctrl = m_dtp_edit_list[hwnd];
	if (!proc_msg(hwnd, msg, wp, lp))
	{
		return CallWindowProc(ctrl->m_org_proc, hwnd, msg, wp, lp);
	}
	return 0L;
}

//--------------------------------------------------------------
//
// Date Time PickerpJ_NX
//
//--------------------------------------------------------------
std::map<HWND, Bcl_dtp_monthcal*> Bcl_dtp_monthcal::m_dtp_monthcal_list;

/// RXgN^
Bcl_dtp_monthcal::Bcl_dtp_monthcal()
{
	ON_KEYDOWN(Bcl_dtp_monthcal::on_key_down);
	ON_MSG(WM_DESTROY, Bcl_dtp_monthcal::on_destroy);
}

//// EBhE쐬֐
/// @param parent eEBhE
/// @param id ID
/// @param x W
/// @param y W
/// @param w 
/// @param h 
/// @return 
bool Bcl_dtp_monthcal::create(Bcl_dtp_cal_dlg* parent, int id, int x, int y, int w, int h)
{
	if (!Bcl_ctrl::create(parent, id, x, y, w, h)) return false;
	m_dtp_parent = parent;
	m_dtp_monthcal_list[m_handle] = this;
	m_org_proc = (WNDPROC)GetWindowLong(m_handle, GWL_WNDPROC);
	SetWindowLong(m_handle, GWL_WNDPROC, (LONG)dtp_monthcal_proc);
	return true;
}

/// WM_KEYDOWÑbZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Bcl_dtp_monthcal::on_key_down(WPARAM wp, LPARAM lp)
{
	if ((int)wp == VK_RETURN)
	{
		NMHDR hdr;
		hdr.hwndFrom = m_handle;
		hdr.idFrom = IDC_CAL_COMBO;
		hdr.code = NM_RETURN;
		m_dtp_parent->send_msg(WM_NOTIFY, IDC_CAL_COMBO, (LPARAM)&hdr);
	}
	else if ((int)wp == VK_ESCAPE)
	{
		NMKEY key;
		key.hdr.hwndFrom = m_handle;
		key.hdr.idFrom = IDC_CAL_COMBO;
		key.hdr.code = NM_KEYDOWN;
		key.nVKey = wp;
		key.uFlags = lp;
		m_dtp_parent->send_msg(WM_NOTIFY, IDC_CAL_COMBO, (LPARAM)&key);
	}
	else
	{
		CallWindowProc(m_org_proc, m_handle, WM_KEYDOWN, wp, lp);
	}
}

/// WM_DESTROỸbZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Bcl_dtp_monthcal::on_destroy()
{
	SetWindowLong(m_handle, GWL_WNDPROC, (LONG)m_org_proc);
	m_dtp_monthcal_list.erase(m_handle);
	m_wnd_list.erase(m_handle);
}

/// EBhEvV[W
/// @param hwnd EBhEnh
/// @param msg bZ[W
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
/// @return 
LRESULT CALLBACK Bcl_dtp_monthcal::dtp_monthcal_proc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp)
{
	Bcl_dtp_monthcal* ctrl = m_dtp_monthcal_list[hwnd];
	if (!proc_msg(hwnd, msg, wp, lp))
	{
//		if (msg == WM_GETDLGCODE) return DLGC_WANTALLKEYS;
		return CallWindowProc(ctrl->m_org_proc, hwnd, msg, wp, lp);
	}
	return 0L;
}

//--------------------------------------------------------------
//
// Date Time PickerpJ__CAONX
//
//--------------------------------------------------------------
std::map<HWND, Bcl_dtp_cal_dlg*> Bcl_dtp_cal_dlg::m_dtp_cal_list;

/// RXgN^
Bcl_dtp_cal_dlg::Bcl_dtp_cal_dlg() : m_is_close(false)
{
	m_style = WS_POPUP | WS_BORDER;
	m_ex_style = WS_EX_CONTROLPARENT;
	m_class_name = "STATIC";
	ON_ACTIVATE(Bcl_dtp_cal_dlg::on_activate);
	ON_SETFOCUS(Bcl_dtp_cal_dlg::on_set_focus);
	ON_NOTIFY(Bcl_dtp_cal_dlg::on_notify);
	ON_MSG(WM_CLOSE, Bcl_dtp_cal_dlg::on_close);
	ON_MSG(WM_DESTROY, Bcl_dtp_cal_dlg::on_destroy);
	ON_COMMAND(0, Bcl_dtp_cal_dlg::on_command);
}

//// EBhE쐬֐
/// @param parent eEBhE
/// @param id ID
/// @param x W
/// @param y W
/// @param w 
/// @param h 
/// @return 
bool Bcl_dtp_cal_dlg::create(Bcl_dtpicker* parent, int x, int y, int w, int h)
{
	if (!Bcl_ctrl::create(parent, NULL, x, y, w, h)) return false;
	m_dtp_parent = parent;
	m_dtp_cal_list[m_handle] = this;
	m_cal.create(this, IDC_CAL_COMBO, 0, 0, 0, 0);
	RECT rect;
	MonthCal_GetMinReqRect(m_cal.get_handle(), &rect);
	m_cal.move(0, 0, rect.right, rect.bottom);
	move(x, y, rect.right, rect.bottom);
	m_cal.set_focus();
	m_org_proc = (WNDPROC)GetWindowLong(m_handle, GWL_WNDPROC);
	SetWindowLong(m_handle, GWL_WNDPROC, (LONG)dtp_cal_proc);
	return true;
}

/// tݒ肵܂
/// @param date t
void Bcl_dtp_cal_dlg::set_date(const Bcl_date& date)
{
	m_date = date;
	m_cal.set_date(date);
}

/// IłłÂtƍłVtݒ肵܂
/// @param min_date łÂt
/// @param max_date łVt
void Bcl_dtp_cal_dlg::set_minmax_date(const Bcl_date& min_date, const Bcl_date& max_date)
{
	m_cal.set_mindate(min_date);
	m_cal.set_maxdate(max_date);
}

/// WM_ACTIVATẼbZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Bcl_dtp_cal_dlg::on_activate(WPARAM wp, LPARAM lp)
{
	if ((wp == WA_INACTIVE) && (!m_is_close))
	{
		send_msg(WM_CLOSE, 0, 0);
	}
}

/// WM_SETFOCUS̃bZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Bcl_dtp_cal_dlg::on_set_focus(WPARAM wp, LPARAM lp)
{
	m_cal.set_focus();
}

/// WM_NOTIFỸbZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Bcl_dtp_cal_dlg::on_notify(WPARAM wp, LPARAM lp)
{
	if (wp == IDC_CAL_COMBO)
	{
		NMHDR* hdr = (NMHDR*)lp;
		if (hdr->code == MCN_SELCHANGE)
		{
			Bcl_date date = m_cal.get_date();
			m_dtp_parent->set_date(date.get_year(), date.get_month(), date.get_day());
		}
		else if (hdr->code == MCN_SELECT)
		{
			Bcl_date date = m_cal.get_date();
			m_dtp_parent->set_date(date.get_year(), date.get_month(), date.get_day());
			send_msg(WM_CLOSE, 0, 0);
		}
		else if (hdr->code == NM_RETURN)
		{
			send_msg(WM_CLOSE, 0, 0);
		}
		else if (hdr->code == NM_KEYDOWN)
		{
			NMKEY* key = (NMKEY*)lp;
			if (key->nVKey == VK_ESCAPE)
			{
				m_dtp_parent->set_date(m_date.get_year(), m_date.get_month(), m_date.get_day());
				send_msg(WM_CLOSE, 0, 0);
			}
		}
	}
}

/// WM_DESTROỸbZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Bcl_dtp_cal_dlg::on_close(WPARAM wp, LPARAM lp)
{
	m_is_close = true;
	Bcl_wnd::on_close(wp, lp);
}

/// WM_DESTROỸbZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Bcl_dtp_cal_dlg::on_destroy(WPARAM wp, LPARAM lp)
{
	NMHDR hdr;
	hdr.hwndFrom = m_dtp_parent->m_handle;
	hdr.idFrom = m_dtp_parent->m_id;
	hdr.code = DTN_CLOSEUP;
	m_dtp_parent->m_parent->send_msg(WM_NOTIFY, m_dtp_parent->m_id, (LPARAM)&hdr);
	SetWindowLong(m_handle, GWL_WNDPROC, (LONG)m_org_proc);
	m_dtp_cal_list.erase(m_handle);
	m_wnd_list.erase(m_handle);
	m_dtp_parent->m_cursor = 0;
	m_dtp_parent->post_msg(WM_SETFOCUS, 0, 0);
	m_is_close = false;
}

/// WM_COMMAND̃bZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Bcl_dtp_cal_dlg::on_command(WPARAM wp, LPARAM lp)
{
	if (HIWORD(wp) == (WORD)DTN_CLOSEUP) send_msg(WM_CLOSE, 0, 0);
}


/// EBhEvV[W
/// @param hwnd EBhEnh
/// @param msg bZ[W
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
/// @return 
LRESULT CALLBACK Bcl_dtp_cal_dlg::dtp_cal_proc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp)
{
	Bcl_dtp_cal_dlg* ctrl = m_dtp_cal_list[hwnd];
	if (!proc_msg(hwnd, msg, wp, lp))
	{
		return CallWindowProc(ctrl->m_org_proc, hwnd, msg, wp, lp);
	}
	return 0L;
}
#endif

//--------------------------------------------------------------
//
// Date Time PickerpNX
//
//--------------------------------------------------------------
/// RXgN^
Bcl_dtpicker::Bcl_dtpicker()
{
#ifndef USE_SYSTEM_DTPICKER
	m_proc = wnd_proc;
	m_style = WS_CHILD | WS_VISIBLE | WS_BORDER | WS_TABSTOP | DS_CONTROL;
	m_ex_style = WS_EX_CLIENTEDGE;
	m_class_name = "DTP";
	ON_NOTIFY(Bcl_dtpicker::on_notify);
	ON_SIZE(Bcl_dtpicker::on_size);
	ON_SETFOCUS(Bcl_dtpicker::on_set_focus);
	ON_COMMAND(IDC_BTN_CALENDAR, Bcl_dtpicker::on_btn_calendar);
	ON_COMMAND(IDC_CHK_VALID, Bcl_dtpicker::on_chk_valid);
	ON_MSG(DTM_GETMONTHCAL, Bcl_dtpicker::on_get_month_cal);
	ON_MSG(WM_DRAWITEM, Bcl_dtpicker::on_draw_item);
#else
	m_class_name	= "SYSDATETIMEPICK32";
	m_style			= WS_CHILD | WS_VISIBLE | WS_TABSTOP | DTS_RIGHTALIGN | DTS_LONGDATEFORMAT;
	m_window_name	= "";
#endif
    INITCOMMONCONTROLSEX ic;
	ic.dwSize = sizeof(INITCOMMONCONTROLSEX);
	ic.dwICC = ICC_DATE_CLASSES | ICC_WIN95_CLASSES;
	InitCommonControlsEx(&ic);
}

/// fXgN^
Bcl_dtpicker::~Bcl_dtpicker()
{
}

#ifndef USE_SYSTEM_DTPICKER
/// o^
/// @param instance CX^X
/// @return 
bool Bcl_dtpicker::set_register(HINSTANCE instance)
{
	if (!Bcl_wnd::init(m_class_name, instance))
	{
		return false;		// leave function
	}
	return true;
}

/// EBhE
/// @param parent eEBhE
/// @param id Rg[hc
/// @param x W
/// @param y W
/// @param w 
/// @param h 
/// @return 
bool Bcl_dtpicker::create(Bcl_wnd* parent, int id, int x, int y, int w, int h)
{
	m_style |= WS_BORDER;
	if (!Bcl_ctrl::create(parent, id, x, y, w, h))
	{
		return false;
	}
	if (m_handle != NULL) create_child(parent);
	return true;
}

/// Rg[Ɗ֘At
/// @param parent eEBhE
/// @param id Rg[hc
bool Bcl_dtpicker::assign(Bcl_wnd* parent, int id)
{
	
	Bcl_ctrl::assign(parent, id);
	set_style(m_style | WS_BORDER);
	set_expand_style(m_ex_style | WS_EX_CLIENTEDGE);
	if (m_handle != NULL)
	{
		SetWindowPos(m_handle, NULL, 0, 0, 0, 0, (SWP_NOMOVE |SWP_NOSIZE | SWP_NOZORDER | SWP_FRAMECHANGED));
		create_child(parent);
	}
	return true;
}

/// qEBhE𐶐܂
/// @param parent eEBhE
void Bcl_dtpicker::create_child(Bcl_wnd* parent)
{
	int width = get_client_width();
	int height = get_client_height();
	int chk_valid = 0;
	if ((m_style & DTS_SHOWNONE) ==  DTS_SHOWNONE)
	{
		m_chk_valid.create(this, IDC_CHK_VALID, 0, 0, height, height);
		chk_valid = height;
	}
	m_edit_display.create(this, IDC_EDIT_DISPLAY, chk_valid, 0, width - chk_valid - 20, height);
	HFONT handle = (HFONT)SendMessage(parent->get_handle(), WM_GETFONT, 0, 0);
	Bcl_font font(handle);
	m_edit_display.set_font(font.get_point_size(parent), font.get_font_name());
	if ((m_style & DTS_UPDOWN) == DTS_UPDOWN)
	{
		m_ud_time.set_style(WS_CHILD | WS_VISIBLE | UDS_ARROWKEYS | UDS_NOTHOUSANDS);
		m_ud_time.create(this, IDC_UD_TIME, width - 20, 0, 20, height);
	}
	else
	{
		m_btn_calendar.set_mode(BTN_MODE_PUSHBTN);
		m_btn_calendar.set_style(m_btn_calendar.get_style() & ~WS_TABSTOP);
		m_btn_calendar.create(this, IDC_BTN_CALENDAR, width - 20, 0, 20, height);
		m_btn_calendar.set_font(6, "lr ");
		m_btn_calendar.set_text("");
	}
	if ((m_style & DTS_TIMEFORMAT) == DTS_TIMEFORMAT)
	{
		m_edit_display.set_format("HH:mm");
	}
	else if ((m_style & DTS_LONGDATEFORMAT) == DTS_LONGDATEFORMAT)
	{
		m_edit_display.set_format("yyyyNMMdd");
	}
	else
	{
		m_edit_display.set_format("yyyy/MM/dd");
	}
	m_wnd_list[Bcl_wnd::m_handle] = this;
	m_chk_valid.set_check(true);
	m_edit_display.set_date(Bcl_date());
	m_edit_display.set_time(Bcl_time());
	m_cursor = 0;
}

/// WM_SIZẼbZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Bcl_dtpicker::on_size(WPARAM wp, LPARAM lp)
{
	int width = LOWORD(lp);
	int height = HIWORD(lp);
	HDWP hDwp;
	int chk_valid = 0;
	if ((m_style & DTS_SHOWNONE) ==  DTS_SHOWNONE)
	{
		hDwp = BeginDeferWindowPos(3);
		hDwp = DeferWindowPos(hDwp, m_chk_valid.get_handle(), HWND_TOP, 0, 0, height, height, SWP_NOZORDER);
		chk_valid = height;
	}
	else
	{
		hDwp = BeginDeferWindowPos(2);
	}
	hDwp = DeferWindowPos(hDwp, m_edit_display.get_handle(), HWND_TOP, chk_valid, 0, width - chk_valid - 20, height, SWP_NOZORDER);
	if ((m_style & DTS_UPDOWN) == DTS_UPDOWN)
	{
		hDwp = DeferWindowPos(hDwp, m_ud_time.get_handle(), HWND_TOP, width - 20, 0, 20, height, SWP_NOZORDER);
	}
	else
	{
		hDwp = DeferWindowPos(hDwp, m_btn_calendar.get_handle(), HWND_TOP, width - 20, 0, 20, height, SWP_NOZORDER);
	}
	EndDeferWindowPos(hDwp);
}

/// WM_NOTIFỸbZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Bcl_dtpicker::on_notify(WPARAM wp, LPARAM lp)
{
	if (wp == IDC_UD_TIME)
	{
		NMUPDOWN* p_udpos = (NMUPDOWN*)lp;
		if (p_udpos->hdr.code == UDN_DELTAPOS)
		{
			set_focus();
			m_edit_display.set_delta_pos(p_udpos->iDelta);
		}
	}
	
}

/// WM_SETFOCUS̃bZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Bcl_dtpicker::on_set_focus(WPARAM wp, LPARAM lp)
{
	if (((m_style & DTS_SHOWNONE) == DTS_SHOWNONE) && (m_cursor == 0)) m_chk_valid.set_focus(); else m_edit_display.set_focus();
}

/// WM_COMMAND(Rg[ID=IDC_BTN_CALENDAR)̃bZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Bcl_dtpicker::on_btn_calendar(WPARAM wp, LPARAM lp)
{
	if ((m_style & DTS_UPDOWN) != DTS_UPDOWN)
	{
		if (!m_chk_valid.is_checked())
		{
			set_check(true);
			send_date_time_change_msg();
		}
		int cal_size = 170;
		RECT desktop_rect;
		RECT rect = get_rect();
		int x = rect.left;
		if ((m_style & DTS_RIGHTALIGN) == DTS_RIGHTALIGN)
		{
			x = rect.right - (cal_size + 20);
		}
		else if ((m_style & DTS_SHOWNONE) == DTS_SHOWNONE)
		{
			x = rect.left + 16;
		}
		int y = rect.bottom;
		GetWindowRect(GetDesktopWindow(), &desktop_rect);
		if (y + cal_size > desktop_rect.bottom) y = rect.top - cal_size;
		m_dlg_cal.create(this, x, y, 0, 0);
		if ((m_style & DTS_RIGHTALIGN) == DTS_RIGHTALIGN)
		{
			RECT dlg_rect = m_dlg_cal.get_rect();
			m_dlg_cal.move(dlg_rect.left + cal_size - (dlg_rect.right - dlg_rect.left + 1), dlg_rect.top, dlg_rect.right - dlg_rect.left + 1, dlg_rect.bottom - dlg_rect.top + 1);
		}
		m_dlg_cal.set_date(m_edit_display.get_date());
		m_dlg_cal.set_minmax_date(m_edit_display.get_mindate(), m_edit_display.get_maxdate());
		m_dlg_cal.set_focus();
		NMHDR hdr;
		hdr.hwndFrom = m_handle;
		hdr.idFrom = m_id;
		hdr.code = DTN_DROPDOWN;
		m_parent->send_msg(WM_NOTIFY, m_id, (LPARAM)&hdr);
	}
}

/// WM_COMMAND(Rg[ID=IDC_CHK_VALID)̃bZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Bcl_dtpicker::on_chk_valid(WPARAM wp, LPARAM lp)
{
	if (HIWORD(wp) == BN_CLICKED)
	{
		set_check(!m_chk_valid.is_checked());
		m_cursor = 0;
		send_date_time_change_msg();
	}
}

/// DTM_GETMONTHCAL̃bZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Bcl_dtpicker::on_get_month_cal(WPARAM wp, LPARAM lp)
{
	m_proc_rtn = (int)m_dlg_cal.get_handle();
}

/// WM_DRAWITEM̃bZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Bcl_dtpicker::on_draw_item(WPARAM wp, LPARAM lp)
{
	if (wp == IDC_CHK_VALID)
	{
		LPDRAWITEMSTRUCT dwi = (LPDRAWITEMSTRUCT)lp;
		if ((dwi->itemState & ODS_DISABLED) == ODS_DISABLED)
		{
			draw_rectangle(dwi->hDC, 0, 0, dwi->rcItem.right - dwi->rcItem.left, dwi->rcItem.bottom - dwi->rcItem.top, RGB(240, 240, 240));
		}
		else
		{
			draw_rectangle(dwi->hDC, 0, 0, dwi->rcItem.right - dwi->rcItem.left, dwi->rcItem.bottom - dwi->rcItem.top, WHITE);
		}
		int w = (dwi->rcItem.right - dwi->rcItem.left - 4) / 16;
		if (w == 0) w = 1;
		draw_rectangle(dwi->hDC, 2, 2, dwi->rcItem.right - dwi->rcItem.left - 2 - w, 2 + w, RGB(160, 160, 160));
		draw_rectangle(dwi->hDC, 2, 2, 2 + w, dwi->rcItem.bottom - dwi->rcItem.top - 2 - w, RGB(160, 160, 160));
		draw_rectangle(dwi->hDC, 2 + w, dwi->rcItem.bottom - dwi->rcItem.top - 2 - w * 2,
					dwi->rcItem.right - dwi->rcItem.left - 2 - w, dwi->rcItem.bottom - dwi->rcItem.top - 2 - w, RGB(227, 227, 227));
		draw_rectangle(dwi->hDC, dwi->rcItem.right - dwi->rcItem.left - 2 - w * 2, 2 + w,
					dwi->rcItem.right - dwi->rcItem.left - 2 - w, dwi->rcItem.bottom - dwi->rcItem.top - 2 - w, RGB(227, 227, 227));
		draw_rectangle(dwi->hDC, 2 + w, 2 + w, dwi->rcItem.right - dwi->rcItem.left - 2 - w * 2, 2 + w * 2, RGB(105, 105, 105));
		draw_rectangle(dwi->hDC, 2 + w, 2 + w, 2 + w * 2, dwi->rcItem.bottom - dwi->rcItem.top - 2 - w * 2, RGB(105, 105, 105));
		if (m_chk_valid.is_checked())
		{
			int x1 = 2 + w * 4;
			int x2 = dwi->rcItem.right - dwi->rcItem.left - 2 - w * 5;
			int x3 = x1 + (x2 - x1) / 3;
			int y1 = 2 + w * 3;
			int y2 = y1 + (x2 - x3);
			int y3 = y2 - (x3 - x1);
			POINT pt[6];
			pt[0].x = x1;
			pt[0].y = y3;
			pt[1].x = x3;
			pt[1].y = y2;
			pt[2].x = x2;
			pt[2].y = y1;
			pt[3].x = x2;
			pt[3].y = y1 + w * 3 - 1;
			pt[4].x = x3;
			pt[4].y = y2 + w * 3 - 1;
			pt[5].x = x1;
			pt[5].y = y3 + w * 3 - 1;
			if ((dwi->itemState & ODS_DISABLED) == ODS_DISABLED)
			{
				draw_polygon(dwi->hDC, pt, 6, RGB(160, 160, 160));
			}
			else
			{
				draw_polygon(dwi->hDC, pt, 6, BLACK);
			}
		}
		if ((dwi->itemState & ODS_FOCUS) == ODS_FOCUS)
		{
			RECT focus_rect;
			focus_rect.top = 1;
			focus_rect.left = 1;
			focus_rect.bottom = dwi->rcItem.bottom - 1;
			focus_rect.right = dwi->rcItem.right - 1;
			DrawFocusRect(dwi->hDC, &focus_rect);
		}
	}
}

/// Date Time PickerRg[̎ނݒ肵܂
/// @param mode 
void Bcl_dtpicker::set_mode(DTP_MODE mode)
{
	m_style &= ~(DTS_LONGDATEFORMAT | DTS_SHORTDATEFORMAT | DTS_TIMEFORMAT | DTS_SHOWNONE);
	switch (mode)
	{
		case DTP_SHORTDATE:
			m_style |= DTS_SHORTDATEFORMAT;
			break;
		case DTP_LONGDATE:
			m_style |= DTS_LONGDATEFORMAT;
			break;
		case DTP_TIME:
			m_style |= DTS_TIMEFORMAT;
			break;
		case DTP_CHK_SHORTDATE:
			m_style |= DTS_SHORTDATEFORMAT | DTS_SHOWNONE;
			break;
		case DTP_CHK_LONGDATE:
			m_style |= DTS_LONGDATEFORMAT | DTS_SHOWNONE;
			break;
		case DTP_CHK_TIME:
			m_style |= DTS_TIMEFORMAT | DTS_SHOWNONE;
			break;
	}
}

/// tH[}bgݒ
/// @param format tH[}bg
void Bcl_dtpicker::set_format(const Bcl_str& format)
{
	if (m_handle != NULL) m_edit_display.set_format(format);
}

/// t擾
/// @return t
Bcl_date Bcl_dtpicker::get_date() const
{
	return m_edit_display.get_date();
}

/// tݒ
/// @param date t
void Bcl_dtpicker::set_date(const Bcl_date& date)
{
	if (m_handle != NULL) m_edit_display.set_date(date);
}

/// IłłÂtݒ肵܂
/// @param date łÂt
void Bcl_dtpicker::set_mindate(const Bcl_date& date)
{
	if (m_handle != NULL) m_edit_display.set_mindate(date);
}

/// IłłVtݒ肵܂
/// @param date łVt
void Bcl_dtpicker::set_maxdate(const Bcl_date& date)
{
	if (m_handle != NULL) m_edit_display.set_maxdate(date);
}

/// Ԏ擾
/// @return 
Bcl_time Bcl_dtpicker::get_time() const
{
	return m_edit_display.get_time();
}

/// Ԑݒ
/// @param time 
void Bcl_dtpicker::set_time(const Bcl_time& time)
{
	if (m_handle != NULL) m_edit_display.set_time(time);
}

/// IłłԂݒ肵܂
/// @param time ł
void Bcl_dtpicker::set_mintime(const Bcl_time& time)
{
	if (m_handle != NULL) m_edit_display.set_mintime(time);
}

/// IłłxԂݒ肵܂
/// @param time łx
void Bcl_dtpicker::set_maxtime(const Bcl_time& time)
{
	if (m_handle != NULL) m_edit_display.set_maxtime(time);
}

/// `FbNԐݒ
/// @param chk `FbN
void Bcl_dtpicker::set_check(bool chk)
{
	if (m_handle != NULL)
	{
		m_chk_valid.set_check(chk);
		m_edit_display.set_enabled(chk);
	}
}

/// `FbNԎ擾
/// @return `FbN
bool Bcl_dtpicker::is_checked() const
{
	return m_chk_valid.is_checked();
}

/// tݒ肵܂
/// @param year N
/// @param month 
/// @param day 
void Bcl_dtpicker::set_date(int year, int month, int day)
{
	if (m_handle != NULL)
	{
		m_edit_display.set_date(Bcl_date(year, month, day));
		send_date_time_change_msg();
	}
}

/// GfBbg{bNXJ[\ʒuݒ肵܂
/// @param cursor J[\ʒu
void Bcl_dtpicker::set_cursor_by_edit(int cursor)
{
	m_cursor = cursor + ((m_style & DTS_SHOWNONE) == DTS_SHOWNONE ? 1 : 0);
}

/// GfBbg{bNXփJ[\ʒu擾܂
/// @return J[\ʒu
int Bcl_dtpicker::get_cursor_for_edit()
{
	return m_cursor - ((m_style & DTS_SHOWNONE) == DTS_SHOWNONE ? 1 : 0);
}

/// J[\ʒuֈړ܂
void Bcl_dtpicker::next_cursor()
{
	m_cursor++;
	m_cursor %= m_edit_display.get_cursor_count() + ((m_style & DTS_SHOWNONE) == DTS_SHOWNONE ? 1 : 0);
	if (((m_style & DTS_SHOWNONE) == DTS_SHOWNONE) && (m_cursor == 0)) m_chk_valid.set_focus(); else m_edit_display.set_focus();
}

/// J[\ʒuOֈړ܂
void Bcl_dtpicker::prev_cursor()
{
	m_cursor += m_edit_display.get_cursor_count() + ((m_style & DTS_SHOWNONE) == DTS_SHOWNONE ? 1 : 0) - 1;
	m_cursor %= m_edit_display.get_cursor_count() + ((m_style & DTS_SHOWNONE) == DTS_SHOWNONE ? 1 : 0);
	if (((m_style & DTS_SHOWNONE) == DTS_SHOWNONE) && (m_cursor == 0)) m_chk_valid.set_focus(); else m_edit_display.set_focus();
}

/// DTN_DATETIMECHANGE𑗐M܂
void Bcl_dtpicker::send_date_time_change_msg()
{
	NMHDR hdr;
	hdr.hwndFrom = m_handle;
	hdr.idFrom = m_id;
	hdr.code = DTN_DATETIMECHANGE;
	m_parent->send_msg(WM_NOTIFY, m_id, (LPARAM)&hdr);
}

/// EBhE̗Lݒ肵܂
/// @param flg L
void Bcl_dtpicker::set_enabled(bool flg)
{
	if (flg)
	{
		if ((m_style & DTS_SHOWNONE) ==  DTS_SHOWNONE)
		{
			m_chk_valid.set_enabled(true);
			m_edit_display.set_enabled(m_chk_valid.is_checked());
		}
		else
		{
			m_edit_display.set_enabled(true);
		}
		if ((m_style & DTS_UPDOWN) == DTS_UPDOWN)
		{
			m_ud_time.set_enabled(true);
		}
		else
		{
			m_btn_calendar.set_enabled(true);
		}
	}
	else
	{
		if ((m_style & DTS_SHOWNONE) ==  DTS_SHOWNONE) m_chk_valid.set_enabled(false);
		m_edit_display.set_enabled(false);
		if ((m_style & DTS_UPDOWN) == DTS_UPDOWN)
		{
			m_ud_time.set_enabled(false);
		}
		else
		{
			m_btn_calendar.set_enabled(false);
		}
	}
	Bcl_ctrl::set_enabled(flg);
}

/// ``悵܂
/// @param hdc foCXReLXgnh
/// @param sx ゘W
/// @param sy ゙W
/// @param ex EW
/// @param ey EW
/// @param col F
void Bcl_dtpicker::draw_rectangle(HDC hdc, int sx, int sy, int ex, int ey, COLORREF col)
{
	HPEN pen = CreatePen(PEN_SOLID, 0, col);
	HPEN old_pen = (HPEN)SelectObject(hdc, pen);
	HBRUSH brush = CreateSolidBrush(col);
	HBRUSH old_brush = (HBRUSH)SelectObject(hdc, brush);
	Rectangle(hdc, sx, sy, ex, ey);
	SelectObject(hdc, old_pen);
	SelectObject(hdc, old_brush);
	DeleteObject(pen);
	DeleteObject(brush);
}

/// p``悵܂
/// @param hdc foCXReLXgnh
/// @param pt _̗
/// @param count _̗
/// @param col F
void Bcl_dtpicker::draw_polygon(HDC hdc, CONST POINT *pt, int count, COLORREF col)
{
	HPEN pen = CreatePen(PEN_SOLID, 0, col);
	HPEN old_pen = (HPEN)SelectObject(hdc, pen);
	HBRUSH brush = CreateSolidBrush(col);
	HBRUSH old_brush = (HBRUSH)SelectObject(hdc, brush);
	Polygon(hdc, pt, count);
	SelectObject(hdc, old_pen);
	SelectObject(hdc, old_brush);
	DeleteObject(pen);
	DeleteObject(brush);
}
#else
/// tH[}bgݒ
/// @param format tH[}bg
void Bcl_dtpicker::set_format(const Bcl_str& format)
{
	DateTime_SetFormat(m_handle, format.to_char());
}

/// t擾
/// @return t
Bcl_date Bcl_dtpicker::get_date() const
{
	Bcl_date date;
	SYSTEMTIME st;
	if (DateTime_GetSystemtime(m_handle, &st) == GDT_VALID)
	{
		date = Bcl_date(st.wYear, st.wMonth, st.wDay);
	}
	return date;
}

/// tݒ
/// @param date t
void Bcl_dtpicker::set_date(const Bcl_date& date)
{
	SYSTEMTIME st = {0,0,0,0,0,0,0,0};
	st.wYear = (WORD)date.get_year();
	st.wMonth = (WORD)date.get_month();
	st.wDay = (WORD)date.get_day();
	DateTime_SetSystemtime(m_handle, GDT_VALID, &st);
}

/// IłłÂtݒ肵܂
/// @param date łÂt
void Bcl_dtpicker::set_mindate(const Bcl_date& date)
{
	SYSTEMTIME st[2];
	DWORD gd = DateTime_GetRange(m_handle, st);
	st[0].wYear = (WORD)date.get_year();
	st[0].wMonth = (WORD)date.get_month();
	st[0].wDay = (WORD)date.get_day();
	DateTime_SetRange(m_handle, gd | GDTR_MIN, &st);
}

/// IłłVtݒ肵܂
/// @param date łVt
void Bcl_dtpicker::set_maxdate(const Bcl_date& date)
{
	SYSTEMTIME st[2];
	DWORD gd = DateTime_GetRange(m_handle, st);
	st[1].wYear = (WORD)date.get_year();
	st[1].wMonth = (WORD)date.get_month();
	st[1].wDay = (WORD)date.get_day();
	DateTime_SetRange(m_handle, gd | GDTR_MAX, &st);
}

/// Ԏ擾
/// @return 
Bcl_time Bcl_dtpicker::get_time() const
{
	Bcl_time time;
	SYSTEMTIME st;
	if (DateTime_GetSystemtime(m_handle, &st) == GDT_VALID)
	{
		time = Bcl_time(st.wHour, st.wMinute, st.wSecond, st.wMilliseconds);
	}
	return time;
}

/// Ԑݒ
/// @param time 
void Bcl_dtpicker::set_time(const Bcl_time& time)
{
	SYSTEMTIME st = {0,0,0,0,0,0,0,0};
	Bcl_date date;
	st.wYear = (WORD)date.get_year();
	st.wMonth = (WORD)date.get_month();
	st.wDay = (WORD)date.get_day();
	st.wHour = (WORD)time.get_hour();
	st.wMinute = (WORD)time.get_minute();
	st.wSecond = (WORD)time.get_sec();
	st.wMilliseconds = (WORD)time.get_msec();
	DateTime_SetSystemtime(m_handle, GDT_VALID, &st);
}

/// IłłԂݒ肵܂
/// @param time ł
void Bcl_dtpicker::set_mintime(const Bcl_time& time)
{
	SYSTEMTIME st[2];
	DWORD gd = DateTime_GetRange(m_handle, st);
	Bcl_date date;
	st[0].wYear = (WORD)date.get_year();
	st[0].wMonth = (WORD)date.get_month();
	st[0].wDay = (WORD)date.get_day();
	st[0].wHour = (WORD)time.get_hour();
	st[0].wMinute = (WORD)time.get_minute();
	st[0].wSecond = (WORD)time.get_sec();
	st[0].wMilliseconds = (WORD)time.get_msec();
	DateTime_SetRange(m_handle, gd | GDTR_MIN, &st);
}

/// IłłxԂݒ肵܂
/// @param time łx
void Bcl_dtpicker::set_maxtime(const Bcl_time& time)
{
	SYSTEMTIME st[2];
	DWORD gd = DateTime_GetRange(m_handle, st);
	Bcl_date date;
	st[1].wYear = (WORD)date.get_year();
	st[1].wMonth = (WORD)date.get_month();
	st[1].wDay = (WORD)date.get_day();
	st[1].wHour = (WORD)time.get_hour();
	st[1].wMinute = (WORD)time.get_minute();
	st[1].wSecond = (WORD)time.get_sec();
	st[1].wMilliseconds = (WORD)time.get_msec();
	DateTime_SetRange(m_handle, gd | GDTR_MAX, &st);
}

/// `FbNԐݒ
/// @param chk `FbN
void Bcl_dtpicker::set_check(bool chk)
{
	SYSTEMTIME st;
	DateTime_GetSystemtime(m_handle, &st);
	if (chk)
	{
		DateTime_SetSystemtime(m_handle, GDT_VALID, &st);
	}
	else
	{
		DateTime_SetSystemtime(m_handle, GDT_NONE, &st);
	}
}

/// `FbNԎ擾
/// @return `FbN
bool Bcl_dtpicker::is_checked() const
{
	SYSTEMTIME st;
	return DateTime_GetSystemtime(m_handle, &st) == GDT_VALID;
	
}
#endif
