#include "bcl_filedlg.h"
#include "bcl_wnd.h"
#include "bcl_citr.h"

#define iskanji(c)       ((unsigned char)(c) >= 0x81 && ((unsigned char)(c) <= 0x9F || ((unsigned char)(c) >= 0xE0 && (unsigned char)(c) <= 0xFC)))

/// RXgN^
Bcl_filedlg::Bcl_filedlg(Bcl_wnd* parent) : m_parent(parent), m_index(1), m_mode(MODE_LOAD),
											m_title(""), m_ext(""), m_path(""),
											m_flags(OFN_EXPLORER | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT | OFN_LONGNAMES), m_is_readonly(false)
{
}

/// fXgN^
Bcl_filedlg::~Bcl_filedlg()
{
}

/// t@C_CAO쐬܂
/// @return 
bool Bcl_filedlg::do_modal()
{
	InitCommonControls();
	char fname[MAX_PATH];
	int length = 0;
	Bcl_citr< std::vector< std::pair<Bcl_str, Bcl_str> > > itr(m_filter);
	while (itr.has_next())
	{
		const std::pair<Bcl_str, Bcl_str>& val = itr.next();
		length += val.first.get_length() + 1;
		length += val.second.get_length() + 1;
	}
	length++;
	char *filter = new char[length];
	itr.reset();
	length = 0;
	while (itr.has_next())
	{
		const std::pair<Bcl_str, Bcl_str>& val = itr.next();
		strcpy(&filter[length], val.first.to_char());
		length += val.first.get_length() + 1;
		strcpy(&filter[length], val.second.to_char());
		length += val.second.get_length() + 1;
	}
	filter[length] = 0;
	if (m_path == "")
	{
		*fname = 0;
	}
	else
	{
		strcpy(fname, m_path.to_char());
	}
	OPENFILENAME ofn;				//I[vt@C_CAO\
	ZeroMemory(&ofn, sizeof(ofn));	//[
	ofn.lStructSize		= OPENFILENAME_SIZE_VERSION_400;
	ofn.hwndOwner		= m_parent->get_handle();
	ofn.lpstrFilter		= filter;
	ofn.nFilterIndex	= m_index;
	ofn.lpstrFile		= fname;
	ofn.nMaxFile		= MAX_PATH;
	ofn.lpstrTitle		= m_title.to_char();
	ofn.lpstrInitialDir = m_path.to_char();
	ofn.Flags			= m_flags;
	ofn.lpstrDefExt		= m_ext.to_char();
	ofn.lpfnHook		= dmy_hook;
	bool rtn;
	if (m_mode == MODE_LOAD)
	{
		rtn = GetOpenFileName(&ofn);
	}
	else
	{
		rtn = GetSaveFileName(&ofn);
	}
	if (rtn)
	{
		if ((ofn.Flags & OFN_ALLOWMULTISELECT) == OFN_ALLOWMULTISELECT)
		{
			// t@C
			if ((ofn.Flags & OFN_EXPLORER) == OFN_EXPLORER)
			{
				// GNXv[X^CiOt@Cj
				int i = 0;
				while (fname[i] != '\0')
				{
					i++;
				}
				fname[i] = '\0';
				i++;
				Bcl_str path(fname);
				if (fname[i] == '\0')
				{
					m_fname.push_back(path);
				}
				else
				{
					int offset = i;
					if (path.right(1) != "\\")
					{
						path += "\\";
					}
					while (fname[i] != '\0')
					{
						while (fname[i] != '\0')
						{
							i++;
						}
						fname[i] = '\0';
						m_fname.push_back(path + &fname[offset]);
						i++;
						offset = i;
					}
				}
			}
			else
			{
				// I[hX^CiV[gt@Cj
				int i = 0;
				while (fname[i] != ' ')
				{
					if (fname[i] == '\0')
					{
						m_fname.push_back(get_long_fname(fname));
						break;
					}
					i++;
				}
				if (fname[i] != '\0')
				{
					fname[i] = '\0';
					Bcl_str path(fname);
					if (path.right(1) != "\\")
					{
						path += "\\";
					}
					bool flag = true;
					while (flag)
					{
						i++;
						int offset = i;
						while ((fname[i] != '\0') && (fname[i] != ' '))
						{
							i++;
						}
						if (fname[i] == '\0') flag = false;
						fname[i] = '\0';
						m_fname.push_back(get_long_fname(path + &fname[offset]));
					}
				}
			}
		}
		else
		{
			m_fname.push_back(fname);
		}
		m_index = ofn.nFilterIndex;
		m_is_readonly = ((ofn.Flags & OFN_READONLY) == OFN_READONLY);
	}
	delete[] filter;
	return rtn;
}

/// tB^[ǉ
/// @param name tB^[
/// @param ext tB^[̊gq
void Bcl_filedlg::add_filter(const Bcl_str& name, const Bcl_str& ext)
{
	m_filter.push_back(std::make_pair(name, ext));
}

/// t@C擾܂
/// @return t@C
int Bcl_filedlg::get_filenum() const
{
	return m_fname.size();
}

/// t@C擾
/// @return t@C
Bcl_str Bcl_filedlg::get_fname(int idx) const
{
	return m_fname[idx];
}

/// t@C_CAÕ[hݒ
/// @param mode [h
void Bcl_filedlg::set_mode(FILEDLG_MODE mode)
{
	m_mode = mode;
}

/// tB^[̃CfbNX擾
/// @return tB^[̃CfbNX
DWORD Bcl_filedlg::get_filter_index() const
{
	return m_index;
}

/// tB^[̃CfbNXݒ
/// @param index tB^[̃CfbNX
void Bcl_filedlg::set_filter_index(DWORD index)
{
	m_index = index;
}

/// ^Cgݒ
/// @param title ^Cg
void Bcl_filedlg::set_title(const Bcl_str& title)
{
	m_title = title;
}

/// ftHggqݒ
/// @param ext ftHggq
void Bcl_filedlg::set_default_ext(const Bcl_str& ext)
{
	m_ext = ext;
}

/// pXݒ
/// @param path pX
void Bcl_filedlg::set_ini_path(const Bcl_str& path)
{
	m_path = path;
}

/// u݋֎~v`FbN{bNX\邩ǂݒ肵܂
/// @param flg 
void Bcl_filedlg::show_readonly(bool flg)
{
	if (flg)
	{
		m_flags &= ~OFN_HIDEREADONLY;
	}
	else
	{
		m_flags |= OFN_HIDEREADONLY;
	}
}

/// u݋֎~v`FbN{bNXI邩ǂݒ肵܂
/// @param flg 
void Bcl_filedlg::set_readonly(bool flg)
{
	if (flg)
	{
		m_flags |= OFN_READONLY;
	}
	else
	{
		m_flags &= ~OFN_READONLY;
	}
}

/// t@C쐬邩ǂ̃vvg\邩ǂݒ肵܂
/// @param flg 
void Bcl_filedlg::set_createprompt(bool flg)
{
	if (flg)
	{
		m_flags |= OFN_CREATEPROMPT;
	}
	else
	{
		m_flags &= ~OFN_CREATEPROMPT;
	}
}

/// u݋֎~v`FbN{bNX̏Ԃ擾܂
/// @return u݋֎~v`FbN{bNX̏
bool Bcl_filedlg::is_readonly() const
{
	return m_is_readonly;
}

/// Ił邩ǂݒ肵܂
/// @param flg 
void Bcl_filedlg::set_multiselect(bool flg)
{
	if (flg)
	{
		m_flags |= OFN_ALLOWMULTISELECT;
	}
	else
	{
		m_flags &= ~OFN_ALLOWMULTISELECT;
	}
}

/// _CAOX^Cݒ肵܂
/// @param style X^C
void Bcl_filedlg::set_style(FILEDLG_STYLE style)
{
	m_flags &= ~(OFN_EXPLORER | OFN_NONETWORKBUTTON | OFN_ENABLEHOOK);
	switch (style)
	{
		case STYLE_EXPLORER:
			m_flags |= OFN_EXPLORER;
			break;
		case STYLE_OLDSTYLE:
			m_flags |= OFN_ENABLEHOOK;
			break;
		case STYLE_OLDSTYLE_NONETWORK:
			m_flags |= OFN_NONETWORKBUTTON | OFN_ENABLEHOOK;
			break;
	}
}

/// Ot@Ĉ擾܂
/// @param fname V[gt@C
/// @return Ot@C
Bcl_str Bcl_filedlg::get_long_fname(const Bcl_str& fname)
{
	WIN32_FIND_DATA fdata;
	int length = fname.get_length();
	int start = 3;
	int i = 3;
	Bcl_str long_fname = fname.left(3);
	while (1)
	{
		while ((i < length) && (fname[i] != '\\'))
		{
			i++;
			if (iskanji(fname[i - 1]))
			{
				i++;
			}
		}
		Bcl_str target_fname = long_fname + fname.mid(start, i - start);
		FindFirstFile(target_fname.to_char(), &fdata);
		long_fname += fdata.cFileName;
		if (i >= length) break;
		long_fname += "\\";
		i++;
		start = i;
	}
	return long_fname;
}

/// _~[̃tbNvV[W
/// @param wnd EBhEnh
/// @param msg bZ[W
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
/// @return 
UINT CALLBACK Bcl_filedlg::dmy_hook(HWND wnd, UINT msg, WPARAM wp, LPARAM lp)
{
	return false;
}
