//==============================================================
//
// Bcl_hsplit
//
//==============================================================
#include "bcl_hsplit.h"

bool Bcl_hsplit::m_reg_flag = false;

/// RXgN^
Bcl_hsplit::Bcl_hsplit() : m_right(NULL), m_left(NULL), m_size(300), m_btn_down(false), m_hold(false)
{
	m_class_name = "HSPLITTER";
	m_proc = wnd_proc;
	m_style = WS_CHILD | WS_CLIPCHILDREN;
	set_cursor(IDC_ARROW);
	set_brush((HBRUSH)(COLOR_BTNFACE + 1));
	ON_SIZE(Bcl_hsplit::on_size);
	ON_MOUSEMOVE(Bcl_hsplit::on_mouse_move);
	ON_LBUTTONDOWN(Bcl_hsplit::on_lbutton_down);
	ON_LBUTTONUP(Bcl_hsplit::on_lbutton_up);
	ON_NOTIFY(Bcl_hsplit::on_notify);
}

/// fXgN^
Bcl_hsplit::~Bcl_hsplit()
{
}

/// EBhE
/// @param parent eEBhE
/// @param id Rg[hc
/// @param x W
/// @param y W
/// @param w 
/// @param h 
/// @return 
bool Bcl_hsplit::create(Bcl_wnd* parent, int id, int x, int y, int w, int h)
{
	m_parent = parent;
	if (m_reg_flag == false)
	{
		if (Bcl_wnd::init(m_class_name, parent->get_instance()) == false)
		{
			return false;
		}
		m_reg_flag = true;
	}
	return Bcl_ctrl::create(parent, id, x, y, w, h);
}

/// ẼEBhEݒ肵܂
/// @param left ̃EBhE
/// @param right ẼEBhE
/// @param size ̃EBhE̕
void Bcl_hsplit::set_window(Bcl_wnd* left, Bcl_wnd* right, int size)
{
	m_left = left;
	m_right = right;
	m_size = size;
}

/// WM_SIZẼbZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Bcl_hsplit::on_size(WPARAM wp, LPARAM lp)
{
	int size = get_client_width();
	if (size > 14)
	{
		if (m_size > size - 14)
		{
			if (m_hold == false)
			{
				m_hold = true;
				m_hold_size = m_size;
			}
			m_size = size - 14;
		}
		else if (m_hold == true)
		{
			m_size = size - 14;
			if (m_size > m_hold_size)
			{
				m_size = m_hold_size;
				m_hold = false;
			}
		}
	}
	else
	{
		if (m_hold == false)
		{
			m_hold = true;
			m_hold_size = m_size;
		}
		m_size = 0;
	}
	if (m_left != NULL)
	{
		m_left->move(0, 0, m_size, get_client_height());
	}
	if (m_right != NULL)
	{
		m_right->move(m_size + 4, 0, size - m_size - 4, get_client_height());
	}
}

/// WM_MOUSEMOVẼbZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Bcl_hsplit::on_mouse_move(WPARAM wp, LPARAM lp)
{
	int x = LOWORD(lp);
	int y = HIWORD(lp);
	if (m_btn_down == true)
	{
		int d = x - m_btn.x;
		if ((m_size + d > 10) && (m_size + d < get_client_width() - 14))
		{
			m_size += d;
			m_btn.x = x;
			m_btn.y = y;
			if (m_left != NULL)
			{
				m_left->move(0, 0, m_size, get_client_height());
			}
			if (m_right != NULL)
			{
				m_right->move(m_size + 4, 0, get_client_width() - m_size - 4, get_client_height());
			}
		}
	}
	else
	{
		if ((x < m_size) || (x > m_size + 4))
		{
			SetCursor(LoadCursor(NULL, IDC_ARROW));
		}
		else
		{
			SetCursor(LoadCursor(NULL, IDC_SIZEWE));
		}
	}
}

/// WM_LBUTTONDOWÑbZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Bcl_hsplit::on_lbutton_down(WPARAM wp, LPARAM lp)
{
	int x = LOWORD(lp);
	int y = HIWORD(lp);
	if ((x >= m_size) && (x <= m_size + 4))
	{
		m_btn_down = true;
		m_hold = false;
		m_btn.x = x;
		m_btn.y = y;
		SetCursor(LoadCursor(NULL, IDC_SIZEWE));
		SetCapture(m_handle);
	}
}

/// WM_LBUTTONUP̃bZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Bcl_hsplit::on_lbutton_up(WPARAM wp, LPARAM lp)
{
	if (m_btn_down == true)
	{
		m_btn_down = false;
		ReleaseCapture();
	}
}

/// WM_NOTIFỸbZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Bcl_hsplit::on_notify(WPARAM wp, LPARAM lp)
{
	SendMessage(m_parent->get_handle(), WM_NOTIFY, wp, lp);
}
