//==============================================================
//
// Bcl_imglist
//
//==============================================================
#include "bcl_imglist.h"
#include "bcl_bmp.h"
#include "bcl_wnd.h"

/// RXgN^
Bcl_imglist::Bcl_imglist()
{
	InitCommonControls();				//RRg[̏
}

/// RXgN^
/// @param parent eEBhE
/// @param w 
/// @param h 
/// @param flag C[WXg̃^Cv
/// @param ininum C[W̏l
/// @param addnum gC[W
Bcl_imglist::Bcl_imglist(Bcl_wnd* parent, int w, int h, UINT flag, int ininum, int addnum)
{
	init(parent, w, h, flag, ininum, addnum);
}

/// fXgN^
Bcl_imglist::~Bcl_imglist()
{
}

/// nh擾
/// @return nh
HIMAGELIST Bcl_imglist::get_handle() const
{
	return m_img_handle;
}

/// L`FbN
/// @return L
bool Bcl_imglist::is_valid() const
{
	if (m_img_handle == NULL)
	{
		return false;
	}
	return true;
}

/// 
/// @param parent eEBhE
/// @param w 
/// @param h 
/// @param flag C[WXg̃^Cv
/// @param ininum C[W̏l
/// @param addnum gC[W
void Bcl_imglist::init(Bcl_wnd* parent, int w, int h, UINT flag, int ininum, int addnum)
{
	m_parent = parent;
	m_w = w;
	m_h = h;
	m_img_handle = ImageList_Create(w, h, flag, ininum, addnum);
}

/// C[Wǉi}XNȂj
/// @param img C[W
/// @return 
bool Bcl_imglist::add_img(const Bcl_bmp& img)
{
	return ImageList_Add(m_img_handle, img.get_handle(), NULL);
}

/// C[WǉiC[W̃}XNj
/// @param img C[W
/// @param mask }XN
/// @return 
bool Bcl_imglist::add_img(const Bcl_bmp& img, const Bcl_bmp& mask)
{
	return ImageList_Add(m_img_handle, img.get_handle(), mask.get_handle());
}

/// C[WǉiF̃}XNj
/// @param img C[W
/// @param mask }XN
/// @return 
bool Bcl_imglist::add_img(const Bcl_bmp& img, COLORREF mask)
{
	return ImageList_AddMasked(m_img_handle, img.get_handle(), mask);
}

/// C[W}i}XNȂj
/// @param idx }ʒu
/// @param img C[W
/// @return 
bool Bcl_imglist::insert_img(int idx, const Bcl_bmp& img)
{
	if (!add_img(img)) return false;
	for (int i = get_count() - 1; i > idx; i--)
	{
		ImageList_Copy(m_img_handle, i - 1, m_img_handle, i, ILCF_SWAP);
	}
	return true;
}

/// C[W}iC[W̃}XNj
/// @param idx }ʒu
/// @param img C[W
/// @param mask }XN
/// @return 
bool Bcl_imglist::insert_img(int idx, const Bcl_bmp& img, const Bcl_bmp& mask)
{
	if (!add_img(img, mask)) return false;
	for (int i = get_count() - 1; i > idx; i--)
	{
		ImageList_Copy(m_img_handle, i - 1, m_img_handle, i, ILCF_SWAP);
	}
	return true;
}

/// C[W}iF̃}XNj
/// @param idx }ʒu
/// @param img C[W
/// @param mask }XN
/// @return 
bool Bcl_imglist::insert_img(int idx, const Bcl_bmp& img, COLORREF mask)
{
	if (!add_img(img, mask)) return false;
	for (int i = get_count() - 1; i > idx; i--)
	{
		ImageList_Copy(m_img_handle, i - 1, m_img_handle, i, ILCF_SWAP);
	}
	return true;
}

/// C[W폜
/// @param num C[Wԍ
/// @return 
bool Bcl_imglist::del_img(int num)
{
	return ImageList_Remove(m_img_handle, num);
}

/// C[W擾
/// @return C[W
int Bcl_imglist::get_count() const
{
	return ImageList_GetImageCount(m_img_handle);
}

/// C[W\
/// @param dc foCXReLXg
/// @param x W
/// @param y W
/// @param num C[Wԍ
void Bcl_imglist::show_img(HDC dc, int x, int y, int num) const
{
	ImageList_Draw(m_img_handle, num, dc, x, y, ILD_TRANSPARENT);
}

/// C[WS\
/// @param dc foCXReLXg
/// @param x W
/// @param y W
void Bcl_imglist::show_all(HDC dc, int x, int y) const
{
	for (int i = 0; i < get_count(); i++)
	{
		show_img(dc, x, y, i);
		x += m_w;
	}
}

/// 擾
/// @return 
int Bcl_imglist::get_width() const
{
	return m_w;
}

/// 擾
/// @return 
int Bcl_imglist::get_height() const
{
	return m_h;
}

/// hbOJn܂
/// @param imgx C[ŴW
/// @param imgy C[ŴW
/// @param x W
/// @param y W
/// @param num C[Wԍ
/// @return 
bool Bcl_imglist::start_dragging(int imgx, int imgy, int x, int y, int num)
{
	m_parent->set_capture();
	if (!ImageList_BeginDrag(m_img_handle, num, x - imgx, y - imgy))
	{
		return false;
	}
	RECT rect = m_parent->get_rect();
	POINT pt;
	pt.x = 0;
	pt.y = 0;
	ClientToScreen(m_parent->get_handle(), &pt);
	ImageList_DragEnter(m_parent->get_handle(), x + (pt.x - rect.left), y + (pt.y - rect.top));
	//EBhE`XV
	m_parent->invalidate(true);
	UpdateWindow(m_parent->get_handle());
	return true;

}

/// hbO
/// @param x W
/// @param y W
/// @return 
bool Bcl_imglist::move_dragging(int x, int y)
{
	RECT rect = m_parent->get_rect();
	POINT pt;
	pt.x = 0;
	pt.y = 0;
	ClientToScreen(m_parent->get_handle(), &pt);
	if (!ImageList_DragMove(x + (pt.x - rect.left), y + (pt.y - rect.top)))
	{
		return false;
	}
	return true;
}

/// hbOI
/// @return 
bool Bcl_imglist::stop_dragging()
{
	ImageList_EndDrag();
	ImageList_DragLeave(m_parent->get_handle());
	m_parent->release_capture();
	return true;
}
