#include "bcl_itr.h"
#include "bcl_layout_frame.h"

/// RXgN^
Bcl_layout_frame::Bcl_layout_frame()
{
	m_pt.x = 0x7fffffff;
	m_pt.y = 0x7fffffff;
	m_width = 0;
	m_height = 0;
}

/// fXgN^
Bcl_layout_frame::~Bcl_layout_frame()
{
	Bcl_itr< std::vector<Layout_frame_info> > itr(m_info);
	while (itr.has_next())
	{
		Layout_frame_info& info = itr.next();
		delete info.layout;
	}
}

/// TCYݒ
/// @param x xW
/// @param y yW
/// @param w 
/// @param h 
void Bcl_layout_frame::set_initial_size(int x, int y, int w, int h)
{
	m_pt.x = x;
	m_pt.y = y;
	m_height = h;
	m_width = w;
	Bcl_itr< std::vector<Layout_frame_info> > itr(m_info);
	while (itr.has_next())
	{
		Layout_frame_info& info = itr.next();
		info.layout->set_initial_size(x, y, w, h);
		info.width = info.layout->get_width();
		info.x = info.layout->get_position().x - x;
		info.height = info.layout->get_height();
		info.y = info.layout->get_position().y - y;
	}
}

/// ړ
/// @param mover mover
/// @param x xW
/// @param y yW
/// @param w 
/// @param h 
void Bcl_layout_frame::move(Bcl_mover& mover, int x, int y, int w, int h)
{
	Bcl_itr< std::vector<Layout_frame_info> > itr(m_info);
	while (itr.has_next())
	{
		Layout_frame_info& info = itr.next();
		int width = info.width;
		if (info.is_flex_width) width += w - m_width;
		int height = info.height;
		if (info.is_flex_height) height += h - m_height;
		if (info.layout != NULL) info.layout->move(mover, x + info.x, y + info.y, width, height);
	}
}

/// ʒu擾܂
/// @return ʒu
POINT Bcl_layout_frame::get_position() const
{
	return m_pt;
}

/// 擾܂
/// @return 
int Bcl_layout_frame::get_width() const
{
	return m_width;
}

/// 擾܂
/// @return 
int Bcl_layout_frame::get_height() const
{
	return m_height;
}

/// CAEgǉ
/// @param layout CAEg
/// @param is_flex_width ςɂ邩
/// @param is_flex_height ςɂ邩
void Bcl_layout_frame::add_layout(Bcl_layout* layout, bool is_flex_width, bool is_flex_height)
{
	Layout_frame_info info;
	info.layout = layout;
	info.is_flex_width = is_flex_width;
	info.is_flex_height = is_flex_height;
	m_info.push_back(info);
	POINT pt = layout->get_position();
	if (pt.x < m_pt.x) m_pt.x = pt.x;
	if (pt.y < m_pt.y) m_pt.y = pt.y;
	pt.x += layout->get_width();
	int width = pt.x - m_pt.x;
	if (width > m_width) m_width = width;
	pt.y += layout->get_height();
	int height = pt.y - m_pt.y;
	if (height > m_height) m_height = height;
}
