//==============================================================
//
// Bcl_listbox
//
//==============================================================
#include <windowsx.h>
#include "bcl_listbox.h"
#include "bcl_str.h"

/// RXgN^
Bcl_listbox::Bcl_listbox()
{
	m_class_name	= "LISTBOX";
	m_style			= WS_CHILD | WS_VISIBLE | WS_TABSTOP | WS_VSCROLL | LBS_STANDARD;
	m_window_name	= "";
}

/// fXgN^
Bcl_listbox::~Bcl_listbox()
{
}

/// Xg{bNXRg[̎ނݒ肵܂
/// @param mode 
void Bcl_listbox::set_mode(LB_MODE mode)
{
	switch (mode)
	{
		case LB_MODE_SINGLE:
			m_style = WS_CHILD | WS_VISIBLE | WS_TABSTOP | WS_VSCROLL | LBS_STANDARD;
			break;
		case LB_MODE_MULTI:
			m_style = WS_CHILD | WS_VISIBLE | WS_TABSTOP | WS_VSCROLL | LBS_STANDARD | LBS_MULTIPLESEL;
			break;
	}
	if (m_handle != NULL)
	{
		MessageBox(NULL, "Oɐݒ肵Ă", "Error", MB_ICONEXCLAMATION | MB_OK);
	}
}

/// ACeNA܂
void Bcl_listbox::clear()
{
	ListBox_ResetContent(m_handle);
}

/// ACeǉ܂
/// @param item ACe
void Bcl_listbox::add_item(const Bcl_str& item)
{
	ListBox_AddString(m_handle, item.to_char());
}

/// ACe}܂
/// @param idx }ʒu
/// @param item ACe
void Bcl_listbox::insert_item(int idx, const Bcl_str& item)
{
	ListBox_InsertString(m_handle, idx, item.to_char());
}

/// ACe폜܂
/// @param idx 폜ACeCfbNX
void Bcl_listbox::delete_item(int idx)
{
	ListBox_DeleteString(m_handle, idx);
}

/// IĂCfbNX擾܂
/// @return IĂCfbNX擾܂
int Bcl_listbox::get_cursel() const
{
	return SendMessage(m_handle, LB_GETCURSEL, 0, 0);
}

/// I܂
/// @param idx CfbNX
void Bcl_listbox::set_cursel(int idx)
{
	SendMessage(m_handle, LB_SETCURSEL, idx, 0);
}

/// ACeIĂ邩ǂ𔻒肵܂
/// @param idx CfbNX
/// @return 
bool Bcl_listbox::is_selected(int idx) const
{
	if (SendMessage(m_handle, LB_GETSEL, idx, 0) == 0)
	{
		return false;
	}
	return true;
}

/// ACȇIԂݒ肵܂
/// @param idx CfbNX
/// @param sel I
void Bcl_listbox::set_selected(int idx, bool sel)
{
	SendMessage(m_handle, LB_SETSEL, sel, idx);
}
