//==============================================================
//
// Bcl_listview
//
//==============================================================
#include "bcl_listview.h"

/// RXgN^
Bcl_listview::Bcl_listview() : m_col(0)
{
	InitCommonControls();				//RRg[̏
	m_ex_style		= WS_EX_CLIENTEDGE;
	m_class_name	= "SYSLISTVIEW32";
	m_style			= WS_CHILD | WS_VISIBLE | WS_TABSTOP | LVS_REPORT;
	m_large_list = NULL;
	m_small_list = NULL;
}

/// fXgN^
Bcl_listview::~Bcl_listview()
{
	if (m_large_list == NULL)
	{
		ImageList_Destroy(m_large_list);
	}
	if (m_small_list == NULL)
	{
		ImageList_Destroy(m_small_list);
	}
}

/// EBhE
/// @param parent eEBhE
/// @param id Rg[hc
/// @param x W
/// @param y W
/// @param w 
/// @param h 
/// @return 
bool Bcl_listview::create(Bcl_wnd* parent, int id, int x, int y, int w, int h)
{
	if (!Bcl_ctrl::create(parent, id, x, y, w, h))
	{
		return false;
	}
	//Xgr[1sAObh\ɂ
	ListView_SetExtendedListViewStyle(m_handle,
			ListView_GetExtendedListViewStyle(m_handle) |
			LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES);
	//c[r[ɃC[WRg[Zbg
//	ListView_SetImageList(m_handle, m_large_list, LVSIL_NORMAL);
//	ListView_SetImageList(m_handle, m_small_list, LVSIL_SMALL);
	return true;
	
}

/// ڒǉ
/// @param cx 
/// @param text eLXg
/// @param fmt ̔zuiLVCFMT_LEFT, LVCFMT_RIGHT, LVCFMT_CENTERj
void Bcl_listview::add_column(int cx, const Bcl_str& text, int fmt)
{
	LV_COLUMN col;
	col.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;
	col.fmt = fmt;
	col.cx = cx;
	col.pszText = (char*)text.to_char();
	col.iSubItem = m_col;
	ListView_InsertColumn(m_handle, m_col, &col);
	m_col++;
}

/// ڐݒ
/// @param col ڔԍ
/// @param fmt ̔zuiLVCFMT_LEFT, LVCFMT_RIGHT, LVCFMT_CENTERj
/// @param cx 
/// @param text eLXg
void Bcl_listview::set_column(int col, int fmt, int cx, const Bcl_str& text)
{
	LV_COLUMN column;
	column.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;
	column.fmt = fmt;
	column.cx = cx;
	column.pszText = (char*)text.to_char();
	column.iSubItem = col;
	ListView_SetColumn(m_handle, col, &column);
}

/// ACe}
/// @param row }s
/// @param text eLXg
/// @param image C[W
/// @param lp ACeɓLȒl
void Bcl_listview::insert_item(int row, const Bcl_str& text, int image, int lp)
{
	LV_ITEM item;
	item.mask = LVIF_TEXT;
	if (image != -1) item.mask |= LVIF_IMAGE;
	if (lp != -1) item.mask |= LVIF_PARAM;
	item.pszText = (char*)text.to_char();
	item.iItem = row;
	item.iSubItem = 0;
	item.iImage = image;
	item.lParam = lp;
	ListView_InsertItem(m_handle, &item);
}

/// ACeݒ
/// @param row ACes
/// @param col ڔԍ
/// @param text eLXg
void Bcl_listview::set_item(int row, int col, const Bcl_str& text)
{
	LV_ITEM item;
	item.mask = LVIF_TEXT;
	item.pszText = (char*)text.to_char();
	item.iItem = row;
	item.iSubItem = col;
	ListView_SetItem(m_handle, &item);
}

/// ACẽeLXgύX
/// @param row ACes
/// @param col ڔԍ
/// @param text eLXg
void Bcl_listview::set_item_text(int row, int col, const Bcl_str& text)
{
	ListView_SetItemText(m_handle, row, col, (char*)text.to_char());
}

/// \ݒ
/// @param mode \[hiLVS_SMALLICON, LVS_ICON, LVS_LIST, LVS_REPORTj
void Bcl_listview::display(LV_DISP mode)
{
	long style = GetWindowLong(m_handle, GWL_STYLE);
	style &= ~(LVS_SMALLICON | LVS_ICON | LVS_LIST | LVS_REPORT);
	switch (mode)
	{
		case LV_DISP_SMALL_ICON:
			style |= LVS_SMALLICON;
			break;
		case LV_DISP_LARGE_ICON:
			style |= LVS_ICON;
			break;
		case LV_DISP_LIST:
			style |= LVS_LIST;
			break;
		case LV_DISP_REPORT:
			style |= LVS_REPORT;
			break;
	}
	SetWindowLong(m_handle, GWL_STYLE, style);
	ListView_Arrange(m_handle, LVA_ALIGNLEFT);
}

/// X[ACRp̃C[WXg𐶐܂
/// @param w ACR̕
/// @param h ACR̍
/// @param flag C[WXg̃^Cv
/// @param num C[W̏l
/// @param ext gC[W
void Bcl_listview::create_small_list(int w, int h, UINT flag, int num, int ext)
{
	m_small_list = ImageList_Create(w, h, flag, num, ext);
	ListView_SetImageList(m_handle, m_small_list, LVSIL_SMALL);
}

/// [WACRp̃C[WXg𐶐܂
/// @param w ACR̕
/// @param h ACR̍
/// @param flag C[WXg̃^Cv
/// @param num C[W̏l
/// @param ext gC[W
void Bcl_listview::create_large_list(int w, int h, UINT flag, int num, int ext)
{
	m_large_list = ImageList_Create(w, h, flag, num, ext);
	ListView_SetImageList(m_handle, m_large_list, LVSIL_NORMAL);
}

/// X[ACR̒ǉ
/// @param icon ACR
void Bcl_listview::add_small_icon(LPCTSTR icon)
{
	ImageList_AddIcon(m_small_list, LoadIcon(m_instance, icon));
}

/// [WACR̒ǉ
/// @param icon ACR
void Bcl_listview::add_large_icon(LPCTSTR icon)
{
	ImageList_AddIcon(m_large_list, LoadIcon(m_instance, icon));
}

/// ̃ACe擾܂
/// @param start Jnʒu
/// @param flag 
/// @return ̃ACẽCfbNX
int Bcl_listview::get_next_item(int start, UINT flag) const
{
	return ListView_GetNextItem(m_handle, start, flag);
}

/// ACe̍폜
/// @param item ACẽCfbNX
void Bcl_listview::delete_item(int item)
{
	ListView_DeleteItem(m_handle, item);
	ListView_Arrange(m_handle, LVA_ALIGNLEFT);
}

/// SACe̍폜
void Bcl_listview::delete_all_items()
{
	ListView_DeleteAllItems(m_handle);
}

/// ACeGfBbg\ɂ܂
void Bcl_listview::set_editable()
{
	m_style |= LVS_EDITLABELS;
	if (m_handle != NULL)
	{
		SetWindowLong(m_handle, GWL_STYLE, m_style);
	}
}

/// ACeҏWԂɂ܂
/// @param item ACẽCfbNX
void Bcl_listview::edit_label(int item)
{
	ListView_EditLabel(m_handle, item);
}

/// ACe̕ҏWԂ̏I
/// @param item ACẽCfbNX
void Bcl_listview::edit_label_end(int item)
{
	char buf[1024];
	SendMessage(ListView_GetEditControl(m_handle), WM_GETTEXT, sizeof(buf), (LPARAM)buf);
	ListView_SetItemText(m_handle, item, 0, buf);
}

/// ACe\[g܂
/// @param func r֐
/// @param col ڔԍ
void Bcl_listview::sort_item(PFNLVCOMPARE func, int col)
{
	ListView_SortItems(m_handle, func, col);
}

/// ACeLȒlŌ܂
/// @param start Jnʒu
/// @param lp ACe̓LȒl
/// @return ACẽCfbNX
int Bcl_listview::find_item(int start, LPARAM lp) const
{
	LV_FINDINFO fi;
	fi.flags = LVFI_PARAM;
	fi.lParam = lp;
	return ListView_FindItem(m_handle, start, &fi);
}

/// ACeeLXgŌ܂
/// @param start Jnʒu
/// @param str eLXg
/// @return ACẽCfbNX
int Bcl_listview::find_item(int start, const Bcl_str& str) const
{
	LV_FINDINFO fi;
	fi.flags = LVFI_PARTIAL | LVFI_STRING;
	fi.psz = str.to_char();
	return ListView_FindItem(m_handle, start, &fi);
}

/// ACẽeLXg擾܂
/// @param row ACes
/// @param col ڔԍ
/// @return ACẽeLXg
Bcl_str Bcl_listview::get_item_text(int row, int col) const
{
	char buf[1024];
	LV_ITEM item;
	item.mask = LVIF_TEXT;
	item.iItem = row;
	item.iSubItem = col;
	item.pszText = buf;
	item.cchTextMax = 1024;
	SendMessage(m_handle, LVM_GETITEMTEXT , (WPARAM)row, (LPARAM)&item);
	Bcl_str str(buf);
	return str;
}
/// ACëʒu擾܂
/// @param item ACẽCfbNX
/// @return ʒu
POINT Bcl_listview::get_item_position(int item) const
{
	POINT pt;
	ListView_GetItemPosition(m_handle, item, &pt);
	return pt;
}

/// ʒu擾܂
/// @return ʒu
int Bcl_listview::get_hpos() const
{
	SCROLLINFO si;
	si.cbSize = sizeof(SCROLLINFO);
	si.fMask = SIF_POS;
	GetScrollInfo(m_handle, SB_HORZ, &si);
	return si.nPos;
}

/// ʒu擾܂
/// @return ʒu
int Bcl_listview::get_vpos() const
{
	SCROLLINFO si;
	si.cbSize = sizeof(SCROLLINFO);
	si.fMask = SIF_POS;
	GetScrollInfo(m_handle, SB_VERT, &si);
	return si.nPos;
}

/// ACe擾܂
/// @return ACe
int Bcl_listview::get_item_count() const
{
	return ListView_GetItemCount(m_handle);
}

/// ObhC̕\ݒ肵܂
/// @param flg \
void Bcl_listview::set_gridline(bool flg)
{
	DWORD dwStyle;
	dwStyle = ListView_GetExtendedListViewStyle(m_handle);
	if (flg)
	{
		dwStyle |= LVS_EX_GRIDLINES;
	}
	else
	{
		dwStyle &= ~LVS_EX_GRIDLINES;
	}
	ListView_SetExtendedListViewStyle(m_handle, dwStyle); 
}

/// s̑I@ݒ肵܂
/// @param flg I@
void Bcl_listview::set_fullrowselect(bool flg)
{
	DWORD dwStyle;
	dwStyle = ListView_GetExtendedListViewStyle(m_handle);
	if (flg)
	{
		dwStyle |= LVS_EX_FULLROWSELECT;
	}
	else
	{
		dwStyle &= ~LVS_EX_FULLROWSELECT;
	}
	ListView_SetExtendedListViewStyle(m_handle, dwStyle); 
}

/// PIǂݒ肵܂
/// @param flg 
void Bcl_listview::set_single_select(bool flg)
{
	if (flg)
	{
		m_style |= LVS_SINGLESEL;
	}
	else
	{
		m_style &= ~LVS_SINGLESEL;
	}
	if (m_handle != NULL)
	{
		SetWindowLong(m_handle, GWL_STYLE, m_style);
	}
}

/// 펞Iǂݒ肵܂
/// @param flg 
void Bcl_listview::set_allways_select(bool flg)
{
	if (flg)
	{
		m_style |= LVS_SHOWSELALWAYS;
	}
	else
	{
		m_style &= ~LVS_SHOWSELALWAYS;
	}
	if (m_handle != NULL)
	{
		SetWindowLong(m_handle, GWL_STYLE, m_style);
	}
}

/// c[`bv\邩ǂݒ肵܂
/// @param flg 
void Bcl_listview::set_style_info_tip(bool flg)
{
	DWORD dwStyle;
	dwStyle = ListView_GetExtendedListViewStyle(m_handle);
	if (flg)
	{
		dwStyle |= LVS_EX_INFOTIP;
	}
	else
	{
		dwStyle &= ~LVS_EX_INFOTIP;
	}
	ListView_SetExtendedListViewStyle(m_handle, dwStyle); 
}

/// `FbN{bNX\邩ǂݒ肵܂
/// @param flg \
void Bcl_listview::set_checkbox(bool flg)
{
	DWORD dwStyle;
	dwStyle = ListView_GetExtendedListViewStyle(m_handle);
	if (flg)
	{
		dwStyle |= LVS_EX_CHECKBOXES;
	}
	else
	{
		dwStyle &= ~LVS_EX_CHECKBOXES;
	}
	ListView_SetExtendedListViewStyle(m_handle, dwStyle); 
}

/// IԂɂ܂
/// @param item ACe
void Bcl_listview::set_select(int item)
{
	ListView_SetItemState(m_handle, item, LVIS_FOCUSED | LVIS_SELECTED, LVIS_FOCUSED | LVIS_SELECTED);
}

/// Ԑݒ
/// @param item ACe
/// @param state 
/// @param mask }XN
void Bcl_listview::set_item_state(int item, UINT state, UINT mask)
{
	ListView_SetItemState(m_handle, item, state, mask);
}

/// ACe悤ɃXN[܂
/// @param item ACe
/// @param flag ꕔł΂nj
void Bcl_listview::ensure_visible(int item, bool flag)
{
	ListView_EnsureVisible(m_handle, item, flag);
}

/// ڂ̃TCY擾܂
/// @param col ڔԍ
/// @return TCY
int Bcl_listview::get_column_size(int col) const
{
	HWND header = (HWND)SendMessage(m_handle, LVM_GETHEADER, 0, 0);
	HDITEM info;
	info.mask = HDI_WIDTH;
	SendMessage(header, HDM_GETITEM, (WPARAM)col, (LPARAM)&info);
	return info.cxy;
}

/// `FbNԂ擾܂
/// @param col ڔԍ
/// @return `FbN
bool Bcl_listview::is_checked(int col) const
{
	return ListView_GetCheckState(m_handle, col);
}

/// `FbNԂݒ肵܂
/// @param col ڔԍ
/// @param chk `FbN
void Bcl_listview::set_check(int col, bool chk)
{
	ListView_SetCheckState(m_handle, col, chk);
}

/// w肵ʒũACe擾܂
/// @param pt ʒu
/// @return ACe
LV_HITTESTINFO Bcl_listview::hit_test(const POINT& pt)
{
	LV_HITTESTINFO info;
	info.pt = pt;
	ListView_HitTest(m_handle, &info);
	return info;
}

/// XN[܂
/// @param x ʒu
/// @param y ʒu
void Bcl_listview::scroll(int x, int y)
{
	ListView_Scroll(m_handle, x, y);
}
