//==============================================================
//
// Bcl_mdi
//
//==============================================================
#include "bcl_mdi.h"
#include "bcl_mdichild.h"
#include "bcl_cld_creator.h"
#include "bcl_citr.h"

#define	ID_MDI_CLIENT		4000			//MDIClientID
#define	ID_MDI_FIRSTCHILD	5000			//MDIqEBhE̍ŏID

/// RXgN^
Bcl_mdi::Bcl_mdi() : m_menu(0), m_zoomed(true)
{
	set_style(WS_OVERLAPPEDWINDOW | WS_CLIPCHILDREN);
	set_brush((HBRUSH)(COLOR_3DSHADOW + 1));
	m_proc = mdi_proc;
	m_client = 0;
}

/// fXgN^
Bcl_mdi::~Bcl_mdi()
{
}

/// MDI frame̐
/// @param class_name NX
/// @param instance CX^X
/// @param x W
/// @param y W
/// @param w 
/// @param h 
/// @return 
bool Bcl_mdi::create(LPCTSTR class_name, HINSTANCE instance, int x, int y, int w, int h)
{
	return create(class_name, instance, false, x, y, w, h);
}

/// MDI frame̐
/// @param class_name NX
/// @param instance CX^X
/// @param is_enable_dblclk _uNbN̗L
/// @param x W
/// @param y W
/// @param w 
/// @param h 
/// @return 
bool Bcl_mdi::create(LPCTSTR class_name, HINSTANCE instance, bool is_enable_dblclk, int x, int y, int w, int h)
{
	bool rtn = false;
	if (init(class_name, instance, is_enable_dblclk))
	{
		rtn = Bcl_wnd::create(NULL, x, y, w, h);
	}
	return rtn;
}

/// qEBhE̐
/// @param creator qEBhE𐶐factory
/// @return qEBhE
Bcl_mdichild* Bcl_mdi::create_child(Bcl_cld_creator* creator)
{
	Bcl_mdichild* focus = get_focus();
	if (focus != NULL)
	{
		if (IsZoomed(focus->get_handle())){
			m_zoomed = true;
		}
		else {
			m_zoomed = false;
		}
	}
	Bcl_mdichild* cld = creator->create(this);
	m_cld_list.push_back(cld);
	return cld;
}

/// qEBhE
/// @param cld qEBhE
void Bcl_mdi::close_child(Bcl_mdichild* cld)
{
	if (cld->get_handle() != NULL)
	{
		if (IsZoomed(cld->get_handle())){
			m_zoomed = true;
		}
		else {
			m_zoomed = false;
		}
	}
	std::vector<Bcl_mdichild*>::iterator itr = std::find(m_cld_list.begin(), m_cld_list.end(), cld);
	if (itr != m_cld_list.end())
	{
		m_cld_list.erase(itr);
	}
}

/// tH[JX̂qEBhE擾܂
/// @return qEBhE
Bcl_mdichild* Bcl_mdi::get_focus() const
{
	HWND focus = (HWND)SendMessage(m_client, WM_MDIGETACTIVE, 0, 0);
	Bcl_citr< std::vector<Bcl_mdichild*> > itr(m_cld_list);
	while (itr.has_next())
	{
		Bcl_mdichild* cld = itr.next();
		if (cld->get_handle() == focus)
		{
			return cld;
		}
	}
	return NULL;
}

/// qEBhE擾܂
/// @param handle qEBhẼnh
/// @return qEBhE
Bcl_mdichild* Bcl_mdi::get_child(HWND handle) const
{
	Bcl_citr< std::vector<Bcl_mdichild*> > itr(m_cld_list);
	while (itr.has_next())
	{
		Bcl_mdichild* cld = itr.next();
		if (cld->get_handle() == handle) return cld;
	}
	return NULL;
}

/// ANZ[^ݒ肵܂
/// @param name ANZ[^
/// @return 
bool Bcl_mdi::include_accel(LPCTSTR name)
{
	m_accel = LoadAccelerators(m_instance, name);
	if(!m_accel)
	{
		MessageBox(NULL, "ANZ[^[̓ǍɎs܂","G[", MB_OK);
		return false;
	}
	return true;
}

/// bZ[W[v
/// @return 
UINT Bcl_mdi::loop()
{
	MSG msg;
	HWND client = GetWindow(m_handle, GW_CHILD);
	while(GetMessage(&msg, NULL, 0, 0))
	{
		// [hX_CAÕbZ[W
		Bcl_citr< std::vector<HWND> > itr(m_dlg_handle);
		bool flg = false;
		while (itr.has_next())
		{
			if (IsDialogMessage(itr.next(), &msg))
			{
				flg = true;
				break;
			}
		}
		// qEBhẼ[hX_CAÕbZ[W
		if (!flg)
		{
			Bcl_citr< std::vector<Bcl_mdichild*> > child_itr(m_cld_list);
			while (child_itr.has_next())
			{
				Bcl_citr< std::vector<HWND> > dlg_itr(child_itr.next()->m_dlg_handle);
				while (dlg_itr.has_next())
				{
					if (IsDialogMessage(dlg_itr.next(), &msg))
					{
						flg = true;
						break;
					}
				}
			}
		}
		if ((!flg) && (!TranslateMDISysAccel(client, &msg)) &&
			(!TranslateAccelerator(m_handle, m_accel, &msg)))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}
	return msg.wParam;
}

/// dN`FbNi~[ebNXɒlݒ肵āA݂邩ǂŃ`FbN܂j
/// @param uniq_name dN`FbŃi~[ebNXɐݒ肷lj
/// @return dNĂ邩ǂ
bool Bcl_mdi::is_only_one(char* uniq_name) const
{
	HANDLE hMutex = CreateMutex(NULL, TRUE, uniq_name);
	if (!hMutex) 	return FALSE;
	// GetLastError()AERROR_ALREADY_EXISTSȂA
	// łɃAvP[VNĂ
	if (GetLastError() == ERROR_ALREADY_EXISTS)
	{
    	//dN
    	return false;
	}
	return true;
}

/// EBhEj[̈ʒuݒ肵܂
/// @param menu EBhEj[̈ʒu
void Bcl_mdi::set_window_menu(int menu)
{
	m_menu = menu + 1;
}

/// NCAg擾
/// @return NCAg̃EBhEnh
HWND Bcl_mdi::get_client() const
{
	return m_client;
}

/// O
/// @return 
bool Bcl_mdi::pre_create()
{
	//MDIqEBhȄ\
	CLIENTCREATESTRUCT ccs;
	//MDIqEBhE\郁j[nh
	if (m_menu > 0)
	{
		ccs.hWindowMenu  = GetSubMenu(GetMenu(m_handle), m_menu - 1);
	}
	else
	{
		ccs.hWindowMenu  = NULL;
	}
	//OSݒ肷MDIqEBhE̍ŏ̃nhi͎IɌ܂j
	ccs.idFirstChild = ID_MDI_FIRSTCHILD;
	m_client = CreateWindowEx(WS_EX_CLIENTEDGE, "MDICLIENT", NULL,
					WS_CHILD | WS_CLIPCHILDREN | WS_VSCROLL | WS_HSCROLL,
					0, 0, 0, 0,
					m_handle, (HMENU)ID_MDI_CLIENT, m_instance, (LPVOID)&ccs);
	if (m_client == NULL) {
		MessageBox(0, "MDIClientEBhE쐬ł܂ł", "G[",
					MB_ICONEXCLAMATION | MB_OK | MB_SYSTEMMODAL);
		return false;
	}
	ShowWindow(m_client, SW_SHOW);
	return true;
	
}

/// NCAg̃TCYݒ
/// @param tbar_height c[o[̍
/// @param sbar_height Xe[^Xo[̍
void Bcl_mdi::set_client_size(int tbar_height, int sbar_height)
{
	RECT rect_client;
	//MainFrameEBhẼTCY擾
	GetClientRect(m_handle, &rect_client);
	//MDIClient̃TCY킹
	MoveWindow(m_client, 0, tbar_height, rect_client.right, rect_client.bottom - tbar_height - sbar_height, TRUE);
}

/// qEBhEd˂ĕ\܂
void Bcl_mdi::arrange_cascade()
{
	SendMessage(m_client, WM_MDICASCADE, 0, 0);
}

/// qEBhEɕׂĕ\܂
void Bcl_mdi::arrange_tile_horz()
{
	SendMessage(m_client, WM_MDITILE, MDITILE_HORIZONTAL, 0);
}

/// qEBhEcɕׂĕ\܂
void Bcl_mdi::arrange_tile_vert()
{
	SendMessage(m_client, WM_MDITILE, MDITILE_VERTICAL, 0);
}

/// ACR𐮗񂵂܂
void Bcl_mdi::arrange_icon()
{
	SendMessage(m_client, WM_MDIICONARRANGE, 0, 0);
}

/// MDĨEBhEvV[W
/// @param handle EBhEnh
/// @param msg bZ[W
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
/// @return 
LRESULT CALLBACK Bcl_mdi::mdi_proc(HWND handle, UINT msg, WPARAM wp, LPARAM lp)
{
	bool user_func;
	if (msg == WM_CREATE)
	{
		m_cur_wnd->set_handle(handle);\
		m_cur_wnd->set_instance((HINSTANCE)GetWindowLong(handle, GWL_HINSTANCE));
		((Bcl_mdi*)m_cur_wnd)->pre_create();
		m_cur_wnd->on_create(wp, lp);
		user_func = true;
	}
	else if (msg == WM_CLOSE)
	{
		m_wnd_list[handle]->on_close(wp, lp);
		user_func = true;
	}
	else
	{
		user_func = proc_msg(handle, msg, wp, lp);
	}
	if(msg == WM_COMMAND || msg == WM_MENUCHAR || msg == WM_SETFOCUS)
	{
		user_func = false;
	}
	if (!user_func)
	{
		if (msg == WM_COMMAND)
		{
			HWND hMDIChild = (HWND)SendMessage(((Bcl_mdi*)m_wnd_list[handle])->get_client(), WM_MDIGETACTIVE, 0, 0);
			if (hMDIChild != NULL) SendMessage(hMDIChild, WM_COMMAND, wp, lp);
		}
		if (msg == WM_DESTROY)
		{
			PostQuitMessage(0); 
		}
		else
		{
			HWND client = NULL;
			if (m_wnd_list.find(handle) != m_wnd_list.end())
			{
				client = ((Bcl_mdi*)m_wnd_list[handle])->get_client();
			}
	 		return DefFrameProc(handle, client, msg, wp, lp); 
		}
	}
	LRESULT rtn = 0;
	if (m_wnd_list.find(handle) != m_wnd_list.end())
	{
		rtn = m_wnd_list[handle]->m_proc_rtn;
		m_wnd_list[handle]->m_proc_rtn = 0;
	}
	return rtn;
}

/// t@C̃hbO邩ǂݒ肵܂
/// @param flag t@C̃hbO邩ǂ
void Bcl_mdi::set_drag_accept_files(bool flag)
{
	DragAcceptFiles(m_handle, flag);
}

/// ő剻Ă邩ǂ肵܂
/// @return ő剻Ă邩ǂ
bool Bcl_mdi::is_zoomed() const
{
	return IsZoomed(m_handle);
}
