//==============================================================
//
// Bcl_mdichild
//
//==============================================================
#include "bcl_mdichild.h"
#include "bcl_mdi.h"

bool Bcl_mdichild::m_reg_flag = false;
HWND Bcl_mdichild::m_focus = NULL;

/// RXgN^
/// @param parent eEBhE
Bcl_mdichild::Bcl_mdichild(Bcl_mdi* parent) : m_parent(parent)
{
	set_brush((HBRUSH)(COLOR_3DFACE + 1));
	m_proc = mdi_child_proc;
}

/// fXgN^
Bcl_mdichild::~Bcl_mdichild()
{
	m_parent->close_child(this);
}

/// MDIqEBhE̐
/// @param class_name NX
/// @param title ^Cg
/// @param x W
/// @param y W
/// @param w 
/// @param h 
/// @return 
bool Bcl_mdichild::create(LPCTSTR class_name, LPCTSTR title, int x, int y, int w, int h)
{
	return create(class_name, title, false, x, y, w, h);
}

/// MDIqEBhE̐
/// @param class_name NX
/// @param title ^Cg
/// @param is_enable_dblclk _uNbN̗L
/// @param x W
/// @param y W
/// @param w 
/// @param h 
/// @return 
bool Bcl_mdichild::create(LPCTSTR class_name, LPCTSTR title, bool is_enable_dblclk, int x, int y, int w, int h)
{
	bool rtn = true;
	if (!m_reg_flag)
	{
		rtn = init(class_name, m_parent->get_instance(), is_enable_dblclk);
		if (rtn)
		{
			m_reg_flag = true;
		}
	}
	if (rtn)
	{
		m_cur_wnd = this;
		//EBhE̐
		m_handle = CreateMDIWindow(class_name, title, MDIS_ALLCHILDSTYLES,
									x, y, w, h,
									m_parent->get_client(), m_parent->get_instance(), NULL);
		if(m_handle == NULL)
		{
			MessageBox(0, "EBhE܂ł!", "G[",
					MB_ICONEXCLAMATION | MB_OK | MB_SYSTEMMODAL);
			return false;
		}
		//EBhE̕\
		ShowWindow(m_handle, SW_SHOW);
		if (m_parent->m_zoomed)
		{
			ShowWindow(m_handle, SW_MAXIMIZE);
		}
	}
	return rtn;

}

/// WM_CLOSẼbZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Bcl_mdichild::on_close(WPARAM wp, LPARAM lp)
{
	SendMessage(m_parent->get_client(), WM_MDIDESTROY, (int)m_handle, 0);
}

/// tH[JXEBhẼnh擾
/// @return tH[JXEBhẼnh
HWND Bcl_mdichild::get_focus_handle()
{
	return m_focus;
}

/// MDIqEBhẼEBhEvV[W
/// @param handle EBhEnh
/// @param msg bZ[W
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
/// @return 
LRESULT CALLBACK Bcl_mdichild::mdi_child_proc(HWND handle, UINT msg, WPARAM wp, LPARAM lp)
{
	bool user_func;
	m_focus = handle;
	if (msg == WM_CREATE)
	{
		m_cur_wnd->set_handle(handle);\
		m_cur_wnd->set_instance((HINSTANCE)GetWindowLong(handle, GWL_HINSTANCE));\
		m_wnd_list[handle] = m_cur_wnd;
		m_cur_wnd->on_create(wp, lp);
		user_func = true;
	}
	else if (msg == WM_CLOSE)
	{
		m_wnd_list[handle]->on_close(wp, lp);
		user_func = true;
	}
	else
	{
		user_func = proc_msg(handle, msg, wp, lp);
	}
	if (msg == WM_CHILDACTIVATE || msg == WM_GETMINMAXINFO || msg == WM_MENUCHAR || msg == WM_MOVE || msg == WM_SETFOCUS || msg == WM_SIZE)
	{
		user_func = false;
	}
	if (msg == WM_DESTROY)
	{
		if (m_wnd_list.find(handle) != m_wnd_list.end())
		{
			delete m_wnd_list[handle];
		}
	}
	if (!user_func)
	{
		return (DefMDIChildProc(handle, msg, wp, lp));
	}
	LRESULT rtn = 0;
	if (m_wnd_list.find(handle) != m_wnd_list.end())
	{
		rtn = m_wnd_list[handle]->m_proc_rtn;
		m_wnd_list[handle]->m_proc_rtn = 0;
	}
	return rtn;
}

/// ő剻Ă邩ǂ肵܂
/// @return ő剻Ă邩ǂ
bool Bcl_mdichild::is_zoomed() const
{
	return IsZoomed(m_handle);
}
