//==============================================================
//
// Bcl_menu
//
//==============================================================
#include "bcl_menu.h"
#include "bcl_wnd.h"
#include "bcl_str.h"

/// RXgN^
/// @param parent eEBhE
Bcl_menu::Bcl_menu(Bcl_wnd* parent)
{
	m_wnd = parent->get_handle();
	m_menu = GetMenu(m_wnd);
}

/// RXgN^
/// @param parent eEBhE
/// @param menu j[hc
Bcl_menu::Bcl_menu(Bcl_wnd* parent, const Bcl_str& menu)
{
	m_wnd = parent->get_handle();
	m_menu = LoadMenu(parent->get_instance(), menu.to_char());
}

/// RXgN^
/// @param wnd eEBhẼnh
/// @param menu j[nh
Bcl_menu::Bcl_menu(HWND wnd, HMENU menu) : m_wnd(wnd), m_menu(menu)
{
}

/// fXgN^
Bcl_menu::~Bcl_menu()
{
}

/// Tuj[擾
/// @param pos j[ʒu
/// @return Tuj[
Bcl_menu Bcl_menu::get_sub_menu(int pos)
{
	return Bcl_menu(m_wnd, GetSubMenu(m_menu, pos));
}

/// Lݒiʒuj
/// @param pos j[ʒu
/// @param flg L
void Bcl_menu::set_enabled_by_pos(int pos, bool flg)
{
	EnableMenuItem(m_menu, pos, MF_BYPOSITION | (flg == true ? MF_ENABLED : MF_GRAYED));
}

/// LݒiR}hj
/// @param cmd R}h
/// @param flg L
void Bcl_menu::set_enabled_by_cmd(int cmd, bool flg)
{
	EnableMenuItem(m_menu, cmd, MF_BYCOMMAND | (flg == true ? MF_ENABLED : MF_GRAYED));
}

/// `FbNݒiʒuj
/// @param pos j[ʒu
/// @param chk L
void Bcl_menu::set_checked_by_pos(int pos, bool chk)
{
	CheckMenuItem(m_menu, pos, MF_BYPOSITION | (chk == true ? MF_CHECKED : MF_UNCHECKED));
}

/// `FbNݒiR}hj
/// @param cmd R}h
/// @param chk L
void Bcl_menu::set_checked_by_cmd(int cmd, bool chk)
{
	CheckMenuItem(m_menu, cmd, MF_BYCOMMAND | (chk == true ? MF_CHECKED : MF_UNCHECKED));
}

/// K荀ڐݒiʒuj
/// @param pos j[ʒu
void Bcl_menu::set_default_item_by_pos(int pos)
{
	SetMenuDefaultItem(m_menu, pos, TRUE);
}

/// K荀ڐݒiR}hj
/// @param cmd R}h
void Bcl_menu::set_default_item_by_cmd(int cmd)
{
	SetMenuDefaultItem(m_menu, cmd, FALSE);
}

/// j[`悵܂
void Bcl_menu::draw()
{
	DrawMenuBar(m_wnd);
}

/// |bvAbvj[\܂
void Bcl_menu::show_popup(int x, int y)
{
	TrackPopupMenu(m_menu, TPM_LEFTALIGN, x, y, 0, m_wnd, NULL);
}

/// j[j܂ij[hcŐꍇj
void Bcl_menu::destroy()
{
	DestroyMenu(m_menu);
}

/// Vj[w肳ꂽEBhEɊ蓖Ă܂B
/// @param parent eEBhE
/// @param menu j[hc
void Bcl_menu::set_menu(Bcl_wnd* parent, const Bcl_str& menu)
{
	HWND handle = parent->get_handle();
	HMENU new_menu = LoadMenu(parent->get_instance(), menu.to_char());
	HMENU old_menu = GetMenu(handle);
	SetMenu(handle, new_menu);
	DestroyMenu(old_menu);
}
