//==============================================================
//
// Bcl_picbox
//
//==============================================================
#include "bcl_picbox.h"
#include "bcl_str.h"

/// RXgN^
Bcl_picbox::Bcl_picbox()
{
	m_proc = wnd_proc;
	m_style = WS_CHILD | WS_CLIPCHILDREN;
	set_cursor(IDC_CROSS);
	Bcl_wnd::set_brush((HBRUSH)GetStockObject(WHITE_BRUSH));
	ON_LBUTTONDOWN(Bcl_picbox::on_lbutton_down);
	ON_LBUTTONUP(Bcl_picbox::on_lbutton_up);
	ON_LBUTTONDBLCLK(Bcl_picbox::on_lbutton_dblclick);
	ON_MBUTTONDOWN(Bcl_picbox::on_mbutton_down);
	ON_MBUTTONUP(Bcl_picbox::on_mbutton_up);
	ON_MBUTTONDBLCLK(Bcl_picbox::on_mbutton_dblclick);
	ON_RBUTTONDOWN(Bcl_picbox::on_rbutton_down);
	ON_RBUTTONUP(Bcl_picbox::on_rbutton_up);
	ON_RBUTTONDBLCLK(Bcl_picbox::on_rbutton_dblclick);
	ON_MOUSEMOVE(Bcl_picbox::on_mouse_move);
	ON_PAINT(Bcl_picbox::on_paint);
}

/// fXgN^
Bcl_picbox::~Bcl_picbox()
{
}

/// o^
/// @param instance CX^X
/// @return 
bool Bcl_picbox::set_register(HINSTANCE instance)
{
	if (!Bcl_wnd::init("PICTUREBOX", instance))
	{
		return false;		// leave function
	}
	return true;
}

/// EBhE
/// @param parent eEBhE
/// @param id Rg[hc
/// @param x W
/// @param y W
/// @param w 
/// @param h 
/// @return 
bool Bcl_picbox::create(Bcl_wnd* parent, int id, int x, int y, int w, int h)
{
	if (!Bcl_ctrl::create(parent, id, x, y, w, h))
	{
		return false;
	}
	if (!set_canvas(this))
	{
		return false;		// leave function
	}
	m_wnd_list[Bcl_wnd::m_handle] = this;
	return true;
}

/// Rg[Ɗ֘At
/// @param parent eEBhE
/// @param id Rg[hc
bool Bcl_picbox::assign(Bcl_wnd* parent, int id)
{
	Bcl_ctrl::assign(parent, id);
	if (!set_canvas(this))
	{
		return false;		// leave function
	}
	m_wnd_list[Bcl_wnd::m_handle] = this;
	return true;
}

/// WM_PAINT̃bZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Bcl_picbox::on_paint(WPARAM wp, LPARAM lp)
{
	paint();
}

/// WM_LBUTTONDOWÑbZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Bcl_picbox::on_lbutton_down(WPARAM wp, LPARAM lp)
{
	send_notify(wp, lp, WM_LBUTTONDOWN);
}

/// WM_LBUTTONUP̃bZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Bcl_picbox::on_lbutton_up(WPARAM wp, LPARAM lp)
{
	send_notify(wp, lp, WM_LBUTTONUP);
}

/// WM_LBUTTONDBLCLICK̃bZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Bcl_picbox::on_lbutton_dblclick(WPARAM wp, LPARAM lp)
{
	send_notify(wp, lp, WM_LBUTTONDBLCLK);
}

/// WM_MBUTTONDOWÑbZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Bcl_picbox::on_mbutton_down(WPARAM wp, LPARAM lp)
{
	send_notify(wp, lp, WM_MBUTTONDOWN);
}

/// WM_MBUTTONUP̃bZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Bcl_picbox::on_mbutton_up(WPARAM wp, LPARAM lp)
{
	send_notify(wp, lp, WM_MBUTTONUP);
}

/// WM_MBUTTONDBLCLICK̃bZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Bcl_picbox::on_mbutton_dblclick(WPARAM wp, LPARAM lp)
{
	send_notify(wp, lp, WM_MBUTTONDBLCLK);
}

/// WM_RBUTTONDOWÑbZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Bcl_picbox::on_rbutton_down(WPARAM wp, LPARAM lp)
{
	send_notify(wp, lp, WM_RBUTTONDOWN);
}

/// WM_RBUTTONUP̃bZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Bcl_picbox::on_rbutton_up(WPARAM wp, LPARAM lp)
{
	send_notify(wp, lp, WM_RBUTTONUP);
}

/// WM_RBUTTONDBLCLICK̃bZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Bcl_picbox::on_rbutton_dblclick(WPARAM wp, LPARAM lp)
{
	send_notify(wp, lp, WM_RBUTTONDBLCLK);
}

/// WM_MOUSEMOVẼbZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Bcl_picbox::on_mouse_move(WPARAM wp, LPARAM lp)
{
	send_notify(wp, lp, WM_MOUSEMOVE);
}

/// eEBhEWM_NOTIFYʒm
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
/// @param msg bZ[W
void Bcl_picbox::send_notify(WPARAM wp, LPARAM lp, UINT msg)
{
	Pb_info info;
	info.hdr.hwndFrom = Bcl_wnd::m_handle;
	info.hdr.idFrom = (UINT)wp;	//}EX𑗂
	info.hdr.code = msg;
	info.x = LOWORD(lp);
	info.y = HIWORD(lp);
	SendMessage(Bcl_ctrl::m_parent->get_handle(), WM_NOTIFY, m_id, (LPARAM)&info);
}
