//==============================================================
//
// Bcl_redit
//
//==============================================================
#include "bcl_redit.h"
#include "bcl_str.h"
#include <richedit.h>

#define	INDENT	567		//1Z`twip
#define	NOMORE	-1

/// RXgN^
/// @param parent eEBhE
/// @param func FINDMSGSTRINGbZ[Wnh
Bcl_redit::Bcl_redit(Bcl_wnd* parent, void (Bcl_wnd::*func)(WPARAM, LPARAM)) : m_fr_handle(NULL)
{
	m_lib = LoadLibrary("RICHED32.DLL");
	m_class_name	= "RICHEDIT";
	m_ex_style		= WS_EX_CLIENTEDGE;
	m_style			= WS_CHILD | WS_VSCROLL | ES_AUTOHSCROLL | ES_AUTOVSCROLL | WS_HSCROLL | ES_NOHIDESEL | ES_MULTILINE | ES_WANTRETURN;
	m_window_name	= "";
	m_frMsg = RegisterWindowMessage(FINDMSGSTRING);
	parent->m_msg.push_back(Message(m_frMsg, 0, func));
}

/// fXgN^
Bcl_redit::~Bcl_redit()
{
	if (m_handle != NULL)
	{
		DestroyWindow(m_handle);
	}
	FreeLibrary(m_lib);
}

/// 񂹐ݒ
/// @param mode 񂹃[h
void Bcl_redit::align(ALIGN_MODE mode)
{
	PARAFORMAT pf;
	memset(&pf, 0, sizeof(PARAFORMAT));
	pf.cbSize = sizeof(PARAFORMAT);
	pf.dwMask = PFM_ALIGNMENT;
	switch (mode)
	{
		case ALIGN_RIGHT:
			pf.wAlignment = PFA_RIGHT;
			break;
		case ALIGN_CENTER:
			pf.wAlignment = PFA_CENTER;
			break;
		case ALIGN_LEFT:
			pf.wAlignment = PFA_LEFT;
			break;
		default:
			pf.wAlignment = PFA_LEFT;
			break;
	}
	SendMessage(m_handle, EM_SETPARAFORMAT, 0, (LPARAM)&pf);
	SetFocus(m_handle);
}

/// Cfgݒ
/// @param mode Cfg[h
void Bcl_redit::indent(INDENT_MODE mode)
{
	PARAFORMAT pf;
	memset(&pf, 0, sizeof(PARAFORMAT));
	pf.cbSize = sizeof(PARAFORMAT);
	pf.dwMask = PFM_STARTINDENT | PFM_RIGHTINDENT;
	SendMessage(m_handle, EM_GETPARAFORMAT, 0, (LPARAM)&pf);
	switch (mode)
	{
		case INDENT_UP_LEFT:
			pf.dxStartIndent += INDENT;
			break;
		case INDENT_DOWN_LEFT:
			pf.dxStartIndent -= INDENT;
			if(pf.dxStartIndent < 0)
				pf.dxStartIndent = 0;
			break;
		case INDENT_UP_RIGHT:
			pf.dxRightIndent += INDENT;
			break;
		case INDENT_DOWN_RIGHT:
			pf.dxRightIndent -= INDENT;
			if(pf.dxRightIndent < 0)
				pf.dxRightIndent = 0;
			break;
	}
	SendMessage(m_handle, EM_SETPARAFORMAT, 0, (LPARAM)&pf);
	SetFocus(m_handle);
}

/// t@Cǂݍ
/// @param fname t@C
bool Bcl_redit::load(const Bcl_str& fname)
{
	HANDLE h_file = CreateFile(fname.to_char(), GENERIC_READ, 0, NULL, OPEN_EXISTING,
						FILE_ATTRIBUTE_NORMAL, NULL);
	if (h_file == INVALID_HANDLE_VALUE) {
		MessageBox(m_handle, "t@CJ܂ł", "G[", MB_OK);
		return false;
	}
	EDITSTREAM eds;
	eds.dwCookie = (DWORD)h_file;
	eds.dwError = 0;
	eds.pfnCallback = read_proc;
	if (fname.right(4).to_lower() == ".rtf")
	{
		SendMessage(m_handle, EM_STREAMIN, (WPARAM)SF_RTF, (LPARAM)&eds);
	}
	else
	{
		SendMessage(m_handle, EM_STREAMIN, (WPARAM)SF_TEXT, (LPARAM)&eds);
	}
	SendMessage(m_handle, EM_SETMODIFY, (WPARAM)FALSE, 0);
	CloseHandle(h_file);
	SetFocus(m_handle);
	return true;
}

/// t@Cۑ
/// @param fname t@C
/// @return 
bool Bcl_redit::save(const Bcl_str& fname)
{
	EDITSTREAM eds;

	HANDLE h_file = CreateFile(fname.to_char(), GENERIC_WRITE, 0,
						NULL, CREATE_ALWAYS,
						FILE_ATTRIBUTE_NORMAL | FILE_FLAG_WRITE_THROUGH, NULL);
	eds.dwCookie = (DWORD)h_file;
	eds.dwError = 0;
	eds.pfnCallback = write_proc;
	if (fname.right(4).to_lower() == ".rtf")
	{
		SendMessage(m_handle, EM_STREAMOUT, (WPARAM)SF_RTF, (LPARAM)&eds);
	}
	else
	{
		SendMessage(m_handle, EM_STREAMOUT, (WPARAM)SF_TEXT, (LPARAM)&eds);
	}
	CloseHandle(h_file);
	SendMessage(m_handle, EM_SETMODIFY, (WPARAM)FALSE, 0);
	SetFocus(m_handle);
	return true;
}

/// tHgݒ
/// @param font tHg
void Bcl_redit::set_font(const Bcl_font& font)
{
	CHARFORMAT cfm;
	cfm.cbSize = sizeof(CHARFORMAT);
	cfm.dwMask = CFM_BOLD | CFM_ITALIC | CFM_UNDERLINE | CFM_STRIKEOUT | CFM_CHARSET | CFM_FACE | CFM_SIZE;
	cfm.dwEffects = 0;
	if (font.get_bold() != FW_REGULAR)
	{
		cfm.dwEffects |= CFE_BOLD;
	}
	if (font.is_italic())
	{
		cfm.dwEffects |= CFE_ITALIC;
	}
	if (font.is_underline())
	{
		cfm.dwEffects |= CFE_UNDERLINE;
	}
	if (font.is_strikeout())
	{
		cfm.dwEffects |= CFE_STRIKEOUT;
	}
	cfm.yHeight = font.get_point_size(this) * 20;
	cfm.bCharSet = font.get_charset();
	cfm.bPitchAndFamily = font.get_pitch_and_family();
	strcpy(cfm.szFaceName, font.get_font_name().to_char());
	SendMessage(m_handle, EM_SETCHARFORMAT, (WPARAM)SCF_SELECTION, (LPARAM)&cfm);
	set_focus();
}

/// eLXgFݒ
/// @param col eLXgF
void Bcl_redit::set_textcolor(COLORREF col)
{
	CHARFORMAT cfm;
	cfm.cbSize = sizeof(CHARFORMAT);
	cfm.dwMask = CFM_COLOR;
	cfm.crTextColor = col;
	SendMessage(m_handle, EM_SETCHARFORMAT, (WPARAM)SCF_SELECTION, (LPARAM)&cfm);
	set_focus();
}

/// eLXg
void Bcl_redit::find_text()
{
	if (m_fr_handle != NULL)
	{
		SendMessage(m_fr_handle, WM_CLOSE, 0, 0);
	}
	ZeroMemory(&m_fr, sizeof(FINDREPLACE));
	m_fr.lStructSize = sizeof(FINDREPLACE);
	m_fr.hwndOwner = m_parent->get_handle();
	m_fr.hInstance = NULL;
	m_fr.Flags = FR_DOWN | FR_FINDNEXT;
	m_fr.lpstrFindWhat = m_find_text;
	m_fr.lpstrReplaceWith = m_replace_text;
	m_fr.wFindWhatLen = MAX_PATH;
	m_fr.wReplaceWithLen = MAX_PATH;
	m_fr.lCustData = NULL;
	m_fr.lpfnHook = NULL;
	m_fr.lpTemplateName = NULL;
	m_fr_handle = FindText(&m_fr);
	m_parent->m_dlg_handle.push_back(m_fr_handle);
}

/// eLXgu
void Bcl_redit::replace_text()
{
	if (m_fr_handle != NULL)
	{
		SendMessage(m_fr_handle, WM_CLOSE, 0, 0);
	}
	ZeroMemory(&m_fr, sizeof(FINDREPLACE));
	m_fr.lStructSize = sizeof(FINDREPLACE);
	m_fr.hwndOwner = m_parent->get_handle();
	m_fr.hInstance = NULL;
	m_fr.Flags = FR_DOWN | FR_REPLACE;
	m_fr.lpstrFindWhat = m_find_text;
	m_fr.lpstrReplaceWith = m_replace_text;
	m_fr.wFindWhatLen = MAX_PATH;
	m_fr.wReplaceWithLen = MAX_PATH;
	m_fr.lCustData = NULL;
	m_fr.lpfnHook = NULL;
	m_fr.lpTemplateName = NULL;
	m_fr_handle = ReplaceText(&m_fr);
	m_parent->m_dlg_handle.push_back(m_fr_handle);
}

/// Eu
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Bcl_redit::find_replace(WPARAM wp, LPARAM lp)
{
	static int fcount = 0;	//񐔂̃JE^[
	static int rcount = 0;	//u񐔂̃JE^[
	static int fc, rc;		//\p̃JE^[iL0ɏ̂Łj
	static CHARRANGE org;	//ŏ̃Lbgʒu
	static long Min;		//IWi̊Jnʒuۑi񌟍Ŏgpj
	static FINDTEXT ft;		//FindText\́|o[chrglpstrText

	LPFINDREPLACE fr = (LPFINDREPLACE)lp;

	if(!fcount)
	{
		//񂾂s
		SendMessage(m_handle, EM_EXGETSEL,
						0, (LPARAM)&ft.chrg);	//I͈͂̏擾
		org = ft.chrg;							//ŏ̃Lbgʒuۑ
		if(ft.chrg.cpMin == ft.chrg.cpMax)
		{
			//I
			if(fr->Flags & FR_DOWN)				//Ȃ
				ft.chrg.cpMax = -1;				//LbgŌ܂
			else								//Ȃ
				Min = lstrlen(m_find_text);		//Lbgŏ(cpMin)܂
		}										//ΏۂƂ
		else
			Min = org.cpMin;					//̌xݒ
	}

	//ւ̃|C^[ݒ
	ft.lpstrText = m_find_text;

	if ((fr->Flags & FR_DIALOGTERM) == FR_DIALOGTERM)
	{
		// _CAO
		std::vector<HWND>::iterator itr = std::find(m_parent->m_dlg_handle.begin(), m_parent->m_dlg_handle.end(), m_fr_handle);
		m_parent->m_dlg_handle.erase(itr);
		m_fr_handle = NULL;
		fc = fcount;
		rc = rcount;
		fcount = 0;
		rcount = 0;
		set_focus();
	}
	else if ((fr->Flags & FR_FINDNEXT) == FR_FINDNEXT)
	{
		// 
		if(fr->Flags & FR_DOWN)
		{
			//
			if (was_found(ft, (fr->Flags & FR_MATCHCASE) | (fr->Flags & FR_WHOLEWORD)))
			{
				SendMessage(m_handle, EM_SETSEL, ft.chrg.cpMin, ft.chrg.cpMin + lstrlen(m_find_text));
				SendMessage(m_handle, EM_SCROLLCARET, 0, 0);
				fcount++;
				set_focus();
				//IԂɂAtH[JX𓾂Ăɐi
				ft.chrg.cpMin += lstrlen(m_find_text);
			}
			else
			{
				SendMessage(m_fr_handle, WM_CLOSE, 0, 0);
				MessageBox(m_parent->get_handle(), "ԉ܂Ō܂", "bZ[W", MB_OK | MB_ICONINFORMATION);
			}
		}
		else
		{
			//
			while(ft.chrg.cpMax >= Min)
			{
				//͈͖̌čs
				//ŏ͈̌͐ݒij
				ft.chrg.cpMin = ft.chrg.cpMax - lstrlen(m_find_text);
				if(!was_found(ft, (fr->Flags & FR_MATCHCASE) | (fr->Flags & FR_WHOLEWORD)))
				{
					//
					--ft.chrg.cpMax;				//̘̌ԌJ艺
				}
				else
				{
					//L
					SendMessage(m_handle, EM_SETSEL, ft.chrg.cpMin, ft.chrg.cpMax);
					SendMessage(m_handle, EM_SCROLLCARET, 0, 0);
					fcount++;
					set_focus();						//I\sAJ艺
					ft.chrg.cpMax -= lstrlen(m_find_text);	//̘̌ԌJ艺
					break;
				}
			}
			if(ft.chrg.cpMin < Min)
			{
				//SɌI
				SendMessage(m_fr_handle, WM_CLOSE, 0, 0);
				MessageBox(m_parent->get_handle(), "ԏ܂Ō܂", "bZ[W", MB_OK | MB_ICONINFORMATION);
			}
		}
	}
	else if(fr->Flags & FR_REPLACE)
	{
		//u
		if (fcount)
		{
			SendMessage(m_handle, EM_REPLACESEL, TRUE, (LPARAM)m_replace_text);
			rcount++;
		}
		if (was_found(ft, (fr->Flags & FR_MATCHCASE) | (fr->Flags & FR_WHOLEWORD)))
		{
			SendMessage(m_handle, EM_SETSEL, ft.chrg.cpMin, ft.chrg.cpMin + lstrlen(m_find_text));
			SendMessage(m_handle, EM_SCROLLCARET, 0, 0);
			fcount++;
			SendMessage(m_handle, EM_SETSEL, ft.chrg.cpMin, ft.chrg.cpMin + lstrlen(m_replace_text));
			SendMessage(m_handle, EM_SCROLLCARET, 0, 0);
			set_focus();
			ft.chrg.cpMin += lstrlen(m_replace_text);
		}
		else
		{
			SendMessage(m_fr_handle, WM_CLOSE, 0, 0);
		}
	}
	else if(fr->Flags & FR_REPLACEALL)
	{
		//ׂĒu
		ft.chrg.cpMin = 0;
		ft.chrg.cpMax = -1;
		while (was_found(ft, (fr->Flags & FR_MATCHCASE) | (fr->Flags & FR_WHOLEWORD)))
		{
			rcount++;
			fcount++;		//Ƃ̐i!fcountɂĂj
			SendMessage(m_handle, EM_SETSEL, ft.chrg.cpMin, ft.chrg.cpMin + lstrlen(m_find_text));
			SendMessage(m_handle, EM_SCROLLCARET, 0, 0);
			SendMessage(m_handle, EM_REPLACESEL, TRUE, (LPARAM)m_replace_text);
			ft.chrg.cpMin += lstrlen(m_replace_text);
		}
		SendMessage(m_fr_handle, WM_CLOSE, 0, 0);
		Bcl_str msg;
		msg.format(" %du܂", rc);
		MessageBox(m_parent->get_handle(), msg.to_char(), "bZ[W", MB_OK | MB_ICONINFORMATION);
	}
	set_focus();
}

/// 񂪌
/// @param ft eLXg
/// @param flag tO
/// @return 
bool Bcl_redit::was_found(FINDTEXT& ft, UINT flag)
{
	return ((ft.chrg.cpMin = SendMessage(m_handle, EM_FINDTEXT, flag, (LPARAM)&ft)) != NOMORE);
}

/// ǂݍ݃vV[W
/// @param dwCookie NbL[
/// @param pbBuf obt@
/// @param cb
/// @param pcb
DWORD CALLBACK Bcl_redit::read_proc(DWORD cookie, LPBYTE buf, LONG cb, LONG* pcb)
{
	ReadFile((HANDLE)cookie, buf, cb, (LPDWORD)pcb, NULL);
	return FALSE;
}

/// ݃vV[W
/// @param dwCookie NbL[
/// @param pbBuf obt@
/// @param cb
/// @param pcb
DWORD CALLBACK Bcl_redit::write_proc(DWORD cookie, LPBYTE buf, LONG cb, LONG* pcb)
{
	if (WriteFile((HANDLE)cookie, buf, cb, (LPDWORD)pcb, NULL))
	{
		return FALSE;
	}
	else
	{
		return TRUE;
	}
}
