//==============================================================
//
// Bcl_scroll
//
//==============================================================

#include	"bcl_scroll.h"

/// 
/// @param parent eEBhE
/// @param max ől
/// @param d ړ
/// @param flg XN[o[[h
void Bcl_scroll::init(Bcl_wnd* parent, int max, int d, int flg)
{
	m_parent = parent;
	m_flg = flg;
	m_si.cbSize = sizeof(m_si);
	m_si.nPos = 0;
	m_si.fMask = SIF_RANGE | SIF_POS;
	m_si.nMin = 0;
	m_si.nMax = max - 1;
	m_si.nPage = 0;
	m_d = d;
	SetScrollInfo(m_parent->get_handle(), m_flg, &m_si, TRUE);
}

/// y[WTCYݒ
/// @param page y[WTCY
void Bcl_scroll::set_page(int page)
{
	m_si.fMask = SIF_RANGE | SIF_PAGE | SIF_POS;
	m_si.nPage = page;
	if (m_si.nPos + page - 1 > m_si.nMax){
		if (page > m_si.nMax){
			m_si.nPos = 0;
		}
		else {
			m_si.nPos = m_si.nMax - page + 1;
		}
	}
	if (m_parent != NULL)
	{
		SetScrollInfo(m_parent->get_handle(), m_flg, &m_si, TRUE);
		if (m_flg == SB_CTL){
			if (page <= m_si.nMax){
				m_parent->show();
				return;
			}
			else {
				m_parent->hide();
				return;
			}
		}
	}
	return;
}

/// őlݒ
/// @param max ől
void Bcl_scroll::set_max(int max)
{
	m_si.fMask = SIF_RANGE | SIF_POS;
	m_si.nMin = 0;
	m_si.nMax = max - 1;
	if ((int)(m_si.nPos + m_si.nPage - 1) > m_si.nMax){
		if ((int)m_si.nPage > m_si.nMax){
			m_si.nPos = 0;
		}
		else {
			m_si.nPos = m_si.nMax - m_si.nPage + 1;
		}
	}
	if (m_parent != NULL)
	{
		SetScrollInfo(m_parent->get_handle(), m_flg, &m_si, TRUE);
		if (m_flg == SB_CTL)
		{
			if ((int)m_si.nPage <= m_si.nMax)
			{
				m_parent->show();
				return;
			}
			else
			{
				m_parent->hide();
				return;
			}
		}
	}
}

/// XN[
/// @param mode XN[[h
/// @param pos XN[ʒu
/// @return XN[ʒu
int Bcl_scroll::scroll(short mode, unsigned short pos)
{
	if ((int)m_si.nPage > m_si.nMax)
	{
		return(m_si.nPos);
	}
	m_si.fMask = SIF_POS;
	switch(mode){
		case SB_LINEUP:
		{
			m_si.nPos -= m_d;
			break;
		}
		case SB_LINEDOWN:
		{
			m_si.nPos += m_d;
			break;
		}
		case SB_PAGEUP:
		{
			m_si.nPos -= m_si.nPage;
			break;
		}
		case SB_PAGEDOWN:
		{
			m_si.nPos += m_si.nPage;
			break;
		}
		case SB_THUMBTRACK:
		{
			SCROLLINFO si;
			si.cbSize = sizeof(si);
			si.fMask = SIF_TRACKPOS;
			GetScrollInfo(m_parent->get_handle(), m_flg, &si);
			m_si.nPos = si.nTrackPos;
			break;
		}
	}
	if (m_si.nPos < m_si.nMin){
		m_si.nPos = m_si.nMin;
	}
	if (m_si.nPos > (int)(m_si.nMax - m_si.nPage + 1))
	{
		if ((int)m_si.nPage > m_si.nMax)
		{
			m_si.nPos = 0;
		}
		else
		{
			m_si.nPos = m_si.nMax - m_si.nPage + 1;
		}
	}
	if (m_parent != NULL)
	{
		SetScrollInfo(m_parent->get_handle(), m_flg, &m_si, TRUE);
	}
	return(m_si.nPos);
}

/// XN[ʒuݒ
/// @param pos XN[ʒu
void Bcl_scroll::set_pos(int pos)
{
	m_si.fMask = SIF_POS;
	m_si.nPos = pos;
	if (m_si.nPos < m_si.nMin){
		m_si.nPos = m_si.nMin;
	}
	if (m_si.nPos > (int)(m_si.nMax - m_si.nPage + 1))
	{
		if ((int)m_si.nPage > m_si.nMax)
		{
			m_si.nPos = 0;
		}
		else
		{
			m_si.nPos = m_si.nMax - m_si.nPage + 1;
		}
	}
	SetScrollInfo(m_parent->get_handle(), m_flg, &m_si, TRUE);
}

/// XN[ʒu擾
/// @return XN[ʒu
int Bcl_scroll::get_pos() const
{
	return (m_si.nPos);
}

/// ől擾
/// @return ől
int Bcl_scroll::get_max() const
{
	return (m_si.nMax + 1);
}
