//==============================================================
//
// Bcl_sdi
//
//==============================================================
#include "bcl_sdi.h"
#include "bcl_citr.h"

/// RXgN^
Bcl_sdi::Bcl_sdi()
{
	m_proc = sdi_proc;
}

/// fXgN^
Bcl_sdi::~Bcl_sdi()
{
}

/// SDI̐
/// @param class_name NX
/// @param instance CX^X
/// @param x W
/// @param y W
/// @param w 
/// @param h 
/// @return 
bool Bcl_sdi::create(LPCTSTR class_name, HINSTANCE instance, int x, int y, int w, int h)
{
	return create(class_name, instance, false, x, y, w, h);
}

/// SDI̐
/// @param class_name NX
/// @param instance CX^X
/// @param is_enable_dblclk _uNbN̗L
/// @param x W
/// @param y W
/// @param w 
/// @param h 
/// @return 
bool Bcl_sdi::create(LPCTSTR class_name, HINSTANCE instance, bool is_enable_dblclk, int x, int y, int w, int h)
{
	bool rtn = false;
	if (init(class_name, instance, is_enable_dblclk))
	{
		rtn = Bcl_wnd::create(NULL, x, y, w, h);
	}
	return rtn;
}

/// ANZ[^ݒ肵܂
/// @param name ANZ[^
/// @return 
bool Bcl_sdi::include_accel(LPCTSTR name)
{
	m_accel = LoadAccelerators(m_instance, name);
	if(!m_accel)
	{
		MessageBox(NULL, "ANZ[^[̓ǍɎs܂","G[", MB_OK);
		return false;
	}
	return true;
}

/// bZ[W[v
/// @return 
UINT Bcl_sdi::loop()
{
	MSG msg;
	while (GetMessage(&msg, NULL, 0, 0))
	{
		Bcl_citr< std::vector<HWND> > itr(m_dlg_handle);
		bool flg = false;
		while (itr.has_next())
		{
			if (IsDialogMessage(itr.next(), &msg))
			{
				flg = true;
				break;
			}
		}
		if ((!flg) && (!TranslateAccelerator(m_handle, m_accel, &msg)))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}
	return msg.wParam;
}

/// dN`FbNi~[ebNXɒlݒ肵āA݂邩ǂŃ`FbN܂j
/// @param uniq_name dN`FbŃi~[ebNXɐݒ肷lj
/// @return dNĂ邩ǂ
bool Bcl_sdi::is_only_one(char* uniq_name) const
{
	HANDLE hMutex = CreateMutex(NULL, TRUE, uniq_name);
	if (!hMutex) 	return FALSE;
	// GetLastError()AERROR_ALREADY_EXISTSȂA
	// łɃAvP[VNĂ
	if (GetLastError() == ERROR_ALREADY_EXISTS)
	{
    	//dN
    	return false;
	}
	return true;
}

/// SDĨEBhEvV[W
/// @param handle EBhEnh
/// @param msg bZ[W
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
/// @return 
LRESULT CALLBACK Bcl_sdi::sdi_proc(HWND handle, UINT msg, WPARAM wp, LPARAM lp)
{
	bool user_func;
	if (msg == WM_CREATE)
	{
		m_cur_wnd->set_handle(handle);
		m_cur_wnd->set_instance((HINSTANCE)GetWindowLong(handle, GWL_HINSTANCE));
		m_cur_wnd->on_create(wp, lp);
		user_func = true;
	}
	else if (msg == WM_CLOSE)
	{
		m_wnd_list[handle]->on_close(wp, lp);
		user_func = true;
	}
	else
	{
		user_func = proc_msg(handle, msg, wp, lp);
	}
	if (!user_func)
	{
		if (msg == WM_DESTROY)
			PostQuitMessage(0); 
		else
	 		return (DefWindowProc(handle, msg, wp, lp)); 
	}
	LRESULT rtn = 0;
	if (m_wnd_list.find(handle) != m_wnd_list.end())
	{
		rtn = m_wnd_list[handle]->m_proc_rtn;
		m_wnd_list[handle]->m_proc_rtn = 0;
	}
	return rtn;
}

/// t@C̃hbO邩ǂݒ肵܂
/// @param flag t@C̃hbO邩ǂ
void Bcl_sdi::set_drag_accept_files(bool flag)
{
	DragAcceptFiles(m_handle, flag);
}

/// ő剻Ă邩ǂ肵܂
/// @return ő剻Ă邩ǂ
bool Bcl_sdi::is_zoomed() const
{
	return IsZoomed(m_handle);
}
