//==============================================================
//
// Bcl_str
//
//==============================================================
#include <sstream>
#include <stdio.h>
#include <stdarg.h>
#include <mbstring.h>
#include "bcl_str.h"

/// RXgN^
Bcl_str::Bcl_str() : m_place(0)
{
}

/// RXgN^i񂩂j
/// @param str 
Bcl_str::Bcl_str(const char* str) : m_str(str), m_place(0)
{
}

/// RXgN^ij
/// @param c 
Bcl_str::Bcl_str(char c) : m_place(0)
{
	char str[2];
	str[0] = c;
	str[1] = 0;
	m_str = str;
}

/// RXgN^ilj
/// @param num l
/// @param radix 
Bcl_str::Bcl_str(long num, RADIX radix) : m_place(0)
{
	std::stringstream oss;
	switch (radix)
	{
		case RADIX_BIN:
			if (num == 0)
			{
				m_str = "0";
			}
			else
			{
				ULONG lnum = num;
				while (lnum > 0)
				{
					if ((lnum & 1) == 1)
					{
						m_str = "1" + m_str;
					}
					else
					{
						m_str = "0" + m_str;
					}
					lnum >>= 1;
				}
			}
			return;
		case RADIX_OCT:
			oss << std::oct;
			break;
		case RADIX_DEC:
			oss << std::dec;
			break;
		case RADIX_UDEC:
			oss << std::dec;
			oss << (UINT)num;
			m_str = oss.str();
			return;
		case RADIX_HEX:
			oss << std::hex;
			break;
	}
	oss << num;
	oss << std::dec;
	m_str = oss.str();
}


/// |C^擾
/// @return |C^
char* Bcl_str::to_char()
{
	return (char*)m_str.c_str();
}

/// |C^擾
/// @return |C^
const char* Bcl_str::to_char() const
{
	return m_str.c_str();
}

/// 擾
/// @return 
int Bcl_str::get_length() const
{
	return m_str.length();
}

/// 擾
/// @return 
int Bcl_str::get_wlength() const
{
	return _mbslen((const unsigned char *)m_str.c_str());
}

/// ݒ
/// @param fmt 
void Bcl_str::format(const char* fmt, ...)
{
	va_list arg;
	char moji[512];
	va_start(arg, fmt);
	vsprintf(moji, fmt, arg);
	m_str = moji;
}

/// ݒ
/// @param size obt@TCY
/// @param fmt 
void Bcl_str::format(int size, const char* fmt, ...)
{
	va_list arg;
	char* moji = new char[size];
	va_start(arg, fmt);
	vsprintf(moji, fmt, arg);
	m_str = moji;
	delete[] moji;
}

/// 擾
/// @param start Jnʒu
/// @param num 
/// @return 
Bcl_str Bcl_str::mid(int start, int num) const
{
	Bcl_str str;
	if (num == 0) return str;
	int src_idx = 0;
	int dst_len = 0;
	while(m_str[src_idx] != 0)
	{
		char work[3];
		memset(work, 0, sizeof(work));
		_mbsncpy((unsigned char*)work, (const unsigned char*)&m_str[src_idx], 1);
		int len = strlen(work);
		if (len == 0) break;
		if (src_idx >= start)
		{
			for (int i = dst_len; i < src_idx - start; i ++)
			{
				str += " ";
				dst_len++;
			}
			if (dst_len + len > num) break;
			str += work;
			dst_len += len;
		}
		src_idx += len;
	}
	return str;
}

/// E擾
/// @param num 
/// @return E
Bcl_str Bcl_str::right(int num) const
{
	if (get_length() < num) return Bcl_str(m_str.c_str());
	return mid(get_length() - num, num);
}

/// 擾
/// @param num 
/// @return 
Bcl_str Bcl_str::left(int num) const
{
	return mid(0, num);
}

/// 擾
/// @param start Jnʒu
/// @param num 
/// @return 
Bcl_str Bcl_str::wmid(int start, int num) const
{
	Bcl_str str;
	int src_idx = 0;
	int src_len = 0;
	int dst_len = 0;
	while(m_str[src_idx] != 0)
	{
		char work[3];
		memset(work, 0, sizeof(work));
		_mbsncpy((unsigned char*)work, (const unsigned char*)&m_str[src_idx], 1);
		int len = strlen(work);
		if (src_len >= start)
		{
			if (dst_len + 1 > num) break;
			str += work;
			dst_len++;
		}
		src_idx += len;
		src_len++;
	}
	return str;
}

/// E擾
/// @param num 
/// @return E
Bcl_str Bcl_str::wright(int num) const
{
	if (get_wlength() < num) return Bcl_str(m_str.c_str());
	return wmid(get_wlength() - num, num);
}

/// 擾
/// @param num 
/// @return 
Bcl_str Bcl_str::wleft(int num) const
{
	return wmid(0, num);
}

/// ɕϊ擾
/// @return ɕϊ
Bcl_str Bcl_str::to_lower() const
{
	Bcl_str str(*this);
	std::string::iterator itr = str.m_str.begin();
	std::string::iterator itr_end = str.m_str.end();
	for (; itr != itr_end; ++itr)
	{
		*itr = (std::string::value_type)tolower(*itr);
	}
	return str;
}

/// 啶ɕϊ擾
/// @return 啶ɕϊ
Bcl_str Bcl_str::to_upper() const
{
	Bcl_str str(*this);
	std::string::iterator itr = str.m_str.begin();
	std::string::iterator itr_end = str.m_str.end();
	for (; itr != itr_end; ++itr)
	{
		*itr = (std::string::value_type)toupper(*itr);
	}
	return str;
}

/// 𐔒lɕϊ
/// @param radix 
/// @return l
long Bcl_str::to_number(RADIX radix) const
{
	std::stringstream iss;
	iss << m_str;
	long num = 0;
	switch (radix)
	{
		case RADIX_BIN:
		{
			int len = m_str.length();
			int i = 0;
			while (i < len)
			{
				if ((m_str[i] != '0') && (m_str[i] != '1'))
				{
					break;
				}
				num <<= 1;
				if (m_str[i] == '1')
				{
					num += 1;
				}
				i++;
			}
			return num;
		}
		case RADIX_OCT:
			iss >> std::oct;
			break;
		case RADIX_DEC:
			iss >> std::dec;
			break;
		case RADIX_UDEC:
			iss >> std::dec;
			UINT lnum;
			iss >> lnum;
			return lnum;
		case RADIX_HEX:
			iss >> std::hex;
			break;
	}
	iss >> num;
	iss >> std::dec;
	return num;
}

/// rijZq
/// @param str r
/// @return r
bool Bcl_str::operator==(const Bcl_str& str) const
{
	return (m_str == str.m_str);
}

/// rijZq
/// @param str r
/// @return r
bool Bcl_str::operator==(const char* str) const
{
	return (m_str == str);
}

/// riIjZq
/// @param str r
/// @return r
bool Bcl_str::operator!=(const Bcl_str& str) const
{
	return !(*this == str);
}

/// riIjZq
/// @param str r
/// @return r
bool Bcl_str::operator!=(const char* str) const
{
	return !(*this == str);
}

/// rijZq
/// @param str r
/// @return r
bool Bcl_str::operator>(const Bcl_str& str) const
{
	return (m_str > str.m_str);
}

/// rijZq
/// @param str r
/// @return r
bool Bcl_str::operator>(const char* str) const
{
	return (m_str > str);
}

/// rijZq
/// @param str r
/// @return r
bool Bcl_str::operator<(const Bcl_str& str) const
{
	return (m_str < str.m_str);
}

/// rijZq
/// @param str r
/// @return r
bool Bcl_str::operator<(const char* str) const
{
	return (m_str < str);
}

/// rijZq
/// @param str r
/// @return r
bool Bcl_str::operator>=(const Bcl_str& str) const
{
	return (m_str >= str.m_str);
}

/// rijZq
/// @param str r
/// @return r
bool Bcl_str::operator>=(const char* str) const
{
	return (m_str >= str);
}

/// rijZq
/// @param str r
/// @return r
bool Bcl_str::operator<=(const Bcl_str& str) const
{
	return (m_str <= str.m_str);
}

/// rijZq
/// @param str r
/// @return r
bool Bcl_str::operator<=(const char* str) const
{
	return (m_str <= str);
}

/// Zq
/// @param str 
/// @return gւ̎Q
Bcl_str& Bcl_str::operator=(const Bcl_str& str)
{
	m_str = str.m_str;
	return *this;
}

/// Zq
/// @param str 
/// @return gւ̎Q
Bcl_str& Bcl_str::operator=(const char* str)
{
	m_str = str;
	return *this;
}

/// Zq
/// @param c 
/// @return gւ̎Q
Bcl_str& Bcl_str::operator=(char c)
{
	m_str = Bcl_str(c).m_str;
	return *this;
}

/// ZZq
/// @param str 
/// @return 
Bcl_str Bcl_str::operator+(const Bcl_str& str) const
{
	Bcl_str rtn(*this);
	rtn.m_str += str.m_str;
	return rtn;
}

/// ZZq
/// @param str 
/// @return 
Bcl_str Bcl_str::operator+(const char* str) const
{
	Bcl_str rtn(*this);
	rtn.m_str += str;
	return rtn;
}

/// ZZq
/// @param c 
/// @return 
Bcl_str Bcl_str::operator+(char c) const
{
	Bcl_str rtn(*this);
	rtn.m_str += Bcl_str(c).m_str;
	return rtn;
}

/// ZZq
/// @param str 
/// @return gւ̎Q
Bcl_str& Bcl_str::operator+=(const Bcl_str& str)
{
	m_str += str.m_str;
	return *this;
}

/// ZZq
/// @param str 
/// @return gւ̎Q
Bcl_str& Bcl_str::operator+=(const char* str)
{
	m_str += str;
	return *this;
}

/// ZZq
/// @param c 
/// @return gւ̎Q
Bcl_str& Bcl_str::operator+=(char c)
{
	m_str += Bcl_str(c).m_str;
	return *this;
}

/// []Zq
/// @param idx Y
/// @return 
char Bcl_str::operator[](int idx) const
{
	return m_str[idx];
}

/// []Zq
/// @param idx Y
/// @return ւ̎Q
char& Bcl_str::operator[](int idx)
{
	return m_str[idx];
}

/// ܂
/// @param str 
/// @param start Jnʒu
/// @return ʒu
int Bcl_str::find(const Bcl_str& str, int start) const
{
	int pos = m_str.find(str.m_str, start);
	if ((UINT)pos == std::string::npos)
	{
		return -1;
	}
	pos -= start;
	return pos;
}

/// ̍s邩肵܂
/// @return true:̍s false:̍sȂ
bool Bcl_str::has_next_line()
{
	return m_place < m_str.length();
}

/// ̍s擾܂
/// @return ̍s
Bcl_str Bcl_str::next_line()
{
	int i = 0;
	while (m_place + i < m_str.length())
	{
		if ((m_str[m_place + i] == '\r') || (m_str[m_place + i] == '\n')) break;
		i++;
	}
	Bcl_str str(m_str.substr(m_place, i).c_str());
	if ((m_str[m_place + i] == '\r') &&
		(m_place + i + 1 < m_str.length()) && (m_str[m_place + i + 1] == '\n'))
	{
		m_place += i + 2;
	}
	else
	{
		m_place += i + 1;
	}
	return str;
}

/// ŏ̍sɖ߂
void Bcl_str::reset_line()
{
	m_place = 0;
}

/// o̓Xg[֏o
/// @param os o̓Xg[
/// @param str 
/// @return o̓Xg[
std::ostream& operator<<(std::ostream& os, const Bcl_str& str)
{
	os << str.m_str;
	return os;
}

/// ̓Xg[
/// @param is ̓Xg[
/// @param str 
/// @return ̓Xg[
std::istream& operator>>(std::istream& is, Bcl_str& str)
{
	is >> str.m_str;
	return is;
}

/// ZZq
/// @param str1 
/// @param str2 
/// @return 
Bcl_str operator+(const char* str1, const Bcl_str& str2)
{
	Bcl_str rtn(str1);
	rtn += str2;
	return rtn;
}

/// ZZq
/// @param c 
/// @param str 
/// @return 
Bcl_str operator+(char c, const Bcl_str& str)
{
	Bcl_str rtn(c);
	rtn += str;
	return rtn;
}
