//==============================================================
//
// Bcl_tab
//
//==============================================================
#include "bcl_tab.h"
#include "bcl_str.h"
#include "bcl_citr.h"

std::map<HWND, Bcl_tab*> Bcl_tab::m_tab_list;

/// RXgN^
Bcl_tab::Bcl_tab()
{
	InitCommonControls();				//RRg[̏
	m_class_name	= "SYSTABCONTROL32";
	m_style			= WS_CHILD | WS_CLIPSIBLINGS | WS_VISIBLE | WS_TABSTOP;
}

/// fXgN^
Bcl_tab::~Bcl_tab()
{
	SetWindowLong(m_handle, GWL_WNDPROC, (LONG)m_org_proc);
	m_tab_list.erase(m_handle);
}

/// EBhE
/// @param parent eEBhE
/// @param id Rg[hc
/// @param x W
/// @param y W
/// @param w 
/// @param h 
/// @return 
bool Bcl_tab::create(Bcl_wnd* parent, int id, int x, int y, int w, int h)
{
	if (!Bcl_ctrl::create(parent, id, x, y, w, h))
	{
		return false;
	}
	m_tab_list[m_handle] = this;
	m_org_proc = (WNDPROC)GetWindowLong(m_handle, GWL_WNDPROC);
	SetWindowLong(m_handle, GWL_WNDPROC, (LONG)proc);
	return true;
}

/// Rg[Ɗ֘At
/// @param parent eEBhE
/// @param id Rg[hc
void Bcl_tab::assign(Bcl_wnd* parent, int id)
{
	Bcl_ctrl::assign(parent, id);
	m_tab_list[m_handle] = this;
	m_org_proc = (WNDPROC)GetWindowLong(m_handle, GWL_WNDPROC);
	SetWindowLong(m_handle, GWL_WNDPROC, (LONG)proc);
	set_expand_style(m_ex_style | WS_EX_CONTROLPARENT);
}

/// ^uy[W擾
/// @return ^uy[W
int Bcl_tab::get_tab_count() const
{
	return TabCtrl_GetItemCount(m_handle);
}

/// IĂy[W擾
/// @return IĂy[Wԍ
int Bcl_tab::get_cur_page() const
{
	return TabCtrl_GetCurSel(m_handle);
}

/// y[W؂ւ
/// @param page y[Wԍ
void Bcl_tab::set_cur_page(int page)
{
	TabCtrl_SetCurSel(m_handle, page);
	changed_page();
}

/// ^uy[Wǉ܂
/// @param wnd EBhE
/// @param text ^u
void Bcl_tab::add_page(Bcl_wnd* wnd, const Bcl_str& text)
{
	int num = get_tab_count();
	TC_ITEM tcItem; 
	tcItem.mask = TCIF_TEXT;
	tcItem.pszText = (char*)text.to_char();
	SendMessage(m_handle, TCM_INSERTITEM, (WPARAM)num, (LPARAM)&tcItem);
	TabCtrl_SetCurSel(m_handle, num);
	RECT tab_size;
	GetClientRect(m_handle, (LPRECT)&tab_size);
	TabCtrl_AdjustRect(m_handle, FALSE, &tab_size);
	wnd->move(tab_size.left, tab_size.top, tab_size.right - tab_size.left, tab_size.bottom - tab_size.top);
	m_wnd.push_back(wnd);
	if (m_wnd.size() > 1)
	{
		m_wnd[m_cur_wnd]->hide();
	}
	m_cur_wnd = num;
	m_wnd[m_cur_wnd]->show();
	InvalidateRect(m_handle, NULL, TRUE);
}

/// ^uy[W폜܂
void Bcl_tab::del_page()
{
	int item = get_cur_page();
	if (item < 0)
	{
		return;
	}
	TabCtrl_DeleteItem(m_handle, item);
	int num = get_tab_count();
	m_wnd[m_cur_wnd]->hide();
	std::vector<Bcl_wnd*>::iterator itr = m_wnd.begin();
	std::advance(itr, m_cur_wnd);
	m_wnd.erase(itr);
	if (item >= num)
	{
		item = num - 1;
	}
	if (num > 0)
	{
		m_cur_wnd = item;
		m_wnd[m_cur_wnd]->show();
	}
	TabCtrl_SetCurSel(m_handle, item);
}

/// ړ
/// @param x W
/// @param y W
/// @param w 
/// @param h 
void Bcl_tab::move(int x, int y, int w, int h)
{
	Bcl_wnd::move(x, y, w, h);
	RECT tab_size;
	GetClientRect(m_handle, (LPRECT)&tab_size);
	TabCtrl_AdjustRect(m_handle, FALSE, &tab_size);
	Bcl_citr< std::vector<Bcl_wnd*> > itr(m_wnd);
	while (itr.has_next())
	{
		itr.next()->move(tab_size.left, tab_size.top, tab_size.right - tab_size.left, tab_size.bottom - tab_size.top);
	}
}

/// y[WύXꂽ
void Bcl_tab::changed_page()
{
	m_wnd[m_cur_wnd]->hide();
	m_cur_wnd = get_cur_page();
	m_wnd[m_cur_wnd]->show();
	InvalidateRect(m_handle, NULL, TRUE);
}

/// qEBhE킹`擾܂
/// @return qEBhE킹`
RECT Bcl_tab::get_adjust_rect() const
{
	RECT tab_size;
	GetClientRect(m_handle, (LPRECT)&tab_size);
	TabCtrl_AdjustRect(m_handle, FALSE, &tab_size);
	tab_size.right--;
	tab_size.bottom--;
	return tab_size;
}

/// qEBhE킹`擾܂
/// @param parent_rect eEBhE̋`
/// @return qEBhE킹`
RECT Bcl_tab::get_adjust_rect(RECT parent_rect) const
{
	RECT tab_size = parent_rect;
	tab_size.right++;
	tab_size.bottom++;
	TabCtrl_AdjustRect(m_handle, FALSE, &tab_size);
	tab_size.right--;
	tab_size.bottom--;
	return tab_size;
}

LRESULT CALLBACK Bcl_tab::proc(HWND handle, UINT msg, WPARAM wp, LPARAM lp)
{
	switch (msg)
	{
		case WM_PAINT:
		{
			if (!m_tab_list[handle]->m_wnd.empty()) UpdateWindow(m_tab_list[handle]->m_wnd[m_tab_list[handle]->m_cur_wnd]->get_handle());
			break;
		}
		case WM_NOTIFY:
		{
			m_tab_list[handle]->m_parent->send_msg(WM_NOTIFY, wp, lp);
			return 0;
		}
		default:
			break;
	}
 	return CallWindowProc(m_tab_list[handle]->m_org_proc, handle, msg, wp, lp);
}
