#include "bcl_typedef.h"
#include "bcl_textfile.h"
#include "bcl_citr.h"

#define iskanji(c)       ((unsigned char)(c) >= 0x81 && ((unsigned char)(c) <= 0x9F || ((unsigned char)(c) >= 0xE0 && (unsigned char)(c) <= 0xFC)))

/// RXgN^
Bcl_textfile::Bcl_textfile()
{
	m_fp = NULL;
}

/// fXgN^
Bcl_textfile::~Bcl_textfile()
{
	if (m_fp != NULL)
	{
		fclose(m_fp);
	}
}

/// ݃[hŊJ
/// @param fname t@C
/// @return 
bool Bcl_textfile::open_write(const Bcl_str& fname)
{
	m_fp = fopen(fname.to_char(), "wt");
	if (m_fp == NULL)
	{
		return false;
	}
	return true;
}

/// ǉ[hŊJ܂
/// @param fname t@C
/// @return 
bool Bcl_textfile::open_append(const Bcl_str& fname)
{
	m_fp = fopen(fname.to_char(), "at");
	if (m_fp == NULL)
	{
		return false;
	}
	return true;
}

/// ݂܂
/// @param str 
/// @return 
bool Bcl_textfile::str_write(const Bcl_str& str)
{
	if (m_fp == NULL)
	{
		return false;
	}
	fprintf(m_fp, "%s", str.to_char());
	return true;
}

/// Ps݂̕܂
/// @param str 
/// @return 
bool Bcl_textfile::line_write(const Bcl_str& str)
{
	
	if (!str_write(str))
	{
		return(false);
	}
	fprintf(m_fp, "\n");
	return true;
}

/// CSVt@ĈPs݂܂
/// @param strs CSV̂Ps
/// @return 
bool Bcl_textfile::csv_write(const std::vector<Bcl_str>& strs)
{
	if (m_fp == NULL)
	{
		return false;
	}
	Bcl_citr < std::vector<Bcl_str> > itr(strs);
	while (itr.has_next())
	{
		const Bcl_str& str = itr.next();
		bool chk = false;
		if ((str.find(",") >= 0) || (str.find("\"") >= 0) || (str.find("\n") >= 0))
		{
			chk = true;
		}
		if (chk)
		{
			fputc('"', m_fp);
		}
		int len = str.get_length();
		int i = 0;
		while (i < len)
		{
			if (iskanji(str[i]))
			{
				fputc(str[i], m_fp);
				fputc(str[i + 1], m_fp);
				i += 2;
			}
			else
			{
				if (str[i] == '"')
				{
					fputc(str[i], m_fp);
				}
				fputc(str[i], m_fp);
				i++;
			}
		}
		if (chk)
		{
			fputc('"', m_fp);
		}
		if (itr.has_next())
		{
			fputc(',', m_fp);
		}
	}
	fputc('\n', m_fp);
	return true;
}

/// ǂݍ݃[hŊJ
/// @param fname t@C
/// @return 
bool Bcl_textfile::open_read(const Bcl_str& fname)
{
	m_fp = fopen(fname.to_char(), "rt");
	if (m_fp == NULL)
	{
		return false;
	}
	return true;
}

/// Psǂݍ݂܂
/// @param str 
/// @return 
bool Bcl_textfile::line_read(Bcl_str* str)
{
	if (m_fp == NULL)
	{
		return false;
	}
	*str = "";
	char buf[256];
	char c = 0;
	char* rtn;
	while (1)
	{
		if (c == 0)
		{
			rtn = fgets(buf, 256, m_fp);
		}
		else
		{
			buf[0] = c;
			rtn = fgets(&buf[1], 255, m_fp);
		}
		int len = strlen(buf);
		if ((len > 0) && (buf[len - 1] == '\n'))
		{
			buf[len - 1] = 0;
			*str += buf;
			break;
		}
		else if (!feof(m_fp))
		{
			if ((len > 0) && (iskanji(buf[len - 1])))
			{
				c = buf[len - 1];
				buf[len - 1] = 0;
				*str += buf;
			}
			else
			{
				c = 0;
				*str += buf;
			}
		}
		else
		{
			if (rtn == NULL)
			{
				return false;
			}
			*str += buf;
			break;
		}
	}
	return true;
}

/// CSVt@ĈPsǂݍ݂܂
/// @param strs CSV̂Ps
/// @return 
bool Bcl_textfile::csv_read(std::vector<Bcl_str>* strs)
{
	Bcl_str line;
	if (!line_read(&line))
	{
		return false;
	}
	strs->clear();
	int len = line.get_length();
	int i = 0;
	bool flag = false;
	Bcl_str data;
	while (i < len)
	{
		if ((flag == false) && (data == "") && (line[i] == '"'))
		{
			flag = true;
			i++;
		}
		else if ((flag == false) && (line[i] == ','))
		{
			strs->push_back(data);
			data = "";
			flag = false;
			i++;
		}
		else if ((flag == true) && (line[i] == '"'))
		{
			i++;
			if (line[i] == '"')
			{
				data += line[i];
				i++;
			}
			else
			{
				flag = false;
			}
		}
		else
		{
			data += line[i];
			if (iskanji(line[i]))
			{
				i++;
				data += line[i];
			}
			i++;
		}
	}
	strs->push_back(data);
	return true;
}

/// tbV
bool Bcl_textfile::flush()
{
	if (m_fp == NULL)
	{
		return false;
	}
	fflush(m_fp);
	return true;
}

/// 
void Bcl_textfile::close()
{
	if (m_fp != NULL)
	{
		fclose(m_fp);
	}
	m_fp = NULL;
}
