//==============================================================
//
// Bcl_time
//
//==============================================================
#include	<time.h>
#include	"Bcl_time.h"
#include	"Bcl_str.h"

/// RXgN^
Bcl_time::Bcl_time()
{
	SYSTEMTIME st;
	GetLocalTime(&st);
	set_time(st.wHour, st.wMinute, st.wSecond, st.wMilliseconds);
}

/// RXgN^
/// @param hour 
/// @param minute 
/// @param sec b
/// @param msec ~b
Bcl_time::Bcl_time(int hour, int minute, int sec, int msec)
{
	set_time(hour, minute, sec, msec);
}

/// ݒ
/// @param hour 
/// @param minute 
/// @param sec b
/// @param msec ~b
void Bcl_time::set_time(int hour, int minute, int sec, int msec)
{
	m_time = hour * 3600000;
	m_time += minute * 60000;
	m_time += sec * 1000;
	m_time += msec;
}

/// fXgN^
Bcl_time::~Bcl_time()
{
}

/// ԕ擾
/// @return ԕ
Bcl_str Bcl_time::get_string() const
{
	int hour;
	int minute;
	int sec;
	int msec;
	get_time(hour, minute, sec, msec);
	Bcl_str rtn;
	rtn = Bcl_str(hour, RADIX_DEC) + ":";
	if (minute < 10) rtn += "0";
	rtn += Bcl_str(minute, RADIX_DEC) + ":";
	if (sec < 10) rtn += "0";
	rtn += Bcl_str(sec, RADIX_DEC) + ".";
	if (msec < 100) rtn += "0";
	if (msec < 10) rtn += "0";
	rtn += Bcl_str(msec, RADIX_DEC);
	return rtn;
}

/// Ԏ擾
/// @return 
int Bcl_time::get_hour() const
{
	int hour;
	int minute;
	int sec;
	int msec;
	get_time(hour, minute, sec, msec);
	return hour;
}

/// 擾
/// @return 
int Bcl_time::get_minute() const
{
	int hour;
	int minute;
	int sec;
	int msec;
	get_time(hour, minute, sec, msec);
	return minute;
}

/// b擾
/// @return b
int Bcl_time::get_sec() const
{
	int hour;
	int minute;
	int sec;
	int msec;
	get_time(hour, minute, sec, msec);
	return sec;
}

/// ~b擾
/// @return ~b
int Bcl_time::get_msec() const
{
	int hour;
	int minute;
	int sec;
	int msec;
	get_time(hour, minute, sec, msec);
	return msec;
}

/// S~b擾
/// @return S~b
unsigned long Bcl_time::get_total_msec() const
{
	return m_time;
}

/// Ԏ擾
/// @param hour 
/// @param minute 
/// @param sec b
/// @param msec ~b
void Bcl_time::get_time(int& hour, int& minute, int& sec, int& msec) const
{
	unsigned long time = m_time;
	msec = time % 1000;
	time /= 1000;
	sec = time % 60;
	time /= 60;
	minute = time % 60;
	hour = time / 60;
}

/// rij֐
/// @param rhs rΏ
/// @return 
bool Bcl_time::operator<(const Bcl_time& rhs) const
{
	if (m_time < rhs.m_time)
	{
		return true;
	}
	return false;
}

/// rij֐
/// @param rhs rΏ
/// @return 
bool Bcl_time::operator<=(const Bcl_time& rhs) const
{
	if (m_time <= rhs.m_time)
	{
		return true;
	}
	return false;
}

/// rij֐
/// @param rhs rΏ
/// @return 
bool Bcl_time::operator>(const Bcl_time& rhs) const
{
	if (m_time > rhs.m_time)
	{
		return true;
	}
	return false;
}

/// rij֐
/// @param rhs rΏ
/// @return 
bool Bcl_time::operator>=(const Bcl_time& rhs) const
{
	if (m_time >= rhs.m_time)
	{
		return true;
	}
	return false;
}

/// rij֐
/// @param rhs rΏ
/// @return 
bool Bcl_time::operator==(const Bcl_time& rhs) const
{
	if (m_time == rhs.m_time)
	{
		return true;
	}
	return false;
}

/// riIj֐
/// @param rhs rΏ
/// @return 
bool Bcl_time::operator!=(const Bcl_time& rhs) const
{
	if (m_time != rhs.m_time)
	{
		return true;
	}
	return false;
}

/// CNg
/// @return gւ̎Q
Bcl_time& Bcl_time::operator++()
{
	m_time++;
	return *this;
}

/// fNg
/// @return gւ̎Q
Bcl_time& Bcl_time::operator--()
{
	m_time--;
	return *this;
}

/// ZZq
/// @param x Zl
/// @return 
Bcl_time Bcl_time::operator+(int x) const
{
	Bcl_time z;
	z.m_time = m_time + x;
	return z;
}

/// ZZq
/// @param x Zl
/// @return gւ̎Q
Bcl_time& Bcl_time::operator+=(int x)
{
	m_time += x;
	return *this;
}

/// ZZq
/// @param x Zl
/// @return 
Bcl_time Bcl_time::operator-(int x) const
{
	Bcl_time z;
	z.m_time = m_time - x;
	return z;
}

/// ZZq
/// @param x Zl
/// @return gւ̎Q
Bcl_time& Bcl_time::operator-=(int x)
{
	m_time -= x;
	return *this;
}

/// vZ
/// @param x Ώۓ
/// @return 
long Bcl_time::operator-(const Bcl_time& x) const
{
	return m_time - x.m_time;
}
