//==============================================================
//
// Bcl_toolbar
//
//==============================================================
#include "bcl_toolbar.h"

/// RXgN^
Bcl_toolbar::Bcl_toolbar()
{
	m_class_name = TOOLBARCLASSNAME;	//c[o[NX̖
	InitCommonControls();				//RRg[̏
	m_style = WS_CHILD | WS_VISIBLE  | TBSTYLE_TOOLTIPS;
	m_ex_style = 0;
}

/// fXgN^
Bcl_toolbar::~Bcl_toolbar()
{
}

/// EBhE쐬֐
/// @param parent eEBhE
/// @param id Rg[ID
/// @return 
bool Bcl_toolbar::create(Bcl_wnd* parent, int id)
{
	if (!Bcl_ctrl::create(parent, id, 0, 0, 0, 0))
	{
		return false;
	}
	TBADDBITMAP tbab;
	//TB_BUTTONSTRUCT\̂̃TCY(bytes)
	SendMessage(m_handle, TB_BUTTONSTRUCTSIZE, (WPARAM)sizeof(TBBUTTON), 0);
	//RRg[W[̃CX^X
	tbab.hInst = HINST_COMMCTRL;
	tbab.nID = IDB_STD_SMALL_COLOR;
	m_std_id = SendMessage(m_handle, TB_ADDBITMAP, 0, (LPARAM)&tbab);
	tbab.nID = IDB_VIEW_SMALL_COLOR;
	m_view_id = SendMessage(m_handle, TB_ADDBITMAP, 0, (LPARAM)&tbab);
	return true;
}

/// c[o[Ɗ֘AÂ
/// @param parent eEBhE
/// @param id Rg[ID
void Bcl_toolbar::assign(Bcl_wnd* parent, int id)
{
	Bcl_ctrl::assign(parent, id);
	TBADDBITMAP tbab;
	//TB_BUTTONSTRUCT\̂̃TCY(bytes)
	SendMessage(m_handle, TB_BUTTONSTRUCTSIZE, (WPARAM)sizeof(TBBUTTON), 0);
	//RRg[W[̃CX^X
	tbab.hInst = HINST_COMMCTRL;
	tbab.nID = IDB_STD_SMALL_COLOR;
	m_std_id = SendMessage(m_handle, TB_ADDBITMAP, 0, (LPARAM)&tbab);
	tbab.nID = IDB_VIEW_SMALL_COLOR;
	m_view_id = SendMessage(m_handle, TB_ADDBITMAP, 0, (LPARAM)&tbab);
	m_parent = parent;
}

/// c[o[ɕ\BITMAPǂݍ
/// @param name rbg}bv
/// @param n rbg}bv
void Bcl_toolbar::add_bmp(LPCTSTR name, int n)
{
	TBADDBITMAP tbab;
	//TB_BUTTONSTRUCT\̂̃TCY(bytes)
	SendMessage(m_handle, TB_BUTTONSTRUCTSIZE, (WPARAM)sizeof(TBBUTTON), 0);
	tbab.hInst = NULL;
	tbab.nID =(int) LoadImage(m_parent->get_instance(), name, IMAGE_BITMAP,
								0, 0, LR_LOADMAP3DCOLORS | LR_LOADTRANSPARENT);
	m_img_id = SendMessage(m_handle, TB_ADDBITMAP, n, (LPARAM)&tbab);
}

/// c[o[STDn̊̃{^ǉ܂
/// @param id {^C[W̔ԍ(STD_***)
/// @param cmd WM_COMMAND̎ID
/// @param state {^̏ԁ@gp\Ȃ
/// @param style {^X^C
/// @param tooltip c[`bv\XgOe[uID
void Bcl_toolbar::add_std_button(int id, int cmd, BYTE state, BYTE style, int tooltip)
{
 	TBBUTTON tbb;
 	memset(&tbb, 0, sizeof(tbb));
	tbb.iBitmap = m_std_id + id;
	tbb.fsState = state;
	tbb.fsStyle = style;
	tbb.idCommand = cmd;
	m_tbb.push_back(tbb);
	if (tooltip > 0)
	{
		m_tooltip_int[cmd] = tooltip;
	}
}

/// c[o[STDn̊̃{^ǉ܂
/// @param id {^C[W̔ԍ(STD_***)
/// @param cmd WM_COMMAND̎ID
/// @param state {^̏ԁ@gp\Ȃ
/// @param style {^X^C
/// @param tooltip c[`bvŕ\镶
void Bcl_toolbar::add_std_button(int id, int cmd, BYTE state, BYTE style, const Bcl_str& tooltip)
{
 	TBBUTTON tbb;
 	memset(&tbb, 0, sizeof(tbb));
	tbb.iBitmap = m_std_id + id;
	tbb.fsState = state;
	tbb.fsStyle = style;
	tbb.idCommand = cmd;
	m_tbb.push_back(tbb);
	m_tooltip_str[cmd] = tooltip;
}

/// c[o[VIEWn̊̃{^ǉ܂
/// @param id {^C[W̔ԍ(VIEW_***)
/// @param cmd WM_COMMAND̎ID
/// @param state {^̏ԁ@gp\Ȃ
/// @param style {^X^C
/// @param tooltip c[`bv\XgOe[uID
void Bcl_toolbar::add_view_button(int id, int cmd, BYTE state, BYTE style, int tooltip)
{
 	TBBUTTON tbb;
 	memset(&tbb, 0, sizeof(tbb));
	tbb.iBitmap = m_view_id + id;
	tbb.fsState = state;
	tbb.fsStyle = style;
	tbb.idCommand = cmd;
	m_tbb.push_back(tbb);
	if (tooltip > 0)
	{
		m_tooltip_int[cmd] = tooltip;
	}
}

/// c[o[VIEWn̊̃{^ǉ܂
/// @param id {^C[W̔ԍ(VIEW_***)
/// @param cmd WM_COMMAND̎ID
/// @param state {^̏ԁ@gp\Ȃ
/// @param style {^X^C
/// @param tooltip c[`bvŕ\镶
void Bcl_toolbar::add_view_button(int id, int cmd, BYTE state, BYTE style, const Bcl_str& tooltip)
{
 	TBBUTTON tbb;
 	memset(&tbb, 0, sizeof(tbb));
	tbb.iBitmap = m_view_id + id;
	tbb.fsState = state;
	tbb.fsStyle = style;
	tbb.idCommand = cmd;
	m_tbb.push_back(tbb);
	m_tooltip_str[cmd] = tooltip;
}

/// c[o[Ɏ̃{^ǉ܂
/// @param cmd WM_COMMAND̎ID
/// @param state {^̏ԁ@gp\Ȃ
/// @param style {^X^C
/// @param tooltip c[`bv\XgOe[uID
void Bcl_toolbar::add_user_button(int cmd, BYTE state, BYTE style, int tooltip)
{
 	TBBUTTON tbb;
 	memset(&tbb, 0, sizeof(tbb));
	tbb.iBitmap = m_img_id;
	tbb.fsState = state;
	tbb.fsStyle = style;
	tbb.idCommand = cmd;
	m_tbb.push_back(tbb);
	if (tooltip > 0)
	{
		m_tooltip_int[cmd] = tooltip;
	}
	m_img_id++;
}

/// c[o[Ɏ̃{^ǉ܂
/// @param cmd WM_COMMAND̎ID
/// @param state {^̏ԁ@gp\Ȃ
/// @param style {^X^C
/// @param tooltip c[`bvŕ\镶
void Bcl_toolbar::add_user_button(int cmd, BYTE state, BYTE style, const Bcl_str& tooltip)
{
 	TBBUTTON tbb;
 	memset(&tbb, 0, sizeof(tbb));
	tbb.iBitmap = m_img_id;
	tbb.fsState = state;
	tbb.fsStyle = style;
	tbb.idCommand = cmd;
	m_tbb.push_back(tbb);
	m_tooltip_str[cmd] = tooltip;
	m_img_id++;
}

/// c[o[ɃZp[^ǉ܂
void Bcl_toolbar::add_separetor()
{
	TBBUTTON tbb;
 	memset(&tbb, 0, sizeof(tbb));
	tbb.fsStyle = TBSTYLE_SEP;
	tbb.iBitmap = 0;
	tbb.fsState = 0;
	tbb.idCommand = 0;
	m_tbb.push_back(tbb);
}

/// c[o[\܂
void Bcl_toolbar::show()
{
	SendMessage(m_handle, TB_ADDBUTTONS, m_tbb.size(), (LPARAM)&m_tbb[0]);
}

/// c[o[̃TCY𒲐܂
void Bcl_toolbar::auto_size()
{
	SendMessage(m_handle, WM_SIZE, 0, 0);
}

/// c[o[̃`FbNԂݒ肵܂
/// @param cmd WM_COMMAND̎ID
/// @param chk `FbN
void Bcl_toolbar::set_checked(int cmd, bool chk)
{
	SendMessage(m_handle, TB_CHECKBUTTON, cmd, (LPARAM)(MAKELONG(chk, 0)));
}

/// c[o[̎gp\Ԃݒ肵܂
/// @param cmd WM_COMMAND̎ID
/// @param flg gp\
void Bcl_toolbar::set_enabled(int cmd, bool flg)
{
	SendMessage(m_handle, TB_ENABLEBUTTON, cmd, (LPARAM)MAKELONG(flg, 0));
}

/// c[o[̕\Ԃݒ肵܂
/// @param cmd WM_COMMAND̎ID
/// @param flg \
void Bcl_toolbar::set_visible(int cmd, bool flg)
{
	SendMessage(m_handle, TB_HIDEBUTTON, cmd, !flg);
}

/// c[`bv\܂
/// @param lptip TOOLTIPTEXT\́iWM_NOTIFYLPARAMj
void Bcl_toolbar::show_tooltip(LPTOOLTIPTEXT lptip)
{
	if (lptip->hdr.code == TTN_NEEDTEXT)
	{
		lptip->hinst = m_instance;
		if (m_tooltip_str.find(lptip->hdr.idFrom) != m_tooltip_str.end())
		{
			lptip->lpszText = (char *)m_tooltip_str[lptip->hdr.idFrom].to_char();
		}
		else if (m_tooltip_int.find(lptip->hdr.idFrom) != m_tooltip_int.end())
		{
			lptip->lpszText = MAKEINTRESOURCE(m_tooltip_int[lptip->hdr.idFrom]);
		}
	}
}
