//==============================================================
//
// Bcl_treeview
//
//==============================================================
#include "bcl_treeview.h"

#define MAX_BUF_SIZE 1024

/// RXgN^
Bcl_treeview::Bcl_treeview()
{
	InitCommonControls();				//RRg[̏
	m_ex_style		= WS_EX_CLIENTEDGE;
	m_class_name	= "SYSTREEVIEW32";
	m_style			= WS_CHILD | WS_VISIBLE | TVS_HASLINES | TVS_LINESATROOT | TVS_HASBUTTONS | TVS_SHOWSELALWAYS;
}

/// fXgN^
Bcl_treeview::~Bcl_treeview()
{
}

/// ACe}܂
/// @param title ^Cg
/// @param parent eACe
/// @param after }̈ʒuiTVI_FIRST, TVI_LAST, TVI_SORTj
/// @param img C[W
/// @param sel_img IƂ̃C[W
/// @param lp ACeɓLȒl
/// @return }ACẽnh
HTREEITEM Bcl_treeview::insert_item(const Bcl_str& title, HTREEITEM parent, HTREEITEM after, int img, int sel_img, int lp)
{
	TV_INSERTSTRUCT item;
	item.hParent = parent;
	item.hInsertAfter = after;
	item.item.mask = TVIF_TEXT;
	if (img != -1) item.item.mask |= TVIF_IMAGE;
	if (sel_img != -1) item.item.mask |= TVIF_SELECTEDIMAGE;
	if (lp != -1) item.item.mask |= TVIF_PARAM;
	item.item.pszText = (char*)title.to_char();
	item.item.iImage = img;
	item.item.iSelectedImage = sel_img;
	item.item.lParam = lp;
	HTREEITEM hitem = TreeView_InsertItem(m_handle, &item);
	InvalidateRect(m_handle, NULL, TRUE);
	return hitem;
}

/// ACRXg𐶐܂
/// @param w ACR̕
/// @param h ACR̍
/// @param flag C[WXg̃^Cv
/// @param num C[W̏l
/// @param ext gC[W
void Bcl_treeview::create_icon_list(int w, int h, UINT flag, int num, int ext)
{
	m_h_img_list = ImageList_Create(w, h, flag, num, ext);
	TreeView_SetImageList(m_handle, m_h_img_list, TVSIL_NORMAL);
}

/// ACRǉ܂
/// @param icon ACR
/// @param mask }XNF
void Bcl_treeview::add_icon(LPCTSTR icon, COLORREF mask)
{
	HBITMAP hBmp = LoadBitmap(m_instance, icon);
	ImageList_AddMasked(m_h_img_list, hBmp, mask);
	DeleteObject(hBmp);
}

/// ACRǉ܂ihcj
/// @param icon ACR
/// @param mask }XNF
void Bcl_treeview::add_icon(int icon, COLORREF mask)
{
	add_icon(MAKEINTRESOURCE(icon), mask);
}

/// IĂACe擾܂
/// @return IĂACẽnh
HTREEITEM Bcl_treeview::get_selection() const
{
	return TreeView_GetSelection(m_handle);
}

/// ACe폜܂
/// @param hitem ACẽnh
void Bcl_treeview::delete_item(HTREEITEM hitem)
{
	TreeView_DeleteItem(m_handle, hitem);
}

/// qACe\[g܂
/// @param hitem eACẽnh
void Bcl_treeview::sort_children(HTREEITEM hitem)
{
	TreeView_SortChildren(m_handle, hitem, 0);
}

/// ACeݒ肵܂
/// @param item ACe
void Bcl_treeview::set_item(TV_ITEM* item)
{
	TreeView_SetItem(m_handle, item);
}

/// Ԑݒ
/// @param hitem ACe
/// @param state 
/// @param mask }XN
void Bcl_treeview::set_item_state(HTREEITEM hitem, UINT state, UINT mask)
{
	TreeView_SetItemState(m_handle, hitem, state, mask);
}

/// w肵ʒũACe擾܂
/// @param pt ʒu
/// @return ACe
TVHITTESTINFO Bcl_treeview::hit_test(const POINT& pt)
{
	TVHITTESTINFO info;
	info.pt = pt;
	TreeView_HitTest(m_handle, &info);
	return info;
}

/// ACẽeLXg擾܂
/// @param hitem ACẽnh
/// @return ACẽeLXg
Bcl_str Bcl_treeview::get_text(HTREEITEM hitem) const
{
	TV_ITEM item;
	char buf[ MAX_BUF_SIZE ];
	item.mask = TVIF_HANDLE | TVIF_TEXT;
	item.hItem = hitem;
	item.pszText = buf;
	item.cchTextMax = MAX_BUF_SIZE;
	TreeView_GetItem(m_handle, &item);
	Bcl_str str(buf);
	return str;
}

/// ACe܂
/// @param hitem eACẽnh
/// @param text ACẽeLXg
/// @return ACẽnh
HTREEITEM Bcl_treeview::find_item(HTREEITEM hitem, const Bcl_str& text) const
{
	HTREEITEM target = NULL;
	if (hitem == NULL)
	{
		target = TreeView_GetRoot(m_handle);
	}
	else
	{
		char buf[MAX_BUF_SIZE];
		TV_ITEM item;
		item.mask = TVIF_HANDLE | TVIF_TEXT | TVIF_CHILDREN;
		item.hItem = hitem;
		item.pszText = buf;
		item.cchTextMax = MAX_BUF_SIZE;
		TreeView_GetItem(m_handle, &item);
		if (text == buf)
		{
			return hitem;		// leave function
		}
		if (item.cChildren > 0)
		{
			target = get_child(hitem);
		}
	}
	while (target != NULL)
	{
		HTREEITEM find = find_item(target, text);
		if (find != NULL)
		{
			return find;		// leave function
		}
		target = get_next(target);
	}
	return NULL;
}

/// ACeI܂
/// @param hitem ACẽnh
void Bcl_treeview::select_item(HTREEITEM hitem) const
{
	TreeView_SelectItem(m_handle, hitem);
}

/// ACenCCgɂ܂
/// @param hitem ACẽnh
void Bcl_treeview::select_drop_target(HTREEITEM hitem) const
{
	TreeView_SelectDropTarget(m_handle, hitem);
}

/// ACe悤ɂ܂
/// @param hitem ACẽnh
void Bcl_treeview::select_set_first_visible(HTREEITEM hitem) const
{
	TreeView_SelectSetFirstVisible(m_handle, hitem);
}

/// eACe擾܂
/// @param hitem qACẽnh
/// @return ACẽnh
HTREEITEM Bcl_treeview::get_parent(HTREEITEM hitem) const
{
	return TreeView_GetParent(m_handle, hitem);
}

/// qACe擾܂
/// @param hitem eACẽnh
/// @return ACẽnh
HTREEITEM Bcl_treeview::get_child(HTREEITEM hitem) const
{
	return TreeView_GetChild(m_handle, hitem);
}

/// ̌Z̃ACe擾܂
/// @param hitem ACẽnh
/// @return ACẽnh
HTREEITEM Bcl_treeview::get_next(HTREEITEM hitem) const
{
	return TreeView_GetNextSibling(m_handle, hitem);
}

/// ACeJ܂
/// @param hitem ACẽnh
/// @param flag JtO
void Bcl_treeview::expand(HTREEITEM hitem, bool flag) const
{
	if (flag)
	{
		TreeView_Expand(m_handle, hitem, TVE_EXPAND);
	}
	else
	{
		TreeView_Expand(m_handle, hitem, TVE_COLLAPSE);
	}
}
