//==============================================================
//
// Bcl_vsplit
//
//==============================================================
#include "bcl_vsplit.h"

bool Bcl_vsplit::m_reg_flag = false;

/// RXgN^
Bcl_vsplit::Bcl_vsplit() : m_up(NULL), m_down(NULL), m_size(300), m_btn_down(false), m_hold(false)
{
	m_class_name = "VSPLITTER";
	m_proc = wnd_proc;
	m_style = WS_CHILD | WS_CLIPCHILDREN;
	set_cursor(IDC_ARROW);
	set_brush((HBRUSH)(COLOR_BTNFACE + 1));
	ON_SIZE(Bcl_vsplit::on_size);
	ON_MOUSEMOVE(Bcl_vsplit::on_mouse_move);
	ON_LBUTTONDOWN(Bcl_vsplit::on_lbutton_down);
	ON_LBUTTONUP(Bcl_vsplit::on_lbutton_up);
	ON_NOTIFY(Bcl_vsplit::on_notify);
}

/// fXgN^
Bcl_vsplit::~Bcl_vsplit()
{
}

/// EBhE
/// @param parent eEBhE
/// @param id Rg[hc
/// @param x W
/// @param y W
/// @param w 
/// @param h 
/// @return 
bool Bcl_vsplit::create(Bcl_wnd* parent, int id, int x, int y, int w, int h)
{
	m_parent = parent;
	if (m_reg_flag == false)
	{
		if (Bcl_wnd::init(m_class_name, parent->get_instance()) == false)
		{
			return false;
		}
		m_reg_flag = true;
	}
	return Bcl_ctrl::create(parent, id, x, y, w, h);
}

/// ㉺̃EBhEݒ肵܂
/// @param up ̃EBhE
/// @param down ̃EBhE
/// @param size ̃EBhE̍
void Bcl_vsplit::set_window(Bcl_wnd* up, Bcl_wnd* down, int size)
{
	m_up = up;
	m_down = down;
	m_size = size;
}

/// WM_SIZẼbZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Bcl_vsplit::on_size(WPARAM wp, LPARAM lp)
{
	int size = get_client_height();
	if (size > 14)
	{
		if (m_size > size - 14)
		{
			if (m_hold == false)
			{
				m_hold = true;
				m_hold_size = m_size;
			}
			m_size = size - 14;
		}
		else if (m_hold == true)
		{
			m_size = size - 14;
			if (m_size > m_hold_size)
			{
				m_size = m_hold_size;
				m_hold = false;
			}
		}
	}
	else
	{
		if (m_hold == false)
		{
			m_hold = true;
			m_hold_size = m_size;
		}
		m_size = 0;
	}
	if (m_up != NULL)
	{
		m_up->move(0, 0, get_client_width(), m_size);
	}
	if (m_down != NULL)
	{
		m_down->move(0, m_size + 4, get_client_width(), size - m_size - 4);
	}
}

/// WM_MOUSEMOVẼbZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Bcl_vsplit::on_mouse_move(WPARAM wp, LPARAM lp)
{
	int x = LOWORD(lp);
	int y = HIWORD(lp);
	if (m_btn_down == true)
	{
		int d = y - m_btn.y;
		if ((m_size + d > 10) && (m_size + d < get_client_height() - 14))
		{
			m_size += d;
			m_btn.x = x;
			m_btn.y = y;
			if (m_up != NULL)
			{
				m_up->move(0, 0, get_client_width(), m_size);
			}
			if (m_down != NULL)
			{
				m_down->move(0, m_size + 4, get_client_width(), get_client_height() - m_size - 4);
			}
		}
	}
	else
	{
		if ((y < m_size) || (y > m_size + 4))
		{
			SetCursor(LoadCursor(NULL, IDC_ARROW));
		}
		else
		{
			SetCursor(LoadCursor(NULL, IDC_SIZENS));
		}
	}
}

/// WM_LBUTTONDOWÑbZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Bcl_vsplit::on_lbutton_down(WPARAM wp, LPARAM lp)
{
	int x = LOWORD(lp);
	int y = HIWORD(lp);
	if ((y >= m_size) && (y <= m_size + 4))
	{
		m_btn_down = true;
		m_hold = false;
		m_btn.x = x;
		m_btn.y = y;
		SetCursor(LoadCursor(NULL, IDC_SIZENS));
		SetCapture(m_handle);
	}
}

/// WM_LBUTTONUP̃bZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Bcl_vsplit::on_lbutton_up(WPARAM wp, LPARAM lp)
{
	if (m_btn_down == true)
	{
		m_btn_down = false;
		ReleaseCapture();
	}
}

/// WM_NOTIFỸbZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Bcl_vsplit::on_notify(WPARAM wp, LPARAM lp)
{
	SendMessage(m_parent->get_handle(), WM_NOTIFY, wp, lp);
}
