//==============================================================
//
// Bcl_wnd
//
//==============================================================
#include "bcl_wnd.h"
#include "bcl_citr.h"

std::map<HWND, Bcl_wnd*> Bcl_wnd::m_wnd_list;
Bcl_wnd* Bcl_wnd::m_cur_wnd;

/// RXgN^
Bcl_wnd::Bcl_wnd() : m_menu(""), m_icon("IDI_ICON"), m_cursor("IDC_ARROW"), m_brush((HBRUSH)(COLOR_WINDOW + 1)),
			   m_window_name("MainWindow"), m_style(WS_OVERLAPPEDWINDOW), m_ex_style(NULL), m_handle(NULL), m_id(NULL), m_proc_rtn(0)
{
	m_proc = wnd_proc;
}

/// fXgN^
Bcl_wnd::~Bcl_wnd()
{
	if (m_wnd_list.find(m_handle) != m_wnd_list.end())
	{
		m_wnd_list.erase(m_handle);
	}
}

/// EBhEnhݒ肵܂iEBhEvV[WŎgpAʓIɂ͒ʏgpȂj
/// @param handle EBhEnh
void Bcl_wnd::set_handle(HWND handle)
{
	m_handle = handle;
}

/// CX^Xݒ肵܂iEBhEvV[WŎgpAʓIɂ͒ʏgpȂj
/// @param instance CX^X
void Bcl_wnd::set_instance(HINSTANCE instance)
{
	m_instance = instance;
}

/// j[ݒ肵܂
/// @param menu j[
void Bcl_wnd::set_menu(const Bcl_str& menu)
{
	m_menu.set_id(menu);
}

/// j[ݒ肵܂
/// @param menu j[
void Bcl_wnd::set_menu(int menu)
{
	m_menu.set_id(menu);
}

/// ACRݒ肵܂
/// @param icon ACR
void Bcl_wnd::set_icon(const Bcl_str& icon)
{
	m_icon.set_id(icon);
	if (m_handle != NULL)
	{
		HICON icon_small = (HICON)LoadImage(m_instance, m_icon.get_str(), IMAGE_ICON, 16, 16, 0);
		SendMessage(m_handle, WM_SETICON, ICON_SMALL, (LPARAM)icon_small);
		HICON icon_big = LoadIcon(m_instance, m_icon.get_str());
		SendMessage(m_handle, WM_SETICON, ICON_BIG, (LPARAM)icon_big);
	}
}

/// ACRݒ肵܂
/// @param icon ACR
void Bcl_wnd::set_icon(int icon)
{
	m_icon.set_id(icon);
	if (m_handle != NULL)
	{
		HICON icon_small = (HICON)LoadImage(m_instance, m_icon.get_str(), IMAGE_ICON, 16, 16, 0);
		SendMessage(m_handle, WM_SETICON, ICON_SMALL, (LPARAM)icon_small);
		HICON icon_big = LoadIcon(m_instance, m_icon.get_str());
		SendMessage(m_handle, WM_SETICON, ICON_BIG, (LPARAM)icon_big);
	}
}

/// J[\ݒ肵܂
/// @param cursor J[\
void Bcl_wnd::set_cursor(const Bcl_str& cursor)
{
	m_cursor.set_id(cursor);
}

/// J[\ݒ肵܂
/// @param cursor J[\
void Bcl_wnd::set_cursor(int cursor)
{
	m_cursor.set_id(cursor);
}

/// J[\ݒ肵܂
/// @param cursor J[\
void Bcl_wnd::set_cursor(LPCTSTR cursor)
{
	m_cursor.set_id(cursor);
}

/// wiݒ肵܂
/// @param brush wi
void Bcl_wnd::set_brush(HBRUSH brush)
{
	m_brush = brush;
}

/// EBhÊݒ肵܂
/// @param window_name EBhE
void Bcl_wnd::set_window_name(LPCTSTR window_name)
{
	m_window_name = window_name;
}

/// EBhEX^Cݒ肵܂
/// @param style EBhEX^C
void Bcl_wnd::set_style(DWORD style)
{
	m_style = style;
	if (m_handle != NULL)
	{
		SetWindowLong(m_handle, GWL_STYLE, style);
	}
}

/// EBhEX^C擾܂
/// @return EBhEX^C
DWORD Bcl_wnd::get_style() const
{
	return m_style;
}

/// EBhEgX^Cݒ肵܂
/// @param ex_style EBhEgX^C
void Bcl_wnd::set_expand_style(DWORD ex_style)
{
	m_ex_style = ex_style;
	if (m_handle != NULL)
	{
		SetWindowLong(m_handle, GWL_EXSTYLE, ex_style);
	}
}

/// ֐iEBhEpj
/// @param class_name NX
/// @param instance CX^X
/// @param is_enable_dblclk _uNbN̗L
/// @return 
bool Bcl_wnd::init(const Bcl_str& class_name, HINSTANCE instance, bool is_enable_dblclk)
{
	m_instance = instance;
	m_class_name = class_name;
	WNDCLASSEX my_wnd;
	//EBhENX̓o^
	my_wnd.cbSize			= sizeof(WNDCLASSEX);			//̍\̂̃TCY
	my_wnd.style			= CS_HREDRAW | CS_VREDRAW;		//cړATCYύXĕ`
	if (is_enable_dblclk) my_wnd.style |= CS_DBLCLKS;
	my_wnd.lpfnWndProc		= m_proc;						//R[obN֐|C^[
	my_wnd.cbClsExtra		= 0;							//̍\̈ȍ~ɒuoCg
	my_wnd.cbWndExtra		= 0;							//CX^Xȍ~ɒuoCg
	my_wnd.hInstance		= m_instance;					//̃EBhẼCX^X
	my_wnd.hIcon			= LoadIcon(instance, m_icon.get_str());	//̃EBhENX̃ACR
	my_wnd.hCursor			= LoadCursor(NULL, m_cursor.get_str());	//̃EBhENX̃J[\
	my_wnd.hbrBackground	= m_brush;						//̃EBhENX̔wiF
	my_wnd.lpszMenuName		= m_menu.get_str();				//̃EBhENX̃j[
	my_wnd.lpszClassName	= m_class_name.to_char();		//̃EBhENX̖
	my_wnd.hIconSm			= (HICON)LoadImage(instance, m_icon.get_str(), IMAGE_ICON, 16, 16, 0);
															//̃EBhENX̃X[ACR
	if(!RegisterClassEx(&my_wnd))
	{
		MessageBox(0, "EBhEo^ł܂łB", "G[",
				MB_ICONEXCLAMATION | MB_OK | MB_SYSTEMMODAL);
		return false;
	}
	return true;
}

//// EBhE쐬֐
/// @param parent eEBhE
/// @param x W
/// @param y W
/// @param w 
/// @param h 
/// @return 
bool Bcl_wnd::create_wnd(Bcl_wnd* parent, int x, int y, int w, int h)
{
	return create(parent->get_handle(), x, y, w, h);
}

//// EBhE쐬֐
/// @param parent eEBhEnh
/// @param x W
/// @param y W
/// @param w 
/// @param h 
/// @return 
bool Bcl_wnd::create(HWND parent, int x, int y, int w, int h)
{
	m_cur_wnd = this;
	//EBhE̐
	m_handle = CreateWindowEx(m_ex_style,
					    	m_class_name.to_char(),
							m_window_name.to_char(),
							m_style,
							x,
							y,
							w,
							h,
							parent,
							(HMENU)m_id,
							m_instance,
							NULL);
	if(m_handle == NULL)
	{
		MessageBox(0, ("EBhE(" + m_class_name + ")܂ł!").to_char(), "G[",
				MB_ICONEXCLAMATION | MB_OK | MB_SYSTEMMODAL);
		return false;
	}
	m_wnd_list[m_handle] = this;
	//EBhE̕\ƍĕ`
	ShowWindow(m_handle, SW_SHOWNORMAL);
	UpdateWindow(m_handle);
	return true;
}

/// EBhEnh擾܂
/// @return EBhEnh
HWND Bcl_wnd::get_handle() const
{
	return m_handle;
}

/// CX^X擾܂
/// @return CX^X
HINSTANCE Bcl_wnd::get_instance() const
{
	return m_instance;
}

/// EBhEփbZ[W𑗐M܂
/// @param msg bZ[W
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
/// @return 
LRESULT Bcl_wnd::send_msg(UINT msg, WPARAM wp, LPARAM lp)
{
	return SendMessage(m_handle, msg, wp, lp);
}

/// Rg[փbZ[W𑗐M܂
/// @param id Rg[hc
/// @param msg bZ[W
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
/// @return 
LRESULT Bcl_wnd::send_item_msg(int id, UINT msg, WPARAM wp, LPARAM lp)
{
	return SendDlgItemMessage(m_handle, id, msg, wp, lp);
}

/// EBhEփbZ[W𑗐M܂
/// @param msg bZ[W
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
/// @return 
LRESULT Bcl_wnd::post_msg(UINT msg, WPARAM wp, LPARAM lp)
{
	return PostMessage(m_handle, msg, wp, lp);
}

/// bZ[W}bv擾܂iEBhEvV[WŎgpAʓIɂ͒ʏgpȂj
/// @return bZ[W}bv
MessageMap* Bcl_wnd::get_message_map()
{
	return &m_msg;
}

/// WM_CREATẼbZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Bcl_wnd::on_create(WPARAM wp, LPARAM lp)
{
}

/// WM_CLOSẼbZ[Wnh
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
void Bcl_wnd::on_close(WPARAM wp, LPARAM lp)
{
	DestroyWindow(m_handle);
}

/// EBhEvV[W
/// @param handle EBhEnh
/// @param msg bZ[W
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
/// @return 
LRESULT CALLBACK Bcl_wnd::wnd_proc(HWND handle, UINT msg, WPARAM wp, LPARAM lp)
{
	bool user_func;
	if (msg == WM_CREATE)
	{
		m_cur_wnd->set_handle(handle);\
		m_cur_wnd->set_instance((HINSTANCE)GetWindowLong(handle, GWL_HINSTANCE));
		m_cur_wnd->on_create(wp, lp);
		user_func = true;
	}
	else
	{
		user_func = proc_msg(handle, msg, wp, lp);
	}
	if (!user_func)
	{
		return (DefWindowProc(handle, msg, wp, lp));
	}
	LRESULT rtn = 0;
	if (m_wnd_list.find(handle) != m_wnd_list.end())
	{
		rtn = m_wnd_list[handle]->m_proc_rtn;
		m_wnd_list[handle]->m_proc_rtn = 0;
	}
	return rtn;
}


/// EBhEvV[W{
/// @param handle EBhEnh
/// @param msg bZ[W
/// @param wp bZ[W̍ŏ̃p[^
/// @param lp bZ[ŴQԖڂ̃p[^
/// @return 
bool Bcl_wnd::proc_msg(HWND handle, UINT msg, WPARAM wp, LPARAM lp)
{
	bool user_func = false;
	if (m_wnd_list.find(handle) != m_wnd_list.end())
	{
			MessageMap* msg_map = m_wnd_list[handle]->get_message_map();
		Bcl_citr<MessageMap> itr(*msg_map);
		while (itr.has_next())
		{
			const Message& msg_val = itr.next();
			if (msg_val.msg == msg)
			{
				if (msg == WM_COMMAND)
				{
					if (msg_val.id == LOWORD(wp))
					{
						(m_wnd_list[handle]->*msg_val.func)(wp, lp);
						user_func = true;
						break;
					}
				}
				else
				{
					(m_wnd_list[handle]->*msg_val.func)(wp, lp);
					user_func = true;
					break;
				}
			}
		}
	}
	return user_func;
}

/// eLXgݒ肵܂
/// @param text eLXg
void Bcl_wnd::set_text(const Bcl_str& text)
{
	SetWindowText(m_handle, text.to_char());
}

/// eLXg擾܂
/// @return eLXg
Bcl_str Bcl_wnd::get_text() const
{
	char moji[65535];
	GetWindowText(m_handle, moji, sizeof(moji));
	Bcl_str text(moji);
	return text;
}

/// EBhE̗Lݒ肵܂
/// @param flg L
void Bcl_wnd::set_enabled(bool flg)
{
	EnableWindow(m_handle, flg);
}

/// EBhE\܂
void Bcl_wnd::show()
{
	ShowWindow(m_handle, SW_SHOW);
}

/// EBhEB
void Bcl_wnd::hide()
{
	ShowWindow(m_handle, SW_HIDE);
}

/// Lv`ݒ
void Bcl_wnd::set_capture()
{
	SetCapture(m_handle);
}

/// Lv`
void Bcl_wnd::release_capture()
{
	ReleaseCapture();
}

/// ANeBuEBhEݒ
void Bcl_wnd::set_active_window()
{
	SetActiveWindow(m_handle);
}

/// tH[JXݒ
void Bcl_wnd::set_focus()
{
	SetFocus(m_handle);
}

/// Oʂɐݒ
void Bcl_wnd::set_foreground_window()
{
	SetForegroundWindow(m_handle);
}

/// NCAg̈ĕ`悵܂
/// @param erase 邩ǂ̏
void Bcl_wnd::invalidate(bool erase)
{
	InvalidateRect(m_handle, NULL, erase);
}

/// NCAg̈̈ꕔĕ`悵܂
/// @param x ĕ`悷鍶゘W
/// @param y ĕ`悷鍶゙W
/// @param w ĕ`悷镝
/// @param h ĕ`悷鍂
/// @param erase 邩ǂ̏
void Bcl_wnd::invalidate_rect(int x, int y, int w, int h, bool erase)
{
	RECT rect;
	rect.left = x;
	rect.top = y;
	rect.right = x + w;
	rect.bottom = y + h;
	InvalidateRect(m_handle, &rect, erase);
}

/// Nbv{[hɃf[^ݒ
/// @param data f[^
void Bcl_wnd::set_clipboard_data(const Bcl_str& data)
{
	int length = strlen(data.to_char());
	HGLOBAL global = GlobalAlloc(GHND, length + 1);
	LPSTR mem = (LPSTR)GlobalLock(global);
	for(int i = 0; i < length; i++)
	{
		mem[i] = data[i];
	}
	GlobalUnlock(global);
	OpenClipboard(m_handle);
	EmptyClipboard();
	SetClipboardData(CF_TEXT, global);
	CloseClipboard(); 
}

/// EBhEvVW̖߂l̐ݒ
/// @param rtn ߂l
void Bcl_wnd::set_proc_rtn(LRESULT rtn)
{
	m_proc_rtn = rtn;
}

/// ړ
/// @param x W
/// @param y W
/// @param w 
/// @param h 
void Bcl_wnd::move(int x, int y, int w, int h)
{

	MoveWindow(m_handle, x, y, w, h, TRUE);
}

/// EBhE̍擾܂
/// @return EBhE̍
int Bcl_wnd::get_height() const
{
	RECT rect;
	GetWindowRect(m_handle, &rect);
	return rect.bottom - rect.top;
}

/// EBhE̕擾܂
/// @return EBhE̕
int Bcl_wnd::get_width() const
{
	RECT rect;
	GetWindowRect(m_handle, &rect);
	return rect.right - rect.left;
}

/// EBhE̋`擾܂
/// @return EBhE̋`
RECT Bcl_wnd::get_rect() const
{
	RECT rect;
	GetWindowRect(m_handle, &rect);
	rect.bottom--;
	rect.right--;
	return rect;
}

/// NCAg̍擾܂
/// @return NCAg̍
int Bcl_wnd::get_client_height() const
{
	RECT rect;
	GetClientRect(m_handle, &rect);
	return rect.bottom - rect.top;
}

/// NCAg̕擾܂
/// @return NCAg̕
int Bcl_wnd::get_client_width() const
{
	RECT rect;
	GetClientRect(m_handle, &rect);
	return rect.right - rect.left;
}

/// NCAg̋`擾܂
/// @return NCAg̋`
RECT Bcl_wnd::get_client_rect() const
{
	RECT rect;
	GetClientRect(m_handle, &rect);
	rect.bottom--;
	rect.right--;
	return rect;
}

/// XN[W擾܂
/// @param pt NCAgW
/// @return XN[W
POINT Bcl_wnd::get_screen_from_client(POINT pt) const
{
	ClientToScreen(m_handle, &pt);
	return pt;
}

/// NCAgW擾܂
/// @param pt XN[W
/// @return NCAgW
POINT Bcl_wnd::get_client_from_screen(POINT pt) const
{
	ScreenToClient(m_handle, &pt);
	return pt;
}

/// bZ[W{bNX\܂
/// @param text eLXg
/// @param caption LvV
/// @param type ^Cv
/// @return 
int Bcl_wnd::show_msg_box(const Bcl_str& text, const Bcl_str& caption, UINT type)
{
	return MessageBox(m_handle, text.to_char(), caption.to_char(), type);
}

/// EBhȄ擾܂
/// @param idx 擾
/// @return 
long Bcl_wnd::get_window_long(int idx) const
{
	return GetWindowLong(m_handle, idx);
}

/// EBhȄݒ肵܂
/// @param idx ݒ肷
/// @param val ݒ肷l
/// @return 
long Bcl_wnd::set_window_long(int idx, long val)
{
	return SetWindowLong(m_handle, idx, val);
}
